/*=================================================================	|
																	|
	Pipsqueak AI Advanced (TM)										|
																	|
	>>> Contact: us@rewireneuro.com									|
	>>> Copyright (C) 2016-2021, Rewire Neuro (TM)			|
																	|
	Rewire Neuro, Inc (TM)									|
	Portland, Oregon												|
																	|
	Supported by:													|
	>>> Rewire Neuro (rewireneuro.com)				|
	>>> WSU Alcohol and Drug Abuse Research Program (ADARP)			|
	>>> The Translational Addiction Research Center (TARC)			|
	>>> NIH DA 033404												|	
	>>> Washington State Initiative Measure No. 171					|
	>>> NIH R43GM134789-01 (NIGMS SBIR Phase I)						|
	>>> State of Oregon SBIR matching grant							|
																	|
																	|
	>>> PLEASE CITE: Slaker, et al., 2016 <<<						|
																	|
																	|
//================================================================	|
*/ 
//=================VERSIONING INFORMATION============================================//

//PipVersion="Pipsqueak AI Advanced (TM) v5.6.0";
var ver="5.6.0";
var verurl="v5-6-0";
var releaseDate="May the 4th be with 2021";

//==================================================================================//

	//Global variables
var pipDir="blank";
var AI_Engine_exec="blank";
var floatAddress=0;
var email_address="";
var user_password=""; 
var order_number="12345";
var license_number="eg: e241-U45n";
//var validLicense="blank";

var TimeString = "BlankDate";

var scale_size = 1.194;
var scale_known = 1;
var scale_pixel = 1;
var scale_unit = "um";
var zsteps = 20;

var background_setting = "Low";
var imageDepth = 0;

var set_intensity_low_threshold = 1.165;
var set_intensity_high_threshold = 5000;
var set_low_particlesize = 70;
var set_high_particlesize = 500;
var set_low_circularity = 0.3;
var set_high_circularity = 1.00;
var set_roi_enlargement_single = 0;
var set_intensity_low_threshold_old = 1.165;
var set_low_particlesize_old = 70;
var set_high_particlesize_old = 99999;
var ROI_type_SL = "oval";

var countSingle = 0;
var first_image = 0;
var second_image = 0;

var series_name = 0;
var subDir = 0;

var first_suffix_flo = 2;
var second_suffix_flo = 3;
var merged_suffix_flo = 1;
var total_images = 3;

var first_stain_type = "Parvalbumin";
var DL1_set_intensity_low_threshold = 1.5;
var DL1_set_intensity_high_threshold = 5000;
var DL1_set_low_particlesize = 40;
var DL1_set_high_particlesize = 500;
var DL1_set_low_circularity = 0.02;
var DL1_set_high_circularity = 1.00;
var DL1_set_roi_enlargement = 0;
var SL1_set_intensity_low_threshold_old = 1.0;
var SL1_set_low_particlesize_old = 40;
var SL1_set_high_particlesize_old = 1000;
var DL1_lower = 0;
var DL1_overlap = 0.8;
var ROI_type_DL1 = "oval";

var second_stain_type = "WFA";
var DL2_set_intensity_low_threshold = 1.65;
var DL2_set_intensity_high_threshold = 5000;
var DL2_set_low_particlesize = 100;
var DL2_set_high_particlesize = 500;
var DL2_set_low_circularity = 0.02;
var DL2_set_high_circularity = 1.00;
var DL2_set_roi_enlargement = 0;
var SL2_set_intensity_low_threshold_old = 1.165;
var SL2_set_low_particlesize_old = 70;
var SL2_set_high_particlesize_old = 99999;
var DL2_lower = 0;
var DL2_overlap = 0.8;
var ROI_type_DL2 = "rectangle";

var first_image_TL = 0;
var second_image_TL= 0;
var third_image_TL = 0;
var merged_image_TL = 0;
var series_name_TL = 0;
var subDir_TL = 0;

var first_suffix_TL_flo= 2;
var second_suffix_TL_flo = 3;
var third_suffix_TL_flo = 4;
var merged_suffix_TL_flo = 1;
var total_images_TL = 4;

var first_stain_type_TL = "Parvalbumin";
var TL1_set_intensity_low_threshold = 1.5;
var TL1_set_intensity_high_threshold = 5000;
var TL1_set_low_particlesize = 40;
var TL1_set_high_particlesize = 500;
var TL1_set_low_circularity = 0.02;
var TL1_set_high_circularity = 1.00;
var TL1_set_roi_enlargement = 0;
var TL1_lower = 0;
var TL1_overlap = 0.8;
var ROI_type_TL1 = "oval";

var second_stain_type_TL = "WFA";
var TL2_set_intensity_low_threshold = 1.65;
var TL2_set_intensity_high_threshold = 5000;
var TL2_set_low_particlesize = 100;
var TL2_set_high_particlesize = 500;
var TL2_set_low_circularity = 0.02;
var TL2_set_high_circularity = 1.00;
var TL2_set_roi_enlargement = 0;
var TL2_lower = 0;
var TL2_overlap = 0.8;
var ROI_type_TL2 = "rectangle";

var third_stain_type_TL = "8-oxo";
var TL3_set_intensity_low_threshold = 1.5;
var TL3_set_intensity_high_threshold = 5000;
var TL3_set_low_particlesize = 50;
var TL3_set_high_particlesize = 300;
var TL3_set_low_circularity = 0.02;
var TL3_set_high_circularity = 1.00;
var TL3_set_roi_enlargement = 0;
var TL3_lower = 0;
var TL3_overlap = 0.8;
var ROI_type_TL3 = "oval";

var lower = 0;
var first_open = 0; //TO BE REMOVED
var last_open = 0; //TO BE REMOVED
var name = 0;
var full_name = 0;
var imageType = 0;
var dir = 0;
var first_time = 0;

var save_location = 0;
var pipsqueakCount = 1;
var countCount = 1;
var countDouble = 0;
var first_open_double = 0; //TO BE REMOVED
var last_open_double = 0; //TO BE REMOVED

var subject = 0;
var first_SL_run=1;
var keep_old_ROIs="empty";
var pass=0; //120
var advanced_detection="no"; //TO BE REMOVED
var low_particle_select_area=50;
var high_particle_select_area=250;

var rollingball_io="On";
var rollingball=50;
var ML_thresh=25;
var dup_thresh=50;

var model="wfa";
var user_model="new model name";
var user_model_1="first_stain";
var user_model_2="second_stain";
var user_model_3="third_stain";
var inference_key=0;
var import_type="";
var Zchannels="";
var channel=1;
var SL_suffix_flo= 3; 
var beastMode=0;
var imageDir="";
var SL_stain_type="WFA";

var os ="";
var _sep_="";
var image_file="";
var reduceSize="Speed";
var rerun="0";
var subsectioning = 1;
var experiment = 0;
var treatment = 0;
var imageKey =  0;
var inferenceMessage = "";

var lic = 0;
var aCoLoArray=newArray(0); 
var bCoLoArray=newArray(0); 
var abCoLoArray=newArray(0);
var aCoLoselectArray=newArray(0);
var bCoLoselectArray=newArray(0);
var abCoLoselectArray=newArray(0);

var subDir1 = "";
var subDir2 = "";
var subDir3 = "";

var limitRegion = "";
var merged_image = "";

var model_library = "";
var common_library = "";
var specific_models = "";
var general_models = "";
var community_models = "";
var custom_models = "";

var imageOrder="";
var menuDefault="Modify ROIs by hand";
var custom_library=newArray();


///////////////////////////																										need to reduce the number of these saved variables 041120
function saveParameters(){
	parFile = File.open(pipDir+"Pipsqueak_config_v"+ver+".txt"); // display file open dialog
	
	print(parFile, pipDir); //0
	print(parFile, floatAddress); //1 								//TO BE REMOVED
   	print(parFile, email_address); //2
	print(parFile, user_password); //3 								//TO BE REMOVED
	print(parFile, order_number); //4
	print(parFile, license_number); //5
	//print(parFile, validLicense); //5

	print(parFile, scale_size); //6
	print(parFile, scale_known); //7
	print(parFile, scale_pixel); //8
	print(parFile, scale_unit); //9
	print(parFile, zsteps); //10 
	print(parFile, background_setting); //11

	print(parFile, set_intensity_low_threshold); //12
	print(parFile, set_intensity_high_threshold); //13
	print(parFile, set_low_particlesize); //14
	print(parFile, set_high_particlesize); //15
	print(parFile, set_low_circularity); //16
	print(parFile, set_high_circularity); //17
	print(parFile, set_roi_enlargement_single); //18
	print(parFile, set_intensity_low_threshold_old); //19
	print(parFile, set_low_particlesize_old); //20
	print(parFile, set_high_particlesize_old); //21
	print(parFile, ROI_type_SL); //22

	print(parFile, first_suffix_flo); //23
	print(parFile, second_suffix_flo); //24
	print(parFile, merged_suffix_flo); //25
	print(parFile, total_images); //26

	print(parFile, first_stain_type); //27
	print(parFile, DL1_set_intensity_low_threshold); //28
	print(parFile, DL1_set_intensity_high_threshold); //29
	print(parFile, DL1_set_low_particlesize); //30
	print(parFile, DL1_set_high_particlesize); //31
	print(parFile, DL1_set_low_circularity); //32
	print(parFile, DL1_set_high_circularity); //33
	print(parFile, DL1_set_roi_enlargement); //34
	print(parFile, SL1_set_intensity_low_threshold_old); //35
	print(parFile, SL1_set_low_particlesize_old); //36
	print(parFile, SL1_set_high_particlesize_old); //37
	print(parFile, DL1_lower); //38 									//TO BE REMOVED
	print(parFile, DL1_overlap); //39
	print(parFile, ROI_type_DL1); //40

	print(parFile, second_stain_type); //41
	print(parFile, DL2_set_intensity_low_threshold); //42
	print(parFile, DL2_set_intensity_high_threshold); //43
	print(parFile, DL2_set_low_particlesize); //44
	print(parFile, DL2_set_high_particlesize); //45
	print(parFile, DL2_set_low_circularity); //46
	print(parFile, DL2_set_high_circularity); //47
	print(parFile, DL2_set_roi_enlargement); //48
	print(parFile, SL2_set_intensity_low_threshold_old); //49
	print(parFile, SL2_set_low_particlesize_old); //50
	print(parFile, SL2_set_high_particlesize_old); //51

	print(parFile, DL2_lower); //52										 //TO BE REMOVED
	print(parFile, DL2_overlap); //53
	print(parFile, ROI_type_DL2); //54

	print(parFile, first_image_TL); //55
	print(parFile, second_image_TL); //56
	print(parFile, third_image_TL); //57
	print(parFile, merged_image_TL); //58
	print(parFile, series_name_TL); //59
	print(parFile, subDir_TL); //60

	print(parFile, first_suffix_TL_flo); //61
	print(parFile, second_suffix_TL_flo); //62
	print(parFile, third_suffix_TL_flo); //63
	print(parFile, merged_suffix_TL_flo); //64
	print(parFile, total_images_TL); //65

	print(parFile, first_stain_type_TL); //66
	print(parFile, TL1_set_intensity_low_threshold); //67
	print(parFile, TL1_set_intensity_high_threshold); //68
	print(parFile, TL1_set_low_particlesize); //69
	print(parFile, TL1_set_high_particlesize); //70
	print(parFile, TL1_set_low_circularity); //71
	print(parFile, TL1_set_high_circularity); //72
	print(parFile, TL1_set_roi_enlargement); //73
	print(parFile, TL1_lower); //74										 //TO BE REMOVED
	print(parFile, TL1_overlap); //75
	print(parFile, ROI_type_TL1); //76

	print(parFile, second_stain_type_TL); //77
	print(parFile, TL2_set_intensity_low_threshold); //78
	print(parFile, TL2_set_intensity_high_threshold); //79
	print(parFile, TL2_set_low_particlesize); //80
	print(parFile, TL2_set_high_particlesize); //81
	print(parFile, TL2_set_low_circularity); //82
	print(parFile, TL2_set_high_circularity); //83
	print(parFile, TL2_set_roi_enlargement); //84
	print(parFile, TL2_lower); //85										 //TO BE REMOVED
	print(parFile, TL2_overlap); //86
	print(parFile, ROI_type_TL2); //87

	print(parFile, third_stain_type_TL); //88
	print(parFile, TL3_set_intensity_low_threshold); //89
	print(parFile, TL3_set_intensity_high_threshold); //90
	print(parFile, TL3_set_low_particlesize); //91
	print(parFile, TL3_set_high_particlesize); //92
	print(parFile, TL3_set_low_circularity); //93
	print(parFile, TL3_set_high_circularity); //94
	print(parFile, TL3_set_roi_enlargement); //95
	print(parFile, TL3_lower); //96										 //TO BE REMOVED
	print(parFile, TL3_overlap); //97
	print(parFile, ROI_type_TL3); //98

	print(parFile, lower); //99											 //TO BE REMOVED
	print(parFile, last_open); //100									 //TO BE REMOVED
	print(parFile, first_time); //101									 //TO BE REMOVED
	print(parFile, first_open_double); //102							 //TO BE REMOVED
	print(parFile, last_open_double); //103								 //TO BE REMOVED

	print(parFile, advanced_detection); //104							 //TO BE REMOVED
	print(parFile, low_particle_select_area); //105						 //TO BE REMOVED
	print(parFile, high_particle_select_area); //106					//TO BE REMOVED
	
	print(parFile, rollingball_io); //107
	print(parFile, rollingball); //108
	print(parFile, ML_thresh); //109
	print(parFile, dup_thresh); //110
	
	print(parFile, model); //111
	//print(parFile, user_model); 
	print(parFile, user_model_1); //113
	print(parFile, user_model_2); //114
	print(parFile, user_model_3); //115
	
	print(parFile, SL_suffix_flo); //116
	print(parFile, SL_stain_type); //117
	print(parFile, reduceSize); //118
	print(parFile, subsectioning); //119
	print(parFile, lic); //120
	
	File.close(parFile);
}

///////////////////////////																												and reduce here
function Read_Variables() {
	
if(File.exists(pipDir+"Pipsqueak_config_v"+ver+".txt")){

	parameters = File.openAsString(pipDir+"Pipsqueak_config_v"+ver+".txt");
	parLines=split(parameters,"\n");

 	pipDir=parLines[0];
 	floatAddress=parseFloat(parLines[1]);							 //TO BE REMOVED
 	email_address=parLines[2];
 	user_password=parLines[3];										 //TO BE REMOVED
 	order_number=parLines[4];
 	license_number=parLines[5];
 	//validLicense=parLines[5];										 //TO BE REMOVED

	scale_size=parseFloat(parLines[6]);
 	scale_known=parseFloat(parLines[7]);
 	scale_pixel=parseFloat(parLines[8]);
 	scale_unit=parLines[9];
 	zsteps=parseFloat(parLines[10]);
	background_setting=parLines[11];

 	set_intensity_low_threshold=parseFloat(parLines[12]);
 	set_intensity_high_threshold=parseFloat(parLines[13]);
 	set_low_particlesize=parseFloat(parLines[14]);
 	set_high_particlesize=parseFloat(parLines[15]);
 	set_low_circularity=parseFloat(parLines[16]);
 	set_high_circularity=parseFloat(parLines[17]);
 	set_roi_enlargement_single=parseFloat(parLines[18]);
 	set_intensity_low_threshold_old=parseFloat(parLines[19]);
 	set_low_particlesize_old=parseFloat(parLines[20]);
 	set_high_particlesize_old=parseFloat(parLines[21]);
 	ROI_type_SL=parLines[22];

 	first_suffix_flo=parseFloat(parLines[23]);
 	second_suffix_flo=parseFloat(parLines[24]);
 	merged_suffix_flo=parseFloat(parLines[25]);
 	total_images=parseFloat(parLines[26]);

 	first_stain_type=parLines[27];
 	DL1_set_intensity_low_threshold=parseFloat(parLines[28]);
 	DL1_set_intensity_high_threshold=parseFloat(parLines[29]);
 	DL1_set_low_particlesize=parseFloat(parLines[30]);
 	DL1_set_high_particlesize=parseFloat(parLines[31]);
 	DL1_set_low_circularity=parseFloat(parLines[32]);
 	DL1_set_high_circularity=parseFloat(parLines[33]);
 	DL1_set_roi_enlargement=parseFloat(parLines[34]);
 	SL1_set_intensity_low_threshold_old=parseFloat(parLines[35]);
 	SL1_set_low_particlesize_old=parseFloat(parLines[36]);
 	SL1_set_high_particlesize_old=parseFloat(parLines[37]);
 	DL1_lower=parseFloat(parLines[38]);									 //TO BE REMOVED
 	DL1_overlap=parseFloat(parLines[39]);
 	ROI_type_DL1=parLines[40];

 	second_stain_type=parLines[41];
 	DL2_set_intensity_low_threshold=parseFloat(parLines[42]);
 	DL2_set_intensity_high_threshold=parseFloat(parLines[43]);
 	DL2_set_low_particlesize=parseFloat(parLines[44]);
 	DL2_set_high_particlesize=parseFloat(parLines[45]);
 	DL2_set_low_circularity=parseFloat(parLines[46]);
 	DL2_set_high_circularity=parseFloat(parLines[47]);
 	DL2_set_roi_enlargement=parseFloat(parLines[48]);
 	SL2_set_intensity_low_threshold_old=parseFloat(parLines[49]);
 	SL2_set_low_particlesize_old=parseFloat(parLines[50]);
 	SL2_set_high_particlesize_old=parseFloat(parLines[51]);

 	DL2_lower=parseFloat(parLines[52]);									 //TO BE REMOVED
 	DL2_overlap=parseFloat(parLines[53]);
 	ROI_type_DL2=parLines[54];

 	first_image_TL=parseFloat(parLines[55]);
 	second_image_TL=parseFloat(parLines[56]);
 	third_image_TL=parseFloat(parLines[57]);
 	merged_image_TL=parseFloat(parLines[58]);
 	series_name_TL=parseFloat(parLines[59]);
 	subDir_TL=parseFloat(parLines[60]);

 	first_suffix_TL_flo=parseFloat(parLines[61]);
 	second_suffix_TL_flo=parseFloat(parLines[62]);
 	third_suffix_TL_flo=parseFloat(parLines[63]);
 	merged_suffix_TL_flo=parseFloat(parLines[64]);
 	total_images_TL=parseFloat(parLines[65]);

 	first_stain_type_TL=parLines[66];
 	TL1_set_intensity_low_threshold=parseFloat(parLines[67]);
 	TL1_set_intensity_high_threshold=parseFloat(parLines[68]);
 	TL1_set_low_particlesize=parseFloat(parLines[69]);
 	TL1_set_high_particlesize=parseFloat(parLines[70]);
 	TL1_set_low_circularity=parseFloat(parLines[71]);
 	TL1_set_high_circularity=parseFloat(parLines[72]);
 	TL1_set_roi_enlargement=parseFloat(parLines[73]);
 	TL1_lower=parseFloat(parLines[74]);													 //TO BE REMOVED
 	TL1_overlap=parseFloat(parLines[75]);
 	ROI_type_TL1=parLines[76];

 	second_stain_type_TL=parLines[77];
 	TL2_set_intensity_low_threshold=parseFloat(parLines[78]);
 	TL2_set_intensity_high_threshold=parseFloat(parLines[79]);
 	TL2_set_low_particlesize=parseFloat(parLines[80]);
 	TL2_set_high_particlesize=parseFloat(parLines[81]);
 	TL2_set_low_circularity=parseFloat(parLines[82]);
 	TL2_set_high_circularity=parseFloat(parLines[83]);
 	TL2_set_roi_enlargement=parseFloat(parLines[84]);
 	TL2_lower=parseFloat(parLines[85]);													 //TO BE REMOVED
 	TL2_overlap=parseFloat(parLines[86]);
 	ROI_type_TL2=parLines[87];

 	third_stain_type_TL=parLines[88];
 	TL3_set_intensity_low_threshold=parseFloat(parLines[89]);
 	TL3_set_intensity_high_threshold=parseFloat(parLines[90]);
 	TL3_set_low_particlesize=parseFloat(parLines[91]);
 	TL3_set_high_particlesize=parseFloat(parLines[92]);
 	TL3_set_low_circularity=parseFloat(parLines[93]);
 	TL3_set_high_circularity=parseFloat(parLines[94]);
 	TL3_set_roi_enlargement=parseFloat(parLines[95]);
 	TL3_lower=parseFloat(parLines[96]);															 //TO BE REMOVED
 	TL3_overlap=parseFloat(parLines[97]);
 	ROI_type_TL3=parLines[98];

 	lower=parseFloat(parLines[99]);											 //TO BE REMOVED
 	last_open=parseFloat(parLines[100]);									 //TO BE REMOVED
 	first_time=parseFloat(parLines[101]);									 //TO BE REMOVED
 	first_open_double=parseFloat(parLines[102]);							//TO BE REMOVED
 	last_open_double=parseFloat(parLines[103]);									 //TO BE REMOVED

 	advanced_detection=parLines[104];										 //TO BE REMOVED
 	low_particle_select_area=parseFloat(parLines[105]);							 //TO BE REMOVED
 	high_particle_select_area=parseFloat(parLines[106]);						 //TO BE REMOVED
 	
 	rollingball_io=parLines[107];
 	rollingball=parseFloat(parLines[108]);
 	ML_thresh =parseFloat(parLines[109]);
 	dup_thresh =parseFloat(parLines[110]);
 	
 	model =parLines[111];
 	//user_model =parLines[112];
 	user_model_1 =parLines[112];
 	user_model_2 =parLines[113];
 	user_model_3 =parLines[114];
 	
 	SL_suffix_flo= parseFloat(parLines[115]); 
 	SL_stain_type= parLines[116];
	reduceSize= parLines[117];
	subsectioning = parLines[118];
	lic = parseFloat(parLines[119]); 	
	}
}
////////////////////////////
function custom_library_reader(){
	custom_library=newArray();
	if(File.exists(pipDir+"custom_library.txt")){

		Lib = File.openAsString(pipDir+"custom_library.txt");
		parLib=split(Lib,"\n");
		
		for(i=0; i<parLib.length; i++){
			custom_library=Array.concat(custom_library,parLib[i]);
		}
	}
}
///////////////////////////
function custom_library_writer(custom_library){
	if(File.exists(pipDir+"custom_library.txt")){
		File.delete(pipDir+"custom_library.txt");
	}
	parFile = File.open(pipDir+"custom_library.txt"); // display file open dialog

	for(i=0; i<custom_library.length; i++){
		print(parFile, custom_library[i]);
	}	
	File.close(parFile);
}
///////////////////////////
function ps_rgch(loginMessage){		//ok 100320 ================================================================
	fiji=getDirectory("imagej");

	//License check
	licenseCheck=exec(AI_Engine_exec, "license-check"); /////////////////  CHANGE
	//print(licenseCheck);
	
	if(licenseCheck!=""){
		licenseCheckLine=split(licenseCheck,"\n");
		licenseLine0=licenseCheckLine[0];
		//print("license line="+licenseLine0);
		
		if(licenseCheckLine.length>0){
			//print("license check longer than a line");
			licenseLine0=licenseCheckLine[0];			
			licenseError=split(licenseLine0,":");
			licenseResult=licenseError[0]; // the point of this script is to determine what line 2 of the return says, and set that value as "licenseResult"
		}else{
			licenseResult="No Error";
		}
		//print("license result="+licenseResult);

		if(licenseResult=="No Error" || licenseResult=="Token Refresh for "+email_address+" successful"){ //ok 100520

			initi();

		} else if (licenseResult=="Error (Token)" || licenseResult=="Error") {
			run("Login");
			call("PipsqueakLoginCommand.setEmail", email_address);
			wait(500);
			
			res=call("PipsqueakLoginCommand.isDone");
			while (res == "not done") {
				wait(500);
				res=call("PipsqueakLoginCommand.isDone");
								
				if (res == "register") {
					lic = 0;
					//print("Going to register function");
					ps_reg("no message");
				}
				if (res == "active") {
					lic = 1;					
				}
				if (res == "inactive") {
					lic = 0;		   
				} 
				if (res == "add license"){
					lic = 0; 
					waitForUser("Switch License", "Your Pipsqueak AI license(s) can be managed, switched, and added \nfrom https://my.pipsqueak.ai We're taking you there now. \n \nWhen you return, your new license will be active upon login.");
					exec("open", "https://my.pipsqueak.ai");
					res=call("PipsqueakLoginCommand.logoutUser");
					loginMessage = "";
					ps_rgch(loginMessage);
				}
				else if (res == "forgot") {
					//print("Going to forgot password function");
					lic = 0; 
					ps_forgot("");
				}
				 //waitForUser("res=="+res);
			}
			//print("Done");
			email_address = call("PipsqueakLoginCommand.getEmail");
			//waitForUser(lic);
			//print("Email: " + email_address);
			saveParameters();
			initi();
		}else{ 			 //rgch_001
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak_ai%2Fcall_home%2F"+verurl+"-APIloginFail-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK_AI%2Fv"+ver+".APIloginFail."+email_address+"%3B&utmu=DC~";
			silent=File.openUrlAsString(call_home_url);
			wait(20);
			exec("open", "mailto: support@rewireneuro.com");
			waitForUser("Pipsqueak AI experienced an error during the license verification. \n\nPlease record this dialogue and contact support@rewireneuro.com \nError message #rgch_001");
			exec("open", "mailto: support@rewireneuro.com");
			exit;
			
		}	
	}else if(File.exists(getDirectory("imagej")+"token.json")){
			initi();
	}else{ 			//rgch_002
		call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak_ai%2Fcall_home%2F"+verurl+"-APIloginFail-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK_AI%2Fv"+ver+".APIloginFail."+email_address+"%3B&utmu=DC~";
		silent=File.openUrlAsString(call_home_url);
		wait(20);
		exec("open", "mailto: support@rewireneuro.com");
		waitForUser("AI_Engine failed to run. Please check your license, restart FIJI, or reinstall Pipsqueak AI. \n\nIf you continue to have this problem, please contact support@RewireNeuro.com \nError message #rgch_002");
		exec("open", "mailto: support@rewireneuro.com");
		exit;
		//ps_rgch();
	}
}
///////////////////////////
function ps_reg(regMessage){	// ok 100320================================================================

	res=call("PipsqueakLoginCommand.logoutUser");
	run("Register");
	wait(500);
	res=call("PipsqueakRegisterCommand.isDone");
	
	//while (res == "not done") {
	//	wait(500);
	//	res=call("PipsqueakRegisterCommand.isDone");
	//}
	while (res == "not done") {
 		wait(500);
 		res=call("PipsqueakRegisterCommand.isDone");
 		//print(res);
 		resMessage=split(res,":");
		//Array.print(resMessage);
		if(resMessage.length>1){
        	resPrint=resMessage[3];
        	//print(resMessage.length);
        	//print(resPrint);
    	    call("PipsqueakRegisterCommand.setMessage", resPrint);
            res = "not done";
        }
    }

	if (res == "back") {
		ps_rgch("")
	}

	email_address=call("PipsqueakRegisterCommand.getEmail");
	saveParameters();
	ps_rgch("All good");
}


///////////////////////////
function ps_forgot(forgotMessage){	//ok 100520 ================================================================
	Dialog.create("Reset forgotten password");
	Dialog.addMessage("Please enter the email address you used to register your account.");
	Dialog.addMessage(" ");
	Dialog.addString("Email address:", email_address, 25);
	Dialog.addMessage(" ");
	Dialog.addMessage(" ");
	Dialog.addMessage(forgotMessage);
	Dialog.addMessage(" ");	
			
	Dialog.show;
	email_address = Dialog.getString();

	iForgot=exec(AI_Engine_exec, "forgot", email_address);
	//print(iForgot);

	if(iForgot!=""){
		iForgotWhereIAm=split(iForgot,"\n");
		iForgotWhyAnythingMatters=iForgotWhereIAm[0];
			
		if(iForgotWhyAnythingMatters=="Error (Forgot Password): {\"message\": \"Internal server error\"}"){  
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak_ai%2Fcall_home%2F"+verurl+"-resetFail-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK_AI%2Fv"+ver+".resetFail."+email_address+"%3B&utmu=DC~";
			silent=File.openUrlAsString(call_home_url);
			wait(20);
			forgotMessage="Sorry, that email address was not associated with a Pipsqueak account or your license has expired.";
			ps_forgot(forgotMessage);
		}
		if(iForgotWhyAnythingMatters=="Check your email for a reset code"){  
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak_ai%2Fcall_home%2F"+verurl+"-resetSeccess-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK_AI%2Fv"+ver+".resetSeccess."+email_address+"%3B&utmu=DC~";
			silent=File.openUrlAsString(call_home_url);
			wait(20);
			resetMessage="If this email is associated with a Pipsqueak AI account, it has been sent an email containing a verification code. \nUse the verification code to create a new password here.";
			ps_reset(resetMessage);
		}else{ //forg_001
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak_ai%2Fcall_home%2F"+verurl+"-APIresetFail-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK_AI%2Fv"+ver+".APIresetFail."+email_address+"%3B&utmu=DC~";
			silent=File.openUrlAsString(call_home_url);
			wait(20);
			loginMessage="We ran into an error while trying to reset your password. Please try again. \n\nIf you continue to have this problem, please contact support@RewireNeuro.com \nError message #forg_001";
			ps_rgch(loginMessage);
		}
	}else{
		call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak_ai%2Fcall_home%2F"+verurl+"-APIresetFail-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK_AI%2Fv"+ver+".APIresetFail."+email_address+"%3B&utmu=DC~";
		silent=File.openUrlAsString(call_home_url);
		wait(20);
		resetMessage="If this email is associated with a Pipsqueak AI account, it has been sent an email containing a verification code. \nUse the verification code to create a new password here.";
		ps_reset(resetMessage);
	}
}
///////////////////////////
function ps_reset(resetMessage){	
	verificationNumber="";
	user_password_check="";
			
	Dialog.create("Choose a new password");
	Dialog.addMessage("Please create a new password for your acocunt.");
	Dialog.addMessage(" ");
	Dialog.addString("Email address:", email_address, 25);
	Dialog.addNumber("Verification code:", verificationNumber);
	Dialog.addString("Password:", user_password, 25);
	Dialog.addString("Enter password again:", user_password_check, 25);
	Dialog.addMessage(" ");
	Dialog.addMessage(" ");
	Dialog.addMessage(resetMessage);
	Dialog.addMessage(" ");
			
	Dialog.show;
	email_address = Dialog.getString();
	verificationNumber = Dialog.getNumber();;
	user_password = Dialog.getString();;
	user_password_check = Dialog.getString();;;

	if(user_password!=user_password_check){
		resetMessage="Your passwords didn't match. Please try again.";
		user_password="";
		user_password_check="";
		ps_reset(resetMessage);
	}
			
	if(lengthOf(user_password)<6){
		resetMessage="Your passwords didn't match. Please try again.";
		user_password="";
		user_password_check="";
		ps_reset(resetMessage);
	}

	needAReset=exec(AI_Engine_exec, "reset", email_address, user_password, verificationNumber);
	
	user_password="";
	user_password_check="";

	if(needAReset!=""){ 
		TewntyTwentyIsTheWorst=split(needAReset,"\n");
		fuckDonaldTrump=TewntyTwentyIsTheWorst[0];
						
		if(fuckDonaldTrump=="Password for user "+email_address+" reset. Please login"){ //ok1003020
			loginMessage="Password reset successful. Please make note of your username and password, and then login.";
			ps_rgch(loginMessage);
		}
		//"Error (Reset): Failed to reset password"
		if(fuckDonaldTrump=="Error (Reset): Failed to reset password"){ //ok1003020
			resetMessage="Check your verification code and try again.";
			ps_reset(resetMessage);
	
		}else{ //rese_001
			forgotMessage="We ran into an error while trying to reset your password. Please try again. \n\nIf you continue to have this problem, please contact support@RewireNeuro.com \nError message #rese_001";
			ps_forgot(forgotMessage);
		}
	}else{ //rese_002
		forgotMessage="We ran into an error while trying to reset your password. Please try again. \n\nIf you continue to have this problem, please contact support@RewireNeuro.com \nError message #rese_002";
		ps_forgot(forgotMessage);
	}
}
				
///////////////////////////	
function updatePipsqueak(){		
	saveParameters();

	checkEngine=exec(AI_Engine_exec, "--version");
	os=getInfo("os.name");	
	fijiDir=getDirectory("imagej");
	if(os!=""){
		osCheckArray=split(os," ");
		osCheck=osCheckArray[0];
	}	
	if(checkEngine!=""){
		checkEnginePosition=split(checkEngine,"\n");
		checkEngineLight1=checkEnginePosition[0];
		if(osCheck=="Windows" && checkEngineLight1=="usage: upload.py [-h]"){
			
			File.delete(AI_Engine_exec);
			exec("powershell", "-command", "Expand-Archive", "-Force", fijiDir+"plugins"+_sep_+"Scripts"+_sep_+"Pipsqueak"+_sep_+"versions"+_sep_+"pipsqueak_windows_v"+ver+".zip", fijiDir+"plugins"+_sep_+"Scripts");
			waitForUser("Pipsqueak made an additional update. This should happen only once. \nPlease restart Fiji and open Pipsqueak.");
			exit;
		}
	}
	if(osCheck=="Windows" && checkEngine==""){
			
		File.delete(AI_Engine_exec);
		exec("powershell", "-command", "Expand-Archive", "-Force", fijiDir+"plugins"+_sep_+"Scripts"+_sep_+"Pipsqueak"+_sep_+"versions"+_sep_+"pipsqueak_windows_v"+ver+".zip", fijiDir+"plugins"+_sep_+"Scripts");
		waitForUser("Pipsqueak made an additional update. This should happen only once. \nPlease restart Fiji and open Pipsqueak.");
		exit;
	}
	
	versionCheck=exec(AI_Engine_exec, "update", "--check");
	//print("versioncheck="+versionCheck);
	if(versionCheck!=""){
		updateAvailable="";
		versionCheckPosition=split(versionCheck,"\n");
		//Array.print(versionCheckPosition);
		//waitForUser;
		
		if(versionCheckPosition.length>1){
			//print("Version check longer than a line");
			versionLine1=versionCheckPosition[1];			
			updateError=split(versionLine1,":");
			updateResult=updateError[0]; // the point of this script is to determine what line 2 of the return says, and set that value as "licenseResult"
		}else{
			updateResult="No Error";
			//print("no error");
		}
		//waitForUser(updateResult);
		//print("updateResult="+updateResult);
		
		if(versionCheckPosition.length>2){
			updateOffline=versionCheckPosition[2];
			//print("updateOffline="+updateOffline);
			if(updateOffline=="Error (Update): Could not read remote data"){	// ok 100620
				waitForUser("Error (Update): Could not read remote data. Please make sure your computer is connected to the internet.");
				loginMessage="Error (Update): Could not read remote data";
				ps_rgch(loginMessage);
			}
		}
		
		if(versionCheckPosition.length>3){
			updateAvailable=versionCheckPosition[3];
			//print("updateAvailable="+updateAvailable);
			updateVersions=versionCheckPosition[4];
			//print("updateVersions="+updateVersions);
		}		
		
		if(updateResult=="Error (Update)"){	// ok 100320
			waitForUser("Pipsqueak AI could not find the necessary files for update. Please check your installation location. \nIf installed outside of FIJI, please reinstall Pipsqueak in FIJI/ImageJ, or Pipsqueak may not run correctly.");
			loginMessage="Pipsqueak AI could not find the necessary files for update. Please check your installation location. \nIf installed outside of FIJI, please reinstall Pipsqueak in FIJI/ImageJ, or Pipsqueak may not run correctly.";
			//print("error");
			ps_rgch(loginMessage);
			
			//"Error (Update): Could not read local data", "Error (Update): Could not read remote data", "Error (Update): OS Error creating resource (Is Fiji installed in a non-user directory?)", "Error (Update): OS Error reading resource (Is Fiji installed in a non-user directory?)" 
		}
		//"Error (Update): Could not read remote data"
		
		else{	// ok 100320			
			if(updateAvailable=="Major Update"){
				//print("available");
				Dialog.create("Update Available");
				Dialog.addMessage("\n");
				Dialog.addMessage(updateVersions);
				Dialog.addMessage("\n");
				radio1 = newArray("Yes, update now", "Remind me later");
				Dialog.addRadioButtonGroup("There is a Major update available for Pipsqueak AI. \n Would you like to update?", radio1, 2, 1, "Yes, update now");
				Dialog.show;
				updateChoice = Dialog.getRadioButton;

				if(updateChoice=="Yes, update now"){
					//silent=
					exec(AI_Engine_exec, "update");
					waitForUser("Pipsqueak AI has been updated. Please restart FIJI");
					exit;
				}else{
					loginMessage="Update delayed";
					ps_rgch(loginMessage);
				}
			}
			if(updateAvailable=="Minor Update"){
				//print("available");
				Dialog.create("Update Available");
				Dialog.addMessage("\n");
				Dialog.addMessage(updateVersions);
				Dialog.addMessage("\n");
				radio1 = newArray("Yes, update now", "Remind me later");
				Dialog.addRadioButtonGroup("There is a Minor update available for Pipsqueak AI. \n Would you like to update?", radio1, 2, 1, "Yes, update now");
				Dialog.show;
				updateChoice = Dialog.getRadioButton;

				if(updateChoice=="Yes, update now"){
					//silent=	
					exec(AI_Engine_exec, "update");
					waitForUser("Pipsqueak AI has been updated. Please restart FIJI");
					exit;
				}else{
					loginMessage="Update delayed";
					ps_rgch(loginMessage);
				}
			}
			if(updateAvailable=="Patch Update"){
				//print("available");
				Dialog.create("Update Available");
				Dialog.addMessage("\n");
				Dialog.addMessage(updateVersions);
				Dialog.addMessage("\n");
				radio1 = newArray("Yes, update now", "Remind me later");
				Dialog.addRadioButtonGroup("There is a Bug Patch available for Pipsqueak AI. \n Would you like to update?", radio1, 2, 1, "Yes, update now");
				Dialog.show;
				updateChoice = Dialog.getRadioButton;

				if(updateChoice=="Yes, update now"){
					//silent=
					exec(AI_Engine_exec, "update");
					waitForUser("Pipsqueak AI has been updated. Please restart FIJI");
					exit;
				}else{
					loginMessage="Update delayed";
					ps_rgch(loginMessage);
				}
			}	
			if(updateAvailable=="No Update"){
				loginMessage="Pipsqueak AI is up-to-date";
				ps_rgch(loginMessage);
				//print("no update");
				
			}else{ //upda_001
				loginMessage="Pipsqueak's Updater failed to run correctly. \nPlease check your internet connection, restart FIJI, or reinstall Pipsqueak AI. \n\nIf you continue to have this problem, please contact support@RewireNeuro.com \nError message #upda_001";
				ps_rgch(loginMessage);
			}
		}
	}else{ //upda_002
		loginMessage="Pipsqueak's Updater failed to run correctly. \nPlease check your internet connection, restart FIJI, or reinstall Pipsqueak AI. \n\nIf you continue to have this problem, please contact support@RewireNeuro.com \nError message #upda_002";
		ps_rgch(loginMessage);	
	}
}

///////////////////////////
function initi(){
	saveParameters();
	
	getDateAndTime(year, month, dayOfWeek, dayOfMonth, hour, minute, second, msec);
	TimeString ="_"+month+1+"_"+dayOfMonth+"_"+year+"_at_"+hour+"-"+minute;
	EngineVerCheck=exec(AI_Engine_exec, "--version");
	EngineVer="unknown";
	if(EngineVerCheck!=""){
		EngineVerCheckPos=split(EngineVerCheck," ");
		EngineVer=EngineVerCheckPos[1];
	}
	
	if (pipsqueakCount==1){

		///call home tracking URL
		//UPDATE HERE (1/4 and 2/4)->

		call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak_ai%2Fcall_home%2F"+verurl+"%2F"+os+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK_AI%2Fv"+ver+"%2F"+os+"%3B&utmu=DC~";
		silent=File.openUrlAsString(call_home_url);
		wait(20);
	
		print("Pipsqueak AI (TM)");
		print("\n"+"Copyright (C) "+year+", Rewire Neuro (TM).");
		version=getVersion;
		print("FIJI version "+version);
		print("Pipsqueak AI version "+ver+", released: "+releaseDate);
		Table.setLocationAndSize((screenWidth/5)*4, (screenHeight/10)*1, screenWidth/5, (screenHeight/10)*9, "Log");
		
		pipsqueakCount = pipsqueakCount+1;

	} else {
		wait(10);
	}
	
	print("\nBackground Setting: "+background_setting);
	print("Distance in pixels: "+scale_size+"\n"+"Unit of length: "+scale_unit);
	print("Date on saved files will be '"+TimeString+"'\n \n");
	
	windowList = getList("image.titles");
  	if (windowList.length!=0){
  		waitForUser("Image windows are open. Make sure you close any images you are about to analyze with Pipsqueak.");
   	}

// START OF MAIN DIALOG CREATION

	//lic=0; // FOR TESTING BASIC LICENSE MENU
	if(lic==1){ // AI ENABLED LICENSE
		run("Pipsqueak");
		wait(500);
		choice0=call("PipsqueakMainCommand.getStatus");
		while (choice0 == "not done") {
			wait(500);
			choice0=call("PipsqueakMainCommand.getStatus");
		}
		/*
		Dialog.create("Pipsqueak AI Main Menu");		// 	old menu stuff
		Dialog.addMessage("Pipsqueak AI version: "+ver+", Released: "+releaseDate+"\nAI Engine version: "+EngineVer);
		Dialog.addMessage("\nAI-enabling license is active.");
		Dialog.addMessage("");
		
		items0 = newArray("Single label analysis", "->Settings", "Double label analysis", "Contact Us and/or Report a bug", "Triple label analysis", "Logout of Pipsqueak AI account");
		Dialog.addRadioButtonGroup("What would you like to do?", items0, 4, 2, " ");
		*/
		
	}else{ // BASIC LICENSE
		Dialog.create("Pipsqueak Basic Main Menu");
		Dialog.addMessage("Pipsqueak AI version: "+ver+", Released: "+releaseDate);
		Dialog.addMessage("\nAI-enabling license has expired. Pipsqueak will run in basic mode. ");
		Dialog.addMessage("");
	
		items0 = newArray("Single label analysis", "Get access to AI-enabled cell detection", "Double label analysis", "Contact Us and/or Report a bug", "Triple label analysis", "Logout of Pipsqueak AI account", "->Settings");
		Dialog.addRadioButtonGroup("What would you like to do?", items0, 4, 2, " ");
		
		Dialog.show;
		choice0 = Dialog.getRadioButton;
	}	

	if(choice0=="Get access to AI-enabled cell detection"){
		//exec("open", "https://rewireneuro.com/product-category/pipsqueak/");
		////waitForUser("Licenses to Pipsqueak AI are available for as little as $20, so that you can get the data you need, when you need them.");
		//switchMessage="";
		//ps_switchLic(switchMessage);
		lic = 0; 
		waitForUser("Switch License", "Your Pipsqueak AI license(s) can be managed, switched, and added \nfrom https://my.pipsqueak.ai We're taking you there now. \n \nWhen you return, your new license will be active upon login.");
		exec("open", "https://my.pipsqueak.ai");
		res=call("PipsqueakLoginCommand.logoutUser");
		loginMessage = "";
		ps_rgch(loginMessage);
	}
//lic == 0 &&
	if ( choice0 =="Logout of Pipsqueak AI account") {
		silent=exec(AI_Engine_exec, "logout");
		loginMessage="";
		ps_rgch(loginMessage);
	}

	if (choice0 =="Create custom model") {
		custom_initi();
	}

	if (choice0 =="Single label analysis") {

		call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-single-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".single."+email_address+"%3B&utmu=DC~";
		silent=File.openUrlAsString(call_home_url);
		wait(20);
		//print("\\Clear");

		saveParameters();
		ps_single();
	}

	if (choice0 =="Double label analysis") {

		///call home tracking URL
		//UPDATE HERE (1/4 and 2/4)->

		//print("MACRO: Double label analysis");
		call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-double-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".double."+email_address+"%3B&utmu=DC~";
		silent=File.openUrlAsString(call_home_url);
		wait(20);
		//print("\\Clear");

		saveParameters();
		ps_double();
	}

	if (choice0=="Triple label analysis") {

		///call home tracking URL
		//UPDATE HERE (1/4 and 2/4)->

		//print("MACRO: Triple label analysis");
		call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-triple-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".triple."+email_address+"%3B&utmu=DC~";
		silent= File.openUrlAsString(call_home_url);
		wait(20);
		//print("\\Clear");
		saveParameters();
		ps_triple();
	}

	if (choice0 =="Contact Us and/or Report a bug") {
		exec("open", "mailto: support@rewireneuro.com");
		waitForUser("Thanks! Please log bugs as best you can (screen shot, description, etc) and send to support@rewireneuro.com \n For questions or help, please use the same email address.");
		saveParameters();
		//initi();
	}

	if (choice0 =="->Settings") {
		//print("MARCO: Settings");
		settings();
		//initi();
	}
	
	initi();
	
}
///////////////////////////////////////

function settings(){
		Dialog.createNonBlocking("Settings Menu");
		items1 = newArray("AI settings", "Image dimensions, scale, and z-steps settings", "Background calculations", "Single label analysis settings", "Double label analysis settings", "Triple label analysis settings", "Purge saved settings");
		Dialog.addRadioButtonGroup("What would you like to do?", items1, 7, 1, " ");

		Dialog.show;

		choice1 = Dialog.getRadioButton;
	//next window
		if (choice1 =="Purge saved settings") {
			Dialog.createNonBlocking("Reset Pipsqueak configuration?");
			Dialog.addMessage("If you are experiencing errors running Pipsqueak, you may want to try purging your settings file.");
			Dialog.addMessage("While this may help reset Pipsqueak analysis functions, it will NOT erase your Pipsqueak account or your Pipsqueak license.");
			Dialog.addMessage(" ");
			Dialog.addString("Do you want to erase your Pipsqueak configurations?", "Please type the word Yes or No", 27);
			Dialog.show;
			startThePurge = Dialog.getString();

			if(startThePurge=="Yes" || startThePurge=="yes"){
				//	load(rocket suits);
				//	neutralize(Morty);
				//	eat(the rich);
				if(File.exists(pipDir+"Pipsqueak_config_v"+ver+".txt")==1) File.delete(pipDir+"Pipsqueak_config_v"+ver+".txt");
				otherConfigs = getFileList(pipDir);
				for(i=0; i<otherConfigs.length; i++){
					config = otherConfigs[i];
					print(config);
					index = lastIndexOf(config, "Pipsqueak_config");
					if (index!=-1) File.delete(pipDir+config);
				}
			waitForUser("Settings reset. Please restart ImageJ, or your old settings will return.");
			exit;
			
			//	play(it feels good);
			//	if(purge=="ended") tellBeth=="Don't";
			}else{
				waitForUser("Settings were not purged");
			}
		}
	
		if (choice1 =="Image dimensions, scale, and z-steps settings") {
			Dialog.createNonBlocking("Image dimensions, scale, and z-steps settings");
			Dialog.addMessage("**Image scale measurements (for both SINGLE, DOUBLE, and TRIPLE label analysis)**");
			Dialog.addNumber("Number of z-steps to be summed:", zsteps);
			Dialog.addMessage(" ");
			Dialog.addNumber("Distance in pixels:", scale_size);
			Dialog.addNumber("Known distance:", scale_known);
			Dialog.addNumber("Pixel aspect ratio:", scale_pixel);
			Dialog.addString("Unit of length:", scale_unit);

			Dialog.show;

			zsteps = Dialog.getNumber();
			scale_size = Dialog.getNumber();;
			scale_known = Dialog.getNumber();;;
			scale_pixel = Dialog.getNumber();;;;
			scale_unit = Dialog.getString();
		}
	//next window
		ML_thresh_display=50-ML_thresh;
		
		if (choice1 =="AI settings") {
			if(subsectioning==1) subsectioning_choice="Off";
			if(subsectioning==2) subsectioning_choice="2x2";
			if(subsectioning==3) subsectioning_choice="3x3";
			if(subsectioning==4) subsectioning_choice="4x4";
			if(subsectioning==5) subsectioning_choice="5x5";
			if(subsectioning==6) subsectioning_choice="6x6";
			
			Dialog.createNonBlocking("AI settings");
			Dialog.addMessage("Adjustments will alter cell determination and MAY reduce identification specificity.");
			Dialog.addMessage("Proceed with caution: here be dragons.");
			Dialog.addMessage(" ");
			Dialog.addSlider("Detection Sensitivity:", 1, 50, ML_thresh_display);
			Dialog.addSlider("Threshold for Removal of Overlapping ROIs (% Area):", 0.0, 100, dup_thresh);
			//Dialog.addChoice("AI Model:", newArray("8-oxo", "c-Fos", "DAPI", "Parvalbumin", "WFA", "Train new detection model"), model);
			Dialog.addChoice("AI Model:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"), model);
			Dialog.addMessage("\n \nAI detection speed can be improved by temporarily reducing the image file size. While this may change the shape or number of the ROIs returned, intensity quantification will not change. \n(i.e., pixel values will remain the same, but ROI shape may vary between methods. Default is \"Accuracy.\")");
			items = newArray("Speed", "Accuracy");
			Dialog.addRadioButtonGroup("AI detection preference:", items, 1, 2, reduceSize);
			Dialog.addMessage("\n \n(Experimental setting:) Detection accuracy within large or \"tiled\" images can be improved by processing the image in smaller subsections.\nThis may reduce analysis speed, but return better detection across large regions of an image. Higher settings should be used for larger images.");
			Dialog.addChoice("Large image subsectioning:", newArray("Off", "2x2", "3x3", "4x4", "5x5", "6x6"), subsectioning_choice);

			Dialog.show;

			ML_thresh_display = Dialog.getNumber();
			dup_thresh = Dialog.getNumber();
			model = Dialog.getChoice();
			ML_thresh=50-ML_thresh_display;
			reduceSize = Dialog.getRadioButton;
			subsectioning_choice = Dialog.getChoice();
			if(subsectioning_choice=="Off") subsectioning=1;
			if(subsectioning_choice=="2x2") subsectioning=2;
			if(subsectioning_choice=="3x3") subsectioning=3;
			if(subsectioning_choice=="4x4") subsectioning=4;
			if(subsectioning_choice=="5x5") subsectioning=5;
			if(subsectioning_choice=="6x6") subsectioning=6;
			
		}

		if (choice1 =="Background calculations") {
					
			Dialog.createNonBlocking("Background settings");
			Dialog.addMessage("Adjustments to these settings WILL alter cell and pixel measurements. \n \nThe multi-faceted background subtraction in Pipsqueak is designed to be highly customizable as many different methods to capture images are used, \nallowing diverse results from lab to lab. Our automatic background subtraction algorithm combines the rolling ball algorithm, built in to ImageJ, with \ncustom thresholding. We offer both automatic and manual selection for background sampling. If automatic background sampling is selected, our \nalgorithm places 22 square ROIs around the perimeter of the image, distributed uniformly. If manual sampling is selected, the user places their own \nROIs for background sampling. It is recommended that at least 5 ROIs are placed, but the algorithm will still perform if less are selected."); 
			Dialog.addMessage("After background sample ROI’s are selected, the rolling ball algorithm settings are finalized and the rolling ball smoothing is performed across the entire \nimage. The ball’s radius is set to 50 pixels by default, but it is highly recommended that the user changes this to be around 1.15-1.25 times the \naverage size of the object of interest, in pixels for best results.");
			Dialog.addMessage("After smoothing is performed, the user’s selection of “high” or “low” background subtraction determines the thresholding method performed on the \nimage. If the user selects “high” background subtraction, we discard the brightest 33% and dimmest 33% ROI from the background ROI set, whereas if \nthe user selects “low” the brightest 77% of ROIs will discarded. Regardless of user selection, we then calculate the mean pixel intensity and standard \ndeviation across the ROIs selected for background sampling. These values are then used to set all pixels in the image dimmer than the \ncalculated mean + two standard deviations to not a number (NaN), so the suppressed background pixels do not interfere with measured cell intensity \nvalues.");
			Dialog.addMessage("\nProceed with caution: here be dragons.");
			Dialog.addMessage(" ");
			Dialog.addMessage("Rolling-ball background correction. Learn more here: https://imagej.net/Image_Intensity_Processing");
			rollingball_items = newArray("On", "Off");
			Dialog.setInsets(0, 20, 0);
			Dialog.addChoice("Rolling-ball background corrention:", rollingball_items, rollingball_io);
			Dialog.setInsets(0, 20, 0);
			Dialog.addNumber("Rolling-ball radius (pixels):", rollingball);
			Dialog.addMessage("High background subtraction: Removes more background, but may also remove lightly stained cells. \nLow background subtraction: Removes less background. More sensitive for lightly stained cells.");
			items2 = newArray("High", "Low");
			Dialog.setInsets(0, 20, 0);
			Dialog.addRadioButtonGroup("Which background subtraction setting would you like to use?", items2, 2, 1, background_setting);
			
			Dialog.show;
			rollingball_io = Dialog.getChoice();
			rollingball = Dialog.getNumber();
		
			choice2 = Dialog.getRadioButton;

			
			if (choice2 =="High") {
				background_setting = "High";
			}

			if (choice2 =="Low") {
				background_setting = "Low";
			}
		}
		
	//next window	
		//if (ROI_type_SL == "freehand"){
			//choice3 ="As-detected";
		//}
		if (ROI_type_SL == "rectangle") {
			choice3 ="Rectangle";
		}
		if (ROI_type_SL == "oval") {
			choice3 ="Oval";
		}

		if (choice1 =="Single label analysis settings") {
			SL_stain_type=model;
			Dialog.createNonBlocking("Single-label Intensity Analysis Settings");
			Dialog.addMessage("Adjustments will alter cell determination and MAY reduce identification specificity.");
			Dialog.addMessage("Proceed with caution: here be dragons.");
			Dialog.addMessage(" ");
			//Dialog.addString("Stain:", SL_stain_type, 15);
			Dialog.addChoice("Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"),  SL_stain_type);
			Dialog.addNumber("Image name suffix (if applicable):", SL_suffix_flo);
			Dialog.addNumber("Lower threshold multiplier:",set_intensity_low_threshold);
			Dialog.addNumber("Upper threshold limit:", set_intensity_high_threshold);
			Dialog.addNumber("Lower limit particle size:", set_low_particlesize);
			Dialog.addNumber("Upper limit particle size:", set_high_particlesize);
			Dialog.addNumber("Lower limit circularity:", set_low_circularity);
			Dialog.addNumber("Upper limit circularity:", set_high_circularity);
			Dialog.addNumber("ROI Enlargement (pixels):", set_roi_enlargement_single);
			items3 = newArray("Rectangle", "Oval");
			Dialog.addRadioButtonGroup("Shape of ROIs:", items3, 2, 1, choice3);

			Dialog.show;

			SL_stain_type=Dialog.getChoice();
			SL_suffix_flo = Dialog.getNumber();;
			set_intensity_low_threshold = Dialog.getNumber();;;
			set_intensity_high_threshold = Dialog.getNumber();;;;
			set_low_particlesize = Dialog.getNumber();;;;;
			set_high_particlesize = Dialog.getNumber();;;;;;
			set_low_circularity = Dialog.getNumber();;;;;;;
			set_high_circularity = Dialog.getNumber();;;;;;;;
			set_roi_enlargement_single = Dialog.getNumber();;;;;;;;;

			choice3 = Dialog.getRadioButton;
		//	if (choice3 =="As-detected") {
			//	ROI_type_SL = "freehand";
			//}
			if (choice3 =="Rectangle") {
				ROI_type_SL = "rectangle";
			}
			if (choice3 =="Oval") {
				ROI_type_SL = "oval";
			}
			
			if(SL_suffix_flo>=0) SL_suffix="_"+SL_suffix_flo;	
			suffix=SL_suffix;
			model=SL_stain_type;
			ROI_shape=ROI_type_SL;
			ROI_enlargement=set_roi_enlargement_single;
		}

//next window
		//if (ROI_type_DL1 == "freehand"){
		//	choice4 ="As-detected";
		//}
		if (ROI_type_DL1 == "rectangle") {
			choice4 ="Rectangle";
		}
		if (ROI_type_DL1 == "oval") {
			choice4 = "Oval";
		}
		if (choice1 =="Double label analysis settings") {
			Dialog.createNonBlocking("Double-label Intensity Analysis Settings");
			Dialog.addMessage("**Window 1 of 2**");
			Dialog.addMessage(" ");
			Dialog.addMessage("Please enter the numbering suffixes of the image series you want to analyze in the space below.");
			Dialog.addMessage("eg: Exp42_SubA_example_1.tif and Exp42_SubA_example_3.tif = #1 and #3");
			Dialog.addMessage(" ");
			Dialog.addNumber("First image (if possible, smaller volume stain):", first_suffix_flo);
			Dialog.addNumber("Second image (if possible, larger volume stain):", second_suffix_flo);
			Dialog.addNumber("Merged image:", merged_suffix_flo);
			Dialog.addMessage(" ");
			Dialog.addMessage("*First stain parameters*");
			//Dialog.addString("Stain type:", first_stain_type, 15);
			Dialog.addChoice("Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"),  first_stain_type);
			Dialog.addNumber("Lower threshold multiplier:", DL1_set_intensity_low_threshold);
			Dialog.addNumber("Upper threshold limit:", DL1_set_intensity_high_threshold);
			Dialog.addNumber("Lower limit particle size:", DL1_set_low_particlesize);
			Dialog.addNumber("Upper limit particle size:", DL1_set_high_particlesize);
			Dialog.addNumber("Lower limit circularity:", DL1_set_low_circularity);
			Dialog.addNumber("Upper limit circularity:", DL1_set_high_circularity);
			Dialog.addNumber("ROI Enlargement (pixels):", DL1_set_roi_enlargement);
			Dialog.addNumber("Min overlap % to be considered double-labeled (% as decimal):", DL1_overlap);
			items4 = newArray("Rectangle", "Oval");
			Dialog.addRadioButtonGroup("Shape of ROIs:", items4, 2, 1, choice4);

			Dialog.show;

			first_suffix_flo = Dialog.getNumber();
			second_suffix_flo = Dialog.getNumber();;
			merged_suffix_flo = Dialog.getNumber();;;
			//total_images = Dialog.getNumber();;;;
			first_stain_type =  Dialog.getChoice();
			DL1_set_intensity_low_threshold = Dialog.getNumber();;
			DL1_set_intensity_high_threshold = Dialog.getNumber();;;
			DL1_set_low_particlesize = Dialog.getNumber();;;;
			DL1_set_high_particlesize = Dialog.getNumber();;;;;
			DL1_set_low_circularity = Dialog.getNumber();;;;;;
			DL1_set_high_circularity = Dialog.getNumber();;;;;;;
			DL1_set_roi_enlargement = Dialog.getNumber();;;;;;;;
			DL1_overlap = Dialog.getNumber();;;;;;;;;
			choice4 = Dialog.getRadioButton;
			
			//if (choice4 =="As-detected") {
			//	ROI_type_DL1 = "freehand";
			//}
			if (choice4 =="Rectangle") {
				ROI_type_DL1 = "rectangle";
			}
			if (choice4 =="Oval") {
				ROI_type_DL1 = "oval";
			}

	//next window
			//if (ROI_type_DL2 == "freehand"){
			//	choice5 = "As-detected";
			//}
			if (ROI_type_DL2 == "rectangle") {
				choice5 = "Rectangle";
			}
			if (ROI_type_DL2 == "oval") {
				choice5 ="Oval";
			}
		
			Dialog.createNonBlocking("Double-label Intensity Analysis Settings");
			Dialog.addMessage("**Window 2 of 2**");
			Dialog.addMessage(" ");
			Dialog.addMessage("*Second stain parameters*");
			//Dialog.addString("Stain type:", second_stain_type, 15);
			Dialog.addChoice("Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"),  second_stain_type);
			Dialog.addNumber("Lower threshold multiplier:", DL2_set_intensity_low_threshold);
			Dialog.addNumber("Upper threshold limit:", DL2_set_intensity_high_threshold);
			Dialog.addNumber("Lower limit particle size:", DL2_set_low_particlesize);
			Dialog.addNumber("Upper limit particle size:", DL2_set_high_particlesize);
			Dialog.addNumber("Lower limit circularity:",  DL2_set_low_circularity);
			Dialog.addNumber("Upper limit circularity:", DL2_set_high_circularity);
			Dialog.addNumber("ROI Enlargement (pixels):", DL2_set_roi_enlargement);
			Dialog.addNumber("Min overlap % to be considered double-labeled (% as decimal):", DL2_overlap);
			items5 = newArray("Rectangle", "Oval");
			Dialog.addRadioButtonGroup("Shape of ROIs:", items5, 2, 1, choice5);

			Dialog.show;

			second_stain_type =  Dialog.getChoice();
			DL2_set_intensity_low_threshold = Dialog.getNumber();;
			DL2_set_intensity_high_threshold = Dialog.getNumber();;;
			DL2_set_low_particlesize = Dialog.getNumber();;;;
			DL2_set_high_particlesize = Dialog.getNumber();;;;;
			DL2_set_low_circularity = Dialog.getNumber();;;;;;
			DL2_set_high_circularity = Dialog.getNumber();;;;;;;
			DL2_set_roi_enlargement = Dialog.getNumber();;;;;;;;
			DL2_overlap = Dialog.getNumber();;;;;;;;;
			choice5 = Dialog.getRadioButton;
			
			//if (choice5 =="As-detected") {
			//	ROI_type_DL2 = "freehand";
			//}
			if (choice5 =="Rectangle") {
				ROI_type_DL2 = "rectangle";
			}
			if (choice5 =="Oval") {
				ROI_type_DL2 = "oval";
			}

			//=============================================================================================
		}	

	//next window
		//if (ROI_type_TL1 == "freehand"){
		//	choice6 = "As-detected";
		//}
		if (ROI_type_TL1 == "rectangle") {
			choice6 = "Rectangle";
		}
		if (ROI_type_TL1 == "oval") {
			choice6 = "Oval";
		}
		
		if (choice1 == "Triple label analysis settings") {
			Dialog.createNonBlocking(" Triple-label Intensity Analysis Settings");
			Dialog.addMessage("**Window 1 of 3**");
			Dialog.addMessage(" ");
			Dialog.addMessage("Please enter the numbering suffixes of the image series you want to analyze in the space below.");
			Dialog.addMessage("eg: Exp42_SubA_example_1.tif and Exp42_SubA_example_3.tif = #1 and #3");
			Dialog.addMessage(" ");
			Dialog.addNumber("First image (if possible, smaller volume stain):", first_suffix_TL_flo);
			Dialog.addNumber("Second image (if possible, larger volume stain):", second_suffix_TL_flo);
			Dialog.addNumber("Third image (if possible, smaller volume stain):", third_suffix_TL_flo);
			Dialog.addNumber("Merged image:", merged_suffix_TL_flo);
			//Dialog.addNumber("Total number of stains plus composite in each subject series:", total_images);
			//REMOVED FOR NOW SEE NOTE IN "_ps_OPENNEXT_DOUBLE".
			Dialog.addMessage(" ");
			Dialog.addMessage("*First stain parameters*");
			//Dialog.addString("Stain type:", first_stain_type_TL, 15);
			Dialog.addChoice("Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"),  first_stain_type_TL);
			Dialog.addNumber("Lower threshold multiplier:", TL1_set_intensity_low_threshold);
			Dialog.addNumber("Upper threshold limit:", TL1_set_intensity_high_threshold);
			Dialog.addNumber("Lower limit particle size:", TL1_set_low_particlesize);
			Dialog.addNumber("Upper limit particle size:", TL1_set_high_particlesize);
			Dialog.addNumber("Lower limit circularity:", TL1_set_low_circularity);
			Dialog.addNumber("Upper limit circularity:", TL1_set_high_circularity);
			Dialog.addNumber("ROI Enlargement (pixels):", TL1_set_roi_enlargement);
			Dialog.addNumber("Min overlap % to be considered double-labeled (% as decimal):", TL1_overlap);
			items6 = newArray("Rectangle", "Oval");
			Dialog.addRadioButtonGroup("Shape of ROIs:", items6, 2, 1, choice6);

			Dialog.show

			first_suffix_TL_flo = Dialog.getNumber();
			second_suffix_TL_flo = Dialog.getNumber();;
			third_suffix_TL_flo = Dialog.getNumber();;;
			merged_suffix_TL_flo = Dialog.getNumber();;;;
			//total_images = Dialog.getNumber();;;;;
			first_stain_type_TL =  Dialog.getChoice();
			TL1_set_intensity_low_threshold = Dialog.getNumber();;
			TL1_set_intensity_high_threshold = Dialog.getNumber();;;
			TL1_set_low_particlesize = Dialog.getNumber();;;;
			TL1_set_high_particlesize = Dialog.getNumber();;;;;
			TL1_set_low_circularity = Dialog.getNumber();;;;;;
			TL1_set_high_circularity = Dialog.getNumber();;;;;;;
			TL1_set_roi_enlargement = Dialog.getNumber();;;;;;;;
			TL1_overlap = Dialog.getNumber();;;;;;;;;
			choice6 = Dialog.getRadioButton;
		
			//if (choice6 =="As-detected") {
			//	ROI_type_TL1 = "freehand";
			//}
			if (choice6 =="Rectangle") {
				ROI_type_TL1 = "rectangle";
			}
			if (choice6 =="Oval") {
				ROI_type_TL1 = "oval";
			}
		
	//next window
			//if (ROI_type_TL2 == "freehand"){
			//	choice7 = "As-detected";
			//}
			if (ROI_type_TL2 == "rectangle") {
				choice7 = "Rectangle";
			}
			if (ROI_type_TL2 == "oval") {
				choice7 = "Oval";
			}
		
			Dialog.createNonBlocking(" Triple-label Intensity Analysis Settings");
			Dialog.addMessage("**Window 2 of 3**");
			Dialog.addMessage(" ");
			Dialog.addMessage("*Second stain parameters*");
			//Dialog.addString("Stain type:", second_stain_type_TL, 15);
			Dialog.addChoice("Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"),  second_stain_type_TL);
			Dialog.addNumber("Lower threshold multiplier:", TL2_set_intensity_low_threshold);
			Dialog.addNumber("Upper threshold limit:", TL2_set_intensity_high_threshold);
			Dialog.addNumber("Lower limit particle size:", TL2_set_low_particlesize);
			Dialog.addNumber("Upper limit particle size:", TL2_set_high_particlesize);
			Dialog.addNumber("Lower limit circularity:",  TL2_set_low_circularity);
			Dialog.addNumber("Upper limit circularity:", TL2_set_high_circularity);
			Dialog.addNumber("ROI Enlargement (pixels):", TL2_set_roi_enlargement);
			Dialog.addNumber("Min overlap % to be considered double-labeled (% as decimal):", TL2_overlap);
			items7 = newArray("Rectangle", "Oval");
			Dialog.addRadioButtonGroup("Shape of ROIs:", items7, 2, 1, choice7);

			Dialog.show;

			second_stain_type_TL =  Dialog.getChoice();
			TL2_set_intensity_low_threshold = Dialog.getNumber();;
			TL2_set_intensity_high_threshold = Dialog.getNumber();;;
			TL2_set_low_particlesize = Dialog.getNumber();;;;
			TL2_set_high_particlesize = Dialog.getNumber();;;;;
			TL2_set_low_circularity = Dialog.getNumber();;;;;;
			TL2_set_high_circularity = Dialog.getNumber();;;;;;;
			TL2_set_roi_enlargement = Dialog.getNumber();;;;;;;;
			TL2_overlap = Dialog.getNumber();;;;;;;;;
			choice7 = Dialog.getRadioButton;
			
			//if (choice7 =="As-detected") {
			//	ROI_type_TL2 = "freehand";
			//}
			if (choice7 =="Rectangle") {
				ROI_type_TL2 = "rectangle";
			}
			if (choice7 =="Oval") {
				ROI_type_TL2 = "oval";
			}
				
	//next window
			//if (ROI_type_TL3 == "freehand"){
			//	choice8 = "As-detected";
			//}
			if (ROI_type_TL3 == "rectangle") {
				choice8 = "Rectangle";
			}
			if (ROI_type_TL3 == "oval") {
				choice8 = "Oval";
			}
			
			Dialog.createNonBlocking(" Triple-label Intensity Analysis Settings");
			Dialog.addMessage("**Window 3 of 3**");;
			Dialog.addMessage(" ");
			Dialog.addMessage("*Third stain parameters*");
			//Dialog.addString("Stain type:", third_stain_type_TL, 15);
			Dialog.addChoice("Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"),  third_stain_type_TL);
			Dialog.addNumber("Lower threshold multiplier:", TL3_set_intensity_low_threshold);
			Dialog.addNumber("Upper threshold limit:", TL3_set_intensity_high_threshold);
			Dialog.addNumber("Lower limit particle size:", TL3_set_low_particlesize);
			Dialog.addNumber("Upper limit particle size:", TL3_set_high_particlesize);
			Dialog.addNumber("Lower limit circularity:",  TL3_set_low_circularity);
			Dialog.addNumber("Upper limit circularity:", TL3_set_high_circularity);
			Dialog.addNumber("ROI Enlargement (pixels):", TL3_set_roi_enlargement);
			Dialog.addNumber("Min overlap % to be considered double-labeled (% as decimal):", TL3_overlap);
			items8 = newArray("Rectangle", "Oval");
			Dialog.addRadioButtonGroup("Shape of ROIs:", items8, 2, 1, choice8);

			Dialog.show;	

			third_stain_type_TL =  Dialog.getChoice();
			TL3_set_intensity_low_threshold = Dialog.getNumber();;
			TL3_set_intensity_high_threshold = Dialog.getNumber();;;
			TL3_set_low_particlesize = Dialog.getNumber();;;;
			TL3_set_high_particlesize = Dialog.getNumber();;;;;
			TL3_set_low_circularity = Dialog.getNumber();;;;;;
			TL3_set_high_circularity = Dialog.getNumber();;;;;;;
			TL3_set_roi_enlargement = Dialog.getNumber();;;;;;;;
			TL3_overlap = Dialog.getNumber();;;;;;;;;
			choice8 = Dialog.getRadioButton;
		
			//if (choice8 =="As-detected") {
			//	ROI_type_TL3 = "freehand";
			//}
			if (choice8 =="Rectangle") {
				ROI_type_TL3 = "rectangle";
			}
			if (choice8 =="Oval") {
				ROI_type_TL3 = "oval";
			}
		}
		saveParameters();
	}

/////////////////////////////

function stackSum(Zchannels){
	call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-Zsum-"+Zchannels+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".Zsum."+Zchannels+"."+email_address+"%3B&utmu=DC~";
	silent= File.openUrlAsString(call_home_url);
	wait(20);
	
	if(Zchannels==1) {
		readChannel="1";
		textChannel=readChannel+" channel";
	}
	if(Zchannels>1) {
		readChannel=Zchannels-1;
		textChannel=""+readChannel+" channels, plus a merged image";
	}
	//print(Zchannels);
	
	beep();
	//waitForUser("PLEASE READ ME:\n \nThis function sums z-stacks that includes ->"+textChannel+".<- \n \nBefore using this function, ensure that \"stack folders\" containing Z-stack images are within a PARENT folder. \nThen, SELECT the PARENT FOLDER in the next window. \n \nie, /Desktop/parent folder/stack folders/z-image1... z-image20");
	Ldest="";
				
	Dialog.createNonBlocking("Open Z-stacks");
	Dialog.addMessage("PLEASE READ ME:\nThis function sums Z-stacks that include:	  ->"+textChannel+".<- \n \nBefore using this function, ensure that your Z-stacks are located within individual folders (one z-stack per folder), and all Z-stack folders are within a PARENT FOLDER. \nThen, SELECT the PARENT FOLDER in the next window. \n \nie, /Desktop/**SELECT THIS PARENT FOLDER**/stack folders/z-image1... z-image20");
	Dialog.addMessage("");
	Dialog.addDirectory("Location of Parent folder:", Ldest);
	Dialog.show();

	Ldest=Dialog.getString();
		
	//Ldest = getDirectory("Choose the Directory ");		 //load from
	Sdest = Ldest+"summed/";		   //save at
	sfold = Sdest;
	stackfold = getFileList(Ldest);

	if(!File.exists(sfold)){
		stackfoldCorrection=0;
	}else{
		stackfoldCorrection=1;
	}
	
	Dialog.create(" Images to be summed");
	Dialog.addMessage("");;
	for (i=0; i<stackfold.length; i++) {
		if(stackfold[i]!="summed"+_sep_ && i<10){
			Dialog.addMessage(i+1+":"+ stackfold[i]);
		}
		if(i+1==stackfold.length){
			Dialog.addMessage("...\n \n->"+stackfold.length-stackfoldCorrection+" stacks total.");
		}
	}
	Dialog.addMessage("\n");
	choice = newArray("Yes", "No");
	Dialog.addRadioButtonGroup("Are these the z-stack files you want to sum?", choice, 2, 1, "Yes");
	Dialog.show;	
	choice = Dialog.getRadioButton;

	if (choice=="No"){
		stackSum(Zchannels);
	}
	Dialog.create("Batch Mode");
	items = newArray("View images during processing", "Don't view images (faster).");

	Dialog.addRadioButtonGroup("Do you want the images to be displayed on your screen as they are processed? \n \nRunning in Batch Mode increases speed by up to 20x.", items, 2, 1, "Don't view images (faster).");
	Dialog.show;

	choice = Dialog.getRadioButton;

	if(!File.exists(sfold)) {
		File.makeDirectory(sfold);	
	}
	title = "[Image Processing Progress]";
	run("Text Window...", "name="+ title +" width=30 height=4 monospaced");

	for(i=0; i<stackfold.length; i++){
		print(title, "\\Update:"+i+1+"/"+stackfold.length-stackfoldCorrection+" ("+((i+1)*100)/stackfold.length-stackfoldCorrection+"%)\n"+getBar(i, stackfold.length-stackfoldCorrection));

	 	stacks = stackfold[i];
		print(stacks);
		stacksDir=Ldest+stacks;
		identify = substring(stacks, 0, lengthOf(stacks)-1);
		names = substring(stacks, lengthOf(stacks)-1);
		

		if(names == "/" && stacks!="summed"+_sep_){
			zsteps = 0;
			zStepsArray = getFileList(stacksDir);
			zsteps=zStepsArray.length;

			if(zsteps==0){
				waitForUser(stacks+" folder did not contain z-stack images.");
			}else{
				zsteps=zsteps/Zchannels; //CHANGE CHANNEL NUMBER HERE (1/3)

				if (choice== "Don't view images (faster)."){
					setBatchMode(true);
				}else{
					setBatchMode(false);
				}
				//ISp = "open=[" + Ldest + stacks + "] number=zsteps starting=q increment=Zchannels scale=100 file=[] or=[] sort";  
				ISp = "dir=[" + Ldest + stacks + "] count=zsteps starting=q step=Zchannels scale=100 file=[] or=[] sort";  
				
				for(q=1; q<(Zchannels+1); q++) { //CHANGE CHANNEL NUMBER HERE (3/3)
					if(zsteps>1){
						run("Image Sequence...", ISp);
						wait(5);
						if((q==1 && Zchannels==1) || (q!=1 && Zchannels>1)){	//DIFF FOR 1 CHANNEL
							run("32-bit");
						}
						
						//waitForUser("pause");
						run("Z Project...", "start=1 stop=zsteps projection=[Sum Slices]");
				
					}else{
						open(Ldest + stacks);
						if((q==1 && Zchannels==1) || (q!=1 && Zchannels>1)){	//DIFF FOR 1 CHANNEL
							run("32-bit");
						}
						
						//waitForUser("zsteps="+zsteps+", nSlices="+nSlices);
						if(nSlices>1){
							zsteps=nSlices;
							run("Z Project...", "start=1 stop=zsteps projection=[Sum Slices]");
						}
						//waitForUser("pause");
					}
					//waitForUser("pause");
					saveAs("Tiff", sfold + identify + "_" + q + ".tif");
					close();
					{
					while(nImages>0){
						selectImage(nImages);
						close();
						}
					}
				}
			}
		setBatchMode(false);
		}
	}
	beep();
	print(title, "\\Close");
	waitForUser(title, "Process Finished: "+stackfold.length-stackfoldCorrection+"/"+stackfold.length-stackfoldCorrection+" images. (100%)\n");
	setBatchMode(false);
	return;;
}

///////////////////////////
function Auto_Background(editBkgd){
	makeRectangle((6*(width-40)/6), (0.1*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((6*(width-40)/6), (1*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((6*(width-40)/6), (2*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((6*(width-40)/6), (3*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((6*(width-40)/6), (4*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((6*(width-40)/6), (5*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((5*(width-40)/6), (5*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((4*(width-40)/6), (5*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((3*(width-40)/6), (5*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((2*(width-40)/6), (5*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((1*(width-40)/6), (5*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((0.1*(width-40)/6), (5*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((0.1*(width-40)/6), (4*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((0.1*(width-40)/6), (3*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((0.1*(width-40)/6), (2*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((0.1*(width-40)/6), (1*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((0.1*(width-40)/6), (0.1*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((1*(width-40)/6), (0.1*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((2*(width-40)/6), (0.1*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((3*(width-40)/6), (0.1*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((4*(width-40)/6), (0.1*(height-40)/5), 30, 30);
	roiManager("Add");
	makeRectangle((5*(width-40)/6), (0.1*(height-40)/5), 30, 30);
	roiManager("Add");

	if(editBkgd==1){
		waitForUser("Please edit the background selection, and **THEN** press OK to continue.");
	}
	if (rollingball_io == "On"){
		run("Subtract Background...", "rolling="+rollingball);
	}
	roiManager("Select", newArray(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,21));
	roiManager("Measure");
	Table.setLocationAndSize((screenWidth/3)*1, (screenHeight/5)*4, (screenWidth/5)*2, screenHeight/6, "Results");
	//print("width="+width);
	return;
}

///////////////////////////
function Set_Background(parentFunction){

	imageDepth=bitDepth();
	
	run("Clear Results");
	run("ROI Manager...");
	Table.setLocationAndSize((screenWidth/3)*2, (screenHeight/5)*1, screenWidth/9, screenHeight/3, "ROI Manager");
	roiManager("reset");
	roiManager("Show All");
	roiManager("Show All with labels");

	height = getHeight;
	width = getWidth;
	selectWindow(full_name);
		
	
	if(beastMode==0){
		Dialog.create("Background subtraction");
		
		if(name == first_image){
			Dialog.addCheckbox("Limit analysis to a subregion of the image", false);
			Dialog.addMessage("");
			Dialog.addMessage("");
		}else if(limitRegion==true && name != first_image && File.exists(dir+subDir1+"sub_region_selection_ROI.zip")==1){
			region_limit_multiplex();
			limitRegion=1;
		}	
		items = newArray("Manually select an ROI that will be use to determine background", "Manually edit 22 boxes around the parameter", "Automatically by measuring 22 boxes around the parameter");
		Dialog.addRadioButtonGroup("Would you like to calculate image background manually or automatically?", items, 3, 1, "Automatically by measuring 22 boxes around the parameter");
		Dialog.addMessage("");
		items2 = newArray("Dark background (e.g. IF)", "Bright background (e.g. IHC)");
		Dialog.addRadioButtonGroup("Image background type: ", items2, 1, 2, "Dark background (e.g. IF)");
		Dialog.show;
		choice = Dialog.getRadioButton;
		bkgd_type = Dialog.getRadioButton;
		limitRegionSelect=Dialog.getCheckbox();

		if(limitRegionSelect==true){
			limitRegion=1;
			choice="";
			region_limit();
			selectWindow(full_name);
			height = getHeight;
			width = getWidth;

			Dialog.create("Background subtraction");
			items = newArray("Manually select an ROI that will be use to determine background", "Manually edit 22 boxes around the parameter", "Automatically by measuring 22 boxes around the parameter");
			Dialog.addRadioButtonGroup("Would you like to calculate image background manually or automatically?", items, 3, 1, "Automatically by measuring 22 boxes around the parameter");
			Dialog.show;
			choice = Dialog.getRadioButton;
		}
		if(bkgd_type=="Bright background (e.g. IHC)"){
			run("Invert");
			saveAs("Tiff", imageDir+name+"_inverted.tif");
			close("*");
			full_name=name+"_inverted.tif";
   			name=name+"_inverted";
   			imageType=".tif";
   			open(imageDir+full_name);
		}

		if (choice== "Manually select an ROI that will be use to determine background"){
			selectWindow(full_name);
			setLocation(screenWidth/3, screenHeight/4,width, height );
			run("Duplicate...", " ");
			selectWindow(name+"-1"+imageType);
			setLocation(0, screenHeight/4,width*1.5, height*1.5 );
			
			if(imageDepth!=32){
				run("32-bit");
			}
			setTool("freehand"); 
			selectWindow(name+"-1"+imageType);
			waitForUser("Add one or more ROIs to be used for determining the level of background to be subtracted \nfrom the image before measuring stain intensities. **THEN** press OK.");
			run("Subtract Background...", "rolling="+rollingball);
			measure_squares=roiManager("count");
			array_bkgd=newArray(measure_squares);
			for(i=0; i<measure_squares;i++) {
				array_bkgd[i] = i;
			}
			roiManager("Select", array_bkgd);
			roiManager("Measure");
		}
		if (choice== "Manually edit 22 boxes around the parameter"){
			editBkgd=1;
			selectWindow(full_name);
			setLocation(screenWidth/3, screenHeight/4,width, height );
			run("Duplicate...", " ");
			selectWindow(name+"-1"+imageType);
			setLocation(0, screenHeight/4,width*1.5, height*1.5 );
			if(imageDepth!=32){
				run("32-bit");
			}
			Auto_Background(editBkgd);
		}
		if (choice== "Automatically by measuring 22 boxes around the parameter"){
			editBkgd=0;
			selectWindow(full_name);
			setLocation(screenWidth/3, screenHeight/4,width, height );
			run("Duplicate...", " ");
			selectWindow(name+"-1"+imageType);
			setLocation(0, screenHeight/4,width*1.5, height*1.5 );
			if(imageDepth!=32){
				run("32-bit");
			}
			Auto_Background(editBkgd);
		}
	}else{
		selectWindow(full_name);
		run("Duplicate...", " ");
		selectWindow(name+"-1"+imageType);
		if(imageDepth!=32){
			run("32-bit");
		}
		editBkgd=0;
		Auto_Background(editBkgd);	
	}

 // Calculating lower threshold background value in "Mean" column
	m=0;
	bkgd_mean=0;
	meanbkgd=0;
	std=0;
	bkgd_std=0;
	stdbkgd=0;
	m = nResults;
	bkgd_mean = newArray(m);
	run("Select None");
	for (i=0; i<m; i++) {
		bkgd_mean[i] = getResult('Mean', i);
	}
	if(background_setting == "High") {
		Array.getStatistics(bkgd_mean, min, max, mean, stdDev);
		Array.sort(bkgd_mean);
		bkgd_high_trim = Array.trim(bkgd_mean, 15);
		Array.getStatistics(bkgd_high_trim, min, max, mean, stdDev);
		Array.reverse(bkgd_high_trim);
		bkgd_low_trim = Array.trim(bkgd_high_trim, 7);
		Array.getStatistics(bkgd_low_trim, min, max, mean, stdDev);
		meanbkgd = mean;
		std = nResults;
		bkgd_std = newArray(std);
		run("Select None");
		for (i=0; i<std; i++) {
			bkgd_std[i] = getResult('StdDev', i);
		}
		Array.getStatistics(bkgd_std, min, max, mean, stdDev);
		Array.sort(bkgd_std);
		bksd_high_trim = Array.trim(bkgd_std, 15);
		Array.getStatistics(bksd_high_trim, min, max, mean, stdDev);
		Array.reverse(bksd_high_trim);
		bksd_low_trim = Array.trim(bksd_high_trim, 7);
		Array.getStatistics(bksd_low_trim, min, max, mean, stdDev);
		stdbkgd = mean;
		lower = ((meanbkgd)+(stdbkgd*2));
	}
	if(background_setting == "Low") {
		Array.getStatistics(bkgd_mean, min, max, mean, stdDev);
		Array.sort(bkgd_mean);
		bkgd_high_trim = Array.trim(bkgd_mean, 5);
		Array.getStatistics(bkgd_high_trim, min, max, mean, stdDev);
		meanbkgd = mean;
		std = nResults;
		bkgd_std = newArray(std);
		run("Select None");
		for (i=0; i<std; i++) {
			bkgd_std[i] = getResult('StdDev', i);
		}
		Array.getStatistics(bkgd_std, min, max, mean, stdDev);
		Array.sort(bkgd_std);
		bksd_high_trim = Array.trim(bkgd_std, 5);
		Array.getStatistics(bksd_high_trim, min, max, mean, stdDev);
		stdbkgd = mean;
		lower = ((meanbkgd)+(stdbkgd*2));
	}

// Setting Threshold
	//print("Mean="+meanbkgd+",_StdDev="+stdbkgd);
	//print("Lower_Threshold="+lower);
	run("Set Measurements...", "area standard min center shape mean redirect=None decimal=3");  //setting measurements.
	selectWindow(name+"-1"+imageType);
	setAutoThreshold("Default dark");
	run("Threshold...");
	wait(200);
	setThreshold(lower, 500000);
	//run("Apply");
	run("NaN Background");
	run("Close");
	
}

/////////////////////////////
function region_limit(){ //===========making smaller region
	
	roiManager("reset");
	selectWindow(full_name);
	setTool("freehand"); 

	
	//waitForUser("Would you like to limit analysis to a subregion?", "OPTIONAL: Limit analysis to ONE subregion of the image. \n \nSELECT the subregion and ADD to the ROI manager. \nPress OK WHEN DONE selecting subregion.");
	waitForUser("Limit analysis to a subregion?", "OPTIONAL: Limit analysis to ONE subregion of the image. \n \nSELECT the subregion and ADD to the ROI manager. \nPress OK WHEN DONE selecting subregion.");
	
	//selectWindow(name+"-1"+imageType);
	roiManager("Show All");
  	roiManager("Show All with labels");
	roi_count = roiManager("count");
	if (roi_count>0) { //if selecting limited region, reverse selection and black them out.
		selectWindow(full_name);
		array=newArray(roi_count);
		roiManager("Show All");
  		roiManager("Show All with labels");

  		roiManager("Select", array);
		roiManager("Save", imageDir+"sub_region_selection_ROI.zip");
				
		for(i=0; i<1; i++) {
	   		roiManager("Select", i);
	   		run("Make Inverse");
	   		setColor(0);
	   		fill();
	   		roiManager("deselect");
	   		roiManager("Select", i);
	   		//run("Auto Crop");
	   		run("Crop");
	   	}
		/*
		 * selectWindow(full_name);
		roiManager("Show All");
  		roiManager("Show All with labels");
		for(i=0; i<roi_count; i++) {
	 		roiManager("Select", i);
	   		run("Make Inverse");
	   		setColor(0);
	   		fill();
		}
		*/
		
		wait(20);
		
		roiManager("Delete");
		selectWindow(full_name);
		setTool("point");
		makePoint(0, 0);
		saveAs("Tiff", imageDir+name+"_limitedArea.tif");
		close("*");
		
   		full_name=name+"_limitedArea.tif";
   		name=name+"_limitedArea";
   		imageType=".tif";
   		open(imageDir+full_name);

   		selectWindow(full_name);
		height=getHeight();													//
		width=getWidth();													//
		setLocation(width*1.7, screenHeight/4,width*1.5, height*1.5 );
   		return;
   		
	}
	//Set_Background();	
	return;
}

/////////////////////////////
function region_limit_multiplex(){
	roiManager("reset");
	selectWindow(full_name);

	roiManager("Open", dir+subDir1+"sub_region_selection_ROI.zip");
	roiManager("Show All");
	roiManager("Show All with labels");

	roi_count = roiManager("count");
	if (roi_count>0) { //if selecting limited region, reverse selection and black them out.
		selectWindow(full_name);
		array=newArray(roi_count);
		roiManager("Show All");
  		roiManager("Show All with labels");

  		//roiManager("Select", array);
		//roiManager("Save", imageDir+"sub_region_selection_ROI.zip");
				
		for(i=0; i<1; i++) {
	   		roiManager("Select", i);
	   		run("Make Inverse");
	   		setColor(0);
	   		fill();
	   		roiManager("deselect");
	   		roiManager("Select", i);
	   		//run("Auto Crop");
	   		run("Crop");
	   	}
		wait(20);
			
		roiManager("Delete");
		selectWindow(full_name);
		setTool("point");
		makePoint(0, 0);
		saveAs("Tiff", imageDir+name+"_limitedArea.tif");
		close("*");
			
	   	full_name=name+"_limitedArea.tif";
	   	name=name+"_limitedArea";
	   	imageType=".tif";
	  	
	}
	
	roiManager("reset");
	silent=File.exists(dir+merged_image);
	if(silent==1 && merged_image!="merged_image_limitedArea.tif"){
		open(dir+merged_image);
		selectWindow(merged_image);
	
		roiManager("Open", dir+subDir1+"sub_region_selection_ROI.zip");
		roiManager("Show All");
		roiManager("Show All with labels");
	
		roi_count = roiManager("count");
		if (roi_count>0) { //if selecting limited region, reverse selection and black them out.
			selectWindow(merged_image);
			array=newArray(roi_count);
			roiManager("Show All");
	  		roiManager("Show All with labels");
	
	  		//roiManager("Select", array);
			//roiManager("Save", imageDir+"sub_region_selection_ROI.zip");
					
			for(i=0; i<1; i++) {
		   		roiManager("Select", i);
		   		run("Make Inverse");
		   		setColor(0);
		   		fill();
		   		roiManager("deselect");
		   		roiManager("Select", i);
		   		//run("Auto Crop");
		   		run("Crop");
		   	}
			wait(20);
				
			roiManager("Delete");
			selectWindow(merged_image);
			setTool("point");
			makePoint(0, 0);
			saveAs("Tiff", dir+"merged_image_limitedArea.tif");
			close("*");
				
		   	merged_image="merged_image_limitedArea.tif";
		   	imageType=".tif";
		}
	}
	
	open(imageDir+full_name);
	wait(50);	
	selectWindow(full_name);
	height=getHeight();													//
	width=getWidth();													//
	setLocation(width*1.7, screenHeight/4,width*1.5, height*1.5 );
	return;
	
	//Set_Background();	
	return;
}
/////////////////////////////
function Initiate_ROI(){
// Measuring ROIs
  //Finding PNNs with Analyze Particles
  	previous_roi_count = roiManager("count");
	setTool("freehand"); 
	roiManager("reset"); // clearing ROI manager
	roiManager("UseNames", "true"); // shows ROI names on image
	run("Clear Results");

	ML_thresh_display=50-ML_thresh;
	if(subsectioning==1) subsectioning_choice="Off"; //"Off"
	if(subsectioning==2) subsectioning_choice="2x2"; //"2x"
	if(subsectioning==3) subsectioning_choice="3x3"; //"3x"
	if(subsectioning==4) subsectioning_choice="4x4"; //"4x"
	if(subsectioning==5) subsectioning_choice="5x5"; //"5x"
	if(subsectioning==6) subsectioning_choice="6x6"; //"6x"

	//model_library=newArray;	
	//model_library=
	model_library_reader();

	/*
	if(File.exists(pipDir+"models.json")){
		parameters = File.openAsString(pipDir+"models.json");
		parLines=split(parameters,"}");
		model_num = parLines.length;

		specific_models=Array.slice(model_library,0,model_num-1);
		general_models=Array.slice(model_library,model_num,(model_num-1)*2);
		community_models=Array.slice(model_library,model_num*2,(model_num-1)*3);
		custom_models=Array.slice(model_library,model_num*3,(model_num-1)*4);
	}
	*/
	
	specific_models=Array.deleteValue(specific_models, "null");
	
	general_models=Array.deleteValue(general_models, "null");
	general_models=Array.concat(general_models, "Threshold Detection");
	
	community_models=Array.deleteValue(community_models, "null");
	if(community_models.length==0) community_models=Array.concat(community_models, "<none>");
	
	custom_models=Array.deleteValue(custom_models, "null");
	if(custom_models.length==0) custom_models=Array.concat(custom_models, "<none>");

	Dialog.create("Cell Detection Parameters");
	Dialog.addSlider("Detection Sensitivity:", 1, 50, ML_thresh_display);
	Dialog.addSlider("Threshold for Removal of Overlapping ROIs (% Area):", 0.0, 100, dup_thresh);
	
	models = Array.concat("*Specific models*", specific_models, "-------------", "*General models*", general_models, "-------------", "*Community models*", community_models, "-------------", "*Custom models", custom_models);
	Dialog.addChoice("AI Model:", models, model);	
	Dialog.addMessage("   AI detection preference: \""+ reduceSize+"\"");
	Dialog.addMessage("   Large image subsectioning: \""+ subsectioning_choice+"\"");
	
	Dialog.addCheckbox("Change Settings", false);
	
	Dialog.show;
	ML_thresh_display = Dialog.getNumber();
	dup_thresh = Dialog.getNumber();
	model = Dialog.getChoice();
	ML_thresh=50-ML_thresh_display;
	//reduceSize = Dialog.getRadioButton;
	editSettings = Dialog.getCheckbox();
	rerun=0;

	if(model=="*Specific models*" || model== "*General models*" || model== "*Community models*" || model== "-------------"  || model== "*Custom models"){
		waitForUser("Invalid Choice: Please select a valid model");
		Initiate_ROI();
	}
	
	saveParameters();

	if(editSettings==true){
		settings();
		Initiate_ROI();
	}

	//if(model=="Threshold Detection"){
	//	threshold_detection();	
	//	pass==1;
	//}
	
  	if(imageType==".tif" && reduceSize=="Speed"){
  		selectWindow(full_name);
  		saveAs("jpeg", imageDir+name);
  		image_file=imageDir+name+".jpg";		
  	}else{
  		image_file=imageDir+full_name;
  	}
  	
}
//////////////////////////////
function model_library_reader(){

/*	
 	model_library=newArray;
	common_library=newArray;	
	
	specific_models=newArray;
	general_models=newArray;
	community_models=newArray;
	custom_models=newArray;
	
	specific_common=newArray;
	general_common=newArray;
	community_common=newArray;
	custom_common=newArray;	
*/	

	if(File.exists(pipDir+"models.json")){
	
		parameters = File.openAsString(pipDir+"models.json");
		parLines=split(parameters,"}");
	
		model_num = parLines.length;
		//print(model_num);

		model_library=newArray(model_num*4);
		common_library=newArray(model_num*4);	
	
		specific_models=newArray(model_num-1);
		general_models=newArray(model_num-1);
		community_models=newArray(model_num-1);
		custom_models=newArray(model_num-1);
		
		specific_common=newArray(model_num-1);
		general_common=newArray(model_num-1);
		community_common=newArray(model_num-1);
		custom_common=newArray(model_num-1);
		 	
	 	for(i=0; i<model_num-1; i++){
		 	Line=parLines[i];
		 	parVars = split(Line,":");
	
		 	parOwner=parVars[1];
		 	parOwner = split(parOwner,"\"");
		 	//print(i);
		 	//print("Owner = "+parOwner[1]);
		 	
		 	parAlias=parVars[2];
		 	parAlias = split(parAlias,"\"");
		 	//print("Alias = "+parAlias[1]);
	
		 	parPublic=parVars[3];
		 	parPublic = split(parPublic,"\"");
		 	//print("public = "+parPublic[1]);
	
		 	parCommon=parVars[5];
		 	parCommon = split(parCommon,"\"");
		 	//print("common = "+parCommon[1]);
	
		 	parModel=parVars[6];
		 	parModel = split(parModel,"\"");
		 	//print("model = "+parModel[1]);
		 	//print("\n");
	
		 	if(parOwner[1]== "us@rewireneuro.com" && parAlias[1]== "false" && parPublic[1]== "yes"){ 
		 		specific_models[i]=parModel[1];
		 		general_models[i]="null";
		 		community_models[i]="null";
		 		custom_models[i]="null";

		 		specific_common[i]=parCommon[1];
		 		general_common[i]="null";
		 		community_common[i]="null";
		 		custom_common[i]="null";
		 			
		 	}else if(parOwner[1]== "us@rewireneuro.com" && parAlias[1]== "true" && parPublic[1]== "yes"){
		 		specific_models[i]="null";
		 		general_models[i]=parModel[1];
		 		community_models[i]="null";
		 		custom_models[i]="null";

		 		specific_common[i]="null";
		 		general_common[i]=parCommon[1];
		 		community_common[i]="null";
		 		custom_common[i]="null";
		 			
		 	}else if(parOwner[1] != "us@rewireneuro.com" && parPublic[1]== "yes"){
		 		specific_models[i]="null";
		 		general_models[i]="null";
		 		community_models[i]=parModel[1];
		 		custom_models[i]="null";

		 		specific_common[i]="null";
		 		general_common[i]="null";
		 		community_common[i]=parCommon[1];
		 		custom_common[i]="null";
		 			
		 	}else if(parOwner[1] != "us@rewireneuro.com" && parPublic[1]== "no"){ 
		 		specific_models[i]="null";
		 		general_models[i]="null";
		 		community_models[i]="null";
		 		custom_models[i]=parModel[1];

		 		specific_common[i]="null";
		 		general_common[i]="null";
		 		community_common[i]="null";
		 		custom_common[i]=parCommon[1];
		 	}	 	
	 	}
	}
	 
	 model_library=Array.concat(specific_models,general_models,community_models,custom_models);
	 common_library=Array.concat(specific_common,general_common,community_common,custom_common);
}

//////////////////////////////
function ProgressBar(){
	if(isOpen("AI Engine Progress")==true){
	 	selectWindow("AI Engine Progress"); 
	 	run("Close");
	 	wait(50);
	 }	 
	
	title = "[AI Engine Progress]";
  	run("Text Window...", "name="+ title +" width=30 height=4 monospaced");
  	selectWindow("AI Engine Progress");
  	setLocation((screenWidth/5)*2, (screenHeight/5)*2);
  	randtime=75+25*random();
  	for (i=0; i<randtime; i++) {
  		print(title, "\\Update:"+i+"/"+100+" ("+(i*100)/100+"%)\n"+getBar(i, 100));
		wait(10);
		if(i==20 || i==40){
		 	wait(150);
		}
  	}
}

function getBar(p1, p2) {
	n = 20;
	bar1 = "____________________";
	bar2 = "||||||||||||||||||||";
	index = round(n*(p1/p2));
	if (index<1) index = 1;
	if (index>n-1) index = n-1;
	return substring(bar2, 0, index) + substring(bar1, index+1, n);
}

//////////////////////////
function recursive_inference(){
	if(model=="Threshold Detection"){
		return;
	}
	Run_Inference();
	menuDefault="Modify ROIs by hand";
	//user_model="";
	menu(inferenceMessage);
}

/////////////////////////////////
function Run_Inference(){
	if(isOpen("AI Engine Results")==false){
  		title2 = "[AI Engine Results]";
  		run("Text Window...", "name="+ title2 +" width=100 height=15 SansSerif");
  		selectWindow("AI Engine Results");
  		setLocation((screenWidth/5)*1.5, (screenHeight/5)*3);
  	}
  	
	inferenceMessage="";
	//AI_Engine_exec=pipDir+"AI_Engine";
	roiManager("reset"); // clearing ROI manager
	run("Clear Results");

	for(i=0; i<model_library.length; i++){
		if(model_library[i]==model) AI_Engine_model=common_library[i];
	}
//print(AI_Engine_model);
	
	if(ML_thresh==0){
		ML_thresh=1;
	}
	AI_Engine_ML_thresh=ML_thresh*0.01;
	AI_Engine_dup_thresh=dup_thresh*0.01;	
	
	if(File.exists(imageDir+name+".zip")==1){
		silent=File.rename(imageDir+name+".zip", imageDir+name+TimeString+"(archived).zip");
	}
	call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-inference-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".inference."+model+"."+email_address+"%3B&utmu=DC~";
	silent= File.openUrlAsString(call_home_url);
	wait(20);

	//setOption("WaitForCompletion", "false");
	ProgressBar();
	title2 = "[AI Engine Results]";	
	//setOption("WaitForCompletion", "true");
	
//print("AI_Engine_exec: "+AI_Engine_exec);
//print("AI_Engine_ML_thresh: "+AI_Engine_ML_thresh);
//print("AI_Engine_dup_thresh: "+AI_Engine_dup_thresh);
//print("image_file: "+image_file);
//print("AI_Engine_model: "+AI_Engine_model);
	
	//print("\n \n");
	if(rerun==1 && imageKey!= 0){
		print(title2, "imageKey for rerun: "+imageKey);
		inference_key=exec(AI_Engine_exec, "inference", "--threshold", AI_Engine_ML_thresh, "--deletion", AI_Engine_dup_thresh, "--rerun", "--image-id", imageKey, image_file, AI_Engine_model, "--split", subsectioning, "--treatment", treatment, "--subject", subject, "--experiment", experiment);
	}else{
		inference_key=exec(AI_Engine_exec, "inference", "--threshold", AI_Engine_ML_thresh, "--deletion", AI_Engine_dup_thresh, image_file, AI_Engine_model, "--split", subsectioning, "--treatment", treatment, "--subject", subject, "--experiment", experiment);
	}
//print(inference_key);
	if(inference_key!=-1){
		inference_result1="";
		
		inference_return=split(inference_key, "\n");
		if(inference_return.length>1){
			inference_result1=inference_return[1];
		}
		
		for(i=0; i<inference_return.length; i++) {
			print(title2, inference_return[i]+"\n");
		}
		//if(i>=2) print(title2, "\n"+inference_return[i]);
		if(inference_return.length>3){
			j=inference_return.length-1;
			imageKey=inference_return[j];
			print(title2, "\nimageKey: "+imageKey);
		}
		//if(i>=2) print(inference_return[i]);
		
		//print(inference_return.length);
		//print(i+": "+inference_return[i]);
			
		if(inference_result1=="Error (Inference): Model '"+AI_Engine_model+"' not allowed"){
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-APIinferenceFail1-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".APIinferenceFail1."+model+"."+email_address+"%3B&utmu=DC~";
			silent= File.openUrlAsString(call_home_url);
			wait(20);
			inferenceMessage="Sorry, looks like the AI Engine was not able to connect or did not successfully process the image.";
			print(title2, "\n"+inference_key);
			//print(inference_key);
			if(beastMode==100)beastMode=50;
		}			
		if(inference_result1=="Error (Inference): License expired; run not allowed"){
			waitForUser("License "+license_number+" for order "+order_number+" has expired. Please enter a new license number, or continue to use Pipsqueak in Basic mode.");
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak_ai%2Fcall_home%2F"+verurl+"-inf_license_expired-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK_AI%2Fv"+ver+".inf_license_expired."+email_address+"%3B&utmu=DC~";
			silent=File.openUrlAsString(call_home_url);
			wait(20);
			if(isOpen("AI Engine Progress")==true){
	 			selectWindow("AI Engine Progress"); 
	 			run("Close");
	 		}
			//close("*");
			if(beastMode==100)beastMode=0;
			//exec(AI_Engine_exec, "logout");
			//ps_switchLic();
			lic=0;
			threshold_name();
			threshold_detection();
		}
		if(inference_result1=="Error (Inference): Upload request failed"){
			inferenceMessage="Pipsqueak AI requires an internet connection. Please check your network connection and try again.";
			if(beastMode==100)beastMode=0;
		}
		if(inference_result1=="Error (Inference): Inference service error"){
			inferenceMessage="Pipsqueak AI encountered an error communicating with the cloud. \nPlease try again and email support@rewireneuro.com if the problem persists.";
			if(beastMode==100)beastMode=0;
		}
		if(inference_result1=="Error (Inference): Logged in else where; run not allowed"){
			loginMessage="Your Pipsqueak AI account is being used in another location. \nIf you did not authorize this usage, please change your password now.";
			if(beastMode==100)beastMode=0;
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak_ai%2Fcall_home%2F"+verurl+"-multiple_logins-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK_AI%2Fv"+ver+".multiple_logins."+email_address+"%3B&utmu=DC~";
			silent=File.openUrlAsString(call_home_url);
			wait(20);
			if(isOpen("AI Engine Progress")==true){
	 			selectWindow("AI Engine Progress"); 
	 			run("Close");
			}
			close("*");
			exec(AI_Engine_exec, "logout");
			ps_rgch(loginMessage);		
		}
		
		
	}else{
		call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-APIinferenceFail1-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".APIinferenceFail1."+model+"."+email_address+"%3B&utmu=DC~";
		silent= File.openUrlAsString(call_home_url);
		wait(20);
		inferenceMessage="Sorry, looks like the AI Engine was not able to connect or did not successfully process the image.";
		//print(inference_key);
		print(title2, "\n"+inference_key);
		if(beastMode==100)beastMode=50;
	}
	print(title2, "\n");
	wait(100);
	roiManager("reset");
	if(File.exists(imageDir+name+".zip")==1){
		zipsize=File.length(imageDir+name+".zip");
		//print("zipsize = "+zipsize);
		if(zipsize<50){
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-APIinferenceFail2-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".APIinferenceFail2."+model+"."+email_address+"%3B&utmu=DC~";
			silent= File.openUrlAsString(call_home_url);
			wait(20);
			inferenceMessage="The robots failed to detect any cells. Try changing parameters here.";
			if(beastMode==100) beastMode=50;
		}else{
		//File.rename(dir+name+".zip", subDir+name+".zip");
		roiManager("Open", imageDir+name+".zip");
		}
	}else{
		wait(10);
		//waitForUser("Robots failed to return your ROIs. Try finding your ROI zip file in the next step.");
	}
	//closeProgressBar();
	if(isOpen("AI Engine Progress")==true){
	 	selectWindow("AI Engine Progress"); 
	 	run("Close");
	 }
	
	roiManager("Show All");
	roiManager("Show All with labels");		
	roiManager("Measure");

  	//Making  ROIs from Particles
	wait(200);
	roiManager("Show All");
	roiManager("Show All with labels");
	selectWindow(full_name);
	count=roiManager("count");
  	
	setTool("point");
	makePoint(0, 0);
	if(beastMode<10){
	  	selectWindow(name+"-1"+imageType);		
	  	roiManager("Show All");
	  	roiManager("Show All with labels");
	}
  	count=roiManager("count");
	array=newArray(count);
	
	if(ROI_enlargement!=0 || ROI_shape!= "oval"){
		roiManager("show none");
		setBatchMode("hide");
		Table.setLocationAndSize((screenWidth/3)*3, (screenHeight/5)*2, screenWidth/9, screenHeight/3, "ROI Manager");
		selectWindow("Log");
			
		title3 = "[ROI Conversion Progress]";
		run("Text Window...", "name="+ title3 +" width=55 height=7");
		selectWindow("ROI Conversion Progress");
		setLocation((screenWidth/5)*2, (screenHeight/5)*2);
		print(title3, "Please wait while ROIs are converted. \nProcess may take 15 seconds... \n \nYour image will reopen when the process is complete.");

		for(i=0; i<count; i++) {
   			roiManager("Select", i);
			if(ROI_shape == "freehand") {
	   			wait(5);
   			}
   			if(ROI_shape == "rectangle") {
	   			run("Specify...", "rectangle centered scaled");
   			}
   			if(ROI_shape == "oval") {
	 			run("Specify...", "oval constrain centered scaled");
   			}
   			run("Enlarge...", "enlarge=ROI_enlargement");
   			roiManager("update");
   		}
   		setBatchMode("exit and display");
		Table.setLocationAndSize((screenWidth/3)*2, (screenHeight/5)*1, screenWidth/9, screenHeight/3, "ROI Manager");
		if(beastMode<10){
			selectWindow(name+"-1"+imageType);
			setLocation(0, screenHeight/4,width*1.5, height*1.5 );
		}
		if(isOpen("ROI Conversion Progress")==true){
			selectWindow("ROI Conversion Progress");
			run("Close");
		}
	}
	wait(10);
	if(beastMode<10){
		selectWindow(name+"-1"+imageType);
		roiManager("Show All");
		roiManager("Show All with labels");
	}
	wait(10);
	selectWindow(full_name);
	roiManager("Show All");
	roiManager("Show All with labels");
	selectWindow(full_name);
	
}

//////////////////////////

function menu(inferenceMessage){
	custom_library_reader();
	if(user_model=="new model name") user_model="No";
	
	ML_thresh_display=50-ML_thresh;
	if(subsectioning==1) subsectioning_choice="Off";
	if(subsectioning==2) subsectioning_choice="2x2";
	if(subsectioning==3) subsectioning_choice="3x3";
	if(subsectioning==4) subsectioning_choice="4x4";
	if(subsectioning==5) subsectioning_choice="5x5";
	if(subsectioning==6) subsectioning_choice="6x6";
			
	choice = "";
	setTool("oval");
	
	if(beastMode<1000){
		Dialog.createNonBlocking("Adjust Cell Detection Parameters");
		items = newArray("Reprocess cell detection using new settings", "Modify ROIs by hand", "Load previous ROI set", "ROIs are complete: Finish analysis");
		Dialog.addSlider("Detection Sensitivity:", 1, 50, ML_thresh_display);
		Dialog.addSlider("Threshold for Removal of Overlapping ROIs (% Area):", 0.0, 100, dup_thresh);
		models = Array.concat("*Specific models*", specific_models, "-------------", "*General models*", general_models, "-------------", "*Community models*", community_models, "-------------", "*Custom models", custom_models);
		Dialog.addChoice("AI Model:", models, model);
		Dialog.addRadioButtonGroup("Would you like to change the cell detection parameters?", items, 5, 1, menuDefault);
		if(parentFunction!="custom_menu()"){
			Dialog.addMessage("");
			Dialog.addMessage("If you have manually edited a lot of ROIs, you may want to train a detection model to fit your image needs.");
			custom_lib = Array.concat("No", "Start a new model", custom_library);
			Dialog.addChoice("   Add these annotations to a custom model?:", custom_lib, user_model);
			Dialog.addMessage("");
		}	
		Dialog.addMessage("\n \nAI detection preference: \""+reduceSize +"\"");
		Dialog.addMessage("Large image subsectioning: \""+subsectioning_choice+"\"");
		Dialog.addCheckbox("\n \nChange Settings", false);
		Dialog.addMessage("");
		Dialog.addMessage("");
		Dialog.addMessage(inferenceMessage);

		Dialog.show;
		ML_thresh_display = Dialog.getNumber();
		dup_thresh = Dialog.getNumber();
		model = Dialog.getChoice();
		ML_thresh=50-ML_thresh_display;
		//reduceSizeMenu = Dialog.getRadioButton;
		if(parentFunction!="custom_menu()") user_model_temp = Dialog.getChoice();		

		choice = Dialog.getRadioButton;
		editSettings = Dialog.getCheckbox();
		
		if(editSettings==true){
			choice = "";
			settings();
			inferenceMessage="Settings saved";
			menu(inferenceMessage);
		}		
		if(parentFunction!="custom_menu()"){
			if (user_model_temp!="No" && lic==0) {
				waitForUser("Sorry, a current Pipsqueak AI license is needed to generate custom AI detection models.");
			}
			if (user_model_temp=="Start a new model" && lic==1) {
				custom_model();
			}
			if (user_model_temp!="No" && user_model_temp!="Start a new model" && lic==1) {
				user_model=user_model_temp;
			}
		}
		if(user_model=="No") user_model="new model name";
		
		if(model=="*Specific models*" || model== "*General models*" || model== "*Community models*" || model== "-------------"  || model== "*Custom models"){
			inferenceMessage="Invalid Choice: Please select a valid model";
			menu(inferenceMessage);
		}		
		if(imageType==".tif" && reduceSize=="Speed"){
  			selectWindow(full_name);
  			saveAs("jpeg", imageDir+name);
  			image_file=imageDir+name+".jpg";		
  		}else{
  			image_file=imageDir+full_name;
  		}
		
		saveParameters();
		/*
		if(model=="Generate custom model"){
			custom_model();	
			manual_menu();
			pass==1;
			return;
	  	}
	  	*/

	  	if(model=="Threshold Detection"){
	  		threshold_name();
			threshold_detection();	
			pass==1;
			return;
	  	}

		if (choice=="Modify ROIs by hand")  {
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-manualFixROIs-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".manualFixROIs."+model+"."+email_address+"%3B&utmu=DC~";
			silent= File.openUrlAsString(call_home_url);
			wait(20);
			selectWindow(full_name);
			roiManager("Show All");
 			roiManager("Show All with labels");
 			setTool("oval");
			waitForUser("How Does That Look?", "Here is your chance to adjust the ROIs to better identify cells. Try adding or deleting ROIs in the ROI manager. **THEN** press OK.");
			
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("save", imageDir+name+".zip");
				inferenceMessage="Manual ROIs added.";
			}else{
				if(File.exists(imageDir+name+".zip")) File.delete(imageDir+name+".zip");
				inferenceMessage="No ROIs added. File saved with 0 ROIs.";
			}
			menu(inferenceMessage);
		}
		if (choice=="Reprocess cell detection using new settings") {
			if(File.exists(imageDir+name+".zip")==1){
				File.delete(imageDir+name+".zip");
			}
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-rerunInference-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".rerunInference."+model+"."+email_address+"%3B&utmu=DC~";
			silent= File.openUrlAsString(call_home_url);
			wait(20);
			rerun=1;
			if(reduceSize=="Speed" && image_file!=imageDir+name+".jpg")rerun=0;
			//reduceSize=reduceSizeMenu;
			
			if(imageType==".tif" && reduceSize=="Speed"){
  				selectWindow(full_name);
  				saveAs("jpeg", imageDir+name);
  				image_file=imageDir+name+".jpg";		
  			}else{
  				image_file=imageDir+full_name;
  			}
  					
			saveParameters();
			recursive_inference();
		}
		if (choice=="Load previous ROI set") {
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-loadPreviousROIs-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".loadPreviousROIs."+model+"."+email_address+"%3B&utmu=DC~";
			silent= File.openUrlAsString(call_home_url);
			wait(20);
			roiManager("reset");
			wait(20);
			open();
			roiManager("Show All");
			roiManager("Show All with labels");
			
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("save", imageDir+name+".zip");
			}
			inferenceMessage="ROIs loaded.";
			menu(inferenceMessage);	
		}
		
		if (choice=="ROIs are complete: Finish analysis")  {
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-ROIsFinished-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".ROIsFinished."+model+"."+email_address+"%3B&utmu=DC~";
			silent= File.openUrlAsString(call_home_url);
			wait(20);
			selectWindow(full_name);  	
  			roiManager("Show All");
  			roiManager("Show All with labels");
  			rerun=0;
  			//reduceSize=reduceSizeMenu;
  			if(beastMode==50) {
  				beastMode=100;
  			}
  			
	  		n=roiManager("count");
			for(i=0; i<n; i++){
				roiManager("select", i);
				roiName = Roi.getName();
				roiNameSplit = split(roiName, "-");
				roiNameNew = roiNameSplit[0]+imageOrder+"-"+roiNameSplit[1];
				//roiNameNew = user_model+"-"+roiName;
				roiManager("select", i);
				roiManager("Rename", roiNameNew);
			}

			if (parentFunction=="custom_menu()") user_model_temp="No";
			
			if(user_model_temp!="No" && user_model_temp!="Start a new model" && lic==1) {
				//waitForUser("upload only string: "+image_file+" "+model+" "+treatment+" "+subject+" "+experiment);  		
				upload_key=exec(AI_Engine_exec, "inference", "--upload-only", image_file, user_model, "--treatment", treatment, "--subject", subject, "--experiment", experiment);
						
				if(upload_key!=-1){
					upload_result1="";
							
					upload_return=split(upload_key, "\n");
					if(upload_return.length>1){
						upload_result1=upload_return[1];
					}
							
					//if(i>=2) print(title2, "\n"+inference_return[i]);
					if(upload_return.length>2){
						j=upload_return.length-1;
						imageKey=upload_return[j];
					}
				}
			}
  			saveParameters();
		}	
	}else{
		/*
		Dialog.create("Stop batch?");
		items = newArray("Stop", "Detection looks good");
		Dialog.addRadioButtonGroup("Stop batch to fix detection?:", items, 2, 1, "Detection looks good");
		Dialog.show;
		choice = Dialog.getRadioButton;
		
		if (choice=="Stop"){
			beastMode=50;
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-batchROIsFixed-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".batchROIsFixed."+model+"."+email_address+"%3B&utmu=DC~";
			silent= File.openUrlAsString(call_home_url);
			wait(20);
			inferenceMessage="Batch mode was haulted. Analysis requires your attention.";
			menu(inferenceMessage);
		}else{
			beastMode=100;	
			call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-batchROIsApproved-"+model+"-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".batchROIsApproved."+model+"."+email_address+"%3B&utmu=DC~";
			silent= File.openUrlAsString(call_home_url);
			wait(20);	 
		}
		*/	
	}
}
/////////////////////////////
function threshold_name(){
	Dialog.create("Stain name?");
	Dialog.addMessage("Please enter the name of the marker you are detecting. This name will be used to help you sort results.");
	Dialog.addString("Name your detection model:", user_model, 30);
	Dialog.show;
	user_model =  Dialog.getString();
	//user_model=model;
}
/////////////////////////////
function threshold_detection(){  //Finding cells with Analyze Particles
  	roiManager("reset"); // clearing ROI manager
  	
  	image_file=imageDir+full_name;
  	//selectWindow(full_name);
  	selectWindow(name+"-1"+imageType);
	roiManager("Show All");
	//roiManager("Show All with labels");

	run("Clear Results");
	wait(200);
	setAutoThreshold("Default dark");
	run("Threshold...");
	wait(200);
	setThreshold(lower*set_intensity_low_threshold, set_intensity_high_threshold);
	wait(200);
	makeRectangle(0, 0, 0, 0);
	run("Analyze Particles...", "size=set_low_particlesize-set_high_particlesize circularity=set_low_circularity-set_high_circularity clear include add");
	wait(200);
	selectWindow("Threshold");
	resetThreshold();
	run("Close");
	roiManager("Measure");

		   //Making  ROIs from Particles

	wait(500);
	add_squares=roiManager("count"); 
	if (add_squares==0) {

		roiManager("Show All");
		roiManager("Show All with labels");
		waitForUser("Oops", "We didn't see any staining here. Try adjusting the Cell Detection Threshold settings in the next step... ");
		setTool("point");
		makePoint(0, 0);
		selectWindow(full_name);
	} else {
		roiManager("show none");
		setBatchMode("hide");
		Table.setLocationAndSize((screenWidth/3)*3, (screenHeight/5)*2, screenWidth/9, screenHeight/3, "ROI Manager");
		selectWindow("Log");

		title = "[ROI Conversion Progress]";
		run("Text Window...", "name="+ title +" width=55 height=7");
		selectWindow("ROI Conversion Progress");
		setLocation((screenWidth/5)*2, (screenHeight/5)*2);
		print(title, "Please wait while ROIs are converted. \nProcess may take 15 seconds... \n \nYour image will reopen when the process is complete.");

		//waitForUser("model="+model);
		array=newArray(add_squares); 
		for(i=0; i<add_squares;i++) { 
			roiManager("Select", i);
			if(ROI_type_SL == "As-detected") {
				wait(10);
			}
			if(ROI_type_SL == "Square") {
				run("Specify...", "centered scaled");
	  		}
 			if(ROI_type_SL == "Circle") {
				run("Specify...", "oval constrain centered scaled");
			}
			if(model == user_model) {
				run("Specify...", "oval constrain centered scaled");
			}	
	   		
	   		run("Enlarge...", "enlarge=set_roi_enlargement_single");
	   		roiManager("update");
		}
		setBatchMode("exit and display");
		
		height=getHeight();													//
		width=getWidth();													//
		selectWindow(name+"-1"+imageType);
		setLocation(0, screenHeight/4,width*1.5, height*1.5 );Table.setLocationAndSize((screenWidth/3)*2, (screenHeight/5)*1, screenWidth/9, screenHeight/3, "ROI Manager");
	
		if(isOpen("ROI Conversion Progress")==true){
			selectWindow("ROI Conversion Progress");
			run("Close");
		}
	} 

	wait(10);	
	setTool("rectangle");
	selectWindow(full_name);
	roiManager("Show All");
	roiManager("Show All with labels");
	wait(10);
	selectWindow(name+"-1"+imageType);
	roiManager("Show All");
	roiManager("Show All with labels");
	selectWindow(name+"-1"+imageType);
	
 	//user_model="";
 	manual_menu();
}

//////////////////////////

function manual_menu(){
	custom_library_reader();
	if(user_model=="new model name") user_model="No";
	
	roiManager("Show All");
	//roiManager("Show All with labels");
	set_intensity_low_threshold_old = set_intensity_low_threshold;
	set_low_particlesize_old = set_low_particlesize;
	set_high_particlesize_old = set_high_particlesize;
	setTool("oval");
	
	Dialog.createNonBlocking("Adjust Cell Detection Threshold");
	items = newArray("Reprocess cell detection using new settings", "Modify ROIs by hand", "Load previous ROI set", "ROIs are complete: Finish analysis"); //, "-> Get access to AI-enabled cell detection <-");
	Dialog.addSlider("Threshold of Detection:", (set_intensity_low_threshold*0.1), (set_intensity_low_threshold*2), set_intensity_low_threshold);
	Dialog.addSlider("Smallest Cell Detected:", 0.0, 10000, set_low_particlesize);
	Dialog.addSlider("Largest Cell Detected:", 0.0, 100000, set_high_particlesize);

	Dialog.addRadioButtonGroup("Would you like to change the cell detection threshold settings?", items, 5, 1, 0);

	Dialog.addMessage("");
	Dialog.addMessage("If you have manually edited a lot of ROIs, you may want to train a detection model to fit your image needs.");
	custom_lib = Array.concat("No", "Start a new model", custom_library);
	Dialog.addChoice("   Add these annotations to a custom model?:", custom_lib, user_model);
	Dialog.addMessage("");

	Dialog.show;
	set_intensity_low_threshold = Dialog.getNumber();
	set_low_particlesize = Dialog.getNumber();
	set_high_particlesize = Dialog.getNumber();
	choice = Dialog.getRadioButton;
	
	user_model_temp = Dialog.getChoice();

	if (user_model_temp!="No" && lic==0) {
		waitForUser("Sorry, a current Pipsqueak AI license is needed to generate custom AI detection models.");
	}
	if (user_model_temp=="Start a new model" && lic==1) {
		custom_model();
	}
	if (user_model_temp!="No" && user_model_temp!="Start a new model" && lic==1) {
		user_model=user_model_temp;
	}	
	
	model=user_model;
	if(user_model=="No") user_model="new model name";
	
	if(choice=="null"){
		manual_menu();
	}else if (choice=="Reprocess cell detection using new settings") {
		threshold_detection();
	}else if (choice=="Modify ROIs by hand" && set_intensity_low_threshold_old==set_intensity_low_threshold && set_low_particlesize_old==set_low_particlesize && set_high_particlesize_old==set_high_particlesize)  {
		selectWindow(full_name);
		roiManager("Show All");
		roiManager("Show All with labels");
		waitForUser("How Does That Look?", "Here is your chance to adjust the ROIs to better identify PNNs. Try adding or deleting ROIs in the ROI manager. **THEN** press OK.");
		roiManager("deselect");
		if(roiManager("count")>0){
			roiManager("save", imageDir+name+".zip");
		}
		manual_menu();
	}else if (choice=="Load previous ROI set") {
		roiManager("reset");
		open();
		selectWindow(full_name); 
		roiManager("Show All");
		//roiManager("Show All with labels");
		roiManager("deselect");
		if(roiManager("count")>0){
			roiManager("save", imageDir+name+".zip");
		}
		manual_menu();		
	}else if (choice=="ROIs are complete: Finish analysis")  {
		selectWindow(full_name);  	
  		roiManager("Show All");

  		n=roiManager("count");
		for(i=0; i<n; i++){
			roiManager("select", i);
			roiName = Roi.getName();
			roiNameSplit = split(roiName, "-");
			roiNameNew = roiNameSplit[0]+imageOrder+"-"+roiNameSplit[1];
			//roiNameNew = user_model+"-"+roiName;
			roiManager("select", i);
			roiManager("Rename", roiNameNew);
		}
		
  		//roiManager("Show All with labels");

		title3 = "[Processing]";
  		if(isOpen("Processing")==false){
  			run("Text Window...", "name="+ title3 +" width=100 height=15 SansSerif");
	  		selectWindow("Processing");
	  		setLocation((screenWidth/5)*1.5, (screenHeight/5)*3);
	  	}
//waitForUser("upload only string: "+image_file+" "+model+" "+treatment+" "+subject+" "+experiment);  		
  		upload_key=exec(AI_Engine_exec, "inference", "--upload-only", image_file, user_model, "--treatment", treatment, "--subject", subject, "--experiment", experiment);
		
		if(upload_key!=-1){
			upload_result1="";
			
			upload_return=split(upload_key, "\n");
			if(upload_return.length>1){
				upload_result1=upload_return[1];
			}
			
			for(i=0; i<upload_return.length; i++) {
				print(title3, upload_return[i]+"\n");
			}
			//if(i>=2) print(title2, "\n"+inference_return[i]);
			if(upload_return.length>2){
				j=upload_return.length-1;
				imageKey=upload_return[j];
				print(title3, "\nimageKey: "+imageKey);
				//print("\nimageKey: "+imageKey);
			}
		}
		if(isOpen("Processing")==true){
			wait(2000);
			selectWindow("Processing");
			run("Close");
		}
	}
}	


/////////////////////////////
function Measure_ROIs(){

	selectWindow(full_name);
	close(full_name);
	wait(20);
	selectWindow(name+"-1"+imageType);
	roiManager("UseNames", "true"); // shows ROI names on image
	roiManager("Show All");
	roiManager("Show All with labels");

	if(File.exists(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip")==1){
		silent=File.rename(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip", imageDir+name+TimeString+"(archived_{single}_("+model+"}_ROI_overlay).zip");
	}

//saving ROI overlay
	save_ROIs=roiManager("count");
	
	if(save_ROIs<=0 && beastMode<10){
		waitForUser("No ROIs present. Results will be saved, then image closed.");
		run("Clear Results");
		//selectWindow(name+"-1"+imageType);;
		//wait(15);
		//run("Close");
		//initi();
		return;
	}
	array=newArray(save_ROIs);
	for(i=0; i<save_ROIs; i++) {
		array[i] = i;
	}
	if(roiManager("count")>0){
		roiManager("Select", array);
		roiManager("Save", imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip");
	}
	wait(100);
	if(File.exists(imageDir+name+".zip")==1){
		silent=File.delete(imageDir+name+".zip");
	}
	//////////////////////////////////////////////////////////////////
	//print(silent);
//Measuring ROIs
	run("Clear Results");
	
	roiManager("Show All");
	roiManager("Show All with labels");
	measure_squares=0;
	measure_squares=roiManager("count");
	array=newArray(measure_squares);
	for(i=0; i<measure_squares;i++) {
		array[i] = i;
	}
	
	roiManager("Select", array);
	roiManager("Measure");
	m=0;
	means=0;
	m = nResults;
	means = newArray(m);
	run("Select None");
	for (i=0; i<m; i++) {
		means[i] = getResult('Mean', i);
	}
	run("Select None");
	for (i=0; i<m; i++) {
		roiManager("Select", i); 
		//roiManager("Rename", i);
		roiName = Roi.getName(); 

		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Integrated_Density", i, (means[i]-lower)*getResult('Area', i));
		setResult("Stain", i, model);
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Ind_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("AnalysisDate", i, TimeString);
	}
	
	setOption("ShowRowNumbers", false);
	updateResults();
	m2 = 0;
	avgmeans = 0;
	m2 = nResults;
	avgmeans = newArray(m2);
	run("Select None");
	for (i=0; i<m2; i++) {
		avgmeans[i] = getResult('Mean-Background', i);
	}
 	Array.getStatistics(avgmeans, min, max, mean, stdDev);
	//print("Mean_Intensity="+mean);
	numberPNNs=0;
	numberPNNs=getValue("results.count");
	//print("Number_of_Cells_Identified="+numberPNNs);
	n = nResults;
	area = newArray(n);
	XM = newArray(n);
	YM = newArray(n);
	mean = newArray(n);
	stddev = newArray(n);
	min = newArray(n);
	max = newArray(n);
	bkgd = newArray(n);
	meanbkgd = newArray(n);
	print("\n");
	//print("Individual cell data:");
	print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
	for (i=0; i<n; i++) {
		area[i] = getResult('Area', i);
		XM[i] = getResult('XM', i);
		YM[i] = getResult('YM', i);
		mean[i] = getResult('Mean', i);
		stddev[i] = getResult('StdDev', i);
		min[i] = getResult('Min', i);
		max[i] = getResult('Max', i);
		bkgd[i] = getResult('Background', i);
		meanbkgd[i] = getResult('Mean-Background', i);
		print(experiment+" "+subject+" "+treatment+" "+name+" "+model+" "+(i+1)+" "+area[i]+" "+XM[i]+" "+YM[i]+" "+mean[i]+" "+stddev[i]+" "+min[i]+" "+max[i]+" "+bkgd[i]+" "+meanbkgd[i]);
	}
}

/////////////////////////////
function Save_ROIs(){
	// Saving data======v

	saveParameters();
	if(File.exists(imageDir+name+"_{single}_{"+model+"}_measurements.csv")==1){
		silent=File.rename(imageDir+name+"_{single}_{"+model+"}_measurements.csv", imageDir+name+"_{single}_{"+model+"}_measurements_(archived-"+TimeString+").csv");
	}
	selectWindow("Log");
	saveAs("Measurements", imageDir+name+"_{single}_{"+model+"}_measurements.csv");
	saveAs("Text", dir+"All_Results"+TimeString+".txt");
	wait(100);

	if(osCheck=="Windows"){
		silent=File.makeDirectory(pipDir+"Temp"); 
		if(File.exists(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip")){
			silent=File.copy(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip", pipDir+"Temp/"+name+"_{single}_{"+model+"}_ROI-overlay.zip");
		}
		if(File.exists(imageDir+name+"_{single}_{"+model+"}_measurements.csv")){
			silent=File.copy(imageDir+name+"_{single}_{"+model+"}_measurements.csv", pipDir+"Temp/"+name+"_{single}_{"+model+"}_measurements.csv");
		}
		silent=exec("powershell", "Compress-Archive", pipDir+"Temp/*", pipDir+"Temp/"+name+"_results.zip");
				
		silent=File.copy(pipDir+"Temp/"+name+"_results.zip", imageDir+name+"_results.zip");
		wait(10);
		File.delete(pipDir+"Temp/"+name+"_{single}_{"+model+"}_measurements.csv");
		File.delete(pipDir+"Temp/"+name+"_{single}_{"+model+"}_ROI-overlay.zip");
		File.delete(pipDir+"Temp/"+name+"_results.zip");
		
	}else{
		silent=exec("zip", imageDir+name+"_results.zip", imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip", imageDir+name+"_{single}_{"+model+"}_measurements.csv");
	}
	
	silent=exec(AI_Engine_exec, "results", imageDir+name+"_results.zip", imageKey);

	// Closing project=======v
	roiManager("reset");
		
	selectWindow(name+"-1"+imageType);
	saveAs("Tiff", imageDir+name+"_bkgd_subtracted.tif");

	selectWindow("ROI Manager");
	wait(15);
	run("Close");
	//waitForUser("end single");
	imageKey = 0;
}

////////////////////////////////////////////////
function ps_single(){
	IJ.redirectErrorMessages();
//Check_Key();
	beastMode="";
	
	Dialog.create("Single Label Functions");
  	items = newArray("Analyze image", "Batch analysis", "Sum Z-stacks for analysis");//, "Compile \"All Results\" file");
  	Dialog.addRadioButtonGroup("Choose single label operation", items, 3, 1, "Analyze image");
  	Dialog.addMessage("\nBatch analysis will speed up analysis by automatically processing a folder of images. \nThis reduces your opportunities for interaction during analysis.");
  	Dialog.show;
  	choice = Dialog.getRadioButton;
  	 	
  	if (choice=="Analyze image") {	
  		
  		beastMode=0;
  		ps_open_single();
	}
	if(choice=="Batch analysis"){
  		
  		beastMode=100;
  		ps_open_single();
	}
	if (choice=="Sum Z-stacks for analysis") {
  		Zchannels=1;
		stackSum(Zchannels);
  	}
	if (choice=="Compile \"All Results\" file") {
  		
		Dialog.create("Compile All-Results");
		Dialog.addMessage("What input would you like to use for compiling an All-Results file?");
  		items = newArray("ROIs and images (useful to change analysis parameters)", "Individual CSV files (faster and more accurate. Pipsqueak version 5.2.0 or later)", "Individual .txt files (from Pipsqueak version 5.1.2 or earlier)");
  		Dialog.addRadioButtonGroup("Input type:", items, 3, 1, "Individual CSV files (faster and more accurate with previous analysis)");
  		Dialog.show;
  		choice = Dialog.getRadioButton;
		
		import_type = 7;
		if( choice== "ROIs and images (useful to change analysis parameters)") {
			ps_Compile_Single();
		}

		if( choice== "Individual CSV files (faster and more accurate. Pipsqueak version 5.2.0 or later)") {
			ps_Compile_Single_csvs();
		}
		
		if( choice== "Individual .txt files (from Pipsqueak version 5.1.2 or earlier)") {
			ps_Compile_Single_txts();
		}
	}	
}
/////////////////////////////
function custom_initi(){
	IJ.redirectErrorMessages();
//Check_Key();
	beastMode=0;
	
	Dialog.create("Create Custom Model");
  	items = newArray("Add images and ROIs to custom model dataset", "Submit dataset for custom model training");//, "Compile \"All Results\" file");
  	Dialog.addRadioButtonGroup("Choose custom model operation", items, 2, 1, "Add images and ROIs to custom model dataset");
  	Dialog.addMessage("");
  	Dialog.addMessage("Training a GOOD model depends on you providing example ROIs. You can place all your ROIs by hand, or start with some that Pipsqueak AI generates for you.");
  	Dialog.addMessage("False positives and false negatives will influence the accuracy of your AI model. \n-->i.e., Draw your annotations how you want your results to look.");
	Dialog.addMessage("");
	Dialog.addMessage("\nWhen you have finished labeling all the images you want to use for training (10-30 images is a good place to start), \nSelect \"Submit dataset for custom model training.\"");
	
  	Dialog.show;
  	choice = Dialog.getRadioButton;
  	 	
  	if (choice=="Add images and ROIs to custom model dataset") {	
  		custom_menu();
	}
	if(choice=="Submit dataset for custom model training"){
		custom_library_reader();
		
		Dialog.create("Select dataset to submit for model training.");
		Dialog.addMessage("Please select a dataset to submit for model training. Detection model training currently may take 3-4 business days. \n \nWhen complete, your new model will become available under \"Custom Models\" in your selection dropdown.");
		Dialog.addChoice("Select dataset for submission", custom_library);
		Dialog.show;
	
		user_model = Dialog.getChoice();
		
  		message="Dataset submission for model training.";
  		silent=exec(AI_Engine_exec, "notify", user_model, message);

  		waitForUser("Your \""+user_model+"\" dataset has been submitted for training! Detection model training currently may take 3-4 business days. \n \nWhen complete, your new model will become available under \"Custom Models\" in your selection dropdown." );

  		custom_library=Array.deleteValue(custom_library, user_model);
  		user_model=user_model+"-*in training*";
  		custom_library=Array.concat(custom_library, user_model);
  		custom_library_writer(custom_library);

  	  }
}
/////////////////////////////
function custom_model(){
	if(isOpen("AI Engine Results")==true){
		selectWindow("AI Engine Results");
		run("Close");
	}
	if(user_model=="No") user_model="new model name";
		
	Dialog.create("New detection model name?");
	Dialog.addMessage("Please enter the name of the marker you are detecting. Use the same model name for all images you intend to train a detection model.");
	Dialog.addString("Name your detection model:", user_model, 30);
	Dialog.show;
	user_model =  Dialog.getString();

	custom_library_reader(); 
	custom_library=Array.concat(custom_library, user_model);
	custom_library_writer(custom_library);

	call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-Custom_Model-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".Custom_Model."+email_address+"%3B&utmu=DC~";
	silent= File.openUrlAsString(call_home_url);
	wait(20);
}
/////////////////////////////
function custom_menu(){
	parentFunction = "custom_menu()";
	model_library_reader();
	custom_library_reader();
	//custom_library_reader();
	custom_lib=newArray();	
	
	specific_models=Array.deleteValue(specific_models, "null");
	general_models=Array.deleteValue(general_models, "null");
	general_models=Array.concat(general_models, "Threshold Detection");
	community_models=Array.deleteValue(community_models, "null");
	if(community_models.length==0) community_models=Array.concat(community_models, "<none>");
	custom_models=Array.deleteValue(custom_models, "null");
	if(custom_models.length==0) custom_models=Array.concat(custom_models, "<none>");
	
	if(isOpen("AI Engine Results")==true){
		selectWindow("AI Engine Results");
		run("Close");
	}
	ML_thresh_display=50-ML_thresh;
	if(subsectioning==1) subsectioning_choice="Off"; //"Off"
	if(subsectioning==2) subsectioning_choice="2x2"; //"2x"
	if(subsectioning==3) subsectioning_choice="3x3"; //"3x"
	if(subsectioning==4) subsectioning_choice="4x4"; //"4x"
	if(subsectioning==5) subsectioning_choice="5x5"; //"5x"
	if(subsectioning==6) subsectioning_choice="6x6"; //"6x"
	
	Dialog.create("Train new detection model");
	Dialog.addMessage("Please give your model a name or select one you have already started. (Remember: Use the same model name for all images you intend to train a detection model.)");
	custom_lib = Array.concat("Start a new model", custom_library);
	Dialog.addChoice("Your models in development:", custom_lib, user_model);
	Dialog.addMessage("");
	Dialog.addMessage("Training a model depends on you providing example ROIs. You can place all your ROIs by hand, or start with some that Pipsqueak AI generates for you.");
	models_temp = Array.concat("*Specific models*", specific_models, "-------------", "*General models*", general_models, "-------------", "*Community models*", community_models, "-------------", "*Previous custom models", custom_models); //, "-------------", "Manually draw ROIs only");
	Dialog.addChoice("Select how you'll start placing ROIs on your image:", models_temp, model);
	Dialog.addSlider("Detection Sensitivity:", 1, 50, ML_thresh_display);
	Dialog.addSlider("Threshold for Removal of Overlapping ROIs (% Area):", 0.0, 100, dup_thresh);	
	Dialog.addMessage("");
	Dialog.addMessage("In a moment, please place ROIs around all of the cells/targets you hope to detect with the AI model. \nFalse positives and false negatives will influence the accuracy of your AI model. \n-->i.e., Draw your annotations how you want your results to look.");
	Dialog.addMessage("\nWhen you have finished labeling all the images you want to use for training (10-30 is a good place to start), \nPress the \"Begin custom model training\" button on the previous screen.");
	Dialog.addMessage("");
	Dialog.addFile("Select an image to add to model training", imageDir);
	Dialog.addMessage("");	
	Dialog.addMessage("   Large image subsectioning: \""+subsectioning_choice+"\"");
	Dialog.addCheckbox("Change Settings", false);
	
	Dialog.show;
	
	user_model = Dialog.getChoice();
	model =  Dialog.getChoice();
	ML_thresh_display = Dialog.getNumber();
	dup_thresh = Dialog.getNumber();
	first_image=Dialog.getString();
	editSettings = Dialog.getCheckbox();
	ML_thresh=50-ML_thresh_display;

	if(editSettings==true){
		settings();
		Initiate_ROI();
	}		
	call_home_url = "http://www.google-analytics.com/__utm.gif?utmwv=5.1.7&utms=1&utmn=1894752493&utmhn=www.jabstracts.org/&utmcs=UTF-8&utmsr=1280×1024&utmsc=24-bit&utmul=en-us&utmje=1&utmfl=10.3%20r183&utmdt=Tracking%20QR%20Codes%20with%20Google%20Analytics&utmhid=1681965357&utmr=http%3A%2F%2Fwww.imagejnih.gov%2F&utmp=%2Fjabstracts.org%2Fpipsqueak%2Fcall_home%2F"+verurl+"-Custom_Model-"+email_address+"%2F&utmac=UA-83183702-1&utmcc=__utma%3D230887938.1463229748.1317737798.1317737798.1317737798.1%3B%2B__utmz%3D230887938.1317737798.1.1.utmcsr%3Dgoogle%7Cutmccn%3D(organic)%7Cutmcmd%3Dorganic%7Cutmctr%3DPIPSQUEAK%2Fv"+ver+".Custom_Model."+email_address+"%3B&utmu=DC~";
	silent= File.openUrlAsString(call_home_url);
	wait(20);

	if(model=="*Specific models*" || model== "*General models*" || model== "*Community models*" || model== "-------------"  || model== "*Custom models"){
		waitForUser("Invalid Choice: Please select a valid model");
		custom_menu();
	}
	saveParameters();

	if(user_model=="Start a new model"){
		user_model="new model name";
		custom_model();
	}
	
	open(first_image);
	full_name = getTitle;
	imageDir=getDirectory("image");
	selectWindow(full_name);
  	setLocation((screenWidth/5)*0.5, (screenHeight/5)*0.5);
  	
	selectWindow(full_name);
	run("Duplicate...", " ");
	
	index = lastIndexOf(full_name, ".");
	if (index!=-1) imageType = substring(full_name, index, lengthOf(full_name));
	if (index!=-1) name = substring(full_name, 0, index);
					
	if(imageType==".tif" && reduceSize=="Speed"){
		selectWindow(full_name);
		saveAs("jpeg", imageDir+name);
		image_file=imageDir+name+".jpg";		
	}else{
		image_file=imageDir+full_name;
	}
	print("Image Name: "+full_name);

	selectWindow(name+"-1"+imageType);
  	setLocation((screenWidth/5)*0.5, (screenHeight/5)*0.5);
  		
	ROI_shape=ROI_type_SL;
	ROI_enlargement=set_roi_enlargement_single;	
	imageOrder="a";
					
	recursive_inference();
	if(isOpen("AI Engine Results")==true){
		selectWindow("AI Engine Results");
		run("Close");
	}
	print("imageKey: "+imageKey);

	///////////////
	//					SL_stain_type=model;
	//				Measure_ROIs();
	//////////////	
		
	title3 = "[Processing]";
  	if(isOpen("Processing")==false){
  		run("Text Window...", "name="+ title3 +" width=100 height=15 SansSerif");
		selectWindow("Processing");
		setLocation((screenWidth/5)*1.5, (screenHeight/5)*3);
	}
	//waitForUser("upload only string: "+image_file+" "+model+" "+treatment+" "+subject+" "+experiment);  		
  	upload_key=exec(AI_Engine_exec, "inference", "--upload-only", image_file, user_model, "--treatment", treatment, "--subject", subject, "--experiment", experiment);
		
	if(upload_key!=-1){
		upload_result1="";
			
		upload_return=split(upload_key, "\n");
		if(upload_return.length>1){
			upload_result1=upload_return[1];
		}
			
		for(i=0; i<upload_return.length; i++) {
			print(title3, upload_return[i]+"\n");
		}
		//if(i>=2) print(title2, "\n"+inference_return[i]);
		if(upload_return.length>2){
			j=upload_return.length-1;
			imageKey=upload_return[j];
			print(title3, "\nimageKey: "+imageKey);
			//print("\nimageKey: "+imageKey);
		}
	}
	if(isOpen("Processing")==true){
		wait(4000);
		selectWindow("Processing");
		run("Close");
	}
	save_ROIs=roiManager("count");
	
	if(save_ROIs<=0 && beastMode<10){
		waitForUser("No ROIs present. Results will be saved, then image closed.");
		run("Clear Results");
		//selectWindow(name+"-1"+imageType);;
		//wait(15);
		//run("Close");
		//initi();
		return;
	}
	if(File.exists(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip")==1){
		silent=File.rename(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip", imageDir+name+TimeString+"(archived_{single}_("+model+"}_ROI_overlay).zip");
	}
	array=newArray(save_ROIs);
	for(i=0; i<save_ROIs; i++) {
		array[i] = i;
	}
	if(roiManager("count")>0){
		roiManager("Select", array);
		roiManager("Save", imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip");
	}
	wait(100);
	if(File.exists(imageDir+name+".zip")==1){
		silent=File.delete(imageDir+name+".zip");
	}
	if(osCheck=="Windows"){
		silent=File.makeDirectory(pipDir+"Temp"); 
		if(File.exists(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip")){
			silent=File.copy(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip", pipDir+"Temp/"+name+"_{single}_{"+model+"}_ROI-overlay.zip");
		}
		if(File.exists(imageDir+name+"_{single}_{"+model+"}_measurements.csv")){
			silent=File.copy(imageDir+name+"_{single}_{"+model+"}_measurements.csv", pipDir+"Temp/"+name+"_{single}_{"+model+"}_measurements.csv");
		}
		silent=exec("powershell", "Compress-Archive", pipDir+"Temp/*", pipDir+"Temp/"+name+"_results.zip");
				
		silent=File.copy(pipDir+"Temp/"+name+"_results.zip", imageDir+name+"_results.zip");
		wait(10);
		File.delete(pipDir+"Temp/"+name+"_{single}_{"+model+"}_measurements.csv");
		File.delete(pipDir+"Temp/"+name+"_{single}_{"+model+"}_ROI-overlay.zip");
		File.delete(pipDir+"Temp/"+name+"_results.zip");
		
	}else{
		silent=exec("zip", imageDir+name+"_results.zip", imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip", imageDir+name+"_{single}_{"+model+"}_measurements.csv");
	}
	
	silent=exec(AI_Engine_exec, "results", imageDir+name+"_results.zip", imageKey);

	roiManager("reset");
	close("*");	

	Dialog.create("Add another image?");
	items = newArray("Annotate another image", "Exit to main menu");
	Dialog.addRadioButtonGroup("Done! Next Move:", items, 2, 1, "Annotate another image");
		Dialog.show;
		choice = Dialog.getRadioButton;
				
		if (choice=="Annotate another image") {
			custom_initi();
		} else {
			//initi();
			return;
		}
	imageKey = 0;
	return;
}
///////////////////////////
function ps_open_single(){
	parentFunction = "open_single()";
	//user_model="No";
	
	if(beastMode==100){
		dir="";
		SL_stain_type=model;

		ML_thresh_display=50-ML_thresh;
		if(subsectioning==1) subsectioning_choice="Off"; //"Off"
		if(subsectioning==2) subsectioning_choice="2x2"; //"2x"
		if(subsectioning==3) subsectioning_choice="3x3"; //"3x"
		if(subsectioning==4) subsectioning_choice="4x4"; //"4x"
		if(subsectioning==5) subsectioning_choice="5x5"; //"5x"
		if(subsectioning==6) subsectioning_choice="6x6"; //"6x"
	
		model_library_reader();

		if(File.exists(pipDir+"models.json")){
			parameters = File.openAsString(pipDir+"models.json");
			parLines=split(parameters,"}");
			model_num = parLines.length;
	
			specific_models=Array.slice(model_library,0,model_num-1);
			general_models=Array.slice(model_library,model_num,(model_num-1)*2);
			community_models=Array.slice(model_library,model_num*2,(model_num-1)*3);
			custom_models=Array.slice(model_library,model_num*3,(model_num-1)*4);
		}
	
		specific_models=Array.deleteValue(specific_models, "null");
		general_models=Array.deleteValue(general_models, "null");
		//general_models=Array.concat(general_models, "Threshold Detection");
		community_models=Array.deleteValue(community_models, "null");
		if(community_models.length==0) community_models=Array.concat(community_models, "<none>");
		custom_models=Array.deleteValue(custom_models, "null");
		if(custom_models.length==0) custom_models=Array.concat(custom_models, "<none>");

		models = Array.concat("*Specific models*", specific_models, "-------------", "*General models*", general_models, "-------------", "*Community models*", community_models, "-------------", "*Custom models", custom_models);
		
		Dialog.createNonBlocking("Select folder for batch image processing.");
		Dialog.addDirectory("Select folder containing a batch of images to process:", dir);
		Dialog.addString("Experiment ID:", "NA");
		Dialog.addString("Subject #:", "");
		Dialog.addString("Independent Variable:", "NA");
		Dialog.addMessage("");
		Dialog.addMessage("Cell Detection Parameters");
		Dialog.addSlider("Detection Sensitivity:", 1, 50, ML_thresh_display);
		Dialog.addSlider("Threshold for Removal of Overlapping ROIs (% Area):", 0.0, 100, dup_thresh);
		Dialog.addChoice("Detection model to be used for all batched images:", models);
		Dialog.addMessage("");
		//Dialog.addMessage("   AI detection preference: \""+ reduceSize+"\"");
		Dialog.addMessage("   Large image subsectioning: \""+subsectioning_choice+"\"");
		Dialog.addCheckbox("Change Settings", false);
		Dialog.show

		dir=Dialog.getString();
		experiment=Dialog.getString();
		subject=Dialog.getString();
		treatment=Dialog.getString();
		subfolders = getFileList(dir);
		ML_thresh_display = Dialog.getNumber();
		dup_thresh = Dialog.getNumber();
		model =  Dialog.getChoice();
			
		ML_thresh=50-ML_thresh_display;
		
		
		editSettings = Dialog.getCheckbox();
		
		if(editSettings==true){
			settings();
			ps_open_single();
		}		
	
		if(model=="*Specific models*" || model== "*General models*" || model== "*Community models*" || model== "-------------"  || model== "*Custom models"){
			waitForUser("Invalid Choice: Please select a valid model");
			ps_open_single();
		}			
		
		saveParameters();
		
		title = "[Image Processing Progress]";
		run("Text Window...", "name="+ title +" width=30 height=4 monospaced");
		selectWindow("Image Processing Progress");
  		setLocation((screenWidth/5)*2, (screenHeight/5)*1.5);
		batchImageArray=newArray();
		batchKeyArray=newArray();

		print("Batch processing images");
		print("Detection Model: "+model);
		print("Detection Sensitivity: "+ML_thresh_display);
		print("Overlap Threshold: "+dup_thresh+"\n");
		print("Images Processed:");
		for(i=0; i<subfolders.length; i++){
			//print("");
			subDir = subfolders[i];
			if(File.isDirectory(dir+subDir)==1){
				print(dir+subDir+" is not an image file.");	
				/*
				//then subfolders are folders with (or without) images
				print(title, "\\Update:"+i+1+"/"+subfolders.length+" ("+((i+1)*100)/subfolders.length+"%)\n"+getBar(i, subfolders.length));
				index = lastIndexOf(subDir, "/");
				if (index!=-1) series_name = substring(subDir, 0, index); //get the name of the subDir folder
				subfolders2 = getFileList(dir+subDir);
				for(j=0; j<subfolders.length; j++){ //determine if the contents of subDir are files or folders
					subDir2 = subfolders2[j];
					if(File.isDirectory(dir+subDir+subDir2)!=1){ // if it is a file, run from here.
						
						name=subDir2;
						subject=name;
						
						index = lastIndexOf(name, ".");
						if (index!=-1) imageType = substring(name, index, lengthOf(name));
						if (index!=-1) name = substring(name, 0, index);
						
						series_name=name+"/";
												
						//now open and process
						if(imageType==".tif" || imageType==".tiff" || imageType==".png" || imageType==".jpg" || imageType==".jpeg" || imageType==".avi" || imageType==".bmp" || imageType==".gif"){
							open(dir+subDir+name+imageType);
							full_name = getTitle;
							run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");
	
							if(File.exists(dir+subDir+series_name)!=1){
								File.makeDirectory(dir+subDir+series_name);
								silent=File.rename(dir+subDir+full_name, dir+subDir+series_name+full_name);
								wait(20);
							}
							imageDir=dir+subDir+series_name;
							if(imageType==".tif" && reduceSize=="Speed"){
						  		selectWindow(full_name);
						  		saveAs("jpeg", imageDir+name);
						  		image_file=imageDir+name+".jpg";		
						  	}else{
						  		image_file=imageDir+full_name;
						  	}
							
							print("full_name: "+full_name);
							print("name: "+name);
							print("imageType: "+imageType);
							print("subject: "+subject);
							print("series_name: "+series_name);
							print("subDir: "+subDir);
							print("dir: "+dir);			
							ROI_shape=ROI_type_SL;
							ROI_enlargement=set_roi_enlargement_single;
							imageOrder="a";
													
							//region_limit();
							Set_Background(parentFunction);
							//Initiate_ROI();
							if(lic==0){
								Dialog.create("License expired");
								items = newArray("Yes", "No");
								Dialog.addMessage("Sorry, you need an active Pipsqueak AI license to perform batch image analysis.");
								Dialog.addRadioButtonGroup("Would you like to open my.pipsqueak.ai to manage or renew your license now?:", items, 2, 1, "Yes");
								Dialog.show;
								choice = Dialog.getRadioButton;
										
								if (choice=="Yes") {
									exec("open", "https://my.pipsqueak.ai");
								} else {
									return;
								}
							}
							if(lic==1){
								//Initiate_ROI();
								//image_file=imageDir+full_name;  
								recursive_inference();
						  		if(isOpen("AI Engine Results")==true){
									selectWindow("AI Engine Results");
									run("Close");
						  		}	
							}
							SL_stain_type=model;
							Measure_ROIs();
							Save_ROIs();
							close("*");	
						}					
					}else{
						waitForUser("Check to make sure that you select the folder containing your batch of images OR \ncontaining a batch of individual subfolders for each image.");
					}
				}
				ps_open_single();
			*/	
			//setBatchMode("hide");
			}	
			roiManager("reset");
			if(File.isDirectory(dir+subDir)==0){
			//else{ //subfolders are image files
				
				print(title, "\\Update:"+i+1+"/"+subfolders.length+" ("+((i+1)*100)/subfolders.length+"%)\n"+getBar(i, subfolders.length));
				name=subDir;
						
				index = lastIndexOf(name, ".");
				if (index!=-1) imageType = substring(name, index, lengthOf(name));
				if (index!=-1) name = substring(name, 0, index);
						
				series_name=name+"/";
									
				//now open and process
				if(imageType==".tif" || imageType==".tiff" || imageType==".png" || imageType==".jpg" || imageType==".jpeg" || imageType==".avi" || imageType==".bmp" || imageType==".gif"){
					open(dir+name+imageType);
					full_name = getTitle;
					batchImageArray=Array.concat(batchImageArray,full_name);
					selectWindow(full_name);
  					setLocation((screenWidth/5)*0.5, (screenHeight/5)*0.5);
						
					if(File.exists(dir+series_name)==0){
						File.makeDirectory(dir+series_name);
						silent=File.copy(dir+full_name, dir+series_name+full_name);
						wait(20);						
					}
					imageDir=dir+series_name;
					if(imageType==".tif" && reduceSize=="Speed"){
				  		selectWindow(full_name);
				  		saveAs("jpeg", imageDir+name);
				  		image_file=imageDir+name+".jpg";		
				  	}else{
				  		image_file=imageDir+full_name;
				  	}
					//print("dir: "+dir);	
					//print("subDir: "+subDir);	
					//print("series_name: "+series_name);	
					print("Image Name: "+full_name);
					
					//print("name: "+name);
					//print("imageType: "+imageType);
					//print("subject: "+subject);
					//print("model: "+model);				
					
					ROI_shape=ROI_type_SL;
					ROI_enlargement=set_roi_enlargement_single;	
					imageOrder="a";

					if(lic==0){
						Dialog.create("License expired");
						items = newArray("Yes", "No");
						Dialog.addMessage("Sorry, you need an active Pipsqueak AI license to perform batch image analysis.");
						Dialog.addRadioButtonGroup("Would you like to open my.pipsqueak.ai to manage or renew your license now?:", items, 2, 1, "Yes");
						Dialog.show;
						choice = Dialog.getRadioButton;
								
						if (choice=="Yes") {
							exec("open", "https://my.pipsqueak.ai");
							close("*");
							wait(20);
							if(isOpen("Image Processing Progress")==true){
						 		selectWindow("Image Processing Progress"); 
						 		run("Close");
							}
							return;
						} else {
							close("*");
							wait(20);
							if(isOpen("Image Processing Progress")==true){
						 		selectWindow("Image Processing Progress"); 
						 		run("Close");
							}
							return;
						}
					}
					if(lic==1){
						Run_Inference();
						print("imageKey: "+imageKey);
						batchKeyArray=Array.concat(batchKeyArray,imageKey);
						
				  		if(isOpen("AI Engine Results")==true){
							selectWindow("AI Engine Results");
							run("Close");
				  		}	
					}
					SL_stain_type=model;
					
					roiManager("UseNames", "true"); // shows ROI names on image
					roiManager("Show All");
					roiManager("Show All with labels");
				
					if(File.exists(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip")==1){
						silent=File.rename(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip", imageDir+name+TimeString+"(archived_{single}_("+model+"}_ROI_overlay).zip");
					}
				wait(25);
				//saving ROI overlay
					save_ROIs=roiManager("count");										
					array=newArray(save_ROIs);
					for(j=0; j<save_ROIs; j++) {
						array[j] = j;
					}
					if(roiManager("count")>0){
						roiManager("Select", array);
						roiManager("Save", imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip");
					}
					wait(100);
					if(File.exists(imageDir+name+".zip")==1){
						silent=File.delete(imageDir+name+".zip");
					}
					close("*");	
				}else{
					print(dir+subDir+" is not an image file.");				
				}
			}
		}
		//setBatchMode("exit and display");
		roiManager("reset");
		wait(20);
		if(isOpen("Image Processing Progress")==true){
	 		selectWindow("Image Processing Progress"); 
	 		run("Close");
		}

		Dialog.createNonBlocking("Image Detection Complete");
		Dialog.addMessage("Object detection for your batch of "+batchImageArray.length+" images has completed. \nPlease use the next step to confirm or adjust each image's ROIs. \n \nReprocessing an image alters the ROIs for that image only.");
		Dialog.show;

		
		title = "[Annotation Certification Progress]";
		run("Text Window...", "name="+ title +" width=35 height=4 monospaced");
		selectWindow("Annotation Certification Progress");
  		setLocation((screenWidth/5)*2, (screenHeight/5)*1.5);
		
		for(i=0; i<batchImageArray.length; i++){
			print(title, "\\Update:"+i+1+"/"+batchImageArray.length+" ("+((i+1)*100)/batchImageArray.length+"%)\n"+getBar(i, batchImageArray.length));
			
			full_name=batchImageArray[i];
			index = lastIndexOf(full_name, ".");
			if (index!=-1) imageType = substring(full_name, index, lengthOf(full_name));
			if (index!=-1) name = substring(full_name, 0, index);
			subDir=name+"/";
			imageDir=dir+subDir;
			image_file=imageDir+full_name;

			open(dir+subDir+full_name);
			selectWindow(full_name);
  			setLocation((screenWidth/5)*0.5, (screenHeight/5)*0.5);

			run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");
			Set_Background(parentFunction);
  			selectWindow(name+"-1"+imageType);
  			setLocation((screenWidth/5)*0.5, (screenHeight/5)*0.7);

			roiManager("reset");
			if(File.exists(imageDir+name+"_{single}_{"+model+"}_ROI-overlay.zip")==1){
				open(dir+subDir+name+"_{single}_{"+model+"}_ROI-overlay.zip");
			}
			imageKey=batchKeyArray[i];
			imageModel=model;

			menuDefault="ROIs are complete: Finish analysis";
			inferenceMessage="Viewing image "+i+1+" out of "+batchImageArray.length;
			menu(inferenceMessage);

			if(subject=="")	subject=name;
			
			Measure_ROIs();
			Save_ROIs();
			close("*");	
			model=imageModel;
		}			
		//beep();
		if(isOpen("Annotation Certification Progress")==true){
			selectWindow("Annotation Certification Progress");
			run("Close");
		}
		if(isOpen("Results")==true){
			selectWindow("Results");
			run("Close");
		}
		if(isOpen("AI Engine Results")==true){
			selectWindow("AI Engine Results");
			run("Close");
		}
		waitForUser("Batch Complete", "Batch processing is complete.");
		
	}else{
		//open();
		/*
		Dialog.createNonBlocking("Open Image");
		Dialog.addMessage("Select first "+SL_stain_type+" image to open");
		Dialog.addFile("image", imageDir);
		Dialog.show();
		*/

		run("Image Picker", "file_count=1");
		wait(500);
		status=call("PipsqueakImageSelectCommand.getStatus");
		while (status == "Not Done") {
			//print("Status: " + status);
			wait(500);
			status=call("PipsqueakImageSelectCommand.getStatus");
		}

		if (status == "quit") {
			initi();
		}

		imageDir=call("PipsqueakImageSelectCommand.getImages");
		print(imageDir);

		imageData=split(imageDir, "\n");
		imageModel=imageData[0];
		imageDir=imageData[1];


		// imageDir=Dialog.getString();
		open(imageDir);
		
		//run("Set Measurements...", "area mean standard min center limit redirect=None decimal=3");  //setting measurements.
		run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");
		
		if(SL_suffix_flo>=0) SL_suffix="_"+SL_suffix_flo;				
		dir = getDirectory("image");
		name = getTitle;
		full_name = getTitle;
		index = lastIndexOf(name, ".");
		if (index!=-1) imageType = substring(name, index, lengthOf(name));
		if (index!=-1) name = substring(name, 0, index);
		first_image = name;
		subDirIndex = lastIndexOf(dir, name);
		if (subDirIndex!=-1) {
			dir = substring(dir, 0, subDirIndex);
		}
		subDir1=name+_sep_;
		
		selectWindow(full_name);
		height=getHeight();													//
		width=getWidth();													//
		setLocation(0, screenHeight/4,width*1.5, height*1.5 );
		
		/*
		seriesIndex = lastIndexOf(full_name, SL_suffix+imageType);
		print("seriesIndex: "+seriesIndex);
		seriesIndexEnd=(lengthOf(full_name)-seriesIndex);
		print("seriesIndexEnd: "+seriesIndexEnd);
		
		if(seriesIndex==-1){
			Dialog.create("Image numbering");
	  		Dialog.addMessage("The numbering suffix entered in settings ( "+SL_suffix_flo+" ) does not match the image selected (" +full_name+ ").");
	  		Dialog.addNumber("Please enter the correct number or leave blank: ", SL_suffix_flo);
	  		Dialog.show 
			SL_suffix_flo =  Dialog.getNumber();
			SL_suffix="_"+SL_suffix_flo;
			saveSettings();

			seriesIndex = lastIndexOf(full_name, SL_suffix+imageType);
			print("new seriesIndex: "+seriesIndex);
			seriesIndexEnd=(lengthOf(full_name)-seriesIndex);
			print("new seriesIndexEnd: "+seriesIndexEnd);
		}		
		if (seriesIndex!=-1 && seriesIndexEnd<=3) {
			series_name = substring(full_name, 0, seriesIndex);
		}else{
			series_name = name;
		}
		subDirIndex = lastIndexOf(dir, series_name);
		if (subDirIndex!=-1) {
			dir = substring(dir, 0, subDirIndex);
		}
		subDir=name+"/";
		subDirIndex = lastIndexOf(dir, series_name);
		if (subDirIndex!=-1) dir = substring(dir, 0, subDirIndex);
	*/
	
	//===================================================================	
		dirCheck = getDirectory("image");
		//waitForUser(dirCheck);
		
		if(dirCheck==dir){ //new image without subDir or series_name
			//print("subDir DOES NOT exists");
			File.makeDirectory(dir+subDir1);
			silent=File.copy(dir+full_name, dir+subDir1+full_name);
			wait(20);
			imageDir=dir+subDir1;
		}else if(dirCheck==dir+subDir1+_sep_){ //image is in a subDir
			//print("subDir exists");
			imageDir=dir+subDir1;
		}else{
			//print("something weird exists");
			imageDir=dirCheck;
		}
		
	//====================================================================			
		Dialog.create("Optional metadata");
	  	Dialog.addMessage("Enter known image and/or subject information to help with data processing.");
	  	Dialog.addString("Experiment ID:", "eg:Exp1");
	  	Dialog.addString("Subject ID:", "eg:Sub_42B");
	  	Dialog.addString("Independent variable grouping:", "eg:Control");
	  	Dialog.show
	  	experiment =  Dialog.getString();
		subject =  Dialog.getString();
		treatment =  Dialog.getString();
		
		//print("full_name: "+full_name);
		//print("name: "+name);
		//print("imageType: "+imageType);
		//print("subject: "+subject);
		//print("SL_suffix: "+SL_suffix);
		//print("series_name: "+series_name);
		//print("subDir: "+subDir);
		//print("dir: "+dir);
		//print("imageDir: "+imageDir);
		//print("stain: "+SL_stain_type);
		//print("model: "+model);
		suffix=SL_suffix;
		model=imageModel;
		ROI_shape=ROI_type_SL;
		ROI_enlargement=set_roi_enlargement_single;
		saveParameters();
		parentFunction = "open_single()";
		imageOrder="a";
				
		//region_limit();
		Set_Background(parentFunction);
		
		if(lic==0){
			//waitForUser("lic==0");
			threshold_name();
			threshold_detection();
			if(isOpen("Processing")==true){
				wait(100);
				selectWindow("Processing");
				run("Close");
			}
			//manual_menu();
		}
		if(lic==1){
			if(model=="Threshold Detection"){
	  			//waitForUser("lic==1");
	  			threshold_name();
				threshold_detection();
				//manual_menu();
				pass==1;
				if(isOpen("Processing")==true){
					wait(100);
					selectWindow("Processing");
					//waitForUser;
					run("Close");
				}	
	  		}else{
				Initiate_ROI();
				recursive_inference();
		  		if(isOpen("AI Engine Results")==true){
					selectWindow("AI Engine Results");
					run("Close");
		  		}
	  		}	
		}
		SL_stain_type=model;
		Measure_ROIs();
		Save_ROIs();
		close("*");
		
		limitRegion=0;
		if(File.exists(dir+subDir1+"sub_region_selection_ROI.zip")==1){
			silent=File.rename(dir+subDir1+"sub_region_selection_ROI.zip", dir+subDir1+"sub_region_selection_ROI_("+TimeString+"_archived).zip");
		}

		Dialog.create("Analyze another image?");
		items = newArray("Open another image", "Exit to main menu");
		Dialog.addRadioButtonGroup("Analysis done! Results saves as All_Results"+TimeString+".txt"+"\n"+"Next Move:", items, 2, 1, "Open another image");
		Dialog.show;
		choice = Dialog.getRadioButton;
				
		if (choice=="Open another image") {
			ps_open_single();
		} else {
			//initi();
			return;
		}
	}
}

////////////////////////////////////////////////


function ps_double(){
	IJ.redirectErrorMessages();

	Dialog.create("Import Type"); // initial dialogue.
	items = newArray("Analyze double-labeled images", "Sum Z-stacks for analysis");
	Dialog.addRadioButtonGroup("Choose double label operation", items, 2, 1, "Analyze double-labeled images");
	Dialog.show;
	choice = Dialog.getRadioButton;

	if (choice=="Auto") {
		import_type = 6;
		waitForUser("Coming tomorrow in an automatic update to v5.1.4");
		initi();
	}
	if (choice=="Sum Z-stacks for analysis") {
		Zchannels=3;
		stackSum(Zchannels);
	}
	if (choice=="Compile \"All Results\" file from previous analysis") {
		import_type = 7;
		//ps_Compile_Double();
		waitForUser("Coming tomorrow in an automatic update to v5.1.4");
		initi();
	}
	
	if (choice=="Analyze double-labeled images") {
		//import_type = 5;
		/*
		Dialog.create("Batch Mode");
  		Dialog.addMessage("Single Label Batch mode? Batch mode will speed up analysis, but is experimental.");
  		items = newArray("Yes", "No");
  		Dialog.addRadioButtonGroup("Batch mode:", items, 2, 1, "");
  		Dialog.show;
  		choice = Dialog.getRadioButton;
  		
  		if(choice=="Yes"){
  			beastMode=100;
  		}else{
  		*/
  			beastMode=0;
  		//}
  		open_double();
	}		
}
	
		
////////////////////////////////////////////////
function ps_triple(){
	IJ.redirectErrorMessages();
	
	Dialog.create("Import Type"); // initial dialogue.
	//items = newArray("Semiautomated analysis of summed triple-labeled images", "Automatic analysis of summed triple-labeled images", "Automatic REanalysis using previous ROIs", "->Make summed triple-labeled images from Z-stacks.");
	items = newArray("Analyze triple-labeled images", "Sum Z-stacks for analysis");//, "Compile \"All Results\" file from previous analysis");
	Dialog.addRadioButtonGroup("Choose triple label operation", items, 3, 1, "Analyze triple-labeled images");
	Dialog.show;
	choice = Dialog.getRadioButton;

	if (choice=="Analyze triple-labeled images") {
		//import_type = 5;
				
		/*
		Dialog.create("Batch Mode");
  		Dialog.addMessage("Single Label Batch mode? Batch mode will speed up analysis, but is experimental.");
  		items = newArray("Yes", "No");
  		Dialog.addRadioButtonGroup("Batch mode:", items, 2, 1, "");
  		Dialog.show;
  		choice2 = Dialog.getRadioButton;
  		
  		if(choice2=="Yes"){
  			beastMode=100;
  		}else{
  		*/
  			beastMode=0;
  		//}
  		open_triple();
	}
	if (choice=="Automatic analysis of summed triple-labeled images") {
		//import_type = 6;
		waitForUser("Coming tomorrow in an automatic update to v5.1.4");
		initi();
	}
	if (choice=="Compile \"All Results\" file from previous analysis") {
		import_type = 7;
		waitForUser("Need to clean this feature up a little. Sorry if it breaks...");
  		//ps_triple();
		ps_Compile_Triple();
	}
	if (choice=="Sum Z-stacks for analysis") {
		Zchannels=4;
		stackSum(Zchannels);
	}
}





//====================================================================================================================================================================================================================================================================

/////////////////////////////////////////////////////
//#################################################//
//#################################################//
/////////////////////////////////////////////////////




function ps_Compile_Single_csvs() { // opening previously summed images

	Dialog.create("Check your stain type");
	Dialog.addMessage("Here are the stain type that will be used. If this are not correct, the compiler will fail.");
	Dialog.addMessage("You can change it here.");
	Dialog.addString("Stain:", model);
	Dialog.addNumber("Image suffix:", SL_suffix_flo);
	Dialog.show;
	model =  Dialog.getString();
	SL_suffix_flo = Dialog.getNumber();;

	print("\\Clear");
	
	waitForUser("Select first the files for which you want to compile an \"All-Results\" file", "Please select the parent folder which contains the subfolders you want to compile.");
	dir = getDirectory("Choose a Directory "); 
	subfolders1 = getFileList(dir);
	print(dir);
	
	Dialog.create("File Name");
	Dialog.addMessage("Please enter the Experiment name or number to name your output file");
   	Dialog.addString("Experiment Name:", "Neat_Science_Exp_1");
	Dialog.show
  	exp_id =  Dialog.getString();
	
	title = "[File Processing Progress]";
	run("Text Window...", "name="+ title +" width=30 height=4 monospaced");

	if(File.exists(dir+exp_id+"_{single}_{"+model+"}_All-Results.csv")!=1){
		Table.create("All-Results");
		wait(10);
		saveAs("text", dir+exp_id+"_{single}_{"+model+"}_All-Results.csv");
		wait(100);
	}
	close("All-Results");

	
	
	for(i=0; i<subfolders1.length; i++){
		print(title, "\\Update:"+i+1+"/"+subfolders1.length+" ("+((i+1)*100)/subfolders1.length+"%)\n"+getBar(i, subfolders1.length));
		subDir1 = subfolders1[i];
		if(File.isDirectory(dir+subDir1)==1){
			print("\n");
			print(subDir1);
			index = lastIndexOf(subDir1, _sep_);
			if (index!=-1) series_name_TL = substring(subDir1, 0, index);

			first_image_TL=series_name_TL+"_"+SL_suffix_flo;
			exec("cat", dir+subDir1+series_name_TL+"_"+SL_suffix_flo+_sep_+first_image_TL+"_{single}_{"+model+"}_measurements.csv", ">>", dir+exp_id+"_{single}_{"+model+"}_All-Results.csv");
			wait(5);			
		}
	}
	wait(50);
	selectWindow("Log");
	saveAs("Text", dir+exp_id+"_{single}_{"+model+"}_All-Results.csv");
	wait(50);
	beep();
	print(title, "\\Close");
	waitForUser("Compiled all available folders");
}

///////////////////////////


function ps_Compile_Single() { // opening previously summed images
	
	
	//selectWindow("Log");
	//run("close");
	//wait(10);
	Dialog.create("Check your stain type");
	Dialog.addMessage("Here are the stain type that will be used. If this are not correct, the compiler will fail.");
	Dialog.addMessage("You can change it here.");
	Dialog.addString("Stain:", model);
	Dialog.addNumber("Image suffix:", SL_suffix_flo);
	Dialog.show;
	model =  Dialog.getString();
	SL_suffix_flo = Dialog.getNumber();;
	//saveParameters();

	waitForUser("Select first the files for which you want to compile an \"All-Results\" file", "Please select the parent folder which contains the subfolders you want to compile.");
	dir = getDirectory("Choose a Directory "); 
	subfolders1 = getFileList(dir);
	print(dir);
	
	Dialog.create("Optional metadata");
	Dialog.addMessage("Enter known image and/or subject information to help with data processing.");
	Dialog.addString("Experiment ID:", "eg:Exp1");
	Dialog.addString("Subject ID:", "eg:Sub_42B");
	Dialog.addString("Independent variable grouping:", "eg:Control");
	Dialog.show
	experiment =  Dialog.getString();
	subject =  Dialog.getString();
	treatment =  Dialog.getString();
	
	title = "[Image Processing Progress]";
	run("Text Window...", "name="+ title +" width=30 height=4 monospaced");

	for(i=0; i<subfolders1.length; i++){
		print(title, "\\Update:"+i+1+"/"+subfolders1.length+" ("+((i+1)*100)/subfolders1.length+"%)\n"+getBar(i, subfolders1.length));
		subDir1 = subfolders1[i];
		if(File.isDirectory(dir+subDir1)==1){
			print("\n");
			print(subDir1);
			index = lastIndexOf(subDir1, _sep_);
			if (index!=-1) series_name_TL = substring(subDir1, 0, index);

			first_image_TL=series_name_TL+"_"+SL_suffix_flo;
			open(dir+subDir1+series_name_TL+"_"+SL_suffix_flo+_sep_+first_image_TL+".tif");
			
			run("Set Measurements...", "area mean standard min center limit redirect=None decimal=3");  //setting measurements.
			run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");

			//setBatchMode(true);
			ps_Compile_Single_Background();
			//setBatchMode(false);
			close("*");
			//waitForUser("finished series, on to next.");
			
			/*
			subfolders2 = getFileList(dir+subDir1);
			for(j=0; j<subfolders2.length; j++){
				subDir2 = subfolders2[j];
				if(File.isDirectory(dir+subDir1+subDir2)==1){
					print(subDir2);
					index = lastIndexOf(subDir2, _sep_);
					if (index!=-1) subDir2name = substring(subDir2, 0, index-1);
				}
			}
			*/
		}
	}
	beep();
	print(title, "\\Close");
	waitForUser("Compiled all available folders");
}
///////////////////////////
///////////////////////////////

function ps_Compile_Single_Background() { //the meat of the pipsqueak. TL= triple-label. DL= double-label. SL= single-label.

//First Image
	// Selecting Background

	first_image_tif = first_image_TL+".tif";  //image names are consistently kept as "first_image_tif" and "second_image_tif" throughout the triple-labeled macro(s)
	run("Clear Results"); //clearing the template

	run("ROI Manager..."); //opening ROI manager
	roiManager("reset"); // clearing ROI manager

	roiManager("Show All"); //turning on show all labels
	roiManager("Show All with labels");

	selectWindow(first_image_tif); //grabbing first image
	
	height = getHeight; //getting dimensions in order to place background ROIs around images of any size
	width = getWidth;

	Auto_Background();
	
	// Calculating lower threshold background value in "Mean" column
	m=0;
	bkgd_mean=0;
	meanbkgd=0;
	std=0;
	bkgd_std=0;
	stdbkgd=0;
	m = nResults;
	bkgd_mean = newArray(m);
	run("Select None");
	for (i=0; i<m; i++) {
		bkgd_mean[i] = getResult('Mean', i);
	}
	if(background_setting == "High") {
		Array.getStatistics(bkgd_mean, min, max, mean, stdDev);
		Array.sort(bkgd_mean);
		bkgd_high_trim = Array.trim(bkgd_mean, 15);
		Array.getStatistics(bkgd_high_trim, min, max, mean, stdDev);
		Array.reverse(bkgd_high_trim);
		bkgd_low_trim = Array.trim(bkgd_high_trim, 7);
		Array.getStatistics(bkgd_low_trim, min, max, mean, stdDev);
		meanbkgd = mean;
		std = nResults;
		bkgd_std = newArray(std);
		run("Select None");
		for (i=0; i<std; i++) {
			bkgd_std[i] = getResult('StdDev', i);
		}
		Array.getStatistics(bkgd_std, min, max, mean, stdDev);
		Array.sort(bkgd_std);
		bksd_high_trim = Array.trim(bkgd_std, 15);
		Array.getStatistics(bksd_high_trim, min, max, mean, stdDev);
		Array.reverse(bksd_high_trim);
		bksd_low_trim = Array.trim(bksd_high_trim, 7);
		Array.getStatistics(bksd_low_trim, min, max, mean, stdDev);
		stdbkgd = mean;
		lower = ((meanbkgd)+(stdbkgd*2));
	}
	if(background_setting == "Low") {
		Array.getStatistics(bkgd_mean, min, max, mean, stdDev);
		Array.sort(bkgd_mean);
		bkgd_high_trim = Array.trim(bkgd_mean, 5);
		Array.getStatistics(bkgd_high_trim, min, max, mean, stdDev);
		meanbkgd = mean;
		std = nResults;
		bkgd_std = newArray(std);
		run("Select None");
		for (i=0; i<std; i++) {
			bkgd_std[i] = getResult('StdDev', i);
		}
		Array.getStatistics(bkgd_std, min, max, mean, stdDev);
		Array.sort(bkgd_std);
		bksd_high_trim = Array.trim(bkgd_std, 5);
		Array.getStatistics(bksd_high_trim, min, max, mean, stdDev);
		stdbkgd = mean;
		lower = ((meanbkgd)+(stdbkgd*2));
	}

// Setting Threshold
run("Set Measurements...", "area mean standard min center limit redir+subDir1ect=None decimal=3");  //setting measurements.
setAutoThreshold("Default dark");
run("Threshold..."); //Opening the threshold function
wait(200);
setThreshold(lower, 500000); //setting the NaN value.
//run("Apply");
run("NaN Background");
//run("Close");


selectWindow(first_image_tif); //duplicating the original image. Here it is important that the original is kept
run("Duplicate...", " "); //alive because it is the only version that can be reverted for the user to view. (alternatively, just reopen fresh image).
//run("8-bit");
run("Duplicate...", " ");
//run("8-bit");
selectWindow(first_image_TL+"-1.tif");

ps_Compile_Single_Background_SL1_ROIs();
}
////////////////////////////////

function ps_Compile_Single_Background_SL1_ROIs() { // this section is macro-ed because we want to be able to return to this point. Good place to use function.

	   // Measuring ROIs
		   //Finding PNNs with Analyze Particles

	name = series_name_TL+" "+first_stain_type_TL+".txt"; //saving the results table in a sub folder.

	first_image_tif = first_image_TL+".tif";
	
	selectWindow(first_image_TL+"-1.tif");
	roiManager("UseNames", "true"); // shows ROI names on image
	roiManager("Show All");
	roiManager("Show All with labels");

	run("Clear Results");

roiManager("Set Color", "red");

if (import_type==7) {
	roiManager("reset");
	roiManager("Open", dir+subDir1+series_name_TL+"_"+SL_suffix_flo+_sep_+first_image_TL+"_{single}_{"+model+"}_ROI-overlay.zip");
	roiManager("Show All");
	roiManager("Show All with labels");
	first_SL_run=(first_SL_run+1);
	//run("_ps_Triple_Background_SL1_ROIs");

	}

selectWindow(first_image_tif); //closing the reverted image
run("Close");

//saving SL1 ROI overlay

SL1_save_ROIs=roiManager("count"); //select all the ROIs in order to save the SL set.
array=newArray(SL1_save_ROIs);
for(i=0; i<SL1_save_ROIs; i++) {
	array[i] = i;
	}
roiManager("Select", array);
//roiManager("Save", dir+subDir1+first_image_TL+first_stain_type_TL+"_ROI-overlay.zip");


//Measuring ROIs

selectWindow(first_image_TL+"-1.tif");

run("Clear Results");
	
	roiManager("Show All");
	roiManager("Show All with labels");
	measure_squares=0;
	measure_squares=roiManager("count");
	array=newArray(measure_squares);
	for(i=0; i<measure_squares;i++) {
		array[i] = i;
	}
	
	roiManager("Select", array);
	roiManager("Measure");
	m=0;
	means=0;
	m = nResults;
	means = newArray(m);
	run("Select None");
	for (i=0; i<m; i++) {
		means[i] = getResult('Mean', i);
	}
	run("Select None");
	for (i=0; i<m; i++) {
		roiManager("Select", i); 
		//roiManager("Rename", i);
		roiName = Roi.getName(); 

		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Stain", i, model);
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("AnalysisDate", i, TimeString);
	}
	setOption("ShowRowNumbers", false);
	updateResults();
	m2 = 0;
	avgmeans = 0;
	m2 = nResults;
	avgmeans = newArray(m2);
	run("Select None");
	for (i=0; i<m2; i++) {
		avgmeans[i] = getResult('Mean-Background', i);
	}
 	Array.getStatistics(avgmeans, min, max, mean, stdDev);
	//print("Mean_Intensity="+mean);
	numberPNNs=0;
	numberPNNs=getValue("results.count");
	//print("Number_of_Cells_Identified="+numberPNNs);
	n = nResults;
	area = newArray(n);
	XM = newArray(n);
	YM = newArray(n);
	mean = newArray(n);
	stddev = newArray(n);
	min = newArray(n);
	max = newArray(n);
	bkgd = newArray(n);
	meanbkgd = newArray(n);
	print("\n");
	//print("Individual cell data:");
	print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
	for (i=0; i<n; i++) {
		area[i] = getResult('Area', i);
		XM[i] = getResult('XM', i);
		YM[i] = getResult('YM', i);
		mean[i] = getResult('Mean', i);
		stddev[i] = getResult('StdDev', i);
		min[i] = getResult('Min', i);
		max[i] = getResult('Max', i);
		bkgd[i] = getResult('Background', i);
		meanbkgd[i] = getResult('Mean-Background', i);
		print(experiment+" "+subject+" "+treatment+" "+name+" "+model+" "+(i+1)+" "+area[i]+" "+XM[i]+" "+YM[i]+" "+mean[i]+" "+stddev[i]+" "+min[i]+" "+max[i]+" "+bkgd[i]+" "+meanbkgd[i]);
	}

roiManager("reset");
selectWindow("ROI Manager");
run("Close");

wait(100);

selectWindow(first_image_TL+"-1.tif");
run("Close");

	// Saving data

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");

}


















//====================================================================================================================================================================================================================================================================

//====================================================================================================================================================================================================================================================================

/////////////////////////////////////////////////////
//#################################################//
//#################################################//
/////////////////////////////////////////////////////

	//Here be double label intensity analysis

function open_double(){

	/*
	run("Image Picker", "file_count=2");
	wait(500);
	imageDir=call("PipsqueakImageSelectCommand.getStatus");
	while (imageDir == "Not Done") {
		print("ImageDir: " + imageDir);
		wait(500);
		imageDir=call("PipsqueakImageSelectCommand.getStatus");
	}

	imageData=call("PipsqueakImageSelectCommand.getImages");
	print("Image Data: " + imageData);

	imageStrings=split(imageData, "\0");
	print("Image Strings 1: " + imageStrings[0]);
	firstImageData=split(imageStrings[0], "\n");
	print("First Image Data Len: " + firstImageData.length);
	print("First Image: " + firstImageData[0] + " " + firstImageData[1]);
	firstImageType=firstImageData[0];
	firstImageLoc=firstImageData[1];
	secondImageData=split(imageStrings[1], "\n");
	print("Second Image: " + secondImageData[0] + " " + secondImageData[1]);
	secondImageType=secondImageData[0];
	secondImageLoc=secondImageData[1];

	print("First Image (" + firstImageType  + "): " + firstImageLoc);
	print("Second Image (" + secondImageType  + "): " + secondImageLoc);


	if (imageDir == "quit") {
		initi();
	}
	
	*/
	
	if(beastMode==100){
		/*

		Dialog.create("Check your stain types");
		Dialog.addMessage("Here are the stain types that will be used. If they are not correct, the compiler will fail.");
		Dialog.addMessage("You can change it here.");
		Dialog.addChoice("First Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"), first_stain_type);
		Dialog.addNumber("First image numbering suffix:", first_suffix_flo);
		Dialog.addChoice("Second Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"), second_stain_type);
		Dialog.addNumber("Second image numbering suffix:", second_suffix_flo);
		Dialog.addNumber("Merged image numbering suffix:", merged_suffix_flo);
		
		Dialog.show;
		first_stain_type =  Dialog.getChoice();
		first_suffix_flo = Dialog.getNumber();;
		first_suffix = "_"+first_suffix_flo;
		second_stain_type =  Dialog.getChoice();;;
		second_suffix_flo = Dialog.getNumber();;;;
		second_suffix = "_"+second_suffix_flo;
		merged_suffix_flo = Dialog.getNumber();;;;;
		merged_suffix = "_"+merged_suffix_flo;
		saveParameters();

	 
		waitForUser("Select first the files that you want to analyze", "Please select the PARENT folder which contains the subfolders or images you want to analyze.");
		dir = getDirectory("Choose a Directory "); 
		subfolders = getFileList(dir);

		title = "[Image Processing Progress]";
		run("Text Window...", "name="+ title +" width=30 height=4 monospaced");

		for(i=0; i<subfolders.length; i++){
			subDir = subfolders[i];
			if(File.isDirectory(dir+subDir)==1){
				//then subfolders are folders with (or without) images
				index = lastIndexOf(subDir, "/");
				if (index!=-1) series_name = substring(subDir, 0, index); //get the name of the subDir folder
				subfolders2 = getFileList(dir+subDir);
				for(j=0; j<subfolders.length; j++){ //determine if the contents of subDir are files or folders
					subDir2 = subfolders2[j];
					if(File.isDirectory(dir+subDir+subDir2)!=1){ // if it is a file, run from here.
						print(title, "\\Update:"+i+1+"/"+subfolders2.length+" ("+((i+1)*100)/subfolders2.length+"%)\n"+getBar(i, subfolders2.length));
						name=subDir2;
						subject=name;
						
						index = lastIndexOf(name, ".");
						if (index!=-1) imageType = substring(name, index, lengthOf(name));
						if (index!=-1) name = substring(name, 0, index);
						
						index = lastIndexOf(name, "_");
						if (index!=-1) SL_suffix_check = substring(name, index, lengthOf(name));
						if (SL_suffix_check!=SL_suffix){
							series_name=subDir2+SL_suffix+_sep_;
						}else{
							series_name=subDir2+_sep_;
						}
						
						//now open and process
						open(dir+subDir+name+imageType);
						full_name = getTitle;
						run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");

						if(File.exists(dir+subDir+series_name)!=1){
							File.makeDirectory(dir+subDir+series_name);
							silent=File.rename(dir+subDir+full_name, dir+subDir+series_name+full_name);
							wait(20);
							imageDir=dir+subDir+series_name;
						}
						
						print("full_name: "+full_name);
						print("name: "+name);
						print("imageType: "+imageType);
						print("subject: "+subject);
						print("SL_suffix: "+SL_suffix);
						print("series_name: "+series_name);
						print("subDir: "+subDir);
						print("dir: "+dir);			
						suffix=SL_suffix;.
						model=SL_stain_type;
						ROI_shape=ROI_type_SL;
						ROI_enlargement=set_roi_enlargement_single;
												
						//region_limit();
						Set_Background();
						//Initiate_ROI();
						recursive_inference();
						Measure_ROIs();
						Save_ROIs();
						close("*");					
	
					}else{
						waitForUser("Check to make sure that you select the PARENT folder containing your images OR \ncontaining individual subfolders for each image.");
					}
				}
				open_double();
				
			}else{ //subfolders are image files
				print(title, "\\Update:"+i+1+"/"+subfolders.length+" ("+((i+1)*100)/subfolders.length+"%)\n"+getBar(i, subfolders.length));
				name=subDir;
				subject=name;
						
				index = lastIndexOf(name, ".");
				if (index!=-1) imageType = substring(name, index, lengthOf(name));
				if (index!=-1) name = substring(name, 0, index);
						
				index = lastIndexOf(name, "_");
				if (index!=-1) SL_suffix_check = substring(name, index, lengthOf(name));
				if (SL_suffix_check!=SL_suffix){
					series_name=subDir+SL_suffix+_sep_;
				}else{
					series_name=subDir+_sep_;
				}
						
				//now open and process
				open(dir+name+imageType);
				full_name = getTitle;
				run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");

				if(File.exists(dir+series_name)!=1){
					File.makeDirectory(dir+series_name);
					silent=File.rename(dir+full_name, dir+series_name+full_name);
					wait(20);
					imageDir=dir+series_name; 
				}
						
				print("full_name: "+full_name);
				print("name: "+name);
				print("imageType: "+imageType);
				print("subject: "+subject);
				print("SL_suffix: "+SL_suffix);
				print("series_name: "+series_name);
				print("subDir: "+subDir);
				print("dir: "+dir);	
				suffix=SL_suffix;
				model=SL_stain_type;	
				ROI_shape=ROI_type_SL;
				ROI_enlargement=set_roi_enlargement_single;	
				
				//region_limit();
				Set_Background();
				//Initiate_ROI();
				recursive_inference();
				Measure_ROIs();
				Save_ROIs();
				close("*");					
			}
		}		
		beep();
		print(title, "\\Close");
		waitForUser("Compiled all available folders");
	*/
	}else{
		//waitForUser("Select First Image", "Please open the first image of the subject series.");
		//open();
		
		first_image_dir = "";
		second_image_dir = "";
		merged_image_dir = "";

		model_library_reader();

		if(File.exists(pipDir+"models.json")){
			parameters = File.openAsString(pipDir+"models.json");
			parLines=split(parameters,"}");
			model_num = parLines.length;
	
			specific_models=Array.slice(model_library,0,model_num-1);
			general_models=Array.slice(model_library,model_num,(model_num-1)*2);
			community_models=Array.slice(model_library,model_num*2,(model_num-1)*3);
			custom_models=Array.slice(model_library,model_num*3,(model_num-1)*4);
		}
	
		specific_models=Array.deleteValue(specific_models, "null");
		
		general_models=Array.deleteValue(general_models, "null");
		general_models=Array.concat(general_models, "Threshold Detection");
		
		community_models=Array.deleteValue(community_models, "null");
		if(community_models.length==0) community_models=Array.concat(community_models, "<none>");
	
		custom_models=Array.deleteValue(custom_models, "null");
		if(custom_models.length==0) custom_models=Array.concat(custom_models, "<none>");

		models = Array.concat("*Specific models*", specific_models, "-------------", "*General models*", general_models, "-------------", "*Community models*", community_models, "-------------", "*Custom models", custom_models);
		
		Dialog.createNonBlocking("Open Images");
		Dialog.addMessage("Select first image file");
		Dialog.addFile("Image (channel) 1", first_image_dir);
		//Dialog.addChoice("First image stain type:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other", "Create detection model"), first_stain_type);
		Dialog.addChoice("First image stain type:", models, first_stain_type);	
		Dialog.addMessage("");
		Dialog.addMessage("Select second image file");
		Dialog.addFile("Image (channel) 2", second_image_dir);
		//Dialog.addChoice("Second image stain type:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other", "Create detection model"), second_stain_type);
		Dialog.addChoice("Second image stain type:", models, second_stain_type);	
		Dialog.addMessage("");
		Dialog.addMessage("Select merged image file (optional for viewing co-localization)");
		Dialog.addFile("Merged image", merged_image_dir);
				
		Dialog.show();
		first_image_dir=Dialog.getString();
		first_stain_type =  Dialog.getChoice();
		second_image_dir=Dialog.getString();
		second_stain_type =  Dialog.getChoice();
		merged_image_dir=Dialog.getString();

		if(first_stain_type=="*Specific models*" || first_stain_type== "*General models*" || first_stain_type== "*Community models*" || first_stain_type== "-------------"  || first_stain_type== "*Custom models" || second_stain_type=="*Specific models*" || second_stain_type== "*General models*" || second_stain_type== "*Community models*" || second_stain_type== "-------------"  || second_stain_type== "*Custom models"){
			waitForUser("Invalid Choice: Please select a valid model");
			open_double();
		}
		saveParameters();
		
		/*
		run("Image Picker", "file_count=1");
		wait(500);
		imageDir=call("PipsqueakImageSelectCommand.getStatus");
		while (imageDir == "Not Done") {
			print("ImageDir: " + imageDir);
			wait(500);
			imageDir=call("PipsqueakImageSelectCommand.getStatus");
		}

		if (imageDir == "quit") {
			initi();
		}
		*/

		open(first_image_dir);			//setting first image variables (and leaving first image open)
		first_image = getTitle;
		dir = getDirectory("image");
		full_name=first_image;
				
		selectWindow(first_image);
		height=getHeight();													
		width=getWidth();
		setLocation(0, screenHeight/4,width*1.5, height*1.5 );

		index = lastIndexOf(first_image, ".");
		if (index!=-1) imageType = substring(first_image, index, lengthOf(first_image));
		//if (index!=-1) series_name = substring(first_image, 0, index-2);								//removing series name becasue images are called by image_dir and save locations are determined by image_dir - image name
		if (index!=-1) first_image = substring(first_image, 0, index);
		subDir1=first_image+_sep_;
		
		open(second_image_dir);				//setting second image variables (and closing image)
		second_image = getTitle;
		dirB = getDirectory("image");
		index = lastIndexOf(second_image, ".");
		if (index!=-1) secondImageType = substring(second_image, index, lengthOf(second_image));
		if (index!=-1) second_image = substring(second_image, 0, index);
		subDir2=second_image+_sep_;
		
		if(secondImageType != imageType){
			waitForUser("Image channels 1 and 2 must be saved in the same format ("+imageType+" or "+secondImageType+")");
			close("*");
			ps_double();
		}
		if(dir != dirB){
			waitForUser("Image channels 1 and 2 must be saved in the same directory location. \n"+first_stain_type+" image: +"dir+"\n"+second_stain_type+" images: "+secondImageType);
			close("*");
			ps_double();
		}
	
		//waitForUser("second_image = "+second_image+"\nsecondImageType = "+secondImageType+"\ndir = "+dir+"\nsubDir2 = "+subDir2+"\n_sep_ = "+_sep_);
		close(second_image+imageType);
		
		//waitForUser(merged_image_dir);
		if(merged_image_dir ==""){			//setting merged image variables (and closing image)
			open(second_image_dir);
			
			selectWindow(first_image+imageType);
			run("Duplicate...", " ");
			first_image_dup = getTitle;

			selectWindow(first_image_dup);
			run("Add Image...", "image="+second_image+imageType+" x=0 y=0 opacity=50");

			close(second_image+imageType);
			selectWindow(first_image_dup);
			saveAs(imageType, dir+"merged_image"+imageType);
			merged_image = "merged_image"+imageType;
			close(merged_image);
			merged_image_dir = dir+merged_image;
			
			//waitForUser("merged_image = "+merged_image+"\nimageType = "+imageType+"\ndir = "+dir+"\nsubDir1 = "+subDir1+"\n_sep_ = "+_sep_);
		}else{
			open(merged_image_dir);				//setting second image variables (and closing image)
			merged_image = getTitle;
			index = lastIndexOf(merged_image, ".");
			if (index!=-1) mergedImageType = substring(merged_image, index, lengthOf(merged_image));
			//if (index!=-1) merged_image = substring(merged_image, 0, index);
			close(merged_image);
			
			if(mergedImageType != imageType){
				waitForUser("Image channels 1 and merged must be saved in the same format ("+imageType+" or "+mergedImageType+")");
				close("*");
				ps_double();
			}
		}			
		//waitForUser(merged_image);										
				
		//run("Set Measurements...", "area mean standard min center limit redirect=None decimal=3");  //setting measurements.
		run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");
		
		Dialog.create("Optional metadata");
		Dialog.addMessage("Enter known image and/or subject information to help with data processing.");
		Dialog.addString("Experiment ID:", "eg:Exp1");
		Dialog.addString("Subject ID:", "eg:Sub_42B");
		Dialog.addString("Independent variable grouping:", "eg:Control");
		Dialog.show
		experiment =  Dialog.getString();
		subject =  Dialog.getString();
		treatment =  Dialog.getString();

		name=first_image;
		//full_name=first_image+imageType;
		
		//===================================================================	
		dirCheck = getDirectory("image");
		//waitForUser(dirCheck);
		
		if(dirCheck==dir){ //new image without subDir or series_name
			//print("subDir DOES NOT exists");
			File.makeDirectory(dir+subDir1);
			full_name=first_image+imageType;
			silent=File.copy(dir+full_name, dir+subDir1+full_name);
			wait(20);
			imageDir=dir+subDir1;
			
		}else if(dirCheck==dir+subDir1){ //image is in a subDir
			//print("subDir exists");
			imageDir=dir+subDir1;
		}else{
			waitForUser("Please place the first, second, and merged image into a single folder. Then, select that folder.");
			ps_double();
		}
				
		//====================================================================	
		
		Dialog.create(" Images to be analyzed");
		Dialog.addMessage("");
		Dialog.addMessage("First  image:   "+first_image+imageType);
		Dialog.addMessage("First image stain: "+first_stain_type);
		Dialog.addMessage("");
		Dialog.addMessage("Second image: "+second_image+imageType);
		Dialog.addMessage("Second image stain: "+second_stain_type);
		Dialog.addMessage("");
		Dialog.addMessage("Merged image: "+merged_image);
		Dialog.addMessage("");
		choice = newArray("Yes", "No");
		Dialog.addRadioButtonGroup("Are these the images you want to analyze?", choice, 2, 1, "Yes");
		Dialog.show;	
		choice = Dialog.getRadioButton;

		if (choice=="No"){
			close("*");
			open_double();
		}
		parentFunction = "open_double()";
		
//first image run
		//imageDir=dir+series_name+first_suffix+_sep_;
		imageDir=dir+subDir1;
		//suffix=first_suffix;
		model=first_stain_type;
		ROI_shape=ROI_type_DL1;
		ROI_enlargement=DL1_set_roi_enlargement;
		saveParameters();
				
		//print("first_image: "+first_image);
		//print("name: "+name);
		//print("imageType: "+imageType);
		//print("subject: "+subject);
		//print("first_suffix: "+first_suffix);
		//print("series_name: "+series_name);
		//print("subDir1: "+series_name+first_suffix+"/");
		//print("dir: "+dir);
		//print("imageDir: "+imageDir);
		//print("stain: "+first_stain_type);
		//print("model: "+model);

		//region_limit();
		Set_Background(parentFunction);
		DL1_lower=lower;
		imageOrder="a";
		
		if(lic==0){
			user_model=user_model_1;
	  		threshold_name();
			threshold_detection();
			user_model_1=user_model;
			if(isOpen("Processing")==true){
				wait(100);
				selectWindow("Processing");
				run("Close");
			}
			//manual_menu();
		}
		if(lic==1){
			if(model=="Threshold Detection"){
	  			user_model=user_model_1;
	  			threshold_name();
				threshold_detection();
				user_model_1=user_model;
				//manual_menu();
				pass==1;
				if(isOpen("Processing")==true){
					wait(100);
					selectWindow("Processing");
					run("Close");
				}	
	  		}else{
				Initiate_ROI();
				recursive_inference();
				if(isOpen("AI Engine Results")==true){
					selectWindow("AI Engine Results");
					run("Close");
		  		}
	  		}	
		}
			
		first_stain_type=model;
		first_image=name;
		//selectWindow("AI Engine Results");
		//run("Close");
		Measure_ROIs();
		Save_ROIs();
		close("*");

//second image run

		open(dir+second_image+imageType);
		name=second_image;
		full_name=name+imageType;

		selectWindow(full_name);
		height=getHeight();													//
		width=getWidth();													//
		setLocation(0, screenHeight/4,width*1.5, height*1.5 );

//===================================================================	
		dirCheck = getDirectory("image");
		//waitForUser(dirCheck);
		
		if(dirCheck==dir){ //new image without subDir or series_name
			//print("subDir DOES NOT exists");
			File.makeDirectory(dir+subDir2);
			silent=File.copy(dir+full_name, dir+subDir2+full_name);
			wait(20);
			imageDir=dir+subDir2;
		}else if(dirCheck==dir+subDir2){ //image is in a subDir
			//print("subDir exists");
			imageDir=dir+subDir2;
		}else{
			waitForUser("Please place the first, second, and merged image into a single folder. Then, select that folder.");
			ps_double();
		}
				
//====================================================================	

		imageDir=dir+subDir2;
		//suffix=second_suffix;
		model=second_stain_type;
		ROI_shape=ROI_type_DL2;
		ROI_enlargement=DL2_set_roi_enlargement;
		saveParameters();
		
		//print("second_image: "+second_image);
		//print("name: "+name);
		//print("imageType: "+imageType);
		//print("subject: "+subject);
		//print("second_suffix: "+second_suffix);
		//print("series_name: "+series_name);
		//print("subDir: "+series_name+second_suffix+_sep_);
		//print("dir: "+dir);
		//print("imageDir: "+imageDir);
		//print("stain: "+second_stain_type);
		//print("model: "+model);
		
		//region_limit();
		Set_Background(parentFunction);
		DL2_lower=lower;
		imageOrder="b";
		
		if(lic==0){
			user_model=user_model_2;
	  		threshold_name();
			threshold_detection();
			user_model_2=user_model;
			if(isOpen("Processing")==true){
				wait(100);
				selectWindow("Processing");
				run("Close");
			}
			//manual_menu();
		}
		if(lic==1){
			if(model=="Threshold Detection"){
	  			user_model=user_model_2;
	  			threshold_name();
				threshold_detection();
				user_model_2=user_model;
				//manual_menu();
				pass==1;
				if(isOpen("Processing")==true){
					wait(100);
					selectWindow("Processing");
					run("Close");
				}	
	  		}else{
				Initiate_ROI();
				recursive_inference();
				if(isOpen("AI Engine Results")==true){
					selectWindow("AI Engine Results");
					run("Close");
		  		}
	  		}	
		}
		second_stain_type=model;
		second_image=name;
		Measure_ROIs();
		Save_ROIs();
		close("*");

		limitRegion=0;
		if(File.exists(dir+subDir1+"sub_region_selection_ROI.zip")==1){
			silent=File.rename(dir+subDir1+"sub_region_selection_ROI.zip", dir+subDir1+"sub_region_selection_ROI_("+TimeString+"_archived).zip");
		}
		
//DL stuff
		if(File.exists(dir+"double-label_results"+_sep_)!=1) File.makeDirectory(dir+"double-label_results"+_sep_);
		//stain 1
		
		//suffix1 = first_suffix;
		//suffix2 = second_suffix;
		first_image_DL = first_image;
		second_image_DL = second_image;
		subDir1_DL = subDir1;
		subDir2_DL = subDir2;
		stain1 = first_stain_type;
		stain2 = second_stain_type;
		first_rois = dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip";
		second_rois = dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip";
		stain1_DL_overlap=DL1_overlap;
		stain2_DL_overlap=DL2_overlap;
		ROI_shape1=ROI_type_DL1;
		ROI_shape2=ROI_type_DL2;	
		
		if(File.exists(first_rois) && File.exists(second_rois)){
			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save1(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
		}else{
			Dialog.create("Co-localization not found");
			items = newArray("Close images and restart analysis", "Determine co-localization manually", "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.addRadioButtonGroup("No co-localization between "+stain1+" and "+stain2+" was found. What would you like to do?", items, 3, 1, "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.show;
			choice = Dialog.getRadioButton;
			if(choice=="Continue analysis without "+stain1+" and "+stain2+" co-localization") {
				roiManager("reset");
				close("*");
				return;
			} 
			if(choice=="Close images and restart analysis"){
				roiManager("reset");
				close("*");
				parentFunction;
			}
			if(choice=="Determine co-localization manually"){
				close("*");
				roiManager("reset");
				manual_colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, merged_image, parentFunction, ROI_shape1, ROI_shape2);
			}
		}

		//stain 2
		
		//suffix1 = second_suffix;
		//suffix2 = first_suffix;
		first_image_DL = second_image;
		second_image_DL = first_image;
		subDir1_DL = subDir2;
		subDir2_DL = subDir1;
		stain1 = second_stain_type;
		stain2 = first_stain_type;
		first_rois = dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip";
		second_rois = dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip";
		stain1_DL_overlap=DL2_overlap;
		stain2_DL_overlap=DL1_overlap;
		ROI_shape1=ROI_type_DL2;
		ROI_shape2=ROI_type_DL1;
		stain1_lower = DL2_lower;
		stain2_lower = DL1_lower;

		if(File.exists(first_rois) && File.exists(second_rois)){
			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save2(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
			//co-check
			checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
			if(File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip") && File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip")){
				measure_dub_coloc(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, parentFunction, stain1_lower, stain2_lower);
			}			
		}else{
			Dialog.create("Co-localization not found");
			items = newArray("Close images and restart analysis", "Determine co-localization manually", "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.addRadioButtonGroup("No co-localization between "+stain1+" and "+stain2+" was found. What would you like to do?", items, 3, 1, "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.show;
			choice = Dialog.getRadioButton;
			if(choice=="Continue analysis without "+stain1+" and "+stain2+" co-localization") {
				roiManager("reset");
				close("*");
			} 
			if(choice=="Close images and restart analysis"){
				roiManager("reset");
				close("*");
				parentFunction;
			}
			if(choice=="Determine co-localization manually"){
				close("*");
				roiManager("reset");
				manual_colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, merged_image, parentFunction, ROI_shape1, ROI_shape2);
			}
		}

		//exit
		Dialog.create("Analyze another image?");
		items = newArray("Open another image", "Exit to main menu");
		Dialog.addRadioButtonGroup("Analysis done! Results saves as All_Results"+TimeString+".txt"+"\n"+"Next Move:", items, 2, 1, "Open another image");
		Dialog.show;
		choice = Dialog.getRadioButton;
		
		if (choice=="Open another image") {
			open_double();
		} else {
			initi();
		}
	}
}

//\\//\\//\\//\\//\\//\\//\\
function colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap){
	aCoLoArray=newArray(0); 
	bCoLoArray=newArray(0); 
	abCoLoArray=newArray(0);
	aCoLoselectArray=newArray(0);
	bCoLoselectArray=newArray(0);
	abCoLoselectArray=newArray(0);
	aCoLo=0;
	bCoLo=0;

	bTotal=0; // number of "a" ROIs checked against "b' ROIs.
	no_co=0; // yes/no variable determining whether overlap was found.
	co_roi_array = newArray(0); // this array will be concatinated with the "b" value for each overlapping "a" so the ROIs can be selected.
	co_roi_array_UI = newArray(0); // this array will be concatinated with the "b2" value for each overlapping "a" so the user can see multiple overlaps.
	CoM_distance_array = newArray(0); // making an array of the distances between the "b" CoM and the "a" CoM.
	
	run("Clear Results");
	roiManager("reset");

	//first_image = first_image_DL;
	//second_image = second_image_DL;

	open(dir+subDir1_DL+first_image_DL+"_bkgd_subtracted.tif");
	open(dir+subDir2_DL+second_image_DL+"_bkgd_subtracted.tif");

	//selectWindow(second_image+"_bkgd_subtracted.tif");
	roiManager("Open", first_rois);
	wait(100);
	stain1Count = roiManager("count"); // determines the number of circle ROIs
	stain1Count_array=newArray(stain1Count);
	//print("stain1Count ="+stain1Count);
	roiManager("reset");
	roiManager("Open", second_rois);
	wait(100);
	stain2Count = roiManager("count");
	stain2Count_array=newArray(stain2Count);
	stain2Start=stain1Count;
	//print("stain2Count ="+stain2Count);
	//print("stain2Start ="+stain2Start);
	roiManager("reset");

	roiManager("Open", first_rois);
	roiManager("Open", second_rois);
	wait(100);
	
	//waitForUser;
	
	roiManager("show all");
	roiManager("show all with labels");
	roiManager("deselect");
	ROIs =roiManager("count"); 
	ROI_array=newArray(ROIs);
	for(i=0; i<ROIs;i++) { 
		ROI_array[i] = i; 
	}
	
	roiManager("deselect");
	roiManager("Measure");
	roiManager("deselect");

	for (i=0; i<ROIs; i++) {
		roiManager("Select", i); 
		roiName = Roi.getName(); 
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
	}
	
	setOption("ShowRowNumbers", false);
	updateResults();

	XM=newArray(ROIs);
	YM=newArray(ROIs);
	BX=newArray(ROIs);
	BY=newArray(ROIs);
	Width=newArray(ROIs);
	Height=newArray(ROIs);
	roiName_array=newArray(ROIs);

	roiManager("deselect");
	for (i=0; i<ROIs; i++) { 
		XM[i] = getResult('XM', i);
		YM[i] = getResult('YM', i);
		BX[i] = getResult('BX', i);
		BY[i] = getResult('BY', i);
		Width[i] = getResult('Width', i);
		Height[i] = getResult('Height', i);
		roiName_array[i] = getResult('roiName', i);
	}

	for(a=stain2Start; a<(ROIs); a++){  // Select stain2 Rois.
		roiManager("Select", a);
		//print("a="+a);
		no_co=0;
		a2=a+1; //a2 is a counting variable to correct for the ROI manager starting at ROI #0.
		no_coArray=newArray(0);
	
		for(b=0; b<(stain1Count); b++){ //Select stain1 Rois.
			b2=b+1; //b2 is a counting variable to correct for the ROI manager starting at ROI #0.
			//print("b="+b);
			roiManager("Select", newArray(a, b)); //select the square then the circle
			roiManager("AND"); //build an overlapping ROI
			overlapType = selectionType();
			//print("overlapType="+overlapType);
			//waitForUser("a[i]="+a+" and b[i]="+b);
		
			if(overlapType==-1){ // and there is not overlapping area under the square and circle ROIs
			}
			if(overlapType!=-1){ // if there is overlap from the square and the circle,
				c = roiManager("Add"); //add the overlap to the ROI manager so that we can measure its size.
				no_co = no_co+1; // to remember that, yes, there is overlap.
			
				roiManager("deselect");
				run("Clear Results");
				roiManager("Select", b); //measure the size of the circle
				roiManager("Measure");
			
				co_roi = (roiManager("count")-1); //find the overlap ROI (it's going to be the last one on the ROI manager list).
				//print("co_roi="+co_roi);	
				roiManager("Select", co_roi); // select it.
				roiManager("Measure"); //measure the area.
			
				roiManager("Select", co_roi);
				roiManager("Delete"); //now removing it beause we only wanted that new ROI to measure the area of overlap.
				b2_area=getResult("Area", 0); // grab the circle-ROI's area from the results
				c_area=getResult("Area", 1); // grab the overlap-ROI's area from the results
				b2_area_80 = b2_area*stain1_DL_overlap;//0.8; // calculate 80% of the circle area (we're using 80% as an arbitrary threshold of minimum circle that should be within the square).
				//print("b2_area="+b2_area);
				//print("c_area="+c_area);
				//print("b2_area_80="+b2_area_80);
			
				if(b2_area_80>c_area){ // if the overlapping area is less 80% of the circle,
					no_co = no_co-1; //then, forget that an overlap was identified and move on (restart the loop).
					//waitForUser("circle "+b2+" identified but <80% overlap");
				} else {
					//if(XM[a]>=BX[b] && XM[a]<=(BX[b]+Width[b]) && YM[a]>=BY[b] && YM[a]<=(BY[b]+Height[b])){
					saveAb=1;
					roiManager("Select", a); 
					aroiName = Roi.getName();
					roiManager("Select", b); 
					broiName = Roi.getName(); 
					//print("A+B = "+aroiName+" + "+broiName);
					//print("x="+XM[a]+" "+BX[b]+" "+(BX[b]+Width[b])+", Y="+YM[a]+" "+BY[b]+" "+(BY[b]+Height[b]));
					
					no_coArray=Array.concat(no_coArray,broiName);
					//print("\nno_coArray:");
					//Array.print(no_coArray);	

					roiDuplicate=0;
					for (h=0; h<aCoLoArray.length; h++) {
						roiName=aCoLoArray[h];
						if(matches(roiName, aroiName)) roiDuplicate=1;
					}
					if(roiDuplicate==0) aCoLoArray=Array.concat(aCoLoArray, aroiName);
					//print("aCoLoArray:");
					//Array.print(aCoLoArray);
					roiDuplicate=0;
				
					if(no_co>1){ // there is more than one co-localized B within A
						//print("no_co="+no_co);
						CoM_distance_array=newArray(0);
						selectWindow(second_image_DL+"_bkgd_subtracted.tif"); //select the A image
		 				run("Clear Results");
   		  				roiManager("deselect");
   	  					roiManager("Select", a); //select the square ROI
   	  					roiManager("Measure"); //measure the square ROI so we can...
	 					CoM_x_A=getResult("XM", 0); // grab A's center of mass x-coordinate from the results.
	 					CoM_y_A=getResult("YM", 0); // grab A's center of mass y-coordinate from the results.
   						//print("Axy="+CoM_x_A+","+CoM_y_A);
   						run("Clear Results");
   						selectWindow(first_image_DL+"_bkgd_subtracted.tif"); //select the B image
   						roiManager("deselect");
   		
   						broi_colo_array=newArray(0);
						for (h=0; h<no_co; h++) { //search ROI list for ROI name
							broiName=no_coArray[h];
							for (i=0; i<ROIs; i++) { 
								roiManager("Select", i); 
								rName = Roi.getName(); 
								if (matches(rName, broiName)) { 
									broi_colo_array=Array.concat(broi_colo_array, i);
								} 
							}
						}
   						roiManager("Select", broi_colo_array); //select the overlapping B ROIs
	   					roiManager("Measure");
 	
  				 		for(i=0; i<no_co; i++){ //doing this as a FOR loop to allow for any range of overlapping ROIs
  							CoM_x_B=getResult("XM", i); // grab B's center of mass x-coordinate from the results.
  							CoM_y_B=getResult("YM", i); // grab B's center of mass y-coordinate from the results.
							x_distance=CoM_x_A-CoM_x_B;
							y_distance=CoM_y_A-CoM_y_B;
							CoM_distance=(Math.sqrt(Math.sqr(x_distance)+Math.sqr(y_distance)));
							CoM_distance_array=Array.concat(CoM_distance_array,CoM_distance);
							//print("CoM_distance_array:");
							//Array.print(CoM_distance_array);
						}
						CoM_distance_rank=Array.rankPositions(CoM_distance_array);
						bWinnerPosition=CoM_distance_rank[0];
						bLoserPosition=CoM_distance_rank[1];
						//print("Rank Array:");
					 	//Array.print(CoM_distance_rank);
					 	//print("bWinner:"+bWinnerPosition);
 						//waitForUser("rank array printed");		

						bWinner=no_coArray[bWinnerPosition];
						bLoser=no_coArray[bLoserPosition];
						//print("bWinner="+bWinner);
						//print("bLoser="+bLoser);
						//waitForUser("bWinner");
					
						roiDuplicate=0;
						//Array.print(bCoLoArray);
						bCoLoArray=Array.deleteValue(bCoLoArray, bLoser);
						//print("bCoLoArray:");
						//Array.print(bCoLoArray);
						//waitForUser("bCoLoArray");
					
						for (h=0; h<bCoLoArray.length; h++) {	
							roiName=bCoLoArray[h];
							if(matches(roiName, bWinner)) roiDuplicate=1;
						}
						if(roiDuplicate==0) {
							bCoLoArray=Array.concat(bCoLoArray, bWinner);
							//print("bCoLoArray:");
							//Array.print(bCoLoArray);
						}
						roiDuplicate=0;
					}else{	
						for (h=0; h<bCoLoArray.length; h++) {
							roiName=bCoLoArray[h];
							if(matches(roiName, broiName)) roiDuplicate=1;
						}
						if(roiDuplicate==0) {
							bCoLoArray=Array.concat(bCoLoArray, broiName);
							//print("bCoLoArray:");
							//Array.print(bCoLoArray);
						}
					roiDuplicate=0;
					}
				}
			}
		}
	}
	abCoLoArray=Array.concat(abCoLoArray, aCoLoArray);
	abCoLoArray=Array.concat(abCoLoArray, bCoLoArray);

	//print("aCoLoArray");
	//Array.print(aCoLoArray); 
	//print("bCoLoArray");
	//Array.print(bCoLoArray); 
	//print("abCoLoArray");
	//Array.print(abCoLoArray); 
	//print("co="+abCoLoArray.length);
		
	//return;
}

function colocalizer_save1(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois){
	//first_image = first_image_DL;
	//second_image = second_image_DL;
	
	//print("aCoLoArray:");
	//Array.print(aCoLoArray);
	//waitForUser("stain1="+stain1+", stain2="+stain2);
		
	roiManager("deselect");
	ROIs =roiManager("count");
	if(aCoLoArray.length>0){ 
		for (h=0; h<aCoLoArray.length; h++) {
			roiName=aCoLoArray[h];
			for (i=0; i<ROIs; i++) { 
				roiManager("Select", i); 
				rName = Roi.getName(); 
				if (matches(rName, roiName)) { 
					aCoLoselectArray=Array.concat(aCoLoselectArray, i);
				} 
			}
		}		 
		roiManager("select", aCoLoselectArray);
		roiManager("save selected", dir+"double-label_results"+_sep_+second_image_DL+"_{double}1_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
		
	}
	//waitForUser;
	roiManager("reset");

	roiManager("Open", first_rois);
	roiManager("Open", second_rois);

	//print("bCoLoArray:");
	//Array.print(bCoLoArray);
	//waitForUser("stain1="+stain1+", stain2="+stain2);
	
	roiManager("deselect");
	if(bCoLoArray.length>0){ 
		for (h=0; h<bCoLoArray.length; h++) {
			roiName=bCoLoArray[h];
			for (i=0; i<ROIs; i++) { 
				roiManager("Select", i); 
				rName = Roi.getName(); 
				if (matches(rName, roiName)) { 
					bCoLoselectArray=Array.concat(bCoLoselectArray, i);
				} 
			}
		}			 
		roiManager("select", bCoLoselectArray);
		roiManager("save selected", dir+"double-label_results"+_sep_+first_image_DL+"_{double}1_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}

	roiManager("reset");
	close("*");
}

function colocalizer_save2(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois){
	//first_image = first_image_DL;
	//second_image = second_image_DL;
	
	//waitForUser("stain1="+stain1+", stain2="+stain2);
	
	roiManager("deselect");
	ROIs =roiManager("count"); 
	if(aCoLoArray.length>0){
		for (h=0; h<aCoLoArray.length; h++) { //search ROI list for ROI name
			roiName=aCoLoArray[h];
			for (i=0; i<ROIs; i++) { 
				roiManager("Select", i); 
				rName = Roi.getName(); 
				if (matches(rName, roiName)) { 
					aCoLoselectArray=Array.concat(aCoLoselectArray, i);
				} 
			}
		}		 
		roiManager("select", aCoLoselectArray);
		roiManager("save selected", dir+"double-label_results"+_sep_+second_image_DL+"_{double}2_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");	
		//roiManager("save selected", dir+"double-label_results"+_sep_+first_image_DL+"_{double}2_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}
	roiManager("reset");
	
	roiManager("Open", first_rois);
	roiManager("Open", second_rois);

	roiManager("deselect");
	if(bCoLoArray.length>0){
		for (h=0; h<bCoLoArray.length; h++) {
			roiName=bCoLoArray[h];
			for (i=0; i<ROIs; i++) { 
				roiManager("Select", i); 
				rName = Roi.getName(); 
				if (matches(rName, roiName)) { 
					bCoLoselectArray=Array.concat(bCoLoselectArray, i);
				} 
			}
		}		 
		roiManager("select", bCoLoselectArray);
		roiManager("save selected", dir+"double-label_results"+_sep_+first_image_DL+"_{double}2_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
		//roiManager("save selected", dir+"double-label_results"+_sep_+second_image_DL+"_{double}2_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	}
	roiManager("reset");
	
	silent=File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}1_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	if(silent==1){
		roiManager("Open", dir+"double-label_results"+_sep_+first_image_DL+"_{double}1_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}
	silent=File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}2_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	if(silent==1){
		roiManager("Open", dir+"double-label_results"+_sep_+first_image_DL+"_{double}2_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}
	
		
	if(roiManager("count")>0){
		roiManager("sort");
		ROIs =roiManager("count"); 
		for (i=1; i<ROIs; i++) { 
			roiManager("Select", i); 
			rName1=Roi.getName();
			//print(rName1);
			roiManager("Select", i-1);
			rName0 = Roi.getName();
			//print(rName0);
	
			if (matches(rName1, rName0)) { 
				roiManager("Select", i); 
				roiManager("delete");
				ROIs=ROIs-1;
			} 
		}		
		roiManager("deselect");	 
		roiManager("save", dir+"double-label_results"+_sep_+first_image_DL+"_{double}3_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}
	//waitForUser;
	roiManager("reset");

	silent=File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}1_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	if(silent==1){
		roiManager("Open", dir+"double-label_results"+_sep_+second_image_DL+"_{double}1_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	}
	silent=File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}2_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	if(silent==1){
		roiManager("Open", dir+"double-label_results"+_sep_+second_image_DL+"_{double}2_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	}
	if(roiManager("count")>0){
		roiManager("sort");
		ROIs =roiManager("count"); 
		for (i=1; i<ROIs; i++) { 
			roiManager("Select", i); 
			rName1=Roi.getName();
			//print(rName1);
			roiManager("Select", i-1);
			rName0 = Roi.getName();
			//print(rName0);
	
			if (matches(rName1, rName0)) { 
				roiManager("Select", i); 
				roiManager("delete");
				ROIs=ROIs-1;
			} 
		}
		roiManager("deselect");	 
		roiManager("save", dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	}
	//waitForUser;
	roiManager("reset");
	
	if(File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}1_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
		silent=File.delete(dir+"double-label_results"+_sep_+first_image_DL+"_{double}1_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}
	if(File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}1_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip")==1){
		silent=File.delete(dir+"double-label_results"+_sep_+second_image_DL+"_{double}1_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	}
	if(File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}2_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
		silent=File.delete(dir+"double-label_results"+_sep_+first_image_DL+"_{double}2_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}
	if(File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}2_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip")==1){
		silent=File.delete(dir+"double-label_results"+_sep_+second_image_DL+"_{double}2_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	}
	if(File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}3_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
		silent=File.rename(dir+"double-label_results"+_sep_+first_image_DL+"_{double}3_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip", dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}
	//waitForUser;
	close("*");
}

function checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap){
	//first_image = first_image_DL;
	//second_image = second_image_DL;
	
	if(File.exists(dir+"STATIC_merged_overlay.tif")){
		File.delete(dir+"STATIC_merged_overlay.tif");
	}
	
	silent=File.exists(dir+merged_image);
	if(silent==1){
		open(dir+merged_image);
		selectWindow(merged_image);
		height=getHeight();
		width=getWidth(); 
		setLocation(0, screenHeight/4, width*1.5, height*1.5);
	}

	if(File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1 && File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip")==1){
		roiManager("Open", dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
		roiManager("Open", dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
		roiManager("show all");
		roiManager("show all with labels");

		if(stain1==stain2){
			choice1=stain1+" no.2";
			choice2=stain2+" no.1";
		}else{
			choice1=stain1;
			choice2=stain2;
		}
		
		Dialog.create("Double Co-localization"); //the first step is asking the user if they want to edit either ROI set.
		items = newArray(choice2, choice1, "Manually determine co-localization from single-label ROIs", "Accept co-localization as is.");
		Dialog.addRadioButtonGroup("Here is your chance to adjust the ROIs to better identify co-localization. Which stain would you like to adjust?", items, 4, 1, "Accept co-localization as is.");
		Dialog.show;
		choice = Dialog.getRadioButton;

		if (choice==choice1) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");	
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4, width*1.5, height*1.5 );	
			
			//setTool("text");
			setFont("SansSerif", 25*(width/512), " antialiased");
			setColor("pink");
			Overlay.drawString("Reference Image for Co-localization Check", (width/10)*0.5, (height/10)*8, 35.0);
			Overlay.show();

			open(dir+subDir1_DL+first_image_DL+"_bkgd_subtracted.tif");
			selectWindow(first_image_DL+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
		
			setTool(ROI_shape1);
			roiManager("reset");
			roiManager("Open", dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");	
			selectWindow("STATIC_merged_overlay.tif");
			selectWindow(first_image_DL+"_bkgd_subtracted.tif");
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
			}
			wait(100);
			
			roiManager("reset");
			close("*");
			if(File.exists(dir+"STATIC_merged_overlay.tif")){
				File.delete(dir+"STATIC_merged_overlay.tif");
			}

			//recheck 2nd ROIs
			first_image_DL_temp = first_image_DL;
			second_image_DL_temp = second_image_DL;
			first_image_DL = second_image_DL_temp;
			second_image_DL = first_image_DL_temp;
			
			subDir1_DL_temp = subDir1_DL;
			subDir2_DL_temp = subDir2_DL;
			subDir1_DL = subDir2_DL_temp;
			subDir2_DL = subDir1_DL_temp;

			stain1_temp = stain1;
			stain2_temp = stain2;
			stain1 = stain2_temp;
			stain2 = stain1_temp;
			
			first_rois = dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip";
			second_rois = dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip";
			
			stain1_DL_overlap_temp=stain1_DL_overlap;
			stain2_DL_overlap_temp=stain2_DL_overlap;
			stain1_DL_overlap=stain2_DL_overlap_temp;
			stain2_DL_overlap=stain1_DL_overlap_temp;
			
			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save1(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
			
			//recheck 1st ROIs
			first_image_DL = first_image_DL_temp;
			second_image_DL = second_image_DL_temp;
			subDir1_DL = subDir1_DL_temp;
			subDir2_DL = subDir2_DL_temp;
			stain1 = stain1_temp;
			stain2 = stain2_temp;
			
			first_rois = dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip";
			second_rois = dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip";
			
			stain1_DL_overlap=stain1_DL_overlap_temp;
			stain2_DL_overlap=stain2_DL_overlap_temp;
			//ROI_shape1=ROI_type_DL2;
			//ROI_shape2=ROI_type_DL1;
			//stain1_lower = DL2_lower;
			//stain2_lower = DL1_lower; 

			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save2(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
			checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
		}
		if (choice==choice2) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");					//
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4, width*1.5, height*1.5 );				//

			//setTool("text");
			setFont("SansSerif", 25*(width/512), " antialiased");
			setColor("pink");
			Overlay.drawString("Reference Image for Co-localization Check", (width/10)*0.5, (height/10)*8, 35.0);
			Overlay.show();
			
			open(dir+subDir2_DL+second_image_DL+"_bkgd_subtracted.tif");
			selectWindow(second_image_DL+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
			
			setTool(ROI_shape2);
			roiManager("reset");
			roiManager("Open", dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");
			selectWindow("STATIC_merged_overlay.tif");	
			selectWindow(second_image_DL+"_bkgd_subtracted.tif");
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
			}	
			wait(100);
			
			roiManager("reset");
			close("*");
			if(File.exists(dir+"STATIC_merged_overlay.tif")){
				File.delete(dir+"STATIC_merged_overlay.tif");
			}
			//recheck 2nd ROIs
			first_image_DL_temp = first_image_DL;
			second_image_DL_temp = second_image_DL;
			first_image_DL = second_image_DL_temp;
			second_image_DL = first_image_DL_temp;
			
			subDir1_DL_temp = subDir1_DL;
			subDir2_DL_temp = subDir2_DL;
			subDir1_DL = subDir2_DL_temp;
			subDir2_DL = subDir1_DL_temp;

			stain1_temp = stain1;
			stain2_temp = stain2;
			stain1 = stain2_temp;
			stain2 = stain1_temp;
			
			first_rois = dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip";
			second_rois = dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip";
			
			stain1_DL_overlap_temp=stain1_DL_overlap;
			stain2_DL_overlap_temp=stain2_DL_overlap;
			stain1_DL_overlap=stain2_DL_overlap_temp;
			stain2_DL_overlap=stain1_DL_overlap_temp;

			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save1(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
			
			//recheck 1st ROIs
			first_image_DL = first_image_DL_temp;
			second_image_DL = second_image_DL_temp;
			subDir1_DL = subDir1_DL_temp;
			subDir2_DL = subDir2_DL_temp;
			stain1 = stain1_temp;
			stain2 = stain2_temp;
			first_rois = dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip";
			second_rois = dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip";
			stain1_DL_overlap=stain1_DL_overlap_temp;
			stain2_DL_overlap=stain2_DL_overlap_temp;	
			ROI_shape1=ROI_type_DL2;
			ROI_shape2=ROI_type_DL1;
			stain1_lower = DL2_lower;
			stain2_lower = DL1_lower; 

			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save2(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
			checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
		}
		if(choice=="Manually determine co-localization from single-label ROIs"){
			Dialog.create("Are you sure?"); //the first step is asking the user if they want to edit either ROI set.
			items = newArray("Yes, undo co-localization of "+stain1+" and "+stain2+", and co-localize by hand.", "No, go back.");
			Dialog.addRadioButtonGroup("Are you sure that you want to manually determine co-localization? It will reset the "+stain1+" and "+stain2+" ROIs.", items, 2, 1, "No, go back.");
			Dialog.show;
			choice2 = Dialog.getRadioButton;
			
			if(choice2=="No, go back."){
				checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
			}	
			if(choice2=="Yes, undo co-localization of "+stain1+" and "+stain2+", and co-localize by hand."){				
				close("*");
				roiManager("reset");
				manual_colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, merged_image, parentFunction, ROI_shape1, ROI_shape2);
			}	
		}
		if (choice=="Accept co-localization as is.") {
			//well, aren't you confident.
			roiManager("reset");
			close("*");
		}
		if(File.exists(dir+"STATIC_merged_overlay.tif")){
			File.delete(dir+"STATIC_merged_overlay.tif");
		}
	}else{
		Dialog.create("Double Co-localization not found");
		items = newArray("Close images and restart analysis", "Determine co-localization manually", "Continue analysis without "+stain1+" and "+stain2+" co-localization");
		Dialog.addRadioButtonGroup("No co-localization between "+stain1+" and "+stain2+" was found. What would you like to do?", items, 3, 1, "Continue analysis without "+stain1+" and "+stain2+" co-localization");
		Dialog.show;
		choice = Dialog.getRadioButton;
		if(choice=="Continue analysis without "+stain1+" and "+stain2+" co-localization") {
			roiManager("reset");
			close("*");
			return;
		} 
		if(choice=="Close images and restart analysis"){
			roiManager("reset");
			close("*");
			parentFunction;
		}
		if(choice=="Determine co-localization manually"){
			close("*");
			roiManager("reset");
			manual_colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, merged_image, parentFunction, ROI_shape1, ROI_shape2);
		}
	}
	//print("done");	
	//roiManager("select", stain2Start);
	//waitForUser(stain1Count+" "+stain2Count+" "+stain2Start+" "+totalROIcount);
}

function manual_colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, merged_image, parentFunction, ROI_shape1, ROI_shape2){
	//roiManager("Set Color", "red");
	//first_image = first_image_DL;
	//second_image = second_image_DL;

	silent=File.exists(dir+merged_image);
	if(silent==1){
		open(dir+merged_image);
		selectWindow(merged_image);
		height=getHeight();
		width=getWidth(); 
		setLocation(screenWidth/1.5, screenHeight/2,width, height );
	}
	
	setLocation(0, screenHeight/4,width*1.5, height*1.5 );
	stain1a=stain2;
	stain2a=stain1;

	if(File.exists(dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip")==1){
		roiManager("Open", dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip");
	}
	if(File.exists(dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip")==1){
		roiManager("Open", dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip");
	}
		roiManager("show all");
		roiManager("show all with labels");

		Dialog.create("Manual Double Co-localization"); //the first step is asking the user if they want to edit either ROI set.
		items = newArray(stain1, stain2, "Accept co-localization as is.");
		Dialog.addRadioButtonGroup("Here is your chance to adjust the ROIs to better identify co-localization. Which stain would you like to adjust?", items, 3, 1, "Accept co-localization as is.");
		Dialog.show;
		choice = Dialog.getRadioButton;

		if (choice==stain1) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");					//
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4,width*1.5, height*1.5 );				//

			open(dir+subDir1_DL+first_image_DL+"_bkgd_subtracted.tif");
			selectWindow(first_image_DL+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
		
			setTool(ROI_shape1);
			roiManager("reset");
			if(File.exists(dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip")==1){
				roiManager("Open", dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip");
			}
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
			}
			wait(100);

			Dialog.create("Adjust the other stain?"); //then the second step is to ask the user if they want to edit the other stain's ROIs.
			items = newArray("Yes", "No, accept double labeling as is.");
			Dialog.addRadioButtonGroup("Do you want to also adjust "+stain2+" double-labeling?", items, 2, 1, "Yes");
			Dialog.show;
			choice2 = Dialog.getRadioButton;

			if (choice2=="Yes") {
				selectWindow(first_image_DL+"_bkgd_subtracted.tif");
				setLocation(screenHeight/1.5, screenHeight/2, width, height );		//
				
				open(dir+subDir2_DL+second_image_DL+"_bkgd_subtracted.tif");
				selectWindow(second_image_DL+"_bkgd_subtracted.tif");
				setLocation(screenHeight/2, screenHeight/4,width*1.5, height*1.5 );	//
				
				setTool(ROI_shape2);
				roiManager("reset");
				if(File.exists(dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip")==1){
					roiManager("Open", dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip");
				}
				roiManager("show all");
				roiManager("show all with labels");
				waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
				roiManager("deselect");
				if(roiManager("count")>0){
					roiManager("Save", dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
				}	
				wait(100);
				roiManager("reset");
				close("*");
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
			}

			if (choice2=="No, accept double labeling as is.") {
				roiManager("reset");
				close("*");
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
			}
		}
		if (choice==stain2) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");					//
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4,width*1.5, height*1.5 );				//
			
			open(dir+subDir2_DL+second_image_DL+"_bkgd_subtracted.tif");
			selectWindow(second_image_DL+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
			
			setTool(ROI_shape2);
			roiManager("reset");
			if(File.exists(dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip")==1){
				roiManager("Open", dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip");
			}
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
			}
			wait(100);
			
			Dialog.create("Adjust the other stain?"); //then the second step is to ask the user if they want to edit the other stain's ROIs.
			items = newArray("Yes", "No, accept double labeling as is.");
			Dialog.addRadioButtonGroup("Do you want to also adjust "+stain1+" double-labeling?", items, 2, 1, "Yes");
			Dialog.show;
			choice2 = Dialog.getRadioButton;

			if (choice2=="Yes") {
				selectWindow(second_image_DL+"_bkgd_subtracted.tif");
				setLocation(screenHeight/1.5, screenHeight/2, width, height );		//
				
				open(dir+subDir1_DL+first_image_DL+"_bkgd_subtracted.tif");
				selectWindow(first_image_DL+"_bkgd_subtracted.tif");
				setLocation(screenHeight/2, screenHeight/4,width*1.5, height*1.5 );	//
				
				setTool(ROI_shape1);
				roiManager("reset");
				if(File.exists(dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip")==1){
					roiManager("Open", dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip");
				}
				roiManager("show all");
				roiManager("show all with labels");
				waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
				roiManager("deselect");
				if(roiManager("count")>0){
					roiManager("Save", dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
				}	
				wait(100);
				roiManager("reset");
				close("*");
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
			}

			if (choice2=="No, accept double labeling as is.") {
				roiManager("reset");
				close("*");
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
			}
		}
		if (choice=="Accept co-localization as is.") {
			//well, aren't you confident.
			if(File.exists(dir+"STATIC_merged_overlay.tif")){
				File.delete(dir+"STATIC_merged_overlay.tif");
			}
			close("*");
		}		
	/*
	}else{
		Dialog.create("Double-label ROIs not found");
		items = newArray("Close and restart analysis", "Continue analysis");
		Dialog.addRadioButtonGroup("An ROI set could not be found for single-labeled "+stain1+" or "+stain2+". What would you like to do?", items, 2, 1, "Continue analysis");
		Dialog.show;
		choice = Dialog.getRadioButton;
		if (choice=="Continue analysis") {
			wait(10);
		} else {
			close("*");
			return;
		}
	}*/
}


//\\//\\//\\//\\//\\//\\//\\

function measure_dub_coloc(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, parentFunction, stain1_lower, stain2_lower) { //this macro simply recalls the ROIs defined in the last macro in order to measure the values again.
	run("Clear Results");
	roiManager("reset");

	//first_image = first_image_DL;
	//second_image = second_image_DL;

//\\\\\\\\\\\\\
//actually measuring the double labeled ROIs (image 1)
	open(dir+merged_image);
	open(dir+subDir1_DL+first_image_DL+"_bkgd_subtracted.tif");
	open(dir+subDir2_DL+second_image_DL+"_bkgd_subtracted.tif");

	run("Clear Results");
	wait(100);
	selectWindow(first_image_DL+"_bkgd_subtracted.tif");
	roiManager("UseNames", "true"); // shows ROI names on image

	roiManager("Open", dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	//name = series_name+" "+first_stain_type+" double-label.txt";

	DL_ROIs=0;
	DL_ROIs =roiManager("count");
	array=newArray(DL_ROIs);
	for(i=0; i<DL_ROIs;i++) {
		array[i] = i;
	}
	//roiManager("Select", array); //by not making an ROI manager selection, and actually deselecting, the ROI manager selects all by default.
	roiManager("deselect");
	roiManager("Measure");
	roiManager("Show All");
	roiManager("Show All with labels");

	DL_ROIs1_m=0;
	DL_ROIs1_means=0;
	DL_ROIs1_m = nResults;
	DL_ROIs1_means = newArray(DL_ROIs1_m);
	roiManager("deselect");
	for (i=0; i<DL_ROIs1_m; i++) {
		DL_ROIs1_means[i] = getResult('Mean', i);
	}
	roiManager("deselect");
	for (i=0; i<DL_ROIs1_m; i++) {
		roiManager("Select", i); 
		//roiManager("Rename", i);
		roiName = Roi.getName(); 

		setResult("Background", i, stain1_lower);
		setResult("Mean-Background", i, DL_ROIs1_means[i]-stain1_lower);
		setResult("Integrated_Density", i, (DL_ROIs1_means[i]-stain1_lower)*getResult('Area', i));
		setResult("Stain", i, stain1+"_coloc_w/_"+stain2);
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, first_image_DL+imageType);
		setResult("AnalysisDate", i, TimeString);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

	DL_ROIs1_m2 = 0;
	DL_ROIs1_avgmeans = 0;	
	DL_ROIs1_m2 = nResults;
	DL_ROIs1_avgmeans = newArray(DL_ROIs1_m2);
	roiManager("deselect");
	for (i=0; i<DL_ROIs1_m2; i++) {
		DL_ROIs1_avgmeans[i] = getResult('Mean-Background', i);
	}
	Array.getStatistics(DL_ROIs1_avgmeans, min, max, mean, stdDev);

	DL_ROIs1_numberStains=0;
	DL_ROIs1_numberStains=getValue("results.count");

	n_dl1 = nResults;
	area_dl1 = newArray(n_dl1);
	XM_dl1 = newArray(n_dl1);
	YM_dl1 = newArray(n_dl1);
	mean_dl1 = newArray(n_dl1);
	stddev_dl1 = newArray(n_dl1);
	min_dl1 = newArray(n_dl1);
	max_dl1 = newArray(n_dl1);
	bkgd_dl1 = newArray(n_dl1);
	meanbkgd_dl1 = newArray(n_dl1);
	print("\n");
	print("Double-labeled "+stain1+" cell data:");
	print("Experiment Subject# Indi_var_group Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
	
	for (i=0; i<n_dl1; i++) {
		area_dl1[i] = getResult('Area', i);
		XM_dl1[i] = getResult('XM', i);
		YM_dl1[i] = getResult('YM', i);
		mean_dl1[i] = getResult('Mean', i);
		stddev_dl1[i] = getResult('StdDev', i);
		min_dl1[i] = getResult('Min', i);
		max_dl1[i] = getResult('Max', i);
		bkgd_dl1[i] = getResult('Background', i);
		meanbkgd_dl1[i] = getResult('Mean-Background', i);
		print(experiment+": "+subject+" "+treatment+" "+first_image_DL+" "+"Double-labeled_"+stain1+" "+(i+1)+" "+area_dl1[i]+" "+XM_dl1[i]+" "+YM_dl1[i]+" "+mean_dl1[i]+" "+stddev_dl1[i]+" "+min_dl1[i]+" "+max_dl1[i]+" "+bkgd_dl1[i]+" "+meanbkgd_dl1[i]);
	}

	// Saving data

	if(File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_measurements.csv")==1){
		silent=File.rename(dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_measurements.csv", dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_measurements_(archived-"+TimeString+").csv");
	}
	saveAs("Measurements", dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_measurements.csv");
	print("\n");

	roiManager("reset");

	//File.delete(dir+"double-lable_results/"+series_name+first_suffix+first_stain_type+"_first_step_double-label_ROIoverlay.zip");
	//silent=File.delete(dir+"double-label_results"+_sep_+first_image+"_refined_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");

//\\\\\\\\\\\\\\\
//measure double labeled ROIs (image 2)

	
	roiManager("Open", dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	//name = series_name+" "+second_stain_type+" double-label.txt";

	run("Clear Results");
	roiManager("UseNames", "true"); // shows ROI names on image
	selectWindow(second_image_DL+"_bkgd_subtracted.tif");

	roiManager("Show All");
	roiManager("Show All with labels");
	roiManager("deselect");

	DL_ROIs=0;
	DL_ROIs =roiManager("count");
	array=newArray(DL_ROIs);
	for(i=0; i<DL_ROIs;i++) {
		array[i] = i;
	}

	roiManager("deselect");
	roiManager("Measure");
	roiManager("Show All");
	roiManager("Show All with labels");

	DL_ROIs2_m=0;
	DL_ROIs2_means=0;
	DL_ROIs2_m = nResults;
	DL_ROIs2_means = newArray(DL_ROIs2_m);
	run("Select None");
	for (i=0; i<DL_ROIs2_m; i++) {
		DL_ROIs2_means[i] = getResult('Mean', i);
	}
	roiManager("deselect");
	for (i=0; i<DL_ROIs2_m; i++) {
		roiManager("Select", i); 
		//roiManager("Rename", i);
		roiName = Roi.getName(); 

		setResult("Background", i, stain2_lower);
		setResult("Mean-Background", i, DL_ROIs2_means[i]-stain2_lower);
		setResult("Integrated_Density", i, (DL_ROIs2_means[i]-stain2_lower)*getResult('Area', i));
		setResult("Stain", i, stain2+"_coloc_w/_"+stain1);
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, second_image_DL+imageType);
		setResult("AnalysisDate", i, TimeString);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

	DL_ROIs2_m2 = 0;
	DL_ROIs2_avgmeans = 0;
	DL_ROIs2_m2 = nResults;
	DL_ROIs2_avgmeans = newArray(DL_ROIs2_m2);
	roiManager("deselect");
	for (i=0; i<DL_ROIs2_m2; i++) {
		DL_ROIs2_avgmeans[i] = getResult('Mean-Background', i);
	}

	Array.getStatistics(DL_ROIs2_avgmeans, min, max, mean, stdDev);
	DL_ROIs2_numberStains=0;
	DL_ROIs2_numberStains=getValue("results.count");
	
	n_dl2 = nResults;
	area_dl2 = newArray(n_dl2);
	XM_dl2 = newArray(n_dl2);
	YM_dl2 = newArray(n_dl2);
	mean_dl2 = newArray(n_dl2);
	stddev_dl2 = newArray(n_dl2);
	min_dl2 = newArray(n_dl2);
	max_dl2 = newArray(n_dl2);
	bkgd_dl2 = newArray(n_dl2);
	meanbkgd_dl2 = newArray(n_dl2);
	print("\n");
	print("Double-labeled "+stain2+" cell data:");
	print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
	for (i=0; i<n_dl2; i++) {
		area_dl2[i] = getResult('Area', i);
		XM_dl2[i] = getResult('XM', i);
		YM_dl2[i] = getResult('YM', i);
		mean_dl2[i] = getResult('Mean', i);
		stddev_dl2[i] = getResult('StdDev', i);
		min_dl2[i] = getResult('Min', i);
		max_dl2[i] = getResult('Max', i);
		bkgd_dl2[i] = getResult('Background', i);
		meanbkgd_dl2[i] = getResult('Mean-Background', i);
		print(experiment+" "+subject+" "+treatment+" "+second_image_DL+" "+"Double-labeled_"+stain2+" "+(i+1)+" "+area_dl2[i]+" "+XM_dl2[i]+" "+YM_dl2[i]+" "+mean_dl2[i]+" "+stddev_dl2[i]+" "+min_dl2[i]+" "+max_dl2[i]+" "+bkgd_dl2[i]+" "+meanbkgd_dl2[i]);
	}

// Saving data

	saveParameters();

	if(File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_measurements.csv")==1){
		silent=File.rename(dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_measurements.csv", dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_measurements_(archived-"+TimeString+").csv");
	}
	saveAs("Measurements", dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_measurements.csv");

	//silent=File.delete(dir+"double-label_results"+_sep_+second_image+"_first_step_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip");
	//File.delete(dir+"double-lable_results/"+series_name+second_suffix+second_stain_type+"_refined-single-label_ROIoverlay.zip");

	selectWindow("Log");
	saveAs("Text", dir+"All_Results"+TimeString+".txt");
	wait(100);
	close("*");
	wait(100);

	roiManager("reset");

	run("Clear Results");
}
/////////////////////////////




































//====================================================================================================================================================================================================================================================================

//====================================================================================================================================================================================================================================================================

//====================================================================================================================================================================================================================================================================





































/////////////////////////////////////////////////////
//#################################################//
//#################################################//
/////////////////////////////////////////////////////


	//Here be triple label intensity analysis

/////////////////////////////

function open_triple() { // opening previously summed images

	/*
	Dialog.create("Check your stain types");
	Dialog.addMessage("Here are the stain types that will be used. If they are not correct, the compiler will fail.");
	Dialog.addMessage("You can change it here.");
	Dialog.addChoice("First Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"), first_stain_type_TL);
	Dialog.addNumber("First image numbering suffix:", first_suffix_TL_flo);
	
	Dialog.addChoice("Second Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"), second_stain_type_TL);
	Dialog.addNumber("Second image numbering suffix:", second_suffix_TL_flo);
	
	Dialog.addChoice("Third Stain:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other"), third_stain_type_TL);
	Dialog.addNumber("Third image numbering suffix:", third_suffix_TL_flo);
	Dialog.addNumber("Merged image numbering suffix:", merged_suffix_TL_flo);
		
	Dialog.show;
	first_stain_type_TL =  Dialog.getChoice();
	first_suffix_TL_flo = Dialog.getNumber();;
	first_suffix_TL = "_"+first_suffix_TL_flo;
	
	second_stain_type_TL =  Dialog.getChoice();;;
	second_suffix_TL_flo = Dialog.getNumber();;;;
	second_suffix_TL = "_"+second_suffix_TL_flo;
	
	third_stain_type_TL =  Dialog.getChoice();;;
	third_suffix_TL_flo = Dialog.getNumber();;;;
	third_suffix_TL = "_"+third_suffix_TL_flo;
	
	merged_suffix_TL_flo = Dialog.getNumber();;;;;
	merged_suffix_TL = "_"+merged_suffix_TL_flo;
	saveParameters();
	*/

	if(beastMode==100){
/*		
		waitForUser("Select first the files that you want to analyze", "Please select the PARENT folder which contains the subfolders or images you want to analyze.");
		dir = getDirectory("Choose a Directory "); 
		subfolders = getFileList(dir);

		title = "[Image Processing Progress]";
		run("Text Window...", "name="+ title +" width=30 height=4 monospaced");

		for(i=0; i<subfolders.length; i++){
			subDir = subfolders[i];
			if(File.isDirectory(dir+subDir)==1){
				//then subfolders are folders with (or without) images
				index = lastIndexOf(subDir, _sep_);
				if (index!=-1) series_name = substring(subDir, 0, index); //get the name of the subDir folder
				subfolders2 = getFileList(dir+subDir);
				for(j=0; j<subfolders.length; j++){ //determine if the contents of subDir are files or folders
					subDir2 = subfolders2[j];
					if(File.isDirectory(dir+subDir+subDir2)!=1){ // if it is a file, run from here.
						print(title, "\\Update:"+i+1+"/"+subfolders2.length+" ("+((i+1)*100)_sep_subfolders2.length+"%)\n"+getBar(i, subfolders2.length));
						name=subDir2;
						subject=name;
						
						index = lastIndexOf(name, ".");
						if (index!=-1) imageType = substring(name, index, lengthOf(name));
						if (index!=-1) name = substring(name, 0, index);
						
						index = lastIndexOf(name, "_");
						if (index!=-1) SL_suffix_check = substring(name, index, lengthOf(name));
						if (SL_suffix_check!=SL_suffix){
							series_name=subDir2+SL_suffix+_sep_;
						}else{
							series_name=subDir2+_sep_;
						}
						
						//now open and process
						open(dir+subDir+name+imageType);
						full_name = getTitle;
						run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");

						if(File.exists(dir+subDir+series_name)!=1){
							File.makeDirectory(dir+subDir+series_name);
							silent=File.rename(dir+subDir+full_name, dir+subDir+series_name+full_name);
							wait(20);
							imageDir=dir+subDir+series_name;
						}
						
						print("full_name: "+full_name);
						print("name: "+name);
						print("imageType: "+imageType);
						print("subject: "+subject);
						print("SL_suffix: "+SL_suffix);
						print("series_name: "+series_name);
						print("subDir: "+subDir);
						print("dir: "+dir);			
						suffix=SL_suffix;.
						model=SL_stain_type;
						ROI_shape=ROI_type_SL;
						ROI_enlargement=set_roi_enlargement_single;
												
						//region_limit();
						Set_Background();
						//Initiate_ROI();
						recursive_inference();
						Measure_ROIs();
						Save_ROIs();
						close("*");					
	
					}else{
						waitForUser("Check to make sure that you select the PARENT folder containing your images OR \ncontaining individual subfolders for each image.");
					}
				}
				open_double();
				
			}else{ //subfolders are image files
				print(title, "\\Update:"+i+1+"/"+subfolders.length+" ("+((i+1)*100)/subfolders.length+"%)\n"+getBar(i, subfolders.length));
				name=subDir;
				subject=name;
						
				index = lastIndexOf(name, ".");
				if (index!=-1) imageType = substring(name, index, lengthOf(name));
				if (index!=-1) name = substring(name, 0, index);
						
				index = lastIndexOf(name, "_");
				if (index!=-1) SL_suffix_check = substring(name, index, lengthOf(name));
				if (SL_suffix_check!=SL_suffix){
					series_name=subDir+SL_suffix+_sep_;
				}else{
					series_name=subDir+_sep_;
				}
						
				//now open and process
				open(dir+name+imageType);
				full_name = getTitle;
				run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");

				if(File.exists(dir+series_name)!=1){
					File.makeDirectory(dir+series_name);
					silent=File.rename(dir+full_name, dir+series_name+full_name);
					wait(20);
					imageDir=dir+series_name;
				}
						
				print("full_name: "+full_name);
				print("name: "+name);
				print("imageType: "+imageType);
				print("subject: "+subject);
				print("SL_suffix: "+SL_suffix);
				print("series_name: "+series_name);
				print("subDir: "+subDir);
				print("dir: "+dir);	
				suffix=SL_suffix;
				model=SL_stain_type;	
				ROI_shape=ROI_type_SL;
				ROI_enlargement=set_roi_enlargement_single;	
				
				//region_limit();
				Set_Background();
				//Initiate_ROI();
				recursive_inference();
				Measure_ROIs();
				Save_ROIs();
				close("*");					
			}
		}		
		beep();
		print(title, "\\Close");
		waitForUser("Compiled all available folders");
*/
	}else{
		//waitForUser("Select First Image", "Please open the first image of the subject series.");
		//open();

		/*
		run("Image Picker", "file_count=3");
		wait(500);
		status=call("PipsqueakImageSelectCommand.getStatus");
		while (status == "Not Done") {
			print("Status: " + status);
			wait(500);
			status=call("PipsqueakImageSelectCommand.getStatus");
		}

		imageData=call("PipsqueakImageSelectCommand.getImages");
		print(imageData);

		imageStrings=split(imageData, "\0");

		firstImageData=split(imageStrings[0], "\n");
		secondImageData=split(imageStrings[1], "\n");
		thirdImageData=split(imageStrings[2], "\n");
		mergedImageData=imageStrings[3];

		first_stain_type_TL=firstImageData[0];
		first_image_TL=firstImageData[1];
		second_stain_type_TL=secondImageData[0];
		second_image_TL=secondImageData[1];
		third_stain_type_TL=thirdImageData[0];
		third_image_TL=thirdImageData[1];
		merged_image_TL=mergedImageData;
		merged_image=mergedImageData;

		firstIndex=lastIndexOf(first_image_TL, "/");
		secondIndex=lastIndexOf(second_image_TL, "/");
		thirdIndex=lastIndexOf(third_image_TL, "/");

		first_image_TL=substring(first_image_TL, firstIndex+1, lengthOf(first_image_TL));
		second_image_TL=substring(second_image_TL, secondIndex+1, lengthOf(second_image_TL));
		third_image_TL=substring(third_image_TL, thirdIndex+1, lengthOf(third_image_TL));

		waitForUser(first_image_TL + " " + second_image_TL + " " + third_image_TL);
		*/
		first_image_dir = "";
		second_image_dir = "";
		third_image_dir = "";
		merged_image_dir = "";

		model_library_reader();

		if(File.exists(pipDir+"models.json")){
			parameters = File.openAsString(pipDir+"models.json");
			parLines=split(parameters,"}");
			model_num = parLines.length;
	
			specific_models=Array.slice(model_library,0,model_num-1);
			general_models=Array.slice(model_library,model_num,(model_num-1)*2);
			community_models=Array.slice(model_library,model_num*2,(model_num-1)*3);
			custom_models=Array.slice(model_library,model_num*3,(model_num-1)*4);
		}
	
		specific_models=Array.deleteValue(specific_models, "null");
		
		
		general_models=Array.deleteValue(general_models, "null");
		general_models=Array.concat(general_models, "Threshold Detection");
		
		community_models=Array.deleteValue(community_models, "null");
		if(community_models.length==0) community_models=Array.concat(community_models, "<none>");
	
		custom_models=Array.deleteValue(custom_models, "null");
		if(custom_models.length==0) custom_models=Array.concat(custom_models, "<none>");

		models = Array.concat("*Specific models*", specific_models, "-------------", "*General models*", general_models, "-------------", "*Community models*", community_models, "-------------", "*Custom models", custom_models);

		Dialog.createNonBlocking("Open Images");
		Dialog.addMessage("Select first image file");
		Dialog.addFile("Image (channel) 1", first_image_dir);
		//Dialog.addChoice("First image stain type:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other", "Create detection model"), first_stain_type_TL);
		Dialog.addChoice("First image stain type:", models, first_stain_type_TL);	
		Dialog.addMessage("");
		Dialog.addMessage("Select second image file");
		Dialog.addFile("Image (channel) 2", second_image_dir);
		//Dialog.addChoice("Second image stain type:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other", "Create detection model"), second_stain_type_TL);
		Dialog.addChoice("Second image stain type:", models, second_stain_type_TL);	
		Dialog.addMessage("");
		Dialog.addMessage("Select third image file");
		Dialog.addFile("Image (channel) 3", third_image_dir);
		//Dialog.addChoice("Third image stain type:", newArray("8-oxo", "c-Fos", "Parvalbumin", "WFA", "Other", "Create detection model"), third_stain_type_TL);
		Dialog.addChoice("Third image stain type:", models, third_stain_type_TL);	
		Dialog.addMessage("");
		Dialog.addMessage("Select merged image file (optional for viewing co-localization)");
		Dialog.addFile("Merged image", merged_image_dir);
				
		Dialog.show();
		first_image_dir=Dialog.getString();
		first_stain_type_TL =  Dialog.getChoice();
		second_image_dir=Dialog.getString();
		second_stain_type_TL =  Dialog.getChoice();
		third_image_dir=Dialog.getString();
		third_stain_type_TL =  Dialog.getChoice();
		merged_image_dir=Dialog.getString();

		if(first_stain_type_TL=="*Specific models*" || first_stain_type_TL== "*General models*" || first_stain_type_TL== "*Community models*" || first_stain_type_TL== "-------------"  || first_stain_type_TL== "*Custom models" || second_stain_type_TL=="*Specific models*" || second_stain_type_TL== "*General models*" || second_stain_type_TL== "*Community models*" || second_stain_type_TL== "-------------"  || second_stain_type_TL== "*Custom models" || third_stain_type_TL=="*Specific models*" || third_stain_type_TL== "*General models*" || third_stain_type_TL== "*Community models*" || third_stain_type_TL== "-------------"  || third_stain_type_TL== "*Custom models"){
			waitForUser("Invalid Choice: Please select a valid model");
			open_triple();
		}
		
		saveParameters();
		
		open(first_image_dir);			//setting first image variables (and leaving first image open)
		first_image = getTitle;
		dir = getDirectory("image");
		full_name=first_image;
				
		selectWindow(first_image);
		height=getHeight();													
		width=getWidth();
		setLocation(0, screenHeight/4,width*1.5, height*1.5 );

		index = lastIndexOf(first_image, ".");
		if (index!=-1) imageType = substring(first_image, index, lengthOf(first_image));
		//if (index!=-1) series_name = substring(first_image, 0, index-2);								//removing series name becasue images are called by image_dir and save locations are determined by image_dir - image name
		if (index!=-1) first_image = substring(first_image, 0, index);
		subDir1=first_image+_sep_;
		
		open(second_image_dir);				//setting second image variables (and closing image)
		second_image = getTitle;
		dirB = getDirectory("image");
		index = lastIndexOf(second_image, ".");
		if (index!=-1) secondImageType = substring(second_image, index, lengthOf(second_image));
		if (index!=-1) second_image = substring(second_image, 0, index);
		subDir2=second_image+_sep_;
		
		if(secondImageType != imageType){
			waitForUser("Image channels 1 and 2 must be saved in the same format ("+imageType+" or "+secondImageType+")");
			close("*");
			ps_triple();
		}
		if(dir != dirB){
			waitForUser("Image channels 1 and 2 must be saved in the same directory location. \n"+first_stain_type_TL+" image: +"dir+"\n"+second_stain_type_TL+" images: "+dirB);
			close("*");
			ps_triple();
		}
	
		//waitForUser("second_image = "+second_image+"\nsecondImageType = "+secondImageType+"\ndir = "+dir+"\nsubDir2 = "+subDir2+"\n_sep_ = "+_sep_);
		close(second_image+imageType);

		open(third_image_dir);				//setting second image variables (and closing image)
		third_image = getTitle;
		dirC = getDirectory("image");
		index = lastIndexOf(third_image, ".");
		if (index!=-1) thirdImageType = substring(third_image, index, lengthOf(third_image));
		if (index!=-1) third_image = substring(third_image, 0, index);
		subDir3=third_image+_sep_;
		
		if(thirdImageType != imageType){
			waitForUser("Image channels 1 and 3 must be saved in the same format ("+imageType+" or "+thirdImageType+")");
			close("*");
			ps_triple();
		}
		if(dir != dirC){
			waitForUser("Image channels 1 and 3 must be saved in the same directory location. \n"+first_stain_type_TL+" image: +"dir+"\n"+third_stain_type_TL+" images: "+dirC);
			close("*");
			ps_triple();
		}
	
		//waitForUser("second_image = "+second_image+"\nsecondImageType = "+secondImageType+"\ndir = "+dir+"\nsubDir2 = "+subDir2+"\n_sep_ = "+_sep_);
		close(third_image+imageType);
		
		//waitForUser(merged_image_dir);
		if(merged_image_dir ==""){			//setting merged image variables (and closing image)
			open(second_image_dir);
			open(third_image_dir);
			
			selectWindow(first_image+imageType);
			run("Duplicate...", " ");
			first_image_dup = getTitle;

			selectWindow(first_image_dup);
			run("Add Image...", "image="+second_image+imageType+" x=0 y=0 opacity=50");
			selectWindow(first_image_dup);
			run("Add Image...", "image="+third_image+imageType+" x=0 y=0 opacity=50");

			close(second_image+imageType);
			close(third_image+imageType);
			
			selectWindow(first_image_dup);
			saveAs(imageType, dir+"merged_image"+imageType);
			merged_image = "merged_image"+imageType;
			close(merged_image);
			merged_image_dir = dir+merged_image;
			
			//waitForUser("merged_image = "+merged_image+"\nimageType = "+imageType+"\ndir = "+dir+"\nsubDir1 = "+subDir1+"\n_sep_ = "+_sep_);
		}else{
			open(merged_image_dir);				//setting second image variables (and closing image)
			merged_image = getTitle;
			index = lastIndexOf(merged_image, ".");
			if (index!=-1) mergedImageType = substring(merged_image, index, lengthOf(merged_image));
			//if (index!=-1) merged_image = substring(merged_image, 0, index);
			close(merged_image);
			
			if(mergedImageType != imageType){
				waitForUser("Image channels 1 and merged must be saved in the same format ("+imageType+" or "+mergedImageType+")");
				close("*");
				ps_triple();
			}
		}			
		//waitForUser(merged_image);	

		//run("Set Measurements...", "area mean standard min center limit redirect=None decimal=3");  //setting measurements.
		run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");

		Dialog.create("Optional metadata");
	  	Dialog.addMessage("Enter known image and/or subject information to help with data processing.");
	  	Dialog.addString("Experiment ID:", "eg:Exp1");
	  	Dialog.addString("Subject ID:", "eg:Sub_42B");
	  	Dialog.addString("Independent variable grouping:", "eg:Control");
	  	Dialog.show
	  	experiment =  Dialog.getString();
		subject =  Dialog.getString();
		treatment =  Dialog.getString();
						
		name=first_image;
		//full_name=first_image+imageType;

		//===================================================================	
		dirCheck = getDirectory("image");
		//waitForUser(dirCheck);
		
		if(dirCheck==dir){ //new image without subDir or series_name
			//print("subDir DOES NOT exists");
			File.makeDirectory(dir+subDir1);
			full_name=first_image+imageType;
			silent=File.copy(dir+full_name, dir+subDir1+full_name);
			wait(20);
			imageDir=dir+subDir1;
			
		}else if(dirCheck==dir+subDir1){ //image is in a subDir
			//print("subDir exists");
			imageDir=dir+subDir1;
		}else{
			waitForUser("Please place all image channels into a single folder. Then, select that folder.");
			ps_triple();
		}
				
	//====================================================================	
		
		Dialog.create(" Images to be analyzed");
		Dialog.addMessage("");
		Dialog.addMessage("First  image:   "+first_image+imageType);
		Dialog.addMessage("First image stain: "+first_stain_type_TL);
		Dialog.addMessage("");
		Dialog.addMessage("Second image: "+second_image+imageType);
		Dialog.addMessage("Second image stain: "+second_stain_type_TL);
		Dialog.addMessage("");
		Dialog.addMessage("Third  image: "+third_image+imageType);
		Dialog.addMessage("Third image stain: "+third_stain_type_TL);
		Dialog.addMessage("");
		Dialog.addMessage("Merged image: "+merged_image);
		Dialog.addMessage("");
		choice = newArray("Yes", "No");
		Dialog.addRadioButtonGroup("Are these the images you want to analyze?", choice, 2, 1, "Yes");
		Dialog.show;	
		choice = Dialog.getRadioButton;

		if (choice=="No"){
			close("*");
			ps_triple();
		}
		parentFunction = "open_triple()";
//first image run
		
		imageDir=dir+subDir1;
		//name=first_image_TL;
		//suffix=first_suffix_TL;
		model=first_stain_type_TL;
		ROI_shape=ROI_type_TL1;
		ROI_enlargement=TL1_set_roi_enlargement;
		// DL_overlap=TL1_overlap;
		saveParameters();
		
		//print("first_image: "+first_image);
		//print("name: "+name);
		//print("imageType: "+imageType);
		//print("subject: "+subject);
		//print("first_suffix: "+first_suffix);
		//print("series_name: "+series_name);
		//print("subDir: "+series_name+first_suffix+_sep_);
		//print("dir: "+dir);
		//print("imageDir: "+imageDir);
		//print("stain: "+first_stain_type);
		//print("model: "+model);
		
		//region_limit();
		Set_Background(parentFunction);
		TL1_lower=lower;
		imageOrder="a";
		
		if(lic==0){
			user_model=user_model_1;
	  		threshold_name();
			threshold_detection();
			user_model_1=user_model;
			if(isOpen("Processing")==true){
				wait(100);
				selectWindow("Processing");
				run("Close");
			}
			//manual_menu();
		}
		if(lic==1){
			if(model=="Threshold Detection"){
	  			user_model=user_model_1;
	  			threshold_name();
				threshold_detection();
				user_model_1=user_model;
				//manual_menu();
				pass==1;
				if(isOpen("Processing")==true){
					wait(100);
					selectWindow("Processing");
					run("Close");
				}	
	  		}else{
				Initiate_ROI();
				recursive_inference();
				if(isOpen("AI Engine Results")==true){
					selectWindow("AI Engine Results");
					run("Close");
		  		}
	  		}	
		}
		first_stain_type_TL=model;
		first_image=name;
		Measure_ROIs();
		Save_ROIs();
		close("*");
		
//second image run

		open(dir+second_image+imageType);
		name=second_image;
		full_name=name+imageType;

		selectWindow(full_name);
		height=getHeight();													//
		width=getWidth();													//
		setLocation(0, screenHeight/4,width*1.5, height*1.5 );

//===================================================================	
		dirCheck = getDirectory("image");
		//waitForUser(dirCheck);
		
		if(dirCheck==dir){ //new image without subDir or series_name
			//print("subDir DOES NOT exists");
			File.makeDirectory(dir+subDir2);
			silent=File.copy(dir+full_name, dir+subDir2+full_name);
			wait(20);
			imageDir=dir+subDir2;
		}else if(dirCheck==dir+subDir2){ //image is in a subDir
			//print("subDir exists");
			imageDir=dir+subDir2;
		}else{
			waitForUser("Please place all image channels into a single folder. Then, select that folder.");
			ps_triple();
		}
				
//====================================================================	

		imageDir=dir+subDir2;
		//suffix=second_suffix_TL;
		model=second_stain_type_TL;
		ROI_shape=ROI_type_TL2;
		ROI_enlargement=TL2_set_roi_enlargement;
		//DL_overlap=TL2_overlap;
		saveParameters();
		
		//print("second_image: "+second_image_TL);
		//print("name: "+name);
		//print("imageType: "+imageType);
		//print("subject: "+subject);
		//print("second_suffix: "+second_suffix_TL);
		//print("series_name: "+series_name);
		//print("subDir: "+series_name+second_suffix_TL+"/");
		//print("dir: "+dir);
		//print("imageDir: "+imageDir);
		//print("stain: "+second_stain_type_TL);
		//print("model: "+model);
		
		//region_limit();
		Set_Background(parentFunction);
		TL2_lower=lower;
		imageOrder="b";
		
		if(lic==0){
			user_model=user_model_2;
		  	threshold_name();
			threshold_detection();
			user_model_2=user_model;
			if(isOpen("Processing")==true){
				wait(100);
				selectWindow("Processing");
				run("Close");
			}
			//manual_menu();
		}
		if(lic==1){
			if(model=="Threshold Detection"){
	  			user_model=user_model_2;
	  			threshold_name();
				threshold_detection();
				user_model_2=user_model;
				//manual_menu();
				pass==1;
				if(isOpen("Processing")==true){
					wait(100);
					selectWindow("Processing");
					run("Close");
				}	
	  		}else{
				Initiate_ROI();
				recursive_inference();
				if(isOpen("AI Engine Results")==true){
					selectWindow("AI Engine Results");
					run("Close");
		  		}
	  		}	
		}
		second_stain_type_TL=model;
		second_image=name;
		Measure_ROIs();
		Save_ROIs();
		close("*");
		
//third image run

		open(dir+third_image+imageType);
		name=third_image;
		full_name=name+imageType;

		selectWindow(full_name);
		height=getHeight();													//
		width=getWidth();													//
		setLocation(0, screenHeight/4,width*1.5, height*1.5 );

//===================================================================	
		dirCheck = getDirectory("image");
		//waitForUser(dirCheck);
		
		if(dirCheck==dir){ //new image without subDir or series_name
			//print("subDir DOES NOT exists");
			File.makeDirectory(dir+subDir3);
			silent=File.copy(dir+full_name, dir+subDir3+full_name);
			wait(20);
			imageDir=dir+subDir3;
		}else if(dirCheck==dir+subDir3){ //image is in a subDir
			//print("subDir exists");
			imageDir=dir+subDir3;
		}else{
			waitForUser("Please place the first, second, and merged image into a single folder. Then, select that folder.");
			ps_triple();
		}
				
//====================================================================	

		imageDir=dir+subDir3;
		//suffix=third_suffix_TL;
		model=third_stain_type_TL;
		ROI_shape=ROI_type_TL3;
		ROI_enlargement=TL3_set_roi_enlargement;
		//DL_overlap=TL3_overlap;
		saveParameters();

		//print(ROI_enlargement);
		//print(TL3_set_roi_enlargement);
		
		//print("third_image: "+third_image);
		//print("name: "+name);
		//print("imageType: "+imageType);
		//print("subject: "+subject);
		//print("third_suffix: "+third_suffix);
		//print("series_name: "+series_name);
		//print("subDir: "+series_name+third_suffix+_sep_);
		//print("dir: "+dir);
		//print("imageDir: "+imageDir);
		//print("stain: "+third_stain_type);
		//print("model: "+model);
		
		//region_limit();
		Set_Background(parentFunction);
		TL3_lower=lower;
		imageOrder="c";
		
		if(lic==0){
			user_model=user_model_3;
			threshold_name();
			threshold_detection();
			user_model_3=user_model;
			if(isOpen("Processing")==true){
				wait(100);
				selectWindow("Processing");
				run("Close");
			}
			//manual_menu();
		}
		if(lic==1){
			if(model=="Threshold Detection"){
	  			user_model=user_model_3;
	  			threshold_name();
				threshold_detection();
				user_model_3=user_model;
				//manual_menu();
				pass==1;
				if(isOpen("Processing")==true){
					wait(100);
					selectWindow("Processing");
					run("Close");
				}	
	  		}else{
				Initiate_ROI();
				recursive_inference();
				if(isOpen("AI Engine Results")==true){
					selectWindow("AI Engine Results");
					run("Close");
		  		}
	  		}	
		}
		third_stain_type_TL=model;
		third_image=name;
		//selectWindow("AI Engine Results");
		//run("Close");
		Measure_ROIs();
		Save_ROIs();

		limitRegion=0;
		if(File.exists(dir+subDir1+"sub_region_selection_ROI.zip")==1){
			silent=File.rename(dir+subDir1+"sub_region_selection_ROI.zip", dir+subDir1+"sub_region_selection_ROI_("+TimeString+"_archived).zip");
		}
		
		close("*");

		if(File.exists(dir+"double-label_results"+_sep_)!=1) File.makeDirectory(dir+"double-label_results"+_sep_);
		parentFunction = "open_triple()";
		
////////colocalize////////	
//DL stuff 1v2
		//stain 1
		
		//suffix1 = first_suffix_TL;
		//suffix2 = second_suffix_TL;
		first_image_DL = first_image;
		second_image_DL = second_image;
		subDir1_DL = subDir1;
		subDir2_DL = subDir2;
		stain1 = first_stain_type_TL;
		stain2 = second_stain_type_TL;
		first_rois = dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip";
		second_rois = dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip";
		stain1_DL_overlap=TL1_overlap;
		stain2_DL_overlap=TL2_overlap;
		ROI_shape1 = ROI_type_TL1;
		ROI_shape2 = ROI_type_TL2;

/*
waitForUser("first_image_DL ="+ first_image_DL +
			"\nsecond_image_DL ="+ second_image_DL +
			"\nsubDir1_DL ="+ subDir1_DL +
			"\nsubDir2_DL ="+ subDir2_DL +

			"\nstain1 ="+ stain1+
			"\nstain2 ="+ stain2+
			"\nfirst_rois ="+ first_rois+
			"\nsecond_rois ="+ second_rois+
			"\nstain1_DL_overlap =" +stain1_DL_overlap);	
*/

		if(File.exists(first_rois) && File.exists(second_rois)){
			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save1(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
		
		//stain 2
		
			//suffix1 = second_suffix_TL;
			//suffix2 = first_suffix_TL;
			first_image_DL = second_image;
			second_image_DL = first_image;
			subDir1_DL = subDir2;
			subDir2_DL = subDir1;
			stain1 = second_stain_type_TL;
			stain2 = first_stain_type_TL;
			first_rois = dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip";
			second_rois = dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip";
			stain1_DL_overlap=TL2_overlap;
			stain2_DL_overlap=TL1_overlap;
			ROI_shape1 = ROI_type_TL2;
			ROI_shape2 = ROI_type_TL1;
			stain1_lower = TL2_lower;
			stain2_lower = TL1_lower;
/*
waitForUser("first_image_DL ="+ first_image_DL +
			"\nsecond_image_DL ="+ second_image_DL +
			"\nsubDir1_DL ="+ subDir1_DL +
			"\nsubDir2_DL ="+ subDir2_DL +

			"\nstain1 ="+ stain1+
			"\nstain2 ="+ stain2+
			"\nfirst_rois ="+ first_rois+
			"\nsecond_rois ="+ second_rois+
			"\nstain1_DL_overlap =" +stain1_DL_overlap+
			"\nROI_shape1="+ROI_shape1+
			"\nROI_shape2="+ROI_shape2+
			"\nstain1_lower ="+ stain1_lower+
			"\nstain2_lower ="+ stain2_lower);
*/	
			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save2(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
			//co-check
			checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
			if(File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip") && File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip")){
				measure_dub_coloc(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, parentFunction, stain1_lower, stain2_lower);
			}	
		}else{
			Dialog.create("Co-localization not found");
			items = newArray("Close images and restart analysis", "Determine co-localization manually", "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.addRadioButtonGroup("No co-localization between "+stain1+" and "+stain2+" was found. What would you like to do?", items, 3, 1, "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.show;
			choice2 = Dialog.getRadioButton;
			if(choice2=="Continue analysis without "+stain1+" and "+stain2+" co-localization") {
				roiManager("reset");
				close("*");
			} 
			if(choice2=="Close images and restart analysis"){
				roiManager("reset");
				close("*");
				return;
			}
			if(choice2=="Determine co-localization manually"){
				close("*");
				roiManager("reset");
				
				manual_colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, merged_image, parentFunction, ROI_shape1, ROI_shape2);
			}
		}

//DL stuff 2v3
		//stain 1
		
		//suffix1 = second_suffix_TL;
		//suffix2 = third_suffix_TL;
		first_image_DL = second_image;
		second_image_DL = third_image;
		subDir1_DL = subDir2;
		subDir2_DL = subDir3;
		stain1 = second_stain_type_TL;
		stain2 = third_stain_type_TL;
		first_rois = dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip";
		second_rois = dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip";
		ROI_shape1 = ROI_type_TL2;
		ROI_shape2 = ROI_type_TL3;
		stain1_DL_overlap=TL2_overlap;
		stain2_DL_overlap=TL3_overlap;
	
		if(File.exists(first_rois) && File.exists(second_rois)){
			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save1(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
			
		//stain 2
		
			//suffix1 = third_suffix_TL;
			//suffix2 = second_suffix_TL;
			first_image_DL = third_image;
			second_image_DL = second_image;
			subDir1_DL = subDir3;
			subDir2_DL = subDir2;
			stain1 = third_stain_type_TL;
			stain2 = second_stain_type_TL;
			first_rois = dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip";
			second_rois = dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip";
			stain1_DL_overlap=TL3_overlap;
			stain2_DL_overlap=TL2_overlap;
			ROI_shape1 = ROI_type_TL3;
			ROI_shape2 = ROI_type_TL2;
			stain1_lower = TL3_lower;
			stain2_lower = TL2_lower;

			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save2(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
			//co-check
			checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
			if(File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip") && File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip")){
				measure_dub_coloc(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, parentFunction, stain1_lower, stain2_lower);
			}
		}else{
			Dialog.create("Co-localization not found");
			items = newArray("Close images and restart analysis", "Determine co-localization manually", "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.addRadioButtonGroup("No co-localization between "+stain1+" and "+stain2+" was found. What would you like to do?", items, 3, 1, "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.show;
			choice2 = Dialog.getRadioButton;
			if(choice2=="Continue analysis without "+stain1+" and "+stain2+" co-localization") {
				roiManager("reset");
				close("*");
			} 
			if(choice2=="Close images and restart analysis"){
				roiManager("reset");
				close("*");
				return;
			}
			if(choice2=="Determine co-localization manually"){
				close("*");
				roiManager("reset");
								
				manual_colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, merged_image, parentFunction, ROI_shape1, ROI_shape2);
			}
		}

//DL stuff 1v3
		//stain 1
		
		//suffix1 = first_suffix_TL;
		//suffix2 = third_suffix_TL;
		first_image_DL = first_image;
		second_image_DL = third_image;
		subDir1_DL = subDir1;
		subDir2_DL = subDir3;
		stain1 = first_stain_type_TL;
		stain2 = third_stain_type_TL;
		first_rois = dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip";
		second_rois = dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip";
		stain1_DL_overlap=TL1_overlap;
		stain2_DL_overlap=TL3_overlap;
		ROI_shape1 = ROI_type_TL1;
		ROI_shape2 = ROI_type_TL3;

		if(File.exists(first_rois) && File.exists(second_rois)){
			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save1(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
		
		//stain 3
		
			//suffix1 = third_suffix_TL;
			//suffix2 = first_suffix_TL;
			first_image_DL = third_image;
			second_image_DL = first_image;
			subDir1_DL = subDir3;
			subDir2_DL = subDir1;
			stain1 = third_stain_type_TL;
			stain2 = first_stain_type_TL;
			first_rois = dir+subDir1_DL+first_image_DL+"_{single}_{"+stain1+"}_ROI-overlay.zip";
			second_rois = dir+subDir2_DL+second_image_DL+"_{single}_{"+stain2+"}_ROI-overlay.zip";
			stain1_DL_overlap=TL3_overlap;
			stain2_DL_overlap=TL1_overlap;
			ROI_shape1 = ROI_type_TL3;
			ROI_shape2 = ROI_type_TL1;
			stain1_lower = TL3_lower;
			stain2_lower = TL1_lower;

			colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, stain1_DL_overlap, stain2_DL_overlap);
			colocalizer_save2(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois);
			//co-check
			checkCo(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, first_rois, second_rois, merged_image, parentFunction, ROI_shape1, ROI_shape2, stain1_DL_overlap, stain2_DL_overlap);
			if(File.exists(dir+"double-label_results"+_sep_+first_image_DL+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip") && File.exists(dir+"double-label_results"+_sep_+second_image_DL+"_{double}_{"+stain2+"_coloc_with_"+stain1+"}_ROI-overlay.zip")){
				measure_dub_coloc(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, parentFunction, stain1_lower, stain2_lower);
			}
		}else{
			Dialog.create("Co-localization not found");
			items = newArray("Close images and restart analysis", "Determine co-localization manually", "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.addRadioButtonGroup("No co-localization between "+stain1+" and "+stain2+" was found. What would you like to do?", items, 3, 1, "Continue analysis without "+stain1+" and "+stain2+" co-localization");
			Dialog.show;
			choice2 = Dialog.getRadioButton;
			if(choice2=="Continue analysis without "+stain1+" and "+stain2+" co-localization") {
				roiManager("reset");
				close("*");
			} 
			if(choice2=="Close images and restart analysis"){
				roiManager("reset");
				close("*");
				return;
			}
			if(choice2=="Determine co-localization manually"){
				close("*");
				roiManager("reset");
								
				manual_colocalizer(first_image_DL, second_image_DL, subDir1_DL, subDir2_DL, stain1, stain2, merged_image, parentFunction, ROI_shape1, ROI_shape2);
			}
		}

//TL stuff
		if(File.exists(dir+"triple-label_results"+_sep_)!=1) File.makeDirectory(dir+"triple-label_results"+_sep_);

		//suffix1 = first_suffix_TL;
		//suffix2 = second_suffix_TL;
		//suffix3 = third_suffix_TL;
		image1 = first_image;
		image2 = second_image;
		image3 = third_image;
		subDir1 = subDir1;
		subDir2 = subDir2;
		subDir3 = subDir3;
		stain1 = first_stain_type_TL;
		stain2 = second_stain_type_TL;
		stain3 = third_stain_type_TL;
		ROI_shape1 = ROI_type_TL1;
		ROI_shape2 = ROI_type_TL2;
		ROI_shape3 = ROI_type_TL3;

		if(File.exists(dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip") && File.exists(dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip") && File.exists(dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip")){
			triple_colocalization1(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, parentFunction);
			triLocalizer_save1(image1, image2, stain1, stain2);
		
			triple_colocalization2(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, parentFunction);
			triLocalizer_save2(image1, image2, stain1, stain2);
			
			triple_colocalization3(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, parentFunction);
			triLocalizer_save3(image3, stain3);

			checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
			//
			if(File.exists(dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip") && File.exists(dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip") && File.exists(dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip")){
				measure_tri_coloc(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, parentFunction);
			}
		}else{
			Dialog.create("Triple-label co-localization not found");
			items = newArray("Close images and restart analysis", "Determine triple co-localization manually", "Continue analysis without triple-label co-localization");
			Dialog.addRadioButtonGroup("No co-localization between "+stain1+", "+stain2+", and "+stain3+" was found. What would you like to do?", items, 3, 1, "Continue analysis without triple-label co-localization");
			Dialog.show;
			
			choice2 = Dialog.getRadioButton;
			
			if(choice2=="Continue analysis without triple-label co-localization") {
				roiManager("reset");
				close("*");
			} 
			if(choice2=="Close images and restart analysis"){
				roiManager("reset");
				close("*");
				parentFunction;
			}
			if(choice2=="Determine triple co-localization manually"){
				close("*");
				roiManager("reset");
				manual_TriLocalizer(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
				measure_tri_coloc(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, parentFunction);
			}
		}
		
		
		Dialog.create("Analyze another image?");
		items = newArray("Open another image", "Exit to main menu");
		Dialog.addRadioButtonGroup("Analysis done! Results saves as All_Results"+TimeString+".txt"+"\n"+"Next Move:", items, 2, 1, "Open another image");
		Dialog.show;
		choice = Dialog.getRadioButton;
		
		if (choice=="Open another image") {
			open_triple();
		} else {
			initi();
		}
	}
}

///////////////////////////////

//\\//\\//\\//\\//\\//\\//\\

function triple_colocalization1(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, parentFunction) {  //this is the macro that identifies triple-labeled cells between all stains. Adapted from "New" double-label overlay detection

	aCoLoArray=newArray(0); 
	bCoLoArray=newArray(0); 
	abcCoLoArray=newArray(0);
	aCoLoselectArray=newArray(0);
	bCoLoselectArray=newArray(0);
	abcCoLoselectArray=newArray(0);
	aCoLo=0;
	bCoLo=0;
		
//triple labeled cell identification
	run("Clear Results");
	roiManager("reset");

	first_image = image1;
	second_image = image2;

	open(dir+subDir1+image1+"_bkgd_subtracted.tif");
	open(dir+subDir2+image2+"_bkgd_subtracted.tif");

	roiManager("deselect");
	roiManager("reset");
	wait(50);

	roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	wait(200);
	stain1Count = roiManager("count"); // determines the number of circle ROIs
	stain1Count_array=newArray(stain1Count);
	//print("stain1Count ="+stain1Count);
	roiManager("reset");

	roiManager("Open", dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip");
	wait(200);
	stain2Count = roiManager("count");
	stain2Count_array=newArray(stain2Count);
	stain2Start=stain1Count;
	//print("stain2Count ="+stain2Count);
	//print("stain2Start ="+stain2Start);
	roiManager("reset");
	
	roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	roiManager("Open", dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip");
	roiManager("show all");
	roiManager("show all with labels");

	roiManager("deselect");
	ROIs =roiManager("count"); 
	ROI_array=newArray(ROIs);
	for(i=0; i<ROIs;i++) { 
		ROI_array[i] = i; 
	}
	
	roiManager("deselect");
	roiManager("Measure");
	roiManager("deselect");

	for (i=0; i<ROIs; i++) {
		roiManager("Select", i); 
		roiName = Roi.getName(); 
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
	}
	
	setOption("ShowRowNumbers", false);
	updateResults();

	XM=newArray(ROIs);
	YM=newArray(ROIs);
	BX=newArray(ROIs);
	BY=newArray(ROIs);
	Width=newArray(ROIs);
	Height=newArray(ROIs);
	roiName_array=newArray(ROIs);

	roiManager("deselect");
	for (i=0; i<ROIs; i++) { 
		XM[i] = getResult('XM', i);
		YM[i] = getResult('YM', i);
		BX[i] = getResult('BX', i);
		BY[i] = getResult('BY', i);
		Width[i] = getResult('Width', i);
		Height[i] = getResult('Height', i);
		roiName_array[i] = getResult('roiName', i);
	}

	for(a=stain2Start; a<(ROIs); a++){  // Select stain2 Rois.
		roiManager("Select", a);
		//print("a="+a);
		no_co=0;
		a2=a+1; //a2 is a counting variable to correct for the ROI manager starting at ROI #0.
		no_coArray=newArray(0);
	
		for(b=0; b<(stain1Count); b++){ //Select stain1 Rois.
			b2=b+1; //b2 is a counting variable to correct for the ROI manager starting at ROI #0.
			//print("b="+b);
			roiManager("Select", newArray(a, b)); //select the square then the circle
			roiManager("AND"); //build an overlapping ROI
			overlapType = selectionType();
			//print("overlapType="+overlapType);
			//waitForUser("a[i]="+a+" and b[i]="+b);
		
			if(overlapType==-1){ // and there is not overlapping area under the square and circle ROIs
			}
			if(overlapType!=-1){ // if there is overlap from the square and the circle,
				c = roiManager("Add"); //add the overlap to the ROI manager so that we can measure its size.
				no_co = no_co+1; // to remember that, yes, there is overlap.
			
				roiManager("deselect");
				run("Clear Results");
				roiManager("Select", b); //measure the size of the circle
				roiManager("Measure");
			
				co_roi = (roiManager("count")-1); //find the overlap ROI (it's going to be the last one on the ROI manager list).
				//print("co_roi="+co_roi);	
				roiManager("Select", co_roi); // select it.
				roiManager("Measure"); //measure the area.
			
				roiManager("Select", co_roi);
				roiManager("Delete"); //now removing it beause we only wanted that new ROI to measure the area of overlap.
				b2_area=getResult("Area", 0); // grab the circle-ROI's area from the results
				c_area=getResult("Area", 1); // grab the overlap-ROI's area from the results
				b2_area_80 = b2_area*TL1_overlap;//0.8; // calculate 80% of the circle area (we're using 80% as an arbitrary threshold of minimum circle that should be within the square).
				//print("b2_area="+b2_area);
				//print("c_area="+c_area);
				//print("b2_area_80="+b2_area_80);
			
				if(b2_area_80>c_area){ // if the overlapping area is less 80% of the circle,
					no_co = no_co-1; //then, forget that an overlap was identified and move on (restart the loop).
					//waitForUser("circle "+b2+" identified but <80% overlap");
				} else {
					//if(XM[a]>=BX[b] && XM[a]<=(BX[b]+Width[b]) && YM[a]>=BY[b] && YM[a]<=(BY[b]+Height[b])){
					saveAb=1;
					roiManager("Select", a); 
					aroiName = Roi.getName();
					roiManager("Select", b); 
					broiName = Roi.getName(); 
					//print("A+B = "+aroiName+" + "+broiName);
					//print("x="+XM[a]+" "+BX[b]+" "+(BX[b]+Width[b])+", Y="+YM[a]+" "+BY[b]+" "+(BY[b]+Height[b]));
					
					no_coArray=Array.concat(no_coArray,broiName);
					//print("\nno_coArray:");
					//Array.print(no_coArray);	

					roiDuplicate=0;
					for (h=0; h<aCoLoArray.length; h++) {
						roiName=aCoLoArray[h];
						if(matches(roiName, aroiName)) roiDuplicate=1;
					}
					if(roiDuplicate==0) aCoLoArray=Array.concat(aCoLoArray, aroiName);
					//print("aCoLoArray:");
					//Array.print(aCoLoArray);
					roiDuplicate=0;
				
					if(no_co>1){ // there is more than one co-localized B within A
						//print("no_co="+no_co);
						CoM_distance_array=newArray(0);
						selectWindow(second_image+"_bkgd_subtracted.tif"); //select the A image
		 				run("Clear Results");
   		  				roiManager("deselect");
   	  					roiManager("Select", a); //select the square ROI
   	  					roiManager("Measure"); //measure the square ROI so we can...
	 					CoM_x_A=getResult("XM", 0); // grab A's center of mass x-coordinate from the results.
	 					CoM_y_A=getResult("YM", 0); // grab A's center of mass y-coordinate from the results.
   						//print("Axy="+CoM_x_A+","+CoM_y_A);
   						run("Clear Results");
   						selectWindow(first_image+"_bkgd_subtracted.tif"); //select the B image
   						roiManager("deselect");
   		
   						broi_colo_array=newArray(0);
						for (h=0; h<no_co; h++) { //search ROI list for ROI name
							broiName=no_coArray[h];
							for (i=0; i<ROIs; i++) { 
								roiManager("Select", i); 
								rName = Roi.getName(); 
								if (matches(rName, broiName)) { 
									broi_colo_array=Array.concat(broi_colo_array, i);
								} 
							}
						}
   						roiManager("Select", broi_colo_array); //select the overlapping B ROIs
	   					roiManager("Measure");
 	
  				 		for(i=0; i<no_co; i++){ //doing this as a FOR loop to allow for any range of overlapping ROIs
  							CoM_x_B=getResult("XM", i); // grab B's center of mass x-coordinate from the results.
  							CoM_y_B=getResult("YM", i); // grab B's center of mass y-coordinate from the results.
							x_distance=CoM_x_A-CoM_x_B;
							y_distance=CoM_y_A-CoM_y_B;
							CoM_distance=(Math.sqrt(Math.sqr(x_distance)+Math.sqr(y_distance)));
							CoM_distance_array=Array.concat(CoM_distance_array,CoM_distance);
							//print("CoM_distance_array:");
							//Array.print(CoM_distance_array);
						}
						CoM_distance_rank=Array.rankPositions(CoM_distance_array);
						bWinnerPosition=CoM_distance_rank[0];
						bLoserPosition=CoM_distance_rank[1];
						//print("Rank Array:");
					 	//Array.print(CoM_distance_rank);
					 	//print("bWinner:"+bWinnerPosition);
 						//waitForUser("rank array printed");		

						bWinner=no_coArray[bWinnerPosition];
						bLoser=no_coArray[bLoserPosition];
						//print("bWinner="+bWinner);
						//print("bLoser="+bLoser);
						//waitForUser("bWinner");
					
						roiDuplicate=0;
						//Array.print(bCoLoArray);
						bCoLoArray=Array.deleteValue(bCoLoArray, bLoser);
						//print("bCoLoArray:");
						//Array.print(bCoLoArray);
						//waitForUser("bCoLoArray");
					
						for (h=0; h<bCoLoArray.length; h++) {	
							roiName=bCoLoArray[h];
							if(matches(roiName, bWinner)) roiDuplicate=1;
						}
						if(roiDuplicate==0) {
							bCoLoArray=Array.concat(bCoLoArray, bWinner);
							//print("bCoLoArray:");
							//Array.print(bCoLoArray);
						}
						roiDuplicate=0;
					}else{	
						for (h=0; h<bCoLoArray.length; h++) {
							roiName=bCoLoArray[h];
							if(matches(roiName, broiName)) roiDuplicate=1;
						}
						if(roiDuplicate==0) {
							bCoLoArray=Array.concat(bCoLoArray, broiName);
							//print("bCoLoArray:");
							//Array.print(bCoLoArray);
						}
					roiDuplicate=0;
					}
				}
			}
		}
	}
	abCoLoArray=Array.concat(abCoLoArray, aCoLoArray);
	abCoLoArray=Array.concat(abCoLoArray, bCoLoArray);

	//print("aCoLoArray");
	//Array.print(aCoLoArray); 
	//print("bCoLoArray");
	//Array.print(bCoLoArray); 
	//print("abCoLoArray");
	//Array.print(abCoLoArray); 
	//print("co="+abCoLoArray.length);
		
	//return;
}

function triLocalizer_save1(image1, image2, stain1, stain2){
	roiManager("deselect");
	ROIs =roiManager("count");
	if(aCoLoArray.length>0){ 
		for (h=0; h<aCoLoArray.length; h++) {
			roiName=aCoLoArray[h];
			for (i=0; i<ROIs; i++) { 
				roiManager("Select", i); 
				rName = Roi.getName(); 
				if (matches(rName, roiName)) { 
					aCoLoselectArray=Array.concat(aCoLoselectArray, i);
				} 
			}
		}		 
		roiManager("select", aCoLoselectArray);
		roiManager("save selected", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
		
	}
	//waitForUser;
	roiManager("reset");

	roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	roiManager("Open", dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip");
	//print("bCoLoArray:");
	//Array.print(bCoLoArray);
	//waitForUser("stain1="+stain1+", stain2="+stain2);
	
	roiManager("deselect");
	if(bCoLoArray.length>0){ 
		for (h=0; h<bCoLoArray.length; h++) {
			roiName=bCoLoArray[h];
			for (i=0; i<ROIs; i++) { 
				roiManager("Select", i); 
				rName = Roi.getName(); 
				if (matches(rName, roiName)) { 
					bCoLoselectArray=Array.concat(bCoLoselectArray, i);
				} 
			}
		}			 
		roiManager("select", bCoLoselectArray);
		roiManager("save selected", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
	}
//waitForUser;
	roiManager("reset");
	close("*");
}

function triple_colocalization2(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, parentFunction) {  //this is the macro that identifies triple-labeled cells between all stains. Adapted from "New" double-label overlay detection

	aCoLoArray=newArray(0); 
	bCoLoArray=newArray(0); 
	abcCoLoArray=newArray(0);
	aCoLoselectArray=newArray(0);
	bCoLoselectArray=newArray(0);
	abcCoLoselectArray=newArray(0);
	aCoLo=0;
	bCoLo=0;
		
//triple labeled cell identification
	run("Clear Results");
	roiManager("reset");

	first_image = image2;
	second_image = image1;

	open(dir+subDir2+image2+"_bkgd_subtracted.tif");
	open(dir+subDir1+image1+"_bkgd_subtracted.tif");
	
	roiManager("deselect");
	roiManager("reset");
	wait(50);

	roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
	wait(200);
	stain1Count = roiManager("count"); // determines the number of circle ROIs
	stain1Count_array=newArray(stain1Count);
	//print("stain1Count ="+stain1Count);
	roiManager("reset");

	roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	wait(200);
	stain2Count = roiManager("count");
	stain2Count_array=newArray(stain2Count);
	stain2Start=stain1Count;
	//print("stain2Count ="+stain2Count);
	//print("stain2Start ="+stain2Start);
	roiManager("reset");
	
	roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
	roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	roiManager("show all");
	roiManager("show all with labels");

	roiManager("deselect");
	ROIs =roiManager("count"); 
	ROI_array=newArray(ROIs);
	for(i=0; i<ROIs;i++) { 
		ROI_array[i] = i; 
	}
	
	roiManager("deselect");
	roiManager("Measure");
	roiManager("deselect");

	for (i=0; i<ROIs; i++) {
		roiManager("Select", i); 
		roiName = Roi.getName(); 
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
	}
	
	setOption("ShowRowNumbers", false);
	updateResults();

	XM=newArray(ROIs);
	YM=newArray(ROIs);
	BX=newArray(ROIs);
	BY=newArray(ROIs);
	Width=newArray(ROIs);
	Height=newArray(ROIs);
	roiName_array=newArray(ROIs);

	roiManager("deselect");
	for (i=0; i<ROIs; i++) { 
		XM[i] = getResult('XM', i);
		YM[i] = getResult('YM', i);
		BX[i] = getResult('BX', i);
		BY[i] = getResult('BY', i);
		Width[i] = getResult('Width', i);
		Height[i] = getResult('Height', i);
		roiName_array[i] = getResult('roiName', i);
	}

	for(a=stain2Start; a<(ROIs); a++){  // Select stain2 Rois.
		roiManager("Select", a);
		//print("a="+a);
		no_co=0;
		a2=a+1; //a2 is a counting variable to correct for the ROI manager starting at ROI #0.
		no_coArray=newArray(0);
	
		for(b=0; b<(stain1Count); b++){ //Select stain1 Rois.
			b2=b+1; //b2 is a counting variable to correct for the ROI manager starting at ROI #0.
			//print("b="+b);
			roiManager("Select", newArray(a, b)); //select the square then the circle
			roiManager("AND"); //build an overlapping ROI
			overlapType = selectionType();
			//print("overlapType="+overlapType);
			//waitForUser("a[i]="+a+" and b[i]="+b);
		
			if(overlapType==-1){ // and there is not overlapping area under the square and circle ROIs
			}
			if(overlapType!=-1){ // if there is overlap from the square and the circle,
				c = roiManager("Add"); //add the overlap to the ROI manager so that we can measure its size.
				no_co = no_co+1; // to remember that, yes, there is overlap.
			
				roiManager("deselect");
				run("Clear Results");
				roiManager("Select", b); //measure the size of the circle
				roiManager("Measure");
			
				co_roi = (roiManager("count")-1); //find the overlap ROI (it's going to be the last one on the ROI manager list).
				//print("co_roi="+co_roi);	
				roiManager("Select", co_roi); // select it.
				roiManager("Measure"); //measure the area.
			
				roiManager("Select", co_roi);
				roiManager("Delete"); //now removing it beause we only wanted that new ROI to measure the area of overlap.
				b2_area=getResult("Area", 0); // grab the circle-ROI's area from the results
				c_area=getResult("Area", 1); // grab the overlap-ROI's area from the results
				b2_area_80 = b2_area*TL2_overlap;//0.8; // calculate 80% of the circle area (we're using 80% as an arbitrary threshold of minimum circle that should be within the square).
				//print("b2_area="+b2_area);
				//print("c_area="+c_area);
				//print("b2_area_80="+b2_area_80);
			
				if(b2_area_80>c_area){ // if the overlapping area is less 80% of the circle,
					no_co = no_co-1; //then, forget that an overlap was identified and move on (restart the loop).
					//waitForUser("circle "+b2+" identified but <80% overlap");
				} else {
					//if(XM[a]>=BX[b] && XM[a]<=(BX[b]+Width[b]) && YM[a]>=BY[b] && YM[a]<=(BY[b]+Height[b])){
					saveAb=1;
					roiManager("Select", a); 
					aroiName = Roi.getName();
					roiManager("Select", b); 
					broiName = Roi.getName(); 
					//print("A+B = "+aroiName+" + "+broiName);
					//print("x="+XM[a]+" "+BX[b]+" "+(BX[b]+Width[b])+", Y="+YM[a]+" "+BY[b]+" "+(BY[b]+Height[b]));
					
					no_coArray=Array.concat(no_coArray,broiName);
					//print("\nno_coArray:");
					//Array.print(no_coArray);	

					roiDuplicate=0;
					for (h=0; h<aCoLoArray.length; h++) {
						roiName=aCoLoArray[h];
						if(matches(roiName, aroiName)) roiDuplicate=1;
					}
					if(roiDuplicate==0) aCoLoArray=Array.concat(aCoLoArray, aroiName);
					//print("aCoLoArray:");
					//Array.print(aCoLoArray);
					roiDuplicate=0;
				
					if(no_co>1){ // there is more than one co-localized B within A
						//print("no_co="+no_co);
						CoM_distance_array=newArray(0);
						selectWindow(second_image+"_bkgd_subtracted.tif"); //select the A image
		 				run("Clear Results");
   		  				roiManager("deselect");
   	  					roiManager("Select", a); //select the square ROI
   	  					roiManager("Measure"); //measure the square ROI so we can...
	 					CoM_x_A=getResult("XM", 0); // grab A's center of mass x-coordinate from the results.
	 					CoM_y_A=getResult("YM", 0); // grab A's center of mass y-coordinate from the results.
   						//print("Axy="+CoM_x_A+","+CoM_y_A);
   						run("Clear Results");
   						selectWindow(first_image+"_bkgd_subtracted.tif"); //select the B image
   						roiManager("deselect");
   		
   						broi_colo_array=newArray(0);
						for (h=0; h<no_co; h++) { //search ROI list for ROI name
							broiName=no_coArray[h];
							for (i=0; i<ROIs; i++) { 
								roiManager("Select", i); 
								rName = Roi.getName(); 
								if (matches(rName, broiName)) { 
									broi_colo_array=Array.concat(broi_colo_array, i);
								} 
							}
						}
   						roiManager("Select", broi_colo_array); //select the overlapping B ROIs
	   					roiManager("Measure");
 	
  				 		for(i=0; i<no_co; i++){ //doing this as a FOR loop to allow for any range of overlapping ROIs
  							CoM_x_B=getResult("XM", i); // grab B's center of mass x-coordinate from the results.
  							CoM_y_B=getResult("YM", i); // grab B's center of mass y-coordinate from the results.
							x_distance=CoM_x_A-CoM_x_B;
							y_distance=CoM_y_A-CoM_y_B;
							CoM_distance=(Math.sqrt(Math.sqr(x_distance)+Math.sqr(y_distance)));
							CoM_distance_array=Array.concat(CoM_distance_array,CoM_distance);
							//print("CoM_distance_array:");
							//Array.print(CoM_distance_array);
						}
						CoM_distance_rank=Array.rankPositions(CoM_distance_array);
						bWinnerPosition=CoM_distance_rank[0];
						bLoserPosition=CoM_distance_rank[1];
						//print("Rank Array:");
					 	//Array.print(CoM_distance_rank);
					 	//print("bWinner:"+bWinnerPosition);
 						//waitForUser("rank array printed");		

						bWinner=no_coArray[bWinnerPosition];
						bLoser=no_coArray[bLoserPosition];
						//print("bWinner="+bWinner);
						//print("bLoser="+bLoser);
						//waitForUser("bWinner");
					
						roiDuplicate=0;
						//Array.print(bCoLoArray);
						bCoLoArray=Array.deleteValue(bCoLoArray, bLoser);
						//print("bCoLoArray:");
						//Array.print(bCoLoArray);
						//waitForUser("bCoLoArray");
					
						for (h=0; h<bCoLoArray.length; h++) {	
							roiName=bCoLoArray[h];
							if(matches(roiName, bWinner)) roiDuplicate=1;
						}
						if(roiDuplicate==0) {
							bCoLoArray=Array.concat(bCoLoArray, bWinner);
							//print("bCoLoArray:");
							//Array.print(bCoLoArray);
						}
						roiDuplicate=0;
					}else{	
						for (h=0; h<bCoLoArray.length; h++) {
							roiName=bCoLoArray[h];
							if(matches(roiName, broiName)) roiDuplicate=1;
						}
						if(roiDuplicate==0) {
							bCoLoArray=Array.concat(bCoLoArray, broiName);
							//print("bCoLoArray:");
							//Array.print(bCoLoArray);
						}
					roiDuplicate=0;
					}
				}
			}
		}
	}
	abCoLoArray=Array.concat(abCoLoArray, aCoLoArray);
	abCoLoArray=Array.concat(abCoLoArray, bCoLoArray);

	//print("aCoLoArray");
	//Array.print(aCoLoArray); 
	//print("bCoLoArray");
	//Array.print(bCoLoArray); 
	//print("abCoLoArray");
	//Array.print(abCoLoArray); 
	//print("co="+abCoLoArray.length);
		
	//return;
}
function triLocalizer_save2(image1, image2, stain1, stain2){
	roiManager("deselect");
	ROIs =roiManager("count"); 
	if(aCoLoArray.length>0){
		for (h=0; h<aCoLoArray.length; h++) { //search ROI list for ROI name
			roiName=aCoLoArray[h];
			for (i=0; i<ROIs; i++) { 
				roiManager("Select", i); 
				rName = Roi.getName(); 
				if (matches(rName, roiName)) { 
					aCoLoselectArray=Array.concat(aCoLoselectArray, i);
				} 
			}
		}		 
		roiManager("select", aCoLoselectArray);
		roiManager("save selected", dir+"triple-label_results"+_sep_+image1+"_{triple}2_{"+stain1+"}_ROI-overlay.zip");	
	}
	roiManager("reset");
	
	roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
	roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");

	roiManager("deselect");
	if(bCoLoArray.length>0){
		for (h=0; h<bCoLoArray.length; h++) {
			roiName=bCoLoArray[h];
			for (i=0; i<ROIs; i++) { 
				roiManager("Select", i); 
				rName = Roi.getName(); 
				if (matches(rName, roiName)) { 
					bCoLoselectArray=Array.concat(bCoLoselectArray, i);
				} 
			}
		}		 
		roiManager("select", bCoLoselectArray);
		roiManager("save selected", dir+"triple-label_results"+_sep_+image2+"_{triple}2_{"+stain2+"}_ROI-overlay.zip");
	}
	roiManager("reset");
	
	silent=File.exists(dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
	if(silent==1){
		roiManager("Open", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
	}
	silent=File.exists(dir+"triple-label_results"+_sep_+image1+"_{triple}2_{"+stain1+"}_ROI-overlay.zip");
	if(silent==1){
		roiManager("Open", dir+"triple-label_results"+_sep_+image1+"_{triple}2_{"+stain1+"}_ROI-overlay.zip");
	}	
	if(roiManager("count")>0){
		roiManager("sort");
		ROIs =roiManager("count"); 
		for (i=1; i<ROIs; i++) { 
			roiManager("Select", i); 
			rName1=Roi.getName();
			//print(rName1);
			roiManager("Select", i-1);
			rName0 = Roi.getName();
			//print(rName0);
	
			if (matches(rName1, rName0)) { 
				roiManager("Select", i); 
				roiManager("delete");
				ROIs=ROIs-1;
			} 
		}	
		roiManager("deselect");	 
		roiManager("save", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
	}
	roiManager("reset");

	silent=File.exists(dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
	if(silent==1){
		roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
	}
	silent=File.exists(dir+"triple-label_results"+_sep_+image2+"_{triple}2_{"+stain2+"}_ROI-overlay.zip");
	if(silent==1){
		roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}2_{"+stain2+"}_ROI-overlay.zip");
	}
	if(roiManager("count")>0){
		roiManager("sort");
		ROIs =roiManager("count"); 
		for (i=1; i<ROIs; i++) { 
			roiManager("Select", i); 
			rName1=Roi.getName();
			//print(rName1);
			roiManager("Select", i-1);
			rName0 = Roi.getName();
			//print(rName0);
	
			if (matches(rName1, rName0)) { 
				roiManager("Select", i); 
				roiManager("delete");
				ROIs=ROIs-1;
			} 
		}
		roiManager("deselect");	 
		roiManager("save", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
	}
	roiManager("reset");

	if(File.exists(dir+"triple-label_results"+_sep_+image1+"_{triple}2_{"+stain1+"}_ROI-overlay.zip")==1){
		silent=File.delete(dir+"triple-label_results"+_sep_+image1+"_{triple}2_{"+stain1+"}_ROI-overlay.zip");
	}
	if(File.exists(dir+"triple-label_results"+_sep_+image2+"_{triple}2_{"+stain2+"}_ROI-overlay.zip")==1){
		silent=File.delete(dir+"triple-label_results"+_sep_+image2+"_{triple}2_{"+stain2+"}_ROI-overlay.zip");
	}
	close("*");
}

function triple_colocalization3(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, parentFunction) {  //this is the macro that identifies triple-labeled cells between all stains. Adapted from "New" double-label overlay detection

	aCoLoArray=newArray(0); 
	bCoLoArray=newArray(0); 
	abcCoLoArray=newArray(0);
	aCoLoselectArray=newArray(0);
	bCoLoselectArray=newArray(0);
	abcCoLoselectArray=newArray(0);
	aCoLo=0;
	bCoLo=0;
		
//triple labeled cell identification
	run("Clear Results");
	roiManager("reset");

	first_image = image2;
	second_image = image3;
	
	open(dir+subDir2+image2+"_bkgd_subtracted.tif");
	open(dir+subDir3+image3+"_bkgd_subtracted.tif");

	roiManager("deselect");
	roiManager("reset");
	wait(50);

	roiManager("Open", dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	wait(200);
	stain1Count = roiManager("count"); // determines the number of circle ROIs
	stain1Count_array=newArray(stain1Count);
	//print("stain1Count ="+stain1Count);
	roiManager("reset");

	roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
	stain2Count = roiManager("count");
	stain2Count_array=newArray(stain2Count);
	stain2Start=stain1Count;
	//print("stain2Count ="+stain2Count);
	//print("stain2Start ="+stain2Start);
	roiManager("reset");
	
	roiManager("Open", dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
	roiManager("show all");
	roiManager("show all with labels");

	roiManager("deselect");
	ROIs =roiManager("count"); 
	ROI_array=newArray(ROIs);
	for(i=0; i<ROIs;i++) { 
		ROI_array[i] = i; 
	}
	
	roiManager("deselect");
	roiManager("Measure");
	roiManager("deselect");

	for (i=0; i<ROIs; i++) {
		roiManager("Select", i); 
		roiName = Roi.getName(); 
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
	}
	
	setOption("ShowRowNumbers", false);
	updateResults();

	XM=newArray(ROIs);
	YM=newArray(ROIs);
	BX=newArray(ROIs);
	BY=newArray(ROIs);
	Width=newArray(ROIs);
	Height=newArray(ROIs);
	roiName_array=newArray(ROIs);

	roiManager("deselect");
	for (i=0; i<ROIs; i++) { 
		XM[i] = getResult('XM', i);
		YM[i] = getResult('YM', i);
		BX[i] = getResult('BX', i);
		BY[i] = getResult('BY', i);
		Width[i] = getResult('Width', i);
		Height[i] = getResult('Height', i);
		roiName_array[i] = getResult('roiName', i);
	}

	for(a=stain2Start; a<(ROIs); a++){  // Select stain2 Rois.
		roiManager("Select", a);
		//print("a="+a);
		no_co=0;
		a2=a+1; //a2 is a counting variable to correct for the ROI manager starting at ROI #0.
		no_coArray=newArray(0);
	
		for(b=0; b<(stain1Count); b++){ //Select stain1 Rois.
			b2=b+1; //b2 is a counting variable to correct for the ROI manager starting at ROI #0.
			//print("b="+b);
			roiManager("Select", newArray(a, b)); //select the square then the circle
			roiManager("AND"); //build an overlapping ROI
			overlapType = selectionType();
			//print("overlapType="+overlapType);
			//waitForUser("a[i]="+a+" and b[i]="+b);
		
			if(overlapType==-1){ // and there is not overlapping area under the square and circle ROIs
			}
			if(overlapType!=-1){ // if there is overlap from the square and the circle,
				c = roiManager("Add"); //add the overlap to the ROI manager so that we can measure its size.
				no_co = no_co+1; // to remember that, yes, there is overlap.
			
				roiManager("deselect");
				run("Clear Results");
				roiManager("Select", b); //measure the size of the circle
				roiManager("Measure");
			
				co_roi = (roiManager("count")-1); //find the overlap ROI (it's going to be the last one on the ROI manager list).
				//print("co_roi="+co_roi);	
				roiManager("Select", co_roi); // select it.
				roiManager("Measure"); //measure the area.
			
				roiManager("Select", co_roi);
				roiManager("Delete"); //now removing it beause we only wanted that new ROI to measure the area of overlap.
				b2_area=getResult("Area", 0); // grab the circle-ROI's area from the results
				c_area=getResult("Area", 1); // grab the overlap-ROI's area from the results
				b2_area_80 = b2_area*TL2_overlap;//0.8; // calculate 80% of the circle area (we're using 80% as an arbitrary threshold of minimum circle that should be within the square).
				//print("b2_area="+b2_area);
				//print("c_area="+c_area);
				//print("b2_area_80="+b2_area_80);
			
				if(b2_area_80>c_area){ // if the overlapping area is less 80% of the circle,
					no_co = no_co-1; //then, forget that an overlap was identified and move on (restart the loop).
					//waitForUser("circle "+b2+" identified but <80% overlap");
				} else {
					//if(XM[a]>=BX[b] && XM[a]<=(BX[b]+Width[b]) && YM[a]>=BY[b] && YM[a]<=(BY[b]+Height[b])){
					saveAb=1;
					roiManager("Select", a); 
					aroiName = Roi.getName();
					roiManager("Select", b); 
					broiName = Roi.getName(); 
					//print("A+B = "+aroiName+" + "+broiName);
					//print("x="+XM[a]+" "+BX[b]+" "+(BX[b]+Width[b])+", Y="+YM[a]+" "+BY[b]+" "+(BY[b]+Height[b]));
					
					no_coArray=Array.concat(no_coArray,broiName);
					//print("\nno_coArray:");
					//Array.print(no_coArray);	

					roiDuplicate=0;
					for (h=0; h<aCoLoArray.length; h++) {
						roiName=aCoLoArray[h];
						if(matches(roiName, aroiName)) roiDuplicate=1;
					}
					if(roiDuplicate==0) aCoLoArray=Array.concat(aCoLoArray, aroiName);
					//print("aCoLoArray:");
					//Array.print(aCoLoArray);
					roiDuplicate=0;
				
					if(no_co>1){ // there is more than one co-localized B within A
						//print("no_co="+no_co);
						CoM_distance_array=newArray(0);
						selectWindow(second_image+"_bkgd_subtracted.tif"); //select the A image
		 				run("Clear Results");
   		  				roiManager("deselect");
   	  					roiManager("Select", a); //select the square ROI
   	  					roiManager("Measure"); //measure the square ROI so we can...
	 					CoM_x_A=getResult("XM", 0); // grab A's center of mass x-coordinate from the results.
	 					CoM_y_A=getResult("YM", 0); // grab A's center of mass y-coordinate from the results.
   						//print("Axy="+CoM_x_A+","+CoM_y_A);
   						run("Clear Results");
   						selectWindow(first_image+"_bkgd_subtracted.tif"); //select the B image
   						roiManager("deselect");
   		
   						broi_colo_array=newArray(0);
						for (h=0; h<no_co; h++) { //search ROI list for ROI name
							broiName=no_coArray[h];
							for (i=0; i<ROIs; i++) { 
								roiManager("Select", i); 
								rName = Roi.getName(); 
								if (matches(rName, broiName)) { 
									broi_colo_array=Array.concat(broi_colo_array, i);
								} 
							}
						}
   						roiManager("Select", broi_colo_array); //select the overlapping B ROIs
	   					roiManager("Measure");
 	
  				 		for(i=0; i<no_co; i++){ //doing this as a FOR loop to allow for any range of overlapping ROIs
  							CoM_x_B=getResult("XM", i); // grab B's center of mass x-coordinate from the results.
  							CoM_y_B=getResult("YM", i); // grab B's center of mass y-coordinate from the results.
							x_distance=CoM_x_A-CoM_x_B;
							y_distance=CoM_y_A-CoM_y_B;
							CoM_distance=(Math.sqrt(Math.sqr(x_distance)+Math.sqr(y_distance)));
							CoM_distance_array=Array.concat(CoM_distance_array,CoM_distance);
							//print("CoM_distance_array:");
							//Array.print(CoM_distance_array);
						}
						CoM_distance_rank=Array.rankPositions(CoM_distance_array);
						bWinnerPosition=CoM_distance_rank[0];
						bLoserPosition=CoM_distance_rank[1];
						//print("Rank Array:");
					 	//Array.print(CoM_distance_rank);
					 	//print("bWinner:"+bWinnerPosition);
 						//waitForUser("rank array printed");		

						bWinner=no_coArray[bWinnerPosition];
						bLoser=no_coArray[bLoserPosition];
						//print("bWinner="+bWinner);
						//print("bLoser="+bLoser);
						//waitForUser("bWinner");
					
						roiDuplicate=0;
						//Array.print(bCoLoArray);
						bCoLoArray=Array.deleteValue(bCoLoArray, bLoser);
						//print("bCoLoArray:");
						//Array.print(bCoLoArray);
						//waitForUser("bCoLoArray");
					
						for (h=0; h<bCoLoArray.length; h++) {	
							roiName=bCoLoArray[h];
							if(matches(roiName, bWinner)) roiDuplicate=1;
						}
						if(roiDuplicate==0) {
							bCoLoArray=Array.concat(bCoLoArray, bWinner);
							//print("bCoLoArray:");
							//Array.print(bCoLoArray);
						}
						roiDuplicate=0;
					}else{	
						for (h=0; h<bCoLoArray.length; h++) {
							roiName=bCoLoArray[h];
							if(matches(roiName, broiName)) roiDuplicate=1;
						}
						if(roiDuplicate==0) {
							bCoLoArray=Array.concat(bCoLoArray, broiName);
							//print("bCoLoArray:");
							//Array.print(bCoLoArray);
						}
					roiDuplicate=0;
					}
				}
			}
		}
	}
	abCoLoArray=Array.concat(abCoLoArray, aCoLoArray);
	abCoLoArray=Array.concat(abCoLoArray, bCoLoArray);

	//print("aCoLoArray");
	//Array.print(aCoLoArray); 
	//print("bCoLoArray");
	//Array.print(bCoLoArray); 
	//print("abCoLoArray");
	//Array.print(abCoLoArray); 
	//print("co="+abCoLoArray.length);
		
	//return;
}

function triLocalizer_save3(image3, stain3){
	roiManager("deselect");
	ROIs =roiManager("count");
	 
	if(bCoLoArray.length>0){
		for (h=0; h<bCoLoArray.length; h++) { //search ROI list for ROI name
			roiName=bCoLoArray[h];
			for (i=0; i<ROIs; i++) { 
				roiManager("Select", i); 
				rName = Roi.getName(); 
				if (matches(rName, roiName)) { 
					bCoLoselectArray=Array.concat(bCoLoselectArray, i);
				} 
			}
		}		 
		roiManager("select", bCoLoselectArray);
		roiManager("save selected", dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip");
	}
	roiManager("reset");
	close("*");
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3){
	first_image = image1;
	second_image = image2;
	third_image = image3;
	if(File.exists(dir+"STATIC_merged_overlay.tif")){
		File.delete(dir+"STATIC_merged_overlay.tif");
	}
	
	silent=File.exists(dir+merged_image);
	if(silent==1){
		open(dir+merged_image);
		selectWindow(merged_image);
		height=getHeight();
		width=getWidth(); 
		setLocation(0, screenHeight/4, width*1.5, height*1.5);
	}
	
	if(File.exists(dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip")==1 && File.exists(dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip")==1 && File.exists(dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip")==1){
		roiManager("Open", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
		roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
		roiManager("Open", dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip");
		roiManager("show all");
		roiManager("show all with labels");

		if(stain1==stain2 && stain1!=stain3){
			choice1=stain1+" no.1";
			choice2=stain2+" no.2";
			choice3=stain3;
		}else if(stain1==stain3 && stain1!=stain2){
			choice1=stain1+" no.1";
			choice2=stain2;
			choice3=stain3+" no.2";
		}else if(stain2==stain3 && stain2!=stain1){
			choice1=stain1;
			choice2=stain2+" no.1";
			choice3=stain3+" no.2";
		}else if(stain1==stain2 && stain2==stain3){
			choice1=stain1+" no.1";
			choice2=stain2+" no.2";
			choice3=stain3+" no.3";
		}else{
			choice1=stain1;
			choice2=stain2;
			choice3=stain3;
		}

		Dialog.create("Triple Co-localization"); //the first step is asking the user if they want to edit either ROI set.
		items = newArray(choice1, choice2, choice3, "Manually determine co-localization from single-label ROIs", "Accept co-localization as is.");
		Dialog.addRadioButtonGroup("Here is your chance to adjust the ROIs to better identify co-localization. Which stain would you like to adjust?", items, 5, 1, "Accept co-localization as is.");
		Dialog.show;
		choice = Dialog.getRadioButton;

		if (choice==choice1) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");					//
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4, width*1.5, height*1.5 );				//

			open(dir+subDir1+image1+"_bkgd_subtracted.tif");
			selectWindow(image1+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
		
			setTool(ROI_shape1);
			roiManager("reset");
			roiManager("Open", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the triple-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
			}
			wait(100);

			close("*");
			if(File.exists(dir+"STATIC_merged_overlay.tif")){
				File.delete(dir+"STATIC_merged_overlay.tif");
			}

			checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
		}
		if (choice==choice2) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");					//
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4, width*1.5, height*1.5 );				//

			open(dir+subDir2+image2+"_bkgd_subtracted.tif");
			selectWindow(image2+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
		
			setTool(ROI_shape2);
			roiManager("reset");
			roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the triple-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
			}
			wait(100);

			close("*");
			if(File.exists(dir+"STATIC_merged_overlay.tif")){
				File.delete(dir+"STATIC_merged_overlay.tif");
			}

			checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
		}
		if (choice==choice3) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");					//
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4, width*1.5, height*1.5 );				//

			open(dir+subDir3+image3+"_bkgd_subtracted.tif");
			selectWindow(image3+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
		
			setTool(ROI_shape3);
			roiManager("reset");
			roiManager("Open", dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip");
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the triple-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip");
			}
			wait(100);

			close("*");
			if(File.exists(dir+"STATIC_merged_overlay.tif")){
				File.delete(dir+"STATIC_merged_overlay.tif");
			}

			checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
		}
		if(choice=="Manually determine co-localization from single-label ROIs"){
			Dialog.create("Are you sure?"); //the first step is asking the user if they want to edit either ROI set.
			items = newArray("Yes, undo co-localization of "+stain1+", "+stain2+", and "+stain3+", and co-localize by hand.", "No, go back.");
			Dialog.addRadioButtonGroup("Are you sure that you want to manually determine co-localization? It will reset the "+stain1+", "+stain2+", "+stain3+" ROIs.", items, 2, 1, "No, go back.");
			Dialog.show;
			choice2 = Dialog.getRadioButton;
			
			if(choice2=="No, go back."){
				checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape33);
			}	
			if(choice2=="Yes, undo co-localization of "+stain1+", "+stain2+", and "+stain3+", and co-localize by hand."){				
				close("*");
				roiManager("reset");
				manual_TriLocalizer(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
			}	
		}
		if (choice=="Accept co-localization as is.") {
			//well, aren't you confident.
			roiManager("reset");
			close("*");
		
			if(File.exists(dir+"STATIC_merged_overlay.tif")){
				File.delete(dir+"STATIC_merged_overlay.tif");
			}
		}
	}else{
		Dialog.create("Triple Co-localization not found");
		items = newArray("Close images and restart analysis", "Determine co-localization manually", "Continue analysis without triple-label co-localization");
		Dialog.addRadioButtonGroup("No triple-label co-localization was found. What would you like to do?", items, 3, 1, "Continue analysis without triple-label co-localization");
		Dialog.show;
		choice = Dialog.getRadioButton;
		if(choice=="Continue analysis without triple-label co-localization") {
			roiManager("reset");
			close("*");
			return;
		} 
		if(choice=="Close images and restart analysis"){
			roiManager("reset");
			close("*");
			parentFunction;
		}
		if(choice=="Determine co-localization manually"){
			close("*");
			roiManager("reset");
			manual_TriLocalizer(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
		}
	}
	//print("done");	
	//roiManager("select", stain2Start);
	//waitForUser(stain1Count+" "+stain2Count+" "+stain2Start+" "+totalROIcount);
}

function manual_TriLocalizer(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3){
	//roiManager("Set Color", "red");
	first_image = image1;
	second_image = image2;
	third_image = image3;

	silent=File.exists(dir+merged_image);
	if(silent==1){
		open(dir+merged_image);
		selectWindow(merged_image);
		height=getHeight();
		width=getWidth(); 
		setLocation(screenWidth/1.5, screenHeight/2,width, height );
	}
	
	setLocation(0, screenHeight/4,width*1.5, height*1.5 );
	
	if(File.exists(dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
		roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}
	if(File.exists(dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip")==1){
		roiManager("Open", dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip");
	}
	if(File.exists(dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
		roiManager("Open", dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
	}
		roiManager("show all");
		roiManager("show all with labels");

		Dialog.create("Manual Triple Co-localizer"); //the first step is asking the user if they want to edit either ROI set.
		items = newArray(stain1, stain2, stain3, "Accept co-localization as is.");
		Dialog.addRadioButtonGroup("Here is your chance to adjust the ROIs to better identify co-localization. Which stain would you like to adjust?", items, 4, 1, "Accept co-localization as is.");
		Dialog.show;
		choice3 = Dialog.getRadioButton;

		if (choice3==stain1) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");					//
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4,width*1.5, height*1.5 );				//

			open(dir+subDir1+first_image+"_bkgd_subtracted.tif");
			selectWindow(first_image+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
		
			setTool(ROI_shape1);
			roiManager("reset");
			if(File.exists(dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
				roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
			}
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
			}	
			wait(100);

			Dialog.create("Adjust the other stains?"); //then the second step is to ask the user if they want to edit the other stain's ROIs.
			items = newArray("Yes", "No, accept double labeling as is.");
			Dialog.addRadioButtonGroup("Do you want to also adjust "+stain2+" and "+stain3+" triple-labeling?", items, 2, 1, "Yes");
			Dialog.show;
			choice4 = Dialog.getRadioButton;

			if (choice4=="Yes") {
				selectWindow(first_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/1.5, screenHeight/2, width, height );		//
				
				open(dir+subDir2+second_image+"_bkgd_subtracted.tif");
				selectWindow(second_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/2, screenHeight/4,width*1.5, height*1.5 );	//
				
				setTool(ROI_shape2);
				roiManager("reset");
				if(File.exists(dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip")==1){
					roiManager("Open", dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip");
				}
				roiManager("show all");
				roiManager("show all with labels");
				waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
				roiManager("deselect");
				if(roiManager("count")>0){
					roiManager("Save", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
				}	
				wait(100);
				roiManager("reset");

				selectWindow(second_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/1.5, screenHeight/2, width, height );		//
				
				open(dir+subDir3+third_image+"_bkgd_subtracted.tif");
				selectWindow(third_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/2, screenHeight/4,width*1.5, height*1.5 );	//
				
				setTool(ROI_shape3);
				roiManager("reset");
				if(File.exists(dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
					roiManager("Open", dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
				}
				roiManager("show all");
				roiManager("show all with labels");
				waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
				roiManager("deselect");
				if(roiManager("count")>0){
					roiManager("Save", dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip");
				}	
				wait(100);
				roiManager("reset");
				close("*");
				
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
			}

			if (choice4=="No, accept double labeling as is.") {
				roiManager("reset");
				close("*");
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
			}
		}
		if (choice3==stain2) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");					//
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4,width*1.5, height*1.5 );				//

			open(dir+subDir2+second_image+"_bkgd_subtracted.tif");
			selectWindow(second_image+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
		
			setTool(ROI_shape2);
			roiManager("reset");
			if(File.exists(dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip")==1){
				roiManager("Open", dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip");
			}
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
			}
			wait(100);

			Dialog.create("Adjust the other stains?"); //then the second step is to ask the user if they want to edit the other stain's ROIs.
			items = newArray("Yes", "No, accept double labeling as is.");
			Dialog.addRadioButtonGroup("Do you want to also adjust "+stain1+" and "+stain3+" triple-labeling?", items, 2, 1, "Yes");
			Dialog.show;
			choice4 = Dialog.getRadioButton;

			if (choice4=="Yes") {
				selectWindow(second_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/1.5, screenHeight/2, width, height );		//
				
				open(dir+subDir1+first_image+"_bkgd_subtracted.tif");
				selectWindow(first_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/2, screenHeight/4,width*1.5, height*1.5 );	//
				
				setTool(ROI_shape1);
				roiManager("reset");
				if(File.exists(dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
					roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
				}
				roiManager("show all");
				roiManager("show all with labels");
				waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
				roiManager("deselect");
				if(roiManager("count")>0){
					roiManager("Save", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
				}	
				wait(100);
				roiManager("reset");

				selectWindow(first_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/1.5, screenHeight/2, width, height );		//
				
				open(dir+subDir3+third_image+"_bkgd_subtracted.tif");
				selectWindow(third_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/2, screenHeight/4,width*1.5, height*1.5 );	//
				
				setTool(ROI_shape3);
				roiManager("reset");
				if(File.exists(dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
					roiManager("Open", dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
				}
				roiManager("show all");
				roiManager("show all with labels");
				waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
				roiManager("deselect");
				if(roiManager("count")>0){
					roiManager("Save", dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip");
				}	
				wait(100);
				roiManager("reset");
				close("*");
				
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
			}

			if (choice4=="No, accept double labeling as is.") {
				roiManager("reset");
				close("*");
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
			}
		}
		if (choice3==stain3) {
			selectWindow(merged_image);											//creating a static image
			roiManager("Show All");												//	
			roiManager("Show All with labels");									//
			run("Select None");													//
			run("Flatten");														//
			saveAs("Tiff", dir+"STATIC_merged_overlay.tif");					//
			selectWindow("STATIC_merged_overlay.tif");
			height=getHeight();													//
			width=getWidth();													//
			setLocation(0, screenHeight/4,width*1.5, height*1.5 );				//

			open(dir+subDir3+third_image+"_bkgd_subtracted.tif");
			selectWindow(third_image+"_bkgd_subtracted.tif");
			setLocation(width*1.6, screenHeight/4,width*1.5, height*1.5 );	//
		
			setTool(ROI_shape3);
			roiManager("reset");
			if(File.exists(dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
				roiManager("Open", dir+"double-label_results"+_sep_+image3+"_{double}_{"+stain3+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
			}
			roiManager("show all");
			roiManager("show all with labels");
			waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
			roiManager("deselect");
			if(roiManager("count")>0){
				roiManager("Save", dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip");
			}
			wait(100);

			Dialog.create("Adjust the other stains?"); //then the second step is to ask the user if they want to edit the other stain's ROIs.
			items = newArray("Yes", "No, accept double labeling as is.");
			Dialog.addRadioButtonGroup("Do you want to also adjust "+stain1+" and "+stain2+" triple-labeling?", items, 2, 1, "Yes");
			Dialog.show;
			choice4 = Dialog.getRadioButton;

			if (choice4=="Yes") {
				selectWindow(third_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/1.5, screenHeight/2, width, height );		//
				
				open(dir+subDir1+first_image+"_bkgd_subtracted.tif");
				selectWindow(first_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/2, screenHeight/4,width*1.5, height*1.5 );	//
				
				setTool(ROI_shape1);
				roiManager("reset");
				if(File.exists(dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip")==1){
					roiManager("Open", dir+"double-label_results"+_sep_+image1+"_{double}_{"+stain1+"_coloc_with_"+stain2+"}_ROI-overlay.zip");
				}
				roiManager("show all");
				roiManager("show all with labels");
				waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
				roiManager("deselect");
				if(roiManager("count")>0){
					roiManager("Save", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
				}	
				wait(100);
				roiManager("reset");

				selectWindow(first_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/1.5, screenHeight/2, width, height );		//
				
				open(dir+subDir2+second_image+"_bkgd_subtracted.tif");
				selectWindow(second_image+"_bkgd_subtracted.tif");
				setLocation(screenHeight/2, screenHeight/4,width*1.5, height*1.5 );	//
				
				setTool(ROI_shape2);
				roiManager("reset");
				if(File.exists(dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip")==1){
					roiManager("Open", dir+"double-label_results"+_sep_+image2+"_{double}_{"+stain2+"_coloc_with_"+stain3+"}_ROI-overlay.zip");
				}
				roiManager("show all");
				roiManager("show all with labels");
				waitForUser("How Does That Look?", "Here is your chance to adjust the double-labeling. Try moving, adding, or deleting ROIs. **THEN** press OK.");
				roiManager("deselect");
				if(roiManager("count")>0){
					roiManager("Save", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
				}		
				wait(100);
				roiManager("reset");
				close("*");
				
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
			}

			if (choice4=="No, accept double labeling as is.") {
				roiManager("reset");
				close("*");
				if(File.exists(dir+"STATIC_merged_overlay.tif")){
					File.delete(dir+"STATIC_merged_overlay.tif");
				}
				checkTriCo(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, merged_image, parentFunction, ROI_shape1, ROI_shape2, ROI_shape3);
			}
		}
		if (choice3=="Accept co-localization as is.") {
			//well, aren't you confident.
			if(File.exists(dir+"STATIC_merged_overlay.tif")){
				File.delete(dir+"STATIC_merged_overlay.tif");
			}
			close("*");
		}
	//}
}


//\\//\\//\\//\\//\\//\\//\\

function measure_tri_coloc(subDir1, subDir2, subDir3, image1, image2, image3, stain1, stain2, stain3, parentFunction){ //this macro simply recalls the ROIs defined in the last macro in order to measure the values again.
	
	first_image = image1;
	second_image = image2;
	third_image = image3;

//\\\\\\\\\\\\\
//actually measuring the triple labeled ROIs (image 1)
	open(dir+merged_image);
	open(dir+subDir1+image1+"_bkgd_subtracted.tif");
	open(dir+subDir2+image2+"_bkgd_subtracted.tif");
	open(dir+subDir3+image3+"_bkgd_subtracted.tif");

	roiManager("reset");
	run("Clear Results");
	selectWindow(image1+"_bkgd_subtracted.tif");

	roiManager("Open", dir+"triple-label_results"+_sep_+image1+"_{triple}_{"+stain1+"}_ROI-overlay.zip");
	roiManager("UseNames", "true"); // shows ROI names on image
	
	TL_ROIs=0;
	TL_ROIs =roiManager("count");
	TL_array=newArray(TL_ROIs);
	for(i=0; i<TL_ROIs;i++) {
		TL_array[i] = i;
	}

	roiManager("deselect");
	roiManager("Measure");
	roiManager("Show All");
	roiManager("Show All with labels");

	TL_ROIs1_m=0;
	TL_ROIs1_means=0;
	TL_ROIs1_m = nResults;
	TL_ROIs1_means = newArray(TL_ROIs1_m);
	roiManager("deselect");
	for (i=0; i<TL_ROIs1_m; i++) {
		TL_ROIs1_means[i] = getResult('Mean', i);
	}
	roiManager("deselect");

	for (i=0; i<TL_ROIs1_m; i++) {
		roiManager("Select", i); 
		//roiManager("Rename", i);
		roiName = Roi.getName();

		setResult("Background", i, TL1_lower);
		setResult("Mean-Background", i, TL_ROIs1_means[i]-TL1_lower);
		setResult("Integrated_Density", i, (TL_ROIs1_means[i]-TL1_lower)*getResult('Area', i));
		setResult("Stain", i, "Triple-labeled_"+stain1);
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, image1+imageType);
		setResult("AnalysisDate", i, TimeString);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

	TL_ROIs1_m2 = 0;
	TL_ROIs1_avgmeans = 0;
	TL_ROIs1_m2 = nResults;
	TL_ROIs1_avgmeans = newArray(TL_ROIs1_m2);
	roiManager("deselect");
	for (i=0; i<TL_ROIs1_m2; i++) {
		TL_ROIs1_avgmeans[i] = getResult('Mean-Background', i);
	}
	Array.getStatistics(TL_ROIs1_avgmeans, min, max, mean, stdDev);

	TL_ROIs1_numberStains=0;
	TL_ROIs1_numberStains=getValue("results.count");
	
	n_tl1 = nResults;
	area_tl1 = newArray(n_tl1);
	XM_tl1 = newArray(n_tl1);
	YM_tl1 = newArray(n_tl1);
	mean_tl1 = newArray(n_tl1);
	stddev_tl1 = newArray(n_tl1);
	min_tl1 = newArray(n_tl1);
	max_tl1 = newArray(n_tl1);
	bkgd_tl1 = newArray(n_tl1);
	meanbkgd_tl1 = newArray(n_tl1);
	print("\n");
	print("Triple-labeled "+stain1+" cell data:");
	print("Experiment Subject# Indi_var_group Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
	for (i=0; i<n_tl1; i++) {
		area_tl1[i] = getResult('Area', i);
		XM_tl1[i] = getResult('XM', i);
		YM_tl1[i] = getResult('YM', i);
		mean_tl1[i] = getResult('Mean', i);
		stddev_tl1[i] = getResult('StdDev', i);
		min_tl1[i] = getResult('Min', i);
		max_tl1[i] = getResult('Max', i);
		bkgd_tl1[i] = getResult('Background', i);
		meanbkgd_tl1[i] = getResult('Mean-Background', i);
		print(experiment+": "+subject+" "+treatment+" "+first_image+" "+"Triple-labeled_"+stain1+" "+(i+1)+" "+area_tl1[i]+" "+XM_tl1[i]+" "+YM_tl1[i]+" "+mean_tl1[i]+" "+stddev_tl1[i]+" "+min_tl1[i]+" "+max_tl1[i]+" "+bkgd_tl1[i]+" "+meanbkgd_tl1[i]);
	}

// Saving data

if(File.exists(dir+"triple-label_results"+_sep_+first_image+"_{triple}_{"+stain1+"}_measurements.csv")==1){
	silent=File.rename(dir+"triple-label_results"+_sep_+first_image+"_{triple}_{"+stain1+"}_measurements.csv", dir+"triple-label_results"+_sep_+first_image+"_{triple}_{"+stain1+"}_measurements_(archived-"+TimeString+").csv");
}
saveAs("Measurements", dir+"triple-label_results"+_sep_+first_image+"_{triple}_{"+stain1+"}_measurements.csv");
print("\n");

roiManager("reset");

//File.delete(dir+"double-lable_results/"+series_name+first_suffix+first_stain_type+"_first_step_double-label_ROIoverlay.zip");
silent=File.delete(dir+"triple-label_results"+_sep_+second_stain_type_TL+"_vs_"+third_stain_type_TL+"_FirstStep_TripleLabel_ROIoverlay.zip");
silent=File.delete(dir+"triple-label_results"+_sep_+first_stain_type_TL+"_vs_"+second_stain_type_TL+"_refined-DoubleLabel_ROIoverlay.zip");


//\\\\\\\\\\\\\\\
//actually measuring the triple labeled ROIs (image 2)

	run("Clear Results");
	selectWindow(image2+"_bkgd_subtracted.tif");

	roiManager("Open", dir+"triple-label_results"+_sep_+image2+"_{triple}_{"+stain2+"}_ROI-overlay.zip");
		roiManager("UseNames", "true"); // shows ROI names on image
	
	TL_ROIs=0;
	TL_ROIs =roiManager("count");
	TL_array=newArray(TL_ROIs);
	for(i=0; i<TL_ROIs;i++) {
		TL_array[i] = i;
	}

	roiManager("deselect");
	roiManager("Measure");
	roiManager("Show All");
	roiManager("Show All with labels");

	TL_ROIs2_m=0;
	TL_ROIs2_means=0;
	TL_ROIs2_m = nResults;
	TL_ROIs2_means = newArray(TL_ROIs2_m);
	roiManager("deselect");
	for (i=0; i<TL_ROIs2_m; i++) {
		TL_ROIs2_means[i] = getResult('Mean', i);
	}
	roiManager("deselect");

	for (i=0; i<TL_ROIs2_m; i++) {
		roiManager("Select", i); 
		//roiManager("Rename", i);
		roiName = Roi.getName();

		setResult("Background", i, TL2_lower);
		setResult("Mean-Background", i, TL_ROIs2_means[i]-TL2_lower);
		setResult("Integrated_Density", i, (TL_ROIs2_means[i]-TL2_lower)*getResult('Area', i));
		setResult("Stain", i, "Triple-labeled_"+stain2);
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, image2+imageType);
		setResult("AnalysisDate", i, TimeString);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

	TL_ROIs2_m2 = 0;
	TL_ROIs2_avgmeans = 0;
	TL_ROIs2_m2 = nResults;
	TL_ROIs2_avgmeans = newArray(TL_ROIs2_m2);
	roiManager("deselect");
	for (i=0; i<TL_ROIs2_m2; i++) {
		TL_ROIs2_avgmeans[i] = getResult('Mean-Background', i);
	}
	Array.getStatistics(TL_ROIs2_avgmeans, min, max, mean, stdDev);

	TL_ROIs2_numberStains=0;
	TL_ROIs2_numberStains=getValue("results.count");
	
	n_tl2 = nResults;
	area_tl2 = newArray(n_tl2);
	XM_tl2 = newArray(n_tl2);
	YM_tl2 = newArray(n_tl2);
	mean_tl2 = newArray(n_tl2);
	stddev_tl2 = newArray(n_tl2);
	min_tl2 = newArray(n_tl2);
	max_tl2 = newArray(n_tl2);
	bkgd_tl2 = newArray(n_tl2);
	meanbkgd_tl2 = newArray(n_tl2);
	print("\n");
	print("Triple-labeled "+stain2+" cell data:");
	print("Experiment Subject# Indi_var_group Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
	for (i=0; i<n_tl2; i++) {
		area_tl2[i] = getResult('Area', i);
		XM_tl2[i] = getResult('XM', i);
		YM_tl2[i] = getResult('YM', i);
		mean_tl2[i] = getResult('Mean', i);
		stddev_tl2[i] = getResult('StdDev', i);
		min_tl2[i] = getResult('Min', i);
		max_tl2[i] = getResult('Max', i);
		bkgd_tl2[i] = getResult('Background', i);
		meanbkgd_tl2[i] = getResult('Mean-Background', i);
		print(experiment+": "+subject+" "+treatment+" "+second_image+" "+"Triple-labeled_"+stain2+" "+(i+1)+" "+area_tl2[i]+" "+XM_tl2[i]+" "+YM_tl2[i]+" "+mean_tl2[i]+" "+stddev_tl2[i]+" "+min_tl2[i]+" "+max_tl2[i]+" "+bkgd_tl2[i]+" "+meanbkgd_tl2[i]);
	}

// Saving data

if(File.exists(dir+"triple-label_results"+_sep_+second_image+"_{triple}_{"+stain2+"}_measurements.csv")==1){
	silent=File.rename(dir+"triple-label_results"+_sep_+second_image+"_{triple}_{"+stain2+"}_measurements.csv", dir+"triple-label_results"+_sep_+second_image+"_{triple}_{"+stain2+"}_measurements_(archived-"+TimeString+").csv");
}
saveAs("Measurements", dir+"triple-label_results"+_sep_+second_image+"_{triple}_{"+stain2+"}_measurements.csv");
print("\n");

roiManager("reset");

//\\\\\\\\\\\\\\\
//actually measuring the triple labeled ROIs (image 3)

	run("Clear Results");
	selectWindow(image3+"_bkgd_subtracted.tif");

	roiManager("Open", dir+"triple-label_results"+_sep_+image3+"_{triple}_{"+stain3+"}_ROI-overlay.zip");
	roiManager("UseNames", "true"); // shows ROI names on image
		
	TL_ROIs=0;
	TL_ROIs =roiManager("count");
	TL_array=newArray(TL_ROIs);
	for(i=0; i<TL_ROIs;i++) {
		TL_array[i] = i;
	}

	roiManager("deselect");
	roiManager("Measure");
	roiManager("Show All");
	roiManager("Show All with labels");

	TL_ROIs3_m=0;
	TL_ROIs3_means=0;
	TL_ROIs3_m = nResults;
	TL_ROIs3_means = newArray(TL_ROIs3_m);
	roiManager("deselect");
	for (i=0; i<TL_ROIs3_m; i++) {
		TL_ROIs3_means[i] = getResult('Mean', i);
	}
	roiManager("deselect");

	for (i=0; i<TL_ROIs3_m; i++) {
		roiManager("Select", i); 
		//roiManager("Rename", i);
		roiName = Roi.getName();

		setResult("Background", i, TL3_lower);
		setResult("Mean-Background", i, TL_ROIs3_means[i]-TL3_lower);
		setResult("Integrated_Density", i, (TL_ROIs3_means[i]-TL3_lower)*getResult('Area', i));
		setResult("Stain", i, "Triple-labeled_"+stain3);
		setResult("CellNumber", i, i+1);
		setResult("roiName", i, roiName);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, image3+imageType);
		setResult("AnalysisDate", i, TimeString);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

	TL_ROIs3_m3 = 0;
	TL_ROIs3_avgmeans = 0;
	TL_ROIs3_m3 = nResults;
	TL_ROIs3_avgmeans = newArray(TL_ROIs3_m3);
	roiManager("deselect");
	for (i=0; i<TL_ROIs3_m3; i++) {
		TL_ROIs3_avgmeans[i] = getResult('Mean-Background', i);
	}
	Array.getStatistics(TL_ROIs3_avgmeans, min, max, mean, stdDev);

	TL_ROIs3_numberStains=0;
	TL_ROIs3_numberStains=getValue("results.count");
	
	n_tl3 = nResults;
	area_tl3 = newArray(n_tl3);
	XM_tl3 = newArray(n_tl3);
	YM_tl3 = newArray(n_tl3);
	mean_tl3 = newArray(n_tl3);
	stddev_tl3 = newArray(n_tl3);
	min_tl3 = newArray(n_tl3);
	max_tl3 = newArray(n_tl3);
	bkgd_tl3 = newArray(n_tl3);
	meanbkgd_tl3 = newArray(n_tl3);
	print("\n");
	print("Triple-labeled "+stain3+" cell data:");
	print("Experiment Subject# Indi_var_group Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
	for (i=0; i<n_tl3; i++) {
		area_tl3[i] = getResult('Area', i);
		XM_tl3[i] = getResult('XM', i);
		YM_tl3[i] = getResult('YM', i);
		mean_tl3[i] = getResult('Mean', i);
		stddev_tl3[i] = getResult('StdDev', i);
		min_tl3[i] = getResult('Min', i);
		max_tl3[i] = getResult('Max', i);
		bkgd_tl3[i] = getResult('Background', i);
		meanbkgd_tl3[i] = getResult('Mean-Background', i);
		print(experiment+": "+subject+" "+treatment+" "+third_image+" "+"Triple-labeled_"+stain3+" "+(i+1)+" "+area_tl3[i]+" "+XM_tl3[i]+" "+YM_tl3[i]+" "+mean_tl3[i]+" "+stddev_tl3[i]+" "+min_tl3[i]+" "+max_tl3[i]+" "+bkgd_tl3[i]+" "+meanbkgd_tl3[i]);
	}

// Saving data

if(File.exists(dir+"triple-label_results"+_sep_+third_image+"_{triple}_{"+stain3+"}_measurements.csv")==1){
	silent=File.rename(dir+"triple-label_results"+_sep_+third_image+"_{triple}_{"+stain3+"}_measurements.csv", dir+"triple-label_results"+_sep_+third_image+"_{triple}_{"+stain3+"}_measurements_(archived-"+TimeString+").csv");
}
saveAs("Measurements", dir+"triple-label_results"+_sep_+third_image+"_{triple}_{"+stain3+"}_measurements.csv");
print("\n");

selectWindow("Log");
saveAs("Text", dir+"/All_Results"+TimeString+".txt");
//waitForUser("Pause before close");

wait(10);
roiManager("reset");
run("Clear Results");
saveParameters();
wait(10);

close("*");

}

//////////////////////////









//====================================================================================================================================================================================================================================================================

//====================================================================================================================================================================================================================================================================

//====================================================================================================================================================================================================================================================================

//====================================================================================================================================================================================================================================================================
















function ps_Compile_Triple() { // opening previously summed images
	
	
	//selectWindow("Log");
	//run("close");
	//wait(10);
	Dialog.create("Check your stain types");
	Dialog.addMessage("Here are the stain types that will be used. If these are not correct, the compiler will fail.");
	Dialog.addMessage("You can change them here.");
	Dialog.addString("First stain:", first_stain_type_TL, 15);
	Dialog.addString("Second stain:", second_stain_type_TL);
	Dialog.addString("Third stain:", third_stain_type_TL);
			
	Dialog.show;

	first_stain_type_TL =  Dialog.getString();
	second_stain_type_TL =  Dialog.getString();
	third_stain_type_TL =  Dialog.getString();
	saveParameters();

	waitForUser("Select first the files for which you want to compile an \"All-Results\" file", "Please select the parent folder which contains the subfolders you want to compile.");
	dir = getDirectory("Choose a Directory "); 
	subfolders1 = getFileList(dir);
	print(dir);
	
	Dialog.create("Optional metadata");
	Dialog.addMessage("Enter known image and/or subject information to help with data processing.");
	Dialog.addString("Experiment ID:", "eg:Exp1");
	Dialog.addString("Subject ID:", "eg:Sub_42B");
	Dialog.addString("Independent variable grouping:", "eg:Control");
	Dialog.show
	experiment =  Dialog.getString();
	subject =  Dialog.getString();
	treatment =  Dialog.getString();
	
	title = "[Image Processing Progress]";
	run("Text Window...", "name="+ title +" width=30 height=4 monospaced");

	for(i=0; i<subfolders1.length; i++){
		print(title, "\\Update:"+i+1+"/"+subfolders1.length+" ("+((i+1)*100)/subfolders1.length+"%)\n"+getBar(i, subfolders1.length));
		subDir1 = subfolders1[i];
		if(File.isDirectory(dir+subDir1)==1){
			print("\n");
			print(subDir1);
			index = lastIndexOf(subDir1, _sep_);
			if (index!=-1) series_name_TL = substring(subDir1, 0, index);

			
			
			first_image_TL=series_name_TL+"_"+first_suffix_TL;
			second_image_TL=series_name_TL+"_"+second_suffix_TL;
			third_image_TL=series_name_TL+"_"+third_suffix_TL;
			merged_image_TL=series_name_TL+"_"+merged_suffix_TL;
			
			open(dir+subDir1+series_name_TL+"_"+first_suffix_TL+_sep_+first_image_TL+".tif");
			open(dir+subDir1+series_name_TL+"_"+second_suffix_TL+_sep_+second_image_TL+".tif");
			open(dir+subDir1+series_name_TL+"_"+third_suffix_TL+_sep_+third_image_TL+".tif");
			open(dir+subDir1+merged_image_TL+".tif");

			run("Set Measurements...", "area mean standard min center limit redirect=None decimal=3");  //setting measurements.
			run("Set Scale...", "distance=scale_size known=scale_known pixel=scale_pixel unit=&scale_unit global");

			//setBatchMode(true);
			ps_Compile_Triple_Background();
			//setBatchMode(false);
			close("*");
			//waitForUser("finished series, on to next.");
			
			/*
			subfolders2 = getFileList(dir+subDir1);
			for(j=0; j<subfolders2.length; j++){
				subDir2 = subfolders2[j];
				if(File.isDirectory(dir+subDir1+subDir2)==1){
					print(subDir2);
					index = lastIndexOf(subDir2, _sep_);
					if (index!=-1) subDir2name = substring(subDir2, 0, index-1);
				}
			}
			*/
		}
	}
	beep();
	print(title, "\\Close");
	waitForUser("Compiled all available folders");
}
///////////////////////////
///////////////////////////////

function ps_Compile_Triple_Background() { //the meat of the pipsqueak. TL= triple-label. DL= double-label. SL= single-label.

//First Image
	// Selecting Background

	first_image_tif = first_image_TL+".tif";  //image names are consistently kept as "first_image_tif" and "second_image_tif" throughout the triple-labeled macro(s)
	second_image_tif = second_image_TL+".tif"; //even though the actual images are duplicated and named things like "first_image_TL-2.tif"
	third_image_tif = third_image_TL+".tif";

	run("Clear Results"); //clearing the template

	run("ROI Manager..."); //opening ROI manager
	roiManager("reset"); // clearing ROI manager

	roiManager("Show All"); //turning on show all labels
	roiManager("Show All with labels");

	selectWindow(first_image_tif); //grabbing first image
	
	height = getHeight; //getting dimensions in order to place background ROIs around images of any size
	width = getWidth;

	Auto_Background();
	
	// Calculating lower threshold background value in "Mean" column

DL1_m=0;
DL1_bkgd_mean=0;
DL1_meanbkgd=0;
DL1_std=0;
DL1_bkgd_std=0;
DL1_stdbkgd=0;

DL1_m = nResults; //building an array for the ROI means.
DL1_bkgd_mean = newArray(DL1_m);
run("Select None");
for (i=0; i<DL1_m; i++) { //getting ROI mean one at a time from ROI manager and putting mean into array.
	DL1_bkgd_mean[i] = getResult('Mean', i);
	}

if (background_setting == "High") {
	Array.getStatistics(DL1_bkgd_mean, min, max, mean, stdDev); //getting other stats from mean array
	Array.sort(DL1_bkgd_mean); //sorting array by mean values.
	DL1_bkgd_high_trim = Array.trim(DL1_bkgd_mean, 15); //removing highest 5 mean values and putting remaining into new array
	Array.getStatistics(DL1_bkgd_high_trim, min, max, mean, stdDev); // getting stats for new array
	Array.reverse(DL1_bkgd_high_trim); //reversing the order of the array values.
	DL1_bkgd_low_trim = Array.trim(DL1_bkgd_high_trim, 7); // removing the lowest 8 values (since the array order had been reversed).
	Array.getStatistics(DL1_bkgd_low_trim, min, max, mean, stdDev); // getting stats from this new new array
	DL1_meanbkgd = mean; //assigning mean value.

	DL1_std = nResults;  //counting the number of ROIs.
	DL1_bkgd_std = newArray(DL1_std);
	run("Select None");
	for (i=0; i<DL1_std; i++) {  //for each ROI, get the standard deviation value (this will lead to a similar function as was used for means above).
		DL1_bkgd_std[i] = getResult('StdDev', i);
		}
	Array.getStatistics(DL1_bkgd_std, min, max, mean, stdDev);
	Array.sort(DL1_bkgd_std);
	DL1_bksd_high_trim = Array.trim(DL1_bkgd_std, 15);
	Array.getStatistics(DL1_bksd_high_trim, min, max, mean, stdDev);
	Array.reverse(DL1_bksd_high_trim);
	DL1_bksd_low_trim = Array.trim(DL1_bksd_high_trim, 7);
	Array.getStatistics(DL1_bksd_low_trim, min, max, mean, stdDev);
	DL1_stdbkgd = mean;
	}

if (background_setting == "Low") {
	Array.getStatistics(DL1_bkgd_mean, min, max, mean, stdDev); //getting other stats from mean array
	Array.sort(DL1_bkgd_mean); //sorting array by mean values.
	DL1_bkgd_high_trim = Array.trim(DL1_bkgd_mean, 5); //removing highest 17 mean values and putting remaining into new array
	Array.getStatistics(DL1_bkgd_high_trim, min, max, mean, stdDev); // getting stats for new array
	DL1_meanbkgd = mean; //assigning mean value.

	DL1_std = nResults;  //counting the number of ROIs.
	DL1_bkgd_std = newArray(DL1_std);
	run("Select None");
	for (i=0; i<DL1_std; i++) {  //for each ROI, get the standard deviation value (this will lead to a similar function as was used for means above).
		DL1_bkgd_std[i] = getResult('StdDev', i);
		}
	Array.getStatistics(DL1_bkgd_std, min, max, mean, stdDev);
	Array.sort(DL1_bkgd_std);
	DL1_bksd_high_trim = Array.trim(DL1_bkgd_std, 5);
	Array.getStatistics(DL1_bksd_high_trim, min, max, mean, stdDev);
	DL1_stdbkgd = mean;
	}

TL1_lower = ((DL1_meanbkgd)+(DL1_stdbkgd*2));  //THIS IS THE VALUE THAT IS USED AS THE NaN VALUE FOR OUR INTENSITY MEASUREMENTS.
//print("\n");
//print("Single "+first_stain_type_TL+" label:");
//print(first_stain_type_TL+" Mean Background = "+DL1_meanbkgd+", Background StdDev = "+DL1_stdbkgd);
//print(first_stain_type_TL+" Lower Threshold= "+TL1_lower);

	// Setting Threshold

run("Set Measurements...", "area mean standard min center limit redir+subDir1ect=None decimal=3");  //setting measurements.
setAutoThreshold("Default dark");
run("Threshold..."); //Opening the threshold function
wait(200);
setThreshold(TL1_lower, 500000); //setting the NaN value.
//run("Apply");
run("NaN Background");
//run("Close");


selectWindow(first_image_tif); //duplicating the original image. Here it is important that the original is kept
run("Duplicate...", " "); //alive because it is the only version that can be reverted for the user to view. (alternatively, just reopen fresh image).
//run("8-bit");
run("Duplicate...", " ");
//run("8-bit");
selectWindow(first_image_TL+"-1.tif");

ps_Compile_Triple_Background_SL1_ROIs();
}
////////////////////////////////

function ps_Compile_Triple_Background_SL1_ROIs() { // this section is macro-ed because we want to be able to return to this point. Good place to use function.

	   // Measuring ROIs
		   //Finding PNNs with Analyze Particles

	name = series_name_TL+" "+first_stain_type_TL+".txt"; //saving the results table in a sub folder.

	first_image_tif = first_image_TL+".tif";
	second_image_tif = second_image_TL+".tif";
	third_image_tif = third_image_TL+".tif";

	selectWindow(first_image_TL+"-1.tif");
	roiManager("Show All");
	roiManager("Show All with labels");

	run("Clear Results");

roiManager("Set Color", "red");

if (import_type==7) {
	roiManager("reset");
	roiManager("Open", dir+subDir1+series_name_TL+"_"+first_suffix_TL+_sep_+first_image_TL+"_ROI-overlay.zip");
	roiManager("Show All");
	roiManager("Show All with labels");
	first_SL_run=(first_SL_run+1);
	//run("_ps_Triple_Background_SL1_ROIs");

	}

selectWindow(first_image_tif); //closing the reverted image
run("Close");

//saving SL1 ROI overlay

SL1_save_ROIs=roiManager("count"); //select all the ROIs in order to save the SL set.
array=newArray(SL1_save_ROIs);
for(i=0; i<SL1_save_ROIs; i++) {
	array[i] = i;
	}
roiManager("Select", array);
//roiManager("Save", dir+subDir1+first_image_TL+first_stain_type_TL+"_ROI-overlay.zip");


//Measuring ROIs

selectWindow(first_image_TL+"-1.tif");

run("Clear Results");
DL1_measure_circles=0;  //Selects all the ROIs and uses measure function to populate the results window.
DL1_measure_circles=roiManager("count");
array=newArray(DL1_measure_circles);
for(i=0; i<DL1_measure_circles;i++) {
		array[i] = i;
}
roiManager("Select", array);
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

DL1_m = nResults; //defining array variable.
DL1_means = newArray(DL1_m); //building array
roiManager("deselect");
for (i=0; i<DL1_m; i++) { //populating array with mean from each result
	  DL1_means[i] = getResult('Mean', i);
	}
roiManager("deselect");
	for (i=0; i<DL1_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

DL1_m2 = nResults; //making a average of the ROI means in order to print a "mean" value for this image.
DL1_avgmeans = newArray(DL1_m2);
run("Select None");
for (i=0; i<DL1_m2; i++) {
	DL1_avgmeans[i] = getResult('Mean-Background', i);
}
Array.getStatistics(DL1_avgmeans, min, max, mean, stdDev);
//print(first_stain_type_TL+" Mean Intensity = "+mean);

DL1_numberStains = 0; //printing the number of cells counted.
DL1_numberStains=getValue("results.count");
//print("Number of "+first_stain_type_TL+" Stained Cells = "+DL1_numberStains);

n_sl1 = nResults; //THIS IS AN IMPORTANT FUNCTION FOR THE RESULTS. SAME RESULTS AS IN TABLE, BUT PRINTED IN LOG, WHICH IS BETTER FOR IMPORTING INTO EXCEL.
area_sl1 = newArray(n_sl1);
XM_sl1 = newArray(n_sl1);
YM_sl1 = newArray(n_sl1);
mean_sl1 = newArray(n_sl1);
stddev_sl1 = newArray(n_sl1);
min_sl1 = newArray(n_sl1);
max_sl1 = newArray(n_sl1);
bkgd_sl1 = newArray(n_sl1);
meanbkgd_sl1 = newArray(n_sl1);
print("\n");
print("Individual "+first_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
n=0;
for (i=0; i<n_sl1; i++) { // for each line in the results table, populate an array with these parameters and print them in the log.
	area_sl1[i] = getResult('Area', i);
	XM_sl1[i] = getResult('XM', i);
	YM_sl1[i] = getResult('YM', i);
	mean_sl1[i] = getResult('Mean', i);
	stddev_sl1[i] = getResult('StdDev', i);
	min_sl1[i] = getResult('Min', i);
	max_sl1[i] = getResult('Max', i);
	bkgd_sl1[i] = getResult('Background', i);
	meanbkgd_sl1[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+first_image_TL+" "+first_stain_type_TL+" "+(i+1)+" "+area_sl1[i]+" "+XM_sl1[i]+" "+YM_sl1[i]+" "+mean_sl1[i]+" "+stddev_sl1[i]+" "+min_sl1[i]+" "+max_sl1[i]+" "+bkgd_sl1[i]+" "+meanbkgd_sl1[i]);

	//roiManager("Select", i);
	//run("Duplicate...", " ");
	//selectWindow(first_image_TL+"-3.tif");
	n=n+1;

	}

roiManager("reset");
selectWindow("ROI Manager");
run("Close");

wait(100);

selectWindow(first_image_TL+"-1.tif");
run("Close");

	// Saving data

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");


//\\//\\//\\//\\//\\//\\

//Second Image //THIS SECTION DOES THE SAME SINGLE-LABEL ROI WORK AS ABOVE, BUT FOR THE SECOND STAIN.
	// Selecting Background

	run("Clear Results");

	roiManager("reset");

	roiManager("Show All");
	roiManager("Show All with labels");

	selectWindow(second_image_tif);


	height = getHeight;
	width = getWidth;

	Auto_Background();
	
	// Calculating lower threshold background value in "Mean" column

DL2_m=0;
DL2_bkgd_mean=0;
DL2_meanbkgd=0;
DL2_std=0;
DL2_bkgd_std=0;
DL2_stdbkgd=0;

DL2_m = nResults;
DL2_bkgd_mean = newArray(DL2_m);
run("Select None");
for (i=0; i<DL2_m; i++) {
	DL2_bkgd_mean[i] = getResult('Mean', i);
	}
if (background_setting == "High") {
	Array.getStatistics(DL2_bkgd_mean, min, max, mean, stdDev); //getting other stats from mean array
	Array.sort(DL2_bkgd_mean); //sorting array by mean values.
	DL2_bkgd_high_trim = Array.trim(DL2_bkgd_mean, 15); //removing highest 5 mean values and putting remaining into new array
	Array.getStatistics(DL2_bkgd_high_trim, min, max, mean, stdDev); // getting stats for new array
	Array.reverse(DL2_bkgd_high_trim); //reversing the order of the array values.
	DL2_bkgd_low_trim = Array.trim(DL2_bkgd_high_trim, 7); // removing the lowest 8 values (since the array order had been reversed).
	Array.getStatistics(DL2_bkgd_low_trim, min, max, mean, stdDev); // getting stats from this new new array
	DL2_meanbkgd = mean; //assigning mean value.

	DL2_std = nResults;  //counting the number of ROIs.
	DL2_bkgd_std = newArray(DL2_std);
	run("Select None");
	for (i=0; i<DL2_std; i++) {  //for each ROI, get the standard deviation value (this will lead to a similar function as was used for means above).
		DL2_bkgd_std[i] = getResult('StdDev', i);
		}
	Array.getStatistics(DL2_bkgd_std, min, max, mean, stdDev);
	Array.sort(DL2_bkgd_std);
	DL2_bksd_high_trim = Array.trim(DL2_bkgd_std, 15);
	Array.getStatistics(DL2_bksd_high_trim, min, max, mean, stdDev);
	Array.reverse(DL2_bksd_high_trim);
	DL2_bksd_low_trim = Array.trim(DL2_bksd_high_trim, 7);
	Array.getStatistics(DL2_bksd_low_trim, min, max, mean, stdDev);
	DL2_stdbkgd = mean;
	}

if (background_setting == "Low") {
	Array.getStatistics(DL2_bkgd_mean, min, max, mean, stdDev); //getting other stats from mean array
	Array.sort(DL2_bkgd_mean); //sorting array by mean values.
	DL2_bkgd_high_trim = Array.trim(DL2_bkgd_mean, 5); //removing highest 17 mean values and putting remaining into new array
	Array.getStatistics(DL2_bkgd_high_trim, min, max, mean, stdDev); // getting stats for new array
	DL2_meanbkgd = mean; //assigning mean value.

	DL2_std = nResults;  //counting the number of ROIs.
	DL2_bkgd_std = newArray(DL2_std);
	run("Select None");
	for (i=0; i<DL2_std; i++) {  //for each ROI, get the standard deviation value (this will lead to a similar function as was used for means above).
		DL2_bkgd_std[i] = getResult('StdDev', i);
		}
	Array.getStatistics(DL2_bkgd_std, min, max, mean, stdDev);
	Array.sort(DL2_bkgd_std);
	DL2_bksd_high_trim = Array.trim(DL2_bkgd_std, 5);
	Array.getStatistics(DL2_bksd_high_trim, min, max, mean, stdDev);
	DL2_stdbkgd = mean;
	}

TL2_lower = ((DL2_meanbkgd)+(DL2_stdbkgd*2));
//print("\n");
//print("Single "+second_stain_type_TL+" label:");
//print(second_stain_type_TL+" Mean Background = "+DL2_meanbkgd+", Background StdDev = "+DL2_stdbkgd);
//print(second_stain_type_TL+" Lower Threshold= "+TL2_lower);

	// Setting Threshold

run("Set Measurements...", "area mean standard min center limit redirect=None decimal=3");  //setting measurements.
setAutoThreshold("Default dark");
run("Threshold...");
wait(200);
setThreshold(TL2_lower, 500000);
//run("Apply");
run("NaN Background");

selectWindow(second_image_tif);
run("Duplicate...", " ");
//run("8-bit");
run("Duplicate...", " ");
//run("8-bit");
selectWindow(second_image_TL+"-1.tif");

ps_Compile_Triple_Background_SL2_ROIs();

}

/////////////////////////////

function ps_Compile_Triple_Background_SL2_ROIs() {


	   // Measuring ROIs
		   //Finding PNNs with Analyze Particles

second_image_tif = second_image_TL+".tif";
third_image_tif = third_image_TL+".tif";

	name = series_name_TL+" "+second_stain_type_TL+".txt";
	selectWindow(second_image_TL+"-1.tif");
	roiManager("Show All");
	roiManager("Show All with labels");

	run("Clear Results");

if(first_SL_run==1) {
	roiManager("reset");
	wait(200);
	setAutoThreshold("Default dark");
	run("Threshold...");
	wait(200);
	setThreshold(TL2_lower*TL2_set_intensity_low_threshold, TL2_set_intensity_high_threshold);
	wait(200);
	makeRectangle(0, 0, 0, 0);
	run("Analyze Particles...", "size=TL2_set_low_particlesize-TL2_set_high_particlesize circularity=TL2_set_low_circularity-TL2_set_high_circularity clear include add");
	wait(200);
	selectWindow("Threshold");
	resetThreshold();
	run("Close");
	roiManager("Measure");

			   //Making square ROIs from Particles

	wait(500);
	DL2_add_squares=roiManager("count");

	if (DL2_add_squares>0) {
		setBatchMode("hide");

		title = "[ROI Conversion Progress]";
		run("Text Window...", "name="+ title +" width=55 height=7");
		selectWindow("ROI Conversion Progress");
		setLocation((screenWidth/5)*2, (screenHeight/5)*2);
		print(title, "Please wait while ROIs are converted. \nProcess may take 15 seconds... \n \nYour image will reopen when the process is complete.");

		array=newArray(DL2_add_squares);
		for(i=0; i<DL2_add_squares;i++) {
			roiManager("Select", i);
			if(ROI_type_TL2 == "As-detected") {
				wait(10);
				}
			if(ROI_type_TL2 == "Square") {
				run("Specify...", "centered scaled");
				}
			if(ROI_type_TL2 == "Circle") {
				run("Specify...", "oval constrain centered scaled");
				}

			run("Enlarge...", "enlarge=TL2_set_roi_enlargement");
			roiManager("update");
		}
		setBatchMode("exit and display");
		roiManager("show all with labels");

		if(isOpen("ROI Conversion Progress")==true){
			selectWindow("ROI Conversion Progress");
			run("Close");
		}
	}
}

if (import_type==7) {
	roiManager("reset");
	roiManager("Open", dir+subDir1+series_name_TL+"_"+second_suffix_TL+_sep_+second_image_TL+"_ROI-overlay.zip");
	roiManager("Show All");
	roiManager("Show All with labels");
	first_SL_run=(first_SL_run+1);

} 

selectWindow(second_image_tif);
run("Close");

//saving SL2 ROI overlay

SL2_save_ROIs=roiManager("count");
array=newArray(SL2_save_ROIs);
for(i=0; i<SL2_save_ROIs; i++) {
	array[i] = i;
	}
roiManager("Select", array);
//roiManager("Save", dir+second_image_TL+second_stain_type_TL+"_ROI-overlay.zip");


//Measuring ROIs

selectWindow(second_image_TL+"-1.tif");
run("Clear Results");
DL2_measure_squares=0;
DL2_measure_squares =roiManager("count");
array=newArray(DL2_measure_squares);
for(i=0; i<DL2_measure_squares;i++) {
		array[i] = i;
	}
roiManager("Select", array);
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

DL2_m=0;
DL2_means=0;
DL2_m = nResults;
DL2_means = newArray(DL2_m);
run("Select None");
	for (i=0; i<DL2_m; i++) {
	  DL2_means[i] = getResult('Mean', i);
	}
run("Select None");
	for (i=0; i<DL2_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

DL2_m2 = 0;
DL2_avgmeans = 0;
DL2_m2 = nResults;
DL2_avgmeans = newArray(DL2_m2);
run("Select None");
	for (i=0; i<DL2_m2; i++) {
	 DL2_avgmeans[i] = getResult('Mean-Background', i);
	}
Array.getStatistics(DL2_avgmeans, min, max, mean, stdDev);
//print(second_stain_type_TL+" Mean Intensity = "+mean);


DL2_numberStains=0;
DL2_numberStains=getValue("results.count");
//print("Number of "+second_stain_type_TL+" Stained Cells = "+DL2_numberStains);

n_sl2 = nResults; //THIS IS AN IMPORTANT FUNCTION FOR THE RESULTS. SAME RESULTS AS IN TABLE, BUT PRINTED IN LOG, WHICH IS BETTER FOR IMPORTING INTO EXCEL.
area_sl2 = newArray(n_sl2);
XM_sl2 = newArray(n_sl2);
YM_sl2 = newArray(n_sl2);
mean_sl2 = newArray(n_sl2);
stddev_sl2 = newArray(n_sl2);
min_sl2 = newArray(n_sl2);
max_sl2 = newArray(n_sl2);
bkgd_sl2 = newArray(n_sl2);
meanbkgd_sl2 = newArray(n_sl2);
print("\n");
print("Individual "+second_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
n=0;
for (i=0; i<n_sl2; i++) { // for each line in the results table, populate an array with these parameters and print them in the log.
	area_sl2[i] = getResult('Area', i);
	XM_sl2[i] = getResult('XM', i);
	YM_sl2[i] = getResult('YM', i);
	mean_sl2[i] = getResult('Mean', i);
	stddev_sl2[i] = getResult('StdDev', i);
	min_sl2[i] = getResult('Min', i);
	max_sl2[i] = getResult('Max', i);
	bkgd_sl2[i] = getResult('Background', i);
	meanbkgd_sl2[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+second_image_TL+" "+second_stain_type_TL+" "+(i+1)+" "+area_sl2[i]+" "+XM_sl2[i]+" "+YM_sl2[i]+" "+mean_sl2[i]+" "+stddev_sl2[i]+" "+min_sl2[i]+" "+max_sl2[i]+" "+bkgd_sl2[i]+" "+meanbkgd_sl2[i]);

	//roiManager("Select", i);
	//run("Duplicate...", " ");
	//selectWindow(second_image_TL+"-3.tif");
	n=n+1;

	}

roiManager("reset");
selectWindow("ROI Manager");
run("Close");

wait(100);

selectWindow(second_image_TL+"-1.tif");
run("Close");

	// Saving data

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");


//\\//\\//\\//\\//\\//\\

//Third Image //THIS SECTION DOES THE SAME SINGLE-LABEL ROI WORK AS ABOVE, BUT FOR THE third STAIN.
	// Selecting Background

	run("Clear Results");

	roiManager("reset");

	roiManager("Show All");
	roiManager("Show All with labels");

	selectWindow(third_image_tif);

	height = getHeight;
	width = getWidth;

	Auto_Background();
		
	// Calculating lower threshold background value in "Mean" column

DL3_m=0;
DL3_bkgd_mean=0;
DL3_meanbkgd=0;
DL3_std=0;
DL3_bkgd_std=0;
DL3_stdbkgd=0;

DL3_m = nResults;
DL3_bkgd_mean = newArray(DL3_m);
run("Select None");
for (i=0; i<DL3_m; i++) {
	DL3_bkgd_mean[i] = getResult('Mean', i);
	}
if (background_setting == "High") {
	Array.getStatistics(DL3_bkgd_mean, min, max, mean, stdDev);
	Array.sort(DL3_bkgd_mean);
	DL3_bkgd_high_trim = Array.trim(DL3_bkgd_mean, 15);
	Array.getStatistics(DL3_bkgd_high_trim, min, max, mean, stdDev);
	Array.reverse(DL3_bkgd_high_trim);
	DL3_bkgd_low_trim = Array.trim(DL3_bkgd_high_trim, 7);
	Array.getStatistics(DL3_bkgd_low_trim, min, max, mean, stdDev);
	DL3_meanbkgd = mean;

	DL3_std = nResults;
	DL3_bkgd_std = newArray(DL3_std);
	run("Select None");
	for (i=0; i<DL3_std; i++) {
		DL3_bkgd_std[i] = getResult('StdDev', i);
		}
	Array.getStatistics(DL3_bkgd_std, min, max, mean, stdDev);
	Array.sort(DL3_bkgd_std);
	DL3_bksd_high_trim = Array.trim(DL3_bkgd_std, 15);
	Array.getStatistics(DL3_bksd_high_trim, min, max, mean, stdDev);
	Array.reverse(DL3_bksd_high_trim);
	DL3_bksd_low_trim = Array.trim(DL3_bksd_high_trim, 7);
	Array.getStatistics(DL3_bksd_low_trim, min, max, mean, stdDev);
	DL3_stdbkgd = mean;
	}

if (background_setting == "Low") {
	Array.getStatistics(DL3_bkgd_mean, min, max, mean, stdDev);
	Array.sort(DL3_bkgd_mean);
	DL3_bkgd_high_trim = Array.trim(DL3_bkgd_mean, 5);
	Array.getStatistics(DL3_bkgd_high_trim, min, max, mean, stdDev);
	DL3_meanbkgd = mean;

	DL3_std = nResults;
	DL3_bkgd_std = newArray(DL3_std);
	run("Select None");
	for (i=0; i<DL3_std; i++) {
		DL3_bkgd_std[i] = getResult('StdDev', i);
		}
	Array.getStatistics(DL3_bkgd_std, min, max, mean, stdDev);
	Array.sort(DL3_bkgd_std);
	DL3_bksd_high_trim = Array.trim(DL3_bkgd_std, 5);
	Array.getStatistics(DL3_bksd_high_trim, min, max, mean, stdDev);
	DL3_stdbkgd = mean;
	}

TL3_lower = ((DL3_meanbkgd)+(DL3_stdbkgd*2));
//print("\n");
//print("Single "+third_stain_type_TL+" label:");
//print(third_stain_type_TL+" Mean Background = "+DL3_meanbkgd+", Background StdDev = "+DL3_stdbkgd);
//print(third_stain_type_TL+" Lower Threshold= "+TL3_lower);

	// Setting Threshold

run("Set Measurements...", "area mean standard min center limit redirect=None decimal=3");  //setting measurements.
setAutoThreshold("Default dark");
run("Threshold...");
wait(200);
setThreshold(TL3_lower, 500000);
//run("Apply");
run("NaN Background");


selectWindow(third_image_tif);
run("Duplicate...", " ");
//run("8-bit");
run("Duplicate...", " ");
//run("8-bit");
selectWindow(third_image_TL+"-1.tif");

ps_Compile_Triple_Background_SL3_ROIs();

}

/////////////////////////////

function ps_Compile_Triple_Background_SL3_ROIs() {


	   // Measuring ROIs
		   //Finding PNNs with Analyze Particles

third_image_tif = third_image_TL+".tif";
name = series_name_TL+" "+third_stain_type_TL+".txt";

selectWindow(third_image_TL+"-1.tif");
roiManager("Show All");
roiManager("Show All with labels");

run("Clear Results");

if(first_SL_run==1) {
	roiManager("reset");
	wait(200);
	setAutoThreshold("Default dark");
	run("Threshold...");
	wait(200);
	setThreshold(TL3_lower*TL3_set_intensity_low_threshold, TL3_set_intensity_high_threshold);
	wait(200);
	makeRectangle(0, 0, 0, 0);
	run("Analyze Particles...", "size=TL3_set_low_particlesize-TL3_set_high_particlesize circularity=TL3_set_low_circularity-TL3_set_high_circularity clear include add");
	wait(200);
	selectWindow("Threshold");
	resetThreshold();
	run("Close");
	roiManager("Measure");

			   //Making square ROIs from Particles

	wait(500);
	DL3_add_circles=roiManager("count");

	if (DL3_add_circles>0) {
		setBatchMode("hide");

		title = "[ROI Conversion Progress]";
		run("Text Window...", "name="+ title +" width=55 height=7");
		selectWindow("ROI Conversion Progress");
		setLocation((screenWidth/5)*2, (screenHeight/5)*2);
		print(title, "Please wait while ROIs are converted. \nProcess may take 15 seconds... \n \nYour image will reopen when the process is complete.");

		array=newArray(DL3_add_circles);
		for(i=0; i<DL3_add_circles;i++) {
			roiManager("Select", i);
			if(ROI_type_TL3 == "As-detected") {
				wait(5);
			}
			if(ROI_type_TL3 == "Square") {
				run("Specify...", "centered scaled");
			}
			if(ROI_type_TL3 == "Circle") {
				run("Specify...", "oval constrain centered scaled");
			}

			run("Enlarge...", "enlarge=TL3_set_roi_enlargement");
			roiManager("update");
		}
		setBatchMode("exit and display");
		roiManager("show all with labels");
		
		if(isOpen("ROI Conversion Progress")==true){
			selectWindow("ROI Conversion Progress");
			run("Close");
		}
	} else {

		waitForUser("Oops", "We didn't see any staining here. Try adding some ROIs in the next step, or changing the image detection settings.");
		}
	}

if (import_type==7) {
	roiManager("reset");
	roiManager("Open", dir+subDir1+series_name_TL+"_"+third_suffix_TL+_sep_+third_image_TL+"_ROI-overlay.zip");
	roiManager("Show All");
	roiManager("Show All with labels");
	first_SL_run=(first_SL_run+1);
} 

selectWindow(third_image_tif);
run("Close");


//saving TL3 ROI overlay

TL3_save_ROIs=roiManager("count");
array=newArray(TL3_save_ROIs);
for(i=0; i<TL3_save_ROIs; i++) {
	array[i] = i;
	}
roiManager("Select", array);
//roiManager("Save", dir+third_image_TL+third_stain_type_TL+"_ROI-overlay.zip");


//Measuring ROIs

selectWindow(third_image_TL+"-1.tif");
run("Clear Results");
DL3_measure_circles=0;
DL3_measure_circles =roiManager("count");
array=newArray(DL3_measure_circles);
for(i=0; i<DL3_measure_circles;i++) {
		array[i] = i;
	}
roiManager("Select", array);
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

DL3_m=0;
DL3_means=0;
DL3_m = nResults;
DL3_means = newArray(DL3_m);
run("Select None");
	for (i=0; i<DL3_m; i++) {
	  DL3_means[i] = getResult('Mean', i);
	}
run("Select None");
	for (i=0; i<DL3_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

DL3_m3 = 0;
DL3_avgmeans = 0;
DL3_m3 = nResults;
DL3_avgmeans = newArray(DL3_m3);
run("Select None");
	for (i=0; i<DL3_m3; i++) {
	 DL3_avgmeans[i] = getResult('Mean-Background', i);
	}
Array.getStatistics(DL3_avgmeans, min, max, mean, stdDev);
//print(third_stain_type_TL+" Mean Intensity = "+mean);


DL3_numberStains=0;
DL3_numberStains=getValue("results.count");
//print("Number of "+third_stain_type_TL+" Stained Cells = "+DL3_numberStains);

n_sl3 = nResults; //THIS IS AN IMPORTANT FUNCTION FOR THE RESULTS. SAME RESULTS AS IN TABLE, BUT PRINTED IN LOG, WHICH IS BETTER FOR IMPORTING INTO EXCEL.
area_sl3 = newArray(n_sl3);
XM_sl3 = newArray(n_sl3);
YM_sl3 = newArray(n_sl3);
mean_sl3 = newArray(n_sl3);
stddev_sl3 = newArray(n_sl3);
min_sl3 = newArray(n_sl3);
max_sl3 = newArray(n_sl3);
bkgd_sl3 = newArray(n_sl3);
meanbkgd_sl3 = newArray(n_sl3);
print("\n");
print("Individual "+third_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
n=0;
for (i=0; i<n_sl3; i++) { // for each line in the results table, populate an array with these parameters and print them in the log.
	area_sl3[i] = getResult('Area', i);
	XM_sl3[i] = getResult('XM', i);
	YM_sl3[i] = getResult('YM', i);
	mean_sl3[i] = getResult('Mean', i);
	stddev_sl3[i] = getResult('StdDev', i);
	min_sl3[i] = getResult('Min', i);
	max_sl3[i] = getResult('Max', i);
	bkgd_sl3[i] = getResult('Background', i);
	meanbkgd_sl3[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+third_image_TL+" "+third_stain_type_TL+" "+(i+1)+" "+area_sl3[i]+" "+XM_sl3[i]+" "+YM_sl3[i]+" "+mean_sl3[i]+" "+stddev_sl3[i]+" "+min_sl3[i]+" "+max_sl3[i]+" "+bkgd_sl3[i]+" "+meanbkgd_sl3[i]);

	//roiManager("Select", i);
	//run("Duplicate...", " ");
	//selectWindow(third_image_TL+"-3.tif");
	n=n+1;

	}

roiManager("reset");
selectWindow("ROI Manager");
run("Close");

wait(100);

selectWindow(third_image_TL+"-1.tif");
run("Close");

	// Saving data

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");

ps_Compile_measure_tpl_Background_DL1and2_ROIs();

}

//\\//\\//\\//\\//\\//\\//\\

function ps_Compile_measure_tpl_Background_DL1and2_ROIs() { //this macro simply recalls the ROIs defined in the last macro in order to measure the values again.

wait(50);

first_image_tif = first_image_TL+"-2.tif";
second_image_tif = second_image_TL+"-2.tif";
merged_image_tif = merged_image_TL+".tif";


//actually measuring the double labeled ROIs (image 1)

run("Clear Results");

selectWindow(first_image_tif);
roiManager("Open", dir+subDir1+first_image_TL+first_stain_type_TL+"_vs_"+second_stain_type_TL+"_double-label_ROIoverlay.zip");
name = series_name_TL+" "+first_stain_type_TL+" vs "+second_stain_type_TL+" double-label.txt";

DL_ROIs=0;
DL_ROIs =roiManager("count");
array=newArray(DL_ROIs);
for(i=0; i<DL_ROIs;i++) {
		array[i] = i;
	}
//roiManager("Select", array); //by not making an ROI manager selection, and actually deselecting, the ROI manager selects all by default.
roiManager("deselect");
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

DL_ROIs1_m=0;
DL_ROIs1_means=0;
DL_ROIs1_m = nResults;
DL_ROIs1_means = newArray(DL_ROIs1_m);
roiManager("deselect");
for (i=0; i<DL_ROIs1_m; i++) {
	DL_ROIs1_means[i] = getResult('Mean', i);
}
roiManager("deselect");
	for (i=0; i<DL_ROIs1_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

DL_ROIs1_m2 = 0;
DL_ROIs1_avgmeans = 0;
DL_ROIs1_m2 = nResults;
DL_ROIs1_avgmeans = newArray(DL_ROIs1_m2);
roiManager("deselect");
for (i=0; i<DL_ROIs1_m2; i++) {
	DL_ROIs1_avgmeans[i] = getResult('Mean-Background', i);
	}
Array.getStatistics(DL_ROIs1_avgmeans, min, max, mean, stdDev);
//print("\n");
//print("Double-labeled "+first_stain_type_TL+" co-occurring with "+second_stain_type_TL+" Mean Intensity = "+mean);


DL_ROIs1_numberStains=0;
DL_ROIs1_numberStains=getValue("results.count");
//print("Final number of Double-labeled "+first_stain_type_TL+" co-occurring with "+second_stain_type_TL+" Cells = "+DL_ROIs1_numberStains);

n_dl1 = nResults;
area_dl1 = newArray(n_dl1);
XM_dl1 = newArray(n_dl1);
YM_dl1 = newArray(n_dl1);
mean_dl1 = newArray(n_dl1);
stddev_dl1 = newArray(n_dl1);
min_dl1 = newArray(n_dl1);
max_dl1 = newArray(n_dl1);
bkgd_dl1 = newArray(n_dl1);
meanbkgd_dl1 = newArray(n_dl1);
print("\n");
print("Double-labeled "+first_stain_type_TL+" vs "+second_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
for (i=0; i<n_dl1; i++) {
	area_dl1[i] = getResult('Area', i);
	XM_dl1[i] = getResult('XM', i);
	YM_dl1[i] = getResult('YM', i);
	mean_dl1[i] = getResult('Mean', i);
	stddev_dl1[i] = getResult('StdDev', i);
	min_dl1[i] = getResult('Min', i);
	max_dl1[i] = getResult('Max', i);
	bkgd_dl1[i] = getResult('Background', i);
	meanbkgd_dl1[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+first_image_TL+" "+"Double-labeled_"+first_stain_type_TL+"_co-occurring_with_"+second_stain_type_TL+" "+(i+1)+" "+area_dl1[i]+" "+XM_dl1[i]+" "+YM_dl1[i]+" "+mean_dl1[i]+" "+stddev_dl1[i]+" "+min_dl1[i]+" "+max_dl1[i]+" "+bkgd_dl1[i]+" "+meanbkgd_dl1[i]);
	}

	// Saving data

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");

roiManager("reset");

//\\\\\\\\\\\\\\\
//measure double labeled ROIs (image 2)

roiManager("Open", dir+subDir1+second_image_TL+second_stain_type_TL+"_vs_"+first_stain_type_TL+"_double-label_ROIoverlay.zip");
name = series_name_TL+" "+second_stain_type_TL+" vs "+first_stain_type_TL+" double-label.txt";

run("Clear Results");
selectWindow(second_image_tif);

//waitForUser("Pause5");

roiManager("Show All");
roiManager("Show All with labels");
roiManager("deselect");

DL_ROIs=0;
DL_ROIs =roiManager("count");
array=newArray(DL_ROIs);
for(i=0; i<DL_ROIs;i++) {
	array[i] = i;
	}

//roiManager("Select", array);
roiManager("deselect");
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

DL_ROIs2_m=0;
DL_ROIs2_means=0;
DL_ROIs2_m = nResults;
DL_ROIs2_means = newArray(DL_ROIs2_m);
run("Select None");
for (i=0; i<DL_ROIs2_m; i++) {
	DL_ROIs2_means[i] = getResult('Mean', i);
	}
roiManager("deselect");
	for (i=0; i<DL_ROIs2_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

DL_ROIs2_m2 = 0;
DL_ROIs2_avgmeans = 0;
DL_ROIs2_m2 = nResults;
DL_ROIs2_avgmeans = newArray(DL_ROIs2_m2);
roiManager("deselect");
for (i=0; i<DL_ROIs2_m2; i++) {
	DL_ROIs2_avgmeans[i] = getResult('Mean-Background', i);
	}

Array.getStatistics(DL_ROIs2_avgmeans, min, max, mean, stdDev);
//print("\n");
//print("Double-labeled "+second_stain_type_TL+" co-occurring with "+first_stain_type_TL+" Mean Intensity = "+mean);


DL_ROIs2_numberStains=0;
DL_ROIs2_numberStains=getValue("results.count");
//print("Final number of Double-labeled "+second_stain_type_TL+" co-occurring with "+first_stain_type_TL+" Cells = "+DL_ROIs2_numberStains);

n_dl2 = nResults;
area_dl2 = newArray(n_dl2);
XM_dl2 = newArray(n_dl2);
YM_dl2 = newArray(n_dl2);
mean_dl2 = newArray(n_dl2);
stddev_dl2 = newArray(n_dl2);
min_dl2 = newArray(n_dl2);
max_dl2 = newArray(n_dl2);
bkgd_dl2 = newArray(n_dl2);
meanbkgd_dl2 = newArray(n_dl2);
print("\n");
print("Double-labeled "+second_stain_type_TL+" vs "+first_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
for (i=0; i<n_dl2; i++) {
	area_dl2[i] = getResult('Area', i);
	XM_dl2[i] = getResult('XM', i);
	YM_dl2[i] = getResult('YM', i);
	mean_dl2[i] = getResult('Mean', i);
	stddev_dl2[i] = getResult('StdDev', i);
	min_dl2[i] = getResult('Min', i);
	max_dl2[i] = getResult('Max', i);
	bkgd_dl2[i] = getResult('Background', i);
	meanbkgd_dl2[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+second_image_TL+" "+"Double-labeled_"+second_stain_type_TL+"_co-occurring_with_"+first_stain_type_TL+" "+(i+1)+" "+area_dl2[i]+" "+XM_dl2[i]+" "+YM_dl2[i]+" "+mean_dl2[i]+" "+stddev_dl2[i]+" "+min_dl2[i]+" "+max_dl2[i]+" "+bkgd_dl2[i]+" "+meanbkgd_dl2[i]);
	}

	// Saving data

//saveAs("Measurements", dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");
//print("\n");
//print("Results saved as: "+dir+name);

roiManager("reset");
run("Clear Results");

ps_Compile_measure_tpl_Background_DL3and2_ROIs();

}
//\\//\\//\\//\\//\\//\\//\\

function ps_Compile_measure_tpl_Background_DL3and2_ROIs() { //this macro simply recalls the ROIs defined in the last macro in order to measure the values again.

third_image_tif = third_image_TL+"-2.tif";
second_image_tif = second_image_TL+"-2.tif";
merged_image_tif = merged_image_TL+".tif";


run("Clear Results");

selectWindow(third_image_tif);
roiManager("Open", dir+subDir1+third_image_TL+third_stain_type_TL+"_vs_"+second_stain_type_TL+"_double-label_ROIoverlay.zip");
name = series_name_TL+" "+third_stain_type_TL+"_vs_"+second_stain_type_TL+" double-label.txt";

DL_ROIs=0;
DL_ROIs =roiManager("count");
array=newArray(DL_ROIs);
for(i=0; i<DL_ROIs;i++) {
	array[i] = i;
	}
//roiManager("Select", array); //by not making an ROI manager selection, and actually deselecting, the ROI manager selects all by default.
roiManager("deselect");
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

DL_ROIs1_m=0;
DL_ROIs1_means=0;
DL_ROIs1_m = nResults;
DL_ROIs1_means = newArray(DL_ROIs1_m);
roiManager("deselect");
for (i=0; i<DL_ROIs1_m; i++) {
	DL_ROIs1_means[i] = getResult('Mean', i);
}
roiManager("deselect");
	for (i=0; i<DL_ROIs1_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

DL_ROIs1_m2 = 0;
DL_ROIs1_avgmeans = 0;
DL_ROIs1_m2 = nResults;
DL_ROIs1_avgmeans = newArray(DL_ROIs1_m2);
roiManager("deselect");
for (i=0; i<DL_ROIs1_m2; i++) {
	DL_ROIs1_avgmeans[i] = getResult('Mean-Background', i);
	}
Array.getStatistics(DL_ROIs1_avgmeans, min, max, mean, stdDev);
//print("\n");
//print("Double-labeled "+third_stain_type_TL+" co-occurring with "+second_stain_type_TL+" Mean Intensity = "+mean);


DL_ROIs1_numberStains=0;
DL_ROIs1_numberStains=getValue("results.count");
//print("Final number of Double-labeled "+third_stain_type_TL+" co-occurring with "+second_stain_type_TL+" Cells = "+DL_ROIs1_numberStains);

n_dl1 = nResults;
area_dl1 = newArray(n_dl1);
XM_dl1 = newArray(n_dl1);
YM_dl1 = newArray(n_dl1);
mean_dl1 = newArray(n_dl1);
stddev_dl1 = newArray(n_dl1);
min_dl1 = newArray(n_dl1);
max_dl1 = newArray(n_dl1);
bkgd_dl1 = newArray(n_dl1);
meanbkgd_dl1 = newArray(n_dl1);
print("\n");
print("Double-labeled "+third_stain_type_TL+" vs "+second_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
for (i=0; i<n_dl1; i++) {
	area_dl1[i] = getResult('Area', i);
	XM_dl1[i] = getResult('XM', i);
	YM_dl1[i] = getResult('YM', i);
	mean_dl1[i] = getResult('Mean', i);
	stddev_dl1[i] = getResult('StdDev', i);
	min_dl1[i] = getResult('Min', i);
	max_dl1[i] = getResult('Max', i);
	bkgd_dl1[i] = getResult('Background', i);
	meanbkgd_dl1[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+third_image_TL+" "+"Double-labeled_"+third_stain_type_TL+"_co-occurring_with_"+second_stain_type_TL+" "+(i+1)+" "+area_dl1[i]+" "+XM_dl1[i]+" "+YM_dl1[i]+" "+mean_dl1[i]+" "+stddev_dl1[i]+" "+min_dl1[i]+" "+max_dl1[i]+" "+bkgd_dl1[i]+" "+meanbkgd_dl1[i]);
	}


	// Saving data

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");

roiManager("reset");

//\\\\\\\\\\\\\\\
//measure double labeled ROIs (image 2)

roiManager("Open", dir+subDir1+second_image_TL+second_stain_type_TL+"_vs_"+third_stain_type_TL+"_double-label_ROIoverlay.zip");
name = series_name_TL+" "+second_stain_type_TL+"_vs_"+third_stain_type_TL+" double-label.txt";

run("Clear Results");
selectWindow(second_image_tif);

//waitForUser("Pause5");

roiManager("Show All");
roiManager("Show All with labels");
roiManager("deselect");

DL_ROIs=0;
DL_ROIs =roiManager("count");
array=newArray(DL_ROIs);
for(i=0; i<DL_ROIs;i++) {
	array[i] = i;
	}

//roiManager("Select", array);
roiManager("deselect");
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

DL_ROIs2_m=0;
DL_ROIs2_means=0;
DL_ROIs2_m = nResults;
DL_ROIs2_means = newArray(DL_ROIs2_m);
run("Select None");
for (i=0; i<DL_ROIs2_m; i++) {
	DL_ROIs2_means[i] = getResult('Mean', i);
	}
roiManager("deselect");
	for (i=0; i<DL_ROIs2_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

DL_ROIs2_m2 = 0;
DL_ROIs2_avgmeans = 0;
DL_ROIs2_m2 = nResults;
DL_ROIs2_avgmeans = newArray(DL_ROIs2_m2);
roiManager("deselect");
for (i=0; i<DL_ROIs2_m2; i++) {
	DL_ROIs2_avgmeans[i] = getResult('Mean-Background', i);
	}

Array.getStatistics(DL_ROIs2_avgmeans, min, max, mean, stdDev);
//print("\n");
//print("Double-labeled "+second_stain_type_TL+" co-occurring with "+third_stain_type_TL+" Mean Intensity = "+mean);


DL_ROIs2_numberStains=0;
DL_ROIs2_numberStains=getValue("results.count");
//print("Final number of Double-labeled "+second_stain_type_TL+" co-occurring with "+third_stain_type_TL+" Cells = "+DL_ROIs2_numberStains);

n_dl2 = nResults;
area_dl2 = newArray(n_dl2);
XM_dl2 = newArray(n_dl2);
YM_dl2 = newArray(n_dl2);
mean_dl2 = newArray(n_dl2);
stddev_dl2 = newArray(n_dl2);
min_dl2 = newArray(n_dl2);
max_dl2 = newArray(n_dl2);
bkgd_dl2 = newArray(n_dl2);
meanbkgd_dl2 = newArray(n_dl2);
print("\n");
print("Double-labeled "+second_stain_type_TL+" vs "+third_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
for (i=0; i<n_dl2; i++) {
	area_dl2[i] = getResult('Area', i);
	XM_dl2[i] = getResult('XM', i);
	YM_dl2[i] = getResult('YM', i);
	mean_dl2[i] = getResult('Mean', i);
	stddev_dl2[i] = getResult('StdDev', i);
	min_dl2[i] = getResult('Min', i);
	max_dl2[i] = getResult('Max', i);
	bkgd_dl2[i] = getResult('Background', i);
	meanbkgd_dl2[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+second_image_TL+" "+"Double-labeled_"+second_stain_type_TL+"_co-occurring_with_"+third_stain_type_TL+" "+(i+1)+" "+area_dl2[i]+" "+XM_dl2[i]+" "+YM_dl2[i]+" "+mean_dl2[i]+" "+stddev_dl2[i]+" "+min_dl2[i]+" "+max_dl2[i]+" "+bkgd_dl2[i]+" "+meanbkgd_dl2[i]);
	}

	// Saving data

//saveAs("Measurements", dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");
//print("\n");
//print("Results saved as: "+dir+name);

roiManager("reset");
run("Clear Results");

ps_Compile_measure_tpl_Background_DL1and3_ROIs();

}
//\\//\\//\\//\\//\\//\\//\\

function ps_Compile_measure_tpl_Background_DL1and3_ROIs() { //this macro simply recalls the ROIs defined in the last macro in order to measure the values again.

first_image_tif = first_image_TL+"-2.tif";
second_image_tif = second_image_TL+"-2.tif";
third_image_tif = third_image_TL+"-2.tif";
merged_image_tif = merged_image_TL+".tif";


run("Clear Results");

selectWindow(first_image_tif);
roiManager("Open", dir+subDir1+first_image_TL+first_stain_type_TL+"_vs_"+third_stain_type_TL+"_double-label_ROIoverlay.zip");
name = series_name_TL+" "+first_stain_type_TL+"_vs_"+third_stain_type_TL+" double-label.txt";

DL_ROIs=0;
DL_ROIs =roiManager("count");
array=newArray(DL_ROIs);
for(i=0; i<DL_ROIs;i++) {
		array[i] = i;
	}
//roiManager("Select", array); //by not making an ROI manager selection, and actually deselecting, the ROI manager selects all by default.
roiManager("deselect");
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

DL_ROIs1_m=0;
DL_ROIs1_means=0;
DL_ROIs1_m = nResults;
DL_ROIs1_means = newArray(DL_ROIs1_m);
roiManager("deselect");
for (i=0; i<DL_ROIs1_m; i++) {
	DL_ROIs1_means[i] = getResult('Mean', i);
}
roiManager("deselect");
	for (i=0; i<DL_ROIs1_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

DL_ROIs1_m2 = 0;
DL_ROIs1_avgmeans = 0;
DL_ROIs1_m2 = nResults;
DL_ROIs1_avgmeans = newArray(DL_ROIs1_m2);
roiManager("deselect");
for (i=0; i<DL_ROIs1_m2; i++) {
	DL_ROIs1_avgmeans[i] = getResult('Mean-Background', i);
	}
Array.getStatistics(DL_ROIs1_avgmeans, min, max, mean, stdDev);
//print("\n");
//print("Double-labeled "+first_stain_type_TL+" co-occurring with "+third_stain_type_TL+" Mean Intensity = "+mean);


DL_ROIs1_numberStains=0;
DL_ROIs1_numberStains=getValue("results.count");
//print("Final number of Double-labeled "+first_stain_type_TL+" co-occurring with "+third_stain_type_TL+" Cells = "+DL_ROIs1_numberStains);

n_dl1 = nResults;
area_dl1 = newArray(n_dl1);
XM_dl1 = newArray(n_dl1);
YM_dl1 = newArray(n_dl1);
mean_dl1 = newArray(n_dl1);
stddev_dl1 = newArray(n_dl1);
min_dl1 = newArray(n_dl1);
max_dl1 = newArray(n_dl1);
bkgd_dl1 = newArray(n_dl1);
meanbkgd_dl1 = newArray(n_dl1);
print("\n");
print("Double-labeled "+first_stain_type_TL+" vs "+third_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
for (i=0; i<n_dl1; i++) {
	area_dl1[i] = getResult('Area', i);
	XM_dl1[i] = getResult('XM', i);
	YM_dl1[i] = getResult('YM', i);
	mean_dl1[i] = getResult('Mean', i);
	stddev_dl1[i] = getResult('StdDev', i);
	min_dl1[i] = getResult('Min', i);
	max_dl1[i] = getResult('Max', i);
	bkgd_dl1[i] = getResult('Background', i);
	meanbkgd_dl1[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+first_image_TL+" "+"Double-labeled_"+first_stain_type_TL+"_co-occurring_with_"+third_stain_type_TL+" "+(i+1)+" "+area_dl1[i]+" "+XM_dl1[i]+" "+YM_dl1[i]+" "+mean_dl1[i]+" "+stddev_dl1[i]+" "+min_dl1[i]+" "+max_dl1[i]+" "+bkgd_dl1[i]+" "+meanbkgd_dl1[i]);
	}

	// Saving data

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");

roiManager("reset");

//\\\\\\\\\\\\\\\
//measure double labeled ROIs (image 3)

roiManager("Open", dir+subDir1+third_image_TL+third_stain_type_TL+"_vs_"+first_stain_type_TL+"_double-label_ROIoverlay.zip");
name = series_name_TL+" "+third_stain_type_TL+"_vs_"+first_stain_type_TL+" double-label.txt";

run("Clear Results");
selectWindow(third_image_tif);

//waitForUser("Pause5");

roiManager("Show All");
roiManager("Show All with labels");
roiManager("deselect");

DL_ROIs=0;
DL_ROIs =roiManager("count");
array=newArray(DL_ROIs);
for(i=0; i<DL_ROIs;i++) {
	array[i] = i;
	}

//roiManager("Select", array);
roiManager("deselect");
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

DL_ROIs2_m=0;
DL_ROIs2_means=0;
DL_ROIs2_m = nResults;
DL_ROIs2_means = newArray(DL_ROIs2_m);
run("Select None");
for (i=0; i<DL_ROIs2_m; i++) {
	DL_ROIs2_means[i] = getResult('Mean', i);
	}
roiManager("deselect");
	for (i=0; i<DL_ROIs2_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

DL_ROIs2_m2 = 0;
DL_ROIs2_avgmeans = 0;
DL_ROIs2_m2 = nResults;
DL_ROIs2_avgmeans = newArray(DL_ROIs2_m2);
roiManager("deselect");
for (i=0; i<DL_ROIs2_m2; i++) {
	DL_ROIs2_avgmeans[i] = getResult('Mean-Background', i);
	}

Array.getStatistics(DL_ROIs2_avgmeans, min, max, mean, stdDev);
//print("\n");
//print("Double-labeled "+third_stain_type_TL+" co-occurring with "+first_stain_type_TL+" Mean Intensity = "+mean);


DL_ROIs2_numberStains=0;
DL_ROIs2_numberStains=getValue("results.count");
//print("Final number of Double-labeled "+third_stain_type_TL+" co-occurring with "+first_stain_type_TL+" Cells = "+DL_ROIs2_numberStains);

n_dl2 = nResults;
area_dl2 = newArray(n_dl2);
XM_dl2 = newArray(n_dl2);
YM_dl2 = newArray(n_dl2);
mean_dl2 = newArray(n_dl2);
stddev_dl2 = newArray(n_dl2);
min_dl2 = newArray(n_dl2);
max_dl2 = newArray(n_dl2);
bkgd_dl2 = newArray(n_dl2);
meanbkgd_dl2 = newArray(n_dl2);
print("\n");
print("Double-labeled "+third_stain_type_TL+" vs "+first_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
for (i=0; i<n_dl2; i++) {
	area_dl2[i] = getResult('Area', i);
	XM_dl2[i] = getResult('XM', i);
	YM_dl2[i] = getResult('YM', i);
	mean_dl2[i] = getResult('Mean', i);
	stddev_dl2[i] = getResult('StdDev', i);
	min_dl2[i] = getResult('Min', i);
	max_dl2[i] = getResult('Max', i);
	bkgd_dl2[i] = getResult('Background', i);
	meanbkgd_dl2[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+third_image_TL+" "+"Double-labeled_"+third_stain_type_TL+"_co-occurring_with_"+first_stain_type_TL+" "+(i+1)+" "+area_dl2[i]+" "+XM_dl2[i]+" "+YM_dl2[i]+" "+mean_dl2[i]+" "+stddev_dl2[i]+" "+min_dl2[i]+" "+max_dl2[i]+" "+bkgd_dl2[i]+" "+meanbkgd_dl2[i]);
	}

	// Saving data

//saveAs("Measurements", dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");
//print("\n");
//print("Results saved as: "+dir+name);

roiManager("reset");
run("Clear Results");

ps_Compile_measure_TL_ROIs();
}

//\\//\\//\\//\\//\\//\\//\\

function ps_Compile_measure_TL_ROIs() { //this macro simply recalls the TL ROIs defined in the last macro in order to measure the values again.

//waitForUser("TL_measure macro");

first_image_tif = first_image_TL+"-2.tif";
second_image_tif = second_image_TL+"-2.tif";
third_image_tif = third_image_TL+"-2.tif";
merged_image_tif = merged_image_TL+".tif";

roiManager("reset");

//\\\\\\\\\\\\\
//actually measuring the triple labeled ROIs (image 1)

run("Clear Results");
selectWindow(first_image_tif);

roiManager("Open", dir+subDir1+first_stain_type_TL+"_vs_"+second_stain_type_TL+"_TripleLabel_ROIoverlay.zip");
name = series_name_TL+" "+first_stain_type_TL+" triple-label.txt";

TL_ROIs=0;
TL_ROIs =roiManager("count");
TL_array=newArray(TL_ROIs);
for(i=0; i<TL_ROIs;i++) {
	TL_array[i] = i;
	}

roiManager("deselect");
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

TL_ROIs1_m=0;
TL_ROIs1_means=0;
TL_ROIs1_m = nResults;
TL_ROIs1_means = newArray(TL_ROIs1_m);
roiManager("deselect");
for (i=0; i<TL_ROIs1_m; i++) {
	TL_ROIs1_means[i] = getResult('Mean', i);
	}
roiManager("deselect");
	for (i=0; i<TL_ROIs1_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

TL_ROIs1_m2 = 0;
TL_ROIs1_avgmeans = 0;
TL_ROIs1_m2 = nResults;
TL_ROIs1_avgmeans = newArray(TL_ROIs1_m2);
roiManager("deselect");
for (i=0; i<TL_ROIs1_m2; i++) {
	TL_ROIs1_avgmeans[i] = getResult('Mean-Background', i);
	}
Array.getStatistics(TL_ROIs1_avgmeans, min, max, mean, stdDev);
//print("\n");
//print("Triple-labeled "+first_stain_type_TL+" Mean Intensity = "+mean);


TL_ROIs1_numberStains=0;
TL_ROIs1_numberStains=getValue("results.count");
//print("Final number of Triple-labeled "+first_stain_type_TL+" Cells = "+TL_ROIs1_numberStains);

n_tl1 = nResults;
area_tl1 = newArray(n_tl1);
XM_tl1 = newArray(n_tl1);
YM_tl1 = newArray(n_tl1);
mean_tl1 = newArray(n_tl1);
stddev_tl1 = newArray(n_tl1);
min_tl1 = newArray(n_tl1);
max_tl1 = newArray(n_tl1);
bkgd_tl1 = newArray(n_tl1);
meanbkgd_tl1 = newArray(n_tl1);
print("\n");
print("Triple-labeled "+first_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
for (i=0; i<n_tl1; i++) {
	area_tl1[i] = getResult('Area', i);
	XM_tl1[i] = getResult('XM', i);
	YM_tl1[i] = getResult('YM', i);
	mean_tl1[i] = getResult('Mean', i);
	stddev_tl1[i] = getResult('StdDev', i);
	min_tl1[i] = getResult('Min', i);
	max_tl1[i] = getResult('Max', i);
	bkgd_tl1[i] = getResult('Background', i);
	meanbkgd_tl1[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+first_image_TL+" "+"Triple-labeled_"+first_stain_type_TL+" "+(i+1)+" "+area_tl1[i]+" "+XM_tl1[i]+" "+YM_tl1[i]+" "+mean_tl1[i]+" "+stddev_tl1[i]+" "+min_tl1[i]+" "+max_tl1[i]+" "+bkgd_tl1[i]+" "+meanbkgd_tl1[i]);
	}

// Saving data

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");

roiManager("reset");

//\\\\\\\\\\\\\\\
//actually measuring the triple labeled ROIs (image 2)

run("Clear Results");
selectWindow(second_image_tif);

roiManager("Open", dir+subDir1+second_stain_type_TL+"_vs_"+third_stain_type_TL+"_TripleLabel_ROIoverlay.zip");
name = series_name_TL+" "+second_stain_type_TL+" triple-label.txt";

TL_ROIs=0;
TL_ROIs =roiManager("count");
TL_array=newArray(TL_ROIs);
for(i=0; i<TL_ROIs;i++) {
	TL_array[i] = i;
	}

roiManager("deselect");
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

TL_ROIs2_m=0;
TL_ROIs2_means=0;
TL_ROIs2_m = nResults;
TL_ROIs2_means = newArray(TL_ROIs2_m);
roiManager("deselect");
for (i=0; i<TL_ROIs2_m; i++) {
	TL_ROIs2_means[i] = getResult('Mean', i);
	}
roiManager("deselect");
	for (i=0; i<TL_ROIs2_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

TL_ROIs2_m2 = 0;
TL_ROIs2_avgmeans = 0;
TL_ROIs2_m2 = nResults;
TL_ROIs2_avgmeans = newArray(TL_ROIs2_m2);
roiManager("deselect");
for (i=0; i<TL_ROIs2_m2; i++) {
	TL_ROIs2_avgmeans[i] = getResult('Mean-Background', i);
	}
Array.getStatistics(TL_ROIs2_avgmeans, min, max, mean, stdDev);
//print("\n");
//print("Triple-labeled "+second_stain_type_TL+" Mean Intensity = "+mean);


TL_ROIs2_numberStains=0;
TL_ROIs2_numberStains=getValue("results.count");
//print("Final number of Triple-labeled "+second_stain_type_TL+" Cells = "+TL_ROIs2_numberStains);

n_tl2 = nResults;
area_tl2 = newArray(n_tl2);
XM_tl2 = newArray(n_tl2);
YM_tl2 = newArray(n_tl2);
mean_tl2 = newArray(n_tl2);
stddev_tl2 = newArray(n_tl2);
min_tl2 = newArray(n_tl2);
max_tl2 = newArray(n_tl2);
bkgd_tl2 = newArray(n_tl2);
meanbkgd_tl2 = newArray(n_tl2);
print("\n");
print("Triple-labeled "+second_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
for (i=0; i<n_tl2; i++) {
	area_tl2[i] = getResult('Area', i);
	XM_tl2[i] = getResult('XM', i);
	YM_tl2[i] = getResult('YM', i);
	mean_tl2[i] = getResult('Mean', i);
	stddev_tl2[i] = getResult('StdDev', i);
	min_tl2[i] = getResult('Min', i);
	max_tl2[i] = getResult('Max', i);
	bkgd_tl2[i] = getResult('Background', i);
	meanbkgd_tl2[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+second_image_TL+" "+"Triple-labeled_"+second_stain_type_TL+" "+(i+1)+" "+area_tl2[i]+" "+XM_tl2[i]+" "+YM_tl2[i]+" "+mean_tl2[i]+" "+stddev_tl2[i]+" "+min_tl2[i]+" "+max_tl2[i]+" "+bkgd_tl2[i]+" "+meanbkgd_tl2[i]);
	}

	// Saving data

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");

roiManager("reset");

//\\\\\\\\\\\\\\\
//actually measuring the triple labeled ROIs (image 3)

run("Clear Results");
selectWindow(third_image_tif);

roiManager("Open", dir+subDir1+third_stain_type_TL+"_vs_"+first_stain_type_TL+"_TripleLabel_ROIoverlay.zip");
name = series_name_TL+" "+third_stain_type_TL+" triple-label.txt";

TL_ROIs=0;
TL_ROIs =roiManager("count");
TL_array=newArray(TL_ROIs);
for(i=0; i<TL_ROIs;i++) {
	TL_array[i] = i;
	}
//roiManager("Select", TL_array); //by not making an ROI manager selection, and actually deselecting, the ROI manager selects all by default.
roiManager("deselect");
roiManager("Measure");
roiManager("Show All");
roiManager("Show All with labels");

TL_ROIs3_m=0;
TL_ROIs3_means=0;
TL_ROIs3_m = nResults;
TL_ROIs3_means = newArray(TL_ROIs3_m);
roiManager("deselect");
for (i=0; i<TL_ROIs3_m; i++) {
	TL_ROIs3_means[i] = getResult('Mean', i);
	}
roiManager("deselect");
	for (i=0; i<TL_ROIs3_m; i++) {
		setResult("cellnumber", i, i+1);
		setResult("Background", i, lower);
		setResult("Mean-Background", i, means[i]-lower);
		setResult("Experiment", i, experiment);
		setResult("Subject", i, subject);
		setResult("Indi_var_group", i, treatment);
		setResult("FileName", i, name);
		setResult("Stain", i, model);
	}
	setOption("ShowRowNumbers", false);
	updateResults();

TL_ROIs3_m2 = 0;
TL_ROIs3_avgmeans = 0;
TL_ROIs3_m2 = nResults;
TL_ROIs3_avgmeans = newArray(TL_ROIs3_m2);
roiManager("deselect");
for (i=0; i<TL_ROIs3_m2; i++) {
	TL_ROIs3_avgmeans[i] = getResult('Mean-Background', i);
	}
Array.getStatistics(TL_ROIs3_avgmeans, min, max, mean, stdDev);
//print("\n");
//print("Triple-labeled "+third_stain_type_TL+" Mean Intensity = "+mean);


TL_ROIs3_numberStains=0;
TL_ROIs3_numberStains=getValue("results.count");
//print("Final number of Triple-labeled "+third_stain_type_TL+" Cells = "+TL_ROIs3_numberStains);

n_tl3 = nResults;
area_tl3 = newArray(n_tl3);
XM_tl3 = newArray(n_tl3);
YM_tl3 = newArray(n_tl3);
mean_tl3 = newArray(n_tl3);
stddev_tl3 = newArray(n_tl3);
min_tl3 = newArray(n_tl3);
max_tl3 = newArray(n_tl3);
bkgd_tl3 = newArray(n_tl3);
meanbkgd_tl3 = newArray(n_tl3);
print("\n");
print("Triple-labeled "+third_stain_type_TL+" cell data:");
print("Experiment Subject# Indi_var Image_name Stain_type Cell# Area XM YM Mean StdDev Min Max Background Mean-Background");
for (i=0; i<n_tl3; i++) {
	area_tl3[i] = getResult('Area', i);
	XM_tl3[i] = getResult('XM', i);
	YM_tl3[i] = getResult('YM', i);
	mean_tl3[i] = getResult('Mean', i);
	stddev_tl3[i] = getResult('StdDev', i);
	min_tl3[i] = getResult('Min', i);
	max_tl3[i] = getResult('Max', i);
	bkgd_tl3[i] = getResult('Background', i);
	meanbkgd_tl3[i] = getResult('Mean-Background', i);
	print(experiment+" "+subject+" "+treatment+" "+second_image_TL+" "+"Triple-labeled_"+third_stain_type_TL+" "+(i+1)+" "+area_tl3[i]+" "+XM_tl3[i]+" "+YM_tl3[i]+" "+mean_tl3[i]+" "+stddev_tl3[i]+" "+min_tl3[i]+" "+max_tl3[i]+" "+bkgd_tl3[i]+" "+meanbkgd_tl3[i]);
	}

	// Saving data

saveParameters();

//saveAs("Measurements", dir+name);
//print("\n");
//print("Results saved as: "+dir+name);
selectWindow("Log");
saveAs("Text", dir+"All_Results"+TimeString+".txt");
wait(10);
roiManager("reset");
wait(10);
run("Clear Results");
//\\\\\\\\\\\\\\\

}















///////////////////////////////////
function Pipsqueak_AI() {
	version=getVersion;
	if (version<"2.1.0/1.53i"){
		waitForUser("STOP!! Please update ImageJ/FIJI to version 1.53f or more recent, and then \nrestart ImageJ/FIJI before running Pipsqueak AI. \n \n*******    You can update by clicking \"Help\">\"Update ImageJ\"    ******* \nFailure to update ImageJ/FIJI may result in Pipsqueak AI not working correctly. \n \n(Also, consider keeping plugins up-to-date with \"Help\">\"Update\").");
		//exit;
	}
	
	_sep_=File.separator; 
	pipDir=getDirectory("plugins")+"Scripts/Pipsqueak/";
	//pipDir=getDirectory("imagej")+"Pipsqueak/"; //dir for testing
	os=getInfo("os.name");	
	if(os!=""){
		osCheckArray=split(os," ");
		osCheck=osCheckArray[0];
	}
	if(osCheck=="Windows"){
		AI_Engine_exec=pipDir+"AI_Engine_v"+ver+".exe"; 
		//AI_Engine_exec=pipDir+"AI_Engine.exe";
	}else{
		AI_Engine_exec=pipDir+"AI_Engine_v"+ver;  
		//AI_Engine_exec=pipDir+"AI_Engine";  
		exec("chmod +x " + AI_Engine_exec);
	}
			
	if(pipDir!=""){
		readOnlyParse=split(pipDir,"/");
		readOnly=readOnlyParse[0];
		if(readOnly=="private"){
			beep();
			waitForUser("It appears that FIJI is being run in read-only mode, which can cause errors. You might need to reinstall FIJI by following these instuctions. \n \nTry following the instructions found here: https://imagej.net/MacOSX_tips \n \nOne thing to try: make sure you extract the FIJI zip outside of your /Applications/ folder and drag the FIJI icon into /Applications/ ");
			exec("open", "https://imagej.net/MacOSX_tips");
		}
		Read_Variables();
		if (email_address == "") {
			silent=exec(AI_Engine_exec, "logout");
			loginMessage="";
			updatePipsqueak();
		}
		loginMessage="";
		updatePipsqueak();
		saveParameters();
	}
}
/////////////////////////
Pipsqueak_AI();





	
	
